Create Your Web Site with Microsoft FrontPage 98


Introducing FrontPage 98

Welcome to Microsoft® FrontPage® 98, the web site creation and management tool that requires no programming knowledge but is robust enough for experienced Web site developers. FrontPage 98 has everything you need to design and build a great looking, easy to navigate, World Wide Web site — quickly and easily.

FrontPage 98 includes the FrontPage Explorer, where you create, design, and manage your entire Web site, and the FrontPage Editor, where you create and edit Web pages without needing to know HTML. FrontPage includes many features that make Web-site creation easy for any user, such as a gallery of professionally designed graphical themes, a full set of wizards and templates for creating pages and FrontPage webs, active page elements for providing complex functionality without programming, and a Tasks list for tracking tasks as you create your FrontPage web.

FrontPage is a member of the Microsoft Office family of products, and shares many of the features of Microsoft Word and Microsoft Excel, such as the Microsoft Clip Gallery, global spell checking and thesaurus, and easy table-editing. FrontPage 98 also manages hyperlinks created in Microsoft Office 97 documents.


To Install FrontPage

  1. Insert the Microsoft FrontPage 98 CD-ROM in your CD-ROM drive. The Setup program will start automatically.

  2. Setup will first search your computer for required networking components and for Web server software.
    • On Windows 95 only, if Setup does not detect required networking components on your computer, you will be prompted to install them. Click “Yes” and follow the Setup instructions on the screen.

    • If Setup does not detect a Web server on your computer, you will be prompted to install the Microsoft Personal Web Server (on Windows 95) or Microsoft Peer Web Services (on Windows NT Workstation). Click “Yes” and follow the Setup instructions on the screen.

    Note You may be prompted to restart your computer. After restarting, Setup will continue, so that you can install other components of Microsoft FrontPage 98.

  3. If the system setting for your language does not match one of the languages in which FrontPage 98 is offered, Setup displays the Select Language dialog box. Choose the language in which you want to use FrontPage and click OK.

  4. The Setup dialog box has options for installing all the components of Microsoft FrontPage 98. Click Install FrontPage 98 to start the Microsoft FrontPage installation.

  5. There are two setup options, Typical and Custom. The Typical option installs all the components you need to get up and running with FrontPage 98. The Custom option lets you select which FrontPage 98 components to install. The Custom option also includes additional components not available in the Typical option, such as additional clip art. Unless you want to install particular FrontPage 98 components, choose Typical and click Next.

  6. When it has finished installing the FrontPage Server Extensions, Setup may prompt you to restart your computer. After you restart your computer, Setup will continue.

  7. After FrontPage 98 is installed, you will be prompted to start the FrontPage Explorer. If you start the FrontPage Explorer, you can continue Setup at any time.

  8. Install the other components of Microsoft FrontPage 98.
    • Click Install Image Composer to install the Microsoft Image Composer, the easy way to arrange, customize, and create your on-screen images.

    • Click Install Internet Explorer to install the latest versions of Microsoft Internet Explorer, the recommended Web browser for use with FrontPage.
  9. Click Exit to exit the Setup program.


About FrontPage

FrontPage includes the FrontPage Explorer and FrontPage Editor on your PC, along with the FrontPage Server Extensions, which run on your Web server.


The FrontPage Explorer

You use the FrontPage Explorer to create the structure or layout of your Web site, apply graphical themes to its pages, organize its files and folders, import and export files, test and repair hyperlinks, administer access privileges, track tasks, and launch the FrontPage Editor to design and edit the contents of your Web pages. When your FrontPage web is completed, you use the FrontPage Explorer to publish it on your computer, your organization’s intranet, or the World Wide Web.


The FrontPage Editor

You use the FrontPage Editor to create, design, and edit World Wide Web pages. As you add text, images, tables, form fields, and other elements to your page, the FrontPage Editor displays them as they would appear in a Web browser. Although it is a powerful tool, the FrontPage Editor is easy to use because of its familiar, word-processor interface. You do not need to learn Hypertext Markup Language (HTML) to use the FrontPage Editor because it creates all the HTML code for you.

If you want to edit HTML code directly, you can using the FrontPage Editor’s HTML view. In this view, you can enter text, edit HTML tags or script code, and use standard word-processing commands such as cutting, pasting, finding, and replacing.


The FrontPage Server Extensions

FrontPage includes a set of programs — the FrontPage Server Extensions — that are installed on the Web server computer on which your FrontPage webs are stored. If you installed the Microsoft Personal Web Server or Microsoft Peer Web Services, FrontPage Setup installed the FrontPage Server Extensions on your PC.

The Server Extensions support authoring and administering FrontPage webs, along with browse-time FrontPage web functionality. For example, when an author is editing a FrontPage web, the Server Extensions support copying or publishing it to other Web servers, creating a table of contents for the web, adding themes and navigational structure to it, and updating hyperlinks to any pages that have been moved or renamed. Using the Server Extensions, an administrator can give a user, group of users, or a specific computer permissions to edit a FrontPage web, browse to it, or administer it. When a user browses a FrontPage web, the Server Extensions support search forms, discussions groups, form processing (including sending form results using e-mail), and other run-time features.


About This Book

This book teaches you the basics of Microsoft FrontPage 98 and introduces you to the Internet and the World Wide Web.

  • The “FrontPage Tutorial” will show you how easy it is to use Microsoft FrontPage to get a new Web site up and running. In three hands-on lessons, it will introduce you to FrontPage using easy to follow, step-by-step procedures.

  • “FrontPage and the World Wide Web” contains an overview of the Internet and the World Wide Web and describes how you use FrontPage during each stage of creating your Web site. Among the topics covered are: creating or importing FrontPage webs, applying themes, adding navigational structure, publishing webs, creating and editing pages, adding tables, images, hyperlinks, and active page elements, using frames, creating forms, and FrontPage database integration.

  • The “Glossary” has a set of definitions of FrontPage, Internet and World Wide Web terms. You can also use this glossary online, by clicking Glossary from any online Help window.


Learning More About FrontPage

Here are some other ways you can learn about FrontPage.


FrontPage Online Help

In Microsoft FrontPage 98, you can get online Help where and when you need it:

Help button

  • When you want to know more about a screen item, such as a command or toolbar button, click the Help button on the toolbar and then click the screen item for an online Help topic describing the item.

  • In a FrontPage dialog box, click Help for a Help topic describing the dialog box.

  • Select any command or dialog box and click F1 for a Help topic describing the command or dialog box.

  • Choose Microsoft FrontPage Help from any Microsoft FrontPage Help menu. You will find a list of all Help topics, an index of Help terms, and a Find tab, in which you can search for Help topics that contain one or more words of interest.

Using the Microsoft FrontPage Help menu, you can also get the latest news and information about Microsoft FrontPage 98. Choose Microsoft on the Web to visit the FrontPage World Wide Web site. At this Web site, you will find the latest information about FrontPage, answers to frequently asked questions, a list of Internet service providers that support the Microsoft FrontPage Server Extensions, and much more.


The FrontPage Server Extensions Resource Kit

The Microsoft FrontPage Server Extensions Resource Kit is an HTML document that is in the \SERK folder of your Microsoft FrontPage 98 CD-ROM. It is designed to make it easy for Internet Service Providers or corporate intranet Web server administrators to install and maintain the FrontPage Server Extensions on a Web server computer.

If you are a Web author or administrator, you do not need to read this document to use FrontPage. However, if you are curious about the FrontPage Server Extensions, you can learn more about them by reading the overview of the Server Extensions, in the file \SERK\intro.htm on the FrontPage 98 CD-ROM.


The FrontPage Software Developer’s Kit

The Microsoft FrontPage Software Developer’s Kit teaches software developers how to create wizards, templates, themes, and other custom FrontPage components.

The Microsoft FrontPage Software Developer’s Kit is in the \SDK folder of your Microsoft FrontPage 98 CD-ROM.


FrontPage News Groups

Microsoft Internet Mail and News and other news readers support participation in online news groups. Microsoft sponsors three news groups for sharing information about Microsoft FrontPage:

  • Microsoft.public.Frontpage.client

  • Microsoft.public.Frontpage.extensions.Unix

  • Microsoft.public.Frontpage.extensions.WindowsNT


Microsoft FrontPage on the World Wide Web

The FrontPage Web site offers a wealth of information and late-breaking news about FrontPage. On the Microsoft FrontPage Help menu, click Microsoft on the Web, or visit the FrontPage Web site at the following location:

http://www.microsoft.com/frontpage


Next Steps

To | See
Learn the basics of Microsoft FrontPage 98 | “The FrontPage Tutorial”


What You Will Learn

This tutorial will show you how easy it is to use Microsoft FrontPage to get a new Web site up and running. The three lessons that follow will introduce you to Microsoft FrontPage using easy to follow, step-by-step procedures.


Building a New Web Site

In Lesson 1, you will learn how to use the FrontPage Explorer to create a four-page Web site with professionally designed Web graphics and functional navigation bars. You will also learn how to edit the pages by adding text, images, formatted lists, and hyperlinks using the FrontPage Editor.


Web Page Design in the FrontPage Editor

In Lesson 2, you will learn how to insert files on a page, collect feedback from visitors to your site, make image maps from pictures, add a table, insert a list, and add a scrolling marquee using the FrontPage Editor.


Testing and Publishing a FrontPage Web

In Lesson 3, you will return to the FrontPage Explorer, where you will test your hyperlinks, check spelling across all Web pages, find and replace text on pages, view and complete Web tasks, and publish your FrontPage Web on the World Wide Web.


Before You Begin

If you do not already have a Web browser installed on your system, you should install Microsoft Internet Explorer, which is included on the FrontPage 98 CD-ROM. After you insert the CD-ROM into your drive, choose “Install Internet Explorer” from the menu that appears.

You can install Microsoft Internet Explorer on your computer even if you are already using another Web browser. Internet Explorer works best with FrontPage to provide enhanced page and themes preview. Other Web browsers are not able to offer these additional features.

Depending on the size of your monitor and the resolution of your graphics adapter, the illustrations in this tutorial may vary slightly from what will appear on your screen.

You can recognize a professional Web site by the consistent look and feel you get throughout the site’s pages: the organization of the site is coherent, page-to-page navigation is intuitive, and the appearance of the pages is appealing and interesting. With FrontPage, you can quickly and easily build Web sites every bit as sophisticated and attractive as many of the award-winning Web sites on the Internet today. The three lessons that follow will make it easy for you to get started.


Next Step

To | See
Learn how to build a new Web site | “Lesson 1”


Building a New Web Site

The World Wide Web is a great way for anyone with Internet access to communicate with the world. While you have conversations with other people over Internet e-mail and in Internet newsgroups, you can also have your own personal Web site — a collection of one or more pages on which you can share all sorts of information.

Your Web site can be about you, your interests, or a particular subject that you enjoy. For professional Web sites and intranets, you can share information about your company’s products and services, and you can make internal information more accessible to the employees in your organization.

You can place text, pictures, video clips, sounds, and animations on your Web pages. No matter how large or small your Web site will be, building it is easy with Microsoft FrontPage.

In this lesson, you will learn how to:

  • Launch Microsoft FrontPage

  • Construct a new FrontPage web

  • Apply a FrontPage theme

  • Design, edit, and save pages

  • Insert images

  • Create hyperlinks from text

  • Preview and save your work


Getting Started

In this first lesson, you will use the Personal Web as a model for building a new FrontPage web template in the FrontPage Explorer.

Û To Create a New FrontPage Web

  1. On the Windows task bar, click the Start button, point to Programs, and then click Microsoft FrontPage.

    The FrontPage Explorer opens and the Getting Started dialog box is displayed. The Getting Started dialog box is a convenient starting point whenever you begin working in FrontPage. You can open an existing FrontPage web from a list of recently opened webs, or you can create a new FrontPage web.

  2. In the Getting Started dialog box, choose Create a New FrontPage Web and then click OK.

    The New FrontPage Web dialog box is displayed. Here, you tell FrontPage what kind of FrontPage web you want to create, and what the title of the new web will be.

  3. In the New FrontPage Web dialog box, select One Page Web next to the number 1.

    This option will create a site consisting of a single home page.

  4. Next to the number 2 in the New FrontPage Web dialog box, type Personal Web into the title field.

    “Personal Web” is the title of your new FrontPage web. This title helps you distinguish between multiple Web sites you create with FrontPage. As you type the name of your new FrontPage web, the FrontPage Explorer suggests a location where this FrontPage web will be stored. For this tutorial, accept the suggested location.

  5. Click OK.

    FrontPage creates a new FrontPage web called “Personal Web.”

    Note Depending on the type of Web server you are using, you may be prompted for name and password authentication before the new FrontPage web is created. To proceed, enter the administrator name and password you chose during FrontPage Setup.


The FrontPage Explorer

The FrontPage Explorer is a main component of Microsoft FrontPage. You use the FrontPage Explorer to build new Web sites and later to change, maintain, administer, and publish established FrontPage webs.

The seven buttons on the FrontPage Explorer’s Views bar provide different ways of looking at information in your FrontPage web. You can choose how you want to view the contents of your Web site throughout the project — from the early steps of creating a new Web site, to the moment it is ready to be published on the World Wide Web.

Navigation button

Select the Navigation view by clicking the Navigation button on the FrontPage Explorer’s Views bar.

The Navigation view consists of a split-screen display that shows the top-level structure of your FrontPage web in the upper half of the screen (the Navigation pane), and a familiar Windows Explorer-like file and folder list in the lower half of the screen (the Files pane).

During this lesson, you will primarily use the Navigation view and the Themes view for the construction of your new FrontPage web.


The Navigation and Themes Views

The Navigation view is the most useful view for constructing a new Web site, because it provides a useful outline of your site structure and it can automatically create navigation bars on all pages in your FrontPage web. A navigation bar is a page region that provides access to other pages in your FrontPage web, using textual or graphical hyperlinks. In larger Web sites, linking all of the pages together in a consistent and accurate manner could take hours of work. If you create your site structure in the Navigation view, FrontPage can do this work for you.

You will use the Themes view to apply a set of professionally designed graphics to your FrontPage web. A theme consists of design elements for bullets, fonts, images, navigation bars, and other page elements. When applied, a theme gives the pages and navigation bars in a FrontPage web an attractive and consistent appearance.

Later, in Lesson 3 of the FrontPage tutorial, you will learn about some of the other FrontPage Explorer views that help you organize files and folders, check and repair the hyperlinks on your pages, and remind you of tasks that must be completed before you publish your site on the World Wide Web.

For a complete discussion of all FrontPage Explorer views, see “FrontPage Webs and the Microsoft FrontPage Explorer”.


Working With Pages

Your Personal Web will consist of four pages that will be linked together. When you first constructed the Personal Web, FrontPage created the first of these pages, called the home page.

The home page is the front door to every Web site. It is the page that is displayed by default in the Web browser when you visit a Web site. The home page that FrontPage created in the previous steps will eventually contain hyperlinks to the other pages in your FrontPage web.

To finish creating your Personal Web’s site structure, you will now use the Navigation view to add three new pages below the home page.

Û To Add New Pages to Your FrontPage Web

New Page button
  1. In the Navigation view, make sure “Home Page” is still selected.

    Selected pages in the Navigation view are displayed in blue.

  2. On the FrontPage Explorer’s toolbar, click the New Page button.

    FrontPage adds a new page labeled “New Page 1” below the home page in the Navigation pane.

  3. When prompted to let FrontPage create navigation bars that link your pages together, answer Yes.

  4. Now click the New Page button two more times.

    FrontPage adds two more pages below the home page, labeled “New Page 2” and “New Page 3.”

    Note the hierarchical structure between the four pages. The Navigation view shows the pages connected by lines — much like the relationship of fields in an organizational chart. This is the hyperlink structure that FrontPage will use to generate navigation bars on your pages.

    Before working with the pages you have just created, you should give each page a meaningful title. Page titles not only help you identify and distinguish the pages in your FrontPage web, they are also displayed in the title bar of the FrontPage Editor, as well as your Web browser. You can change page titles without leaving the Navigation view.

Û To Add Titles to Pages

  1. With the Home Page still selected in the Navigation view, press the TAB key on your keyboard.

    FrontPage highlights the left page below the home page and activates its page title for editing.

  2. Type Interests, then press the ENTER key.

    FrontPage changes the page title “New Page 1” to “Interests.”

  3. On your keyboard, press the TAB key.

    FrontPage highlights the middle page below the home page and activates its page title for editing.

  4. Type Photo Album, then press the ENTER key.

  5. Press the TAB key once more.

    FrontPage highlights the right page below the home page and activates its page title for editing.

  6. Type Favorites, then press the ENTER key.

Your screen should now look like this:

An Alternate Way to Add Pages You can add new pages in the Navigation view by right-clicking a page and choosing the New Page command from the shortcut menu. This command will create a new page below the selected page.

Any changes you make to the site structure in the FrontPage Explorer’s Navigation view are not actually applied until you take one of several actions, including switching views in the FrontPage Explorer, switching to another Windows application, or opening a page in the FrontPage Editor.

Undo button

If you make a mistake or change your mind about a modification you have made, you can use the Undo button on the FrontPage Explorer’s toolbar to undo the last action.


Applying a FrontPage Theme

With Microsoft FrontPage, you can easily create dynamic and visually consistent Web sites by applying one of several pre-designed themes.

Before applying a theme, you can preview its appearance in the FrontPage Explorer’s Themes view. In the steps below, you will add the “Global Marketing” theme to the Personal Web.

Û To Apply a FrontPage Theme to the Personal Web

Themes button
  1. On the FrontPage Explorer’s Views bar, click the Themes button.

  2. Click on different themes in the scrolling list box.

    The Theme Preview pane lets you preview the graphical elements as they will appear on your Web pages. You can preview a theme before applying it by selecting it from the list of themes.

    Before applying a theme, you can select theme options that affect the appearance of the theme’s components. Selecting Vivid Colors will apply brighter colors to text and graphics, selecting Active Graphics will animate certain theme components, and selecting Background Image will apply a background image to the pages in your current FrontPage web.

  3. For this lesson, select Vivid Colors and Background Image.

  4. From the list of themes, select Global Marketing, then click the Apply button.

    The selected theme is applied to the pages in your current FrontPage web. In the next section of this lesson, you will see how the selected theme gives your pages a consistent and attractive appearance.


Opening Pages in the FrontPage Editor

Now that the layout of the Personal Web is in place, you will add content to each of the pages. While page creation and file management tasks are best handled in the FrontPage Explorer, designing and editing pages is done in the FrontPage Editor.

The FrontPage Editor is used to create, edit, and view pages using a familiar WYSIWYG (What You See Is What You Get) interface similar to word-processing programs such as Microsoft Word. All text, styles, and page formatting is based on Hypertext Markup Language (HTML) standards.

The following exercises will introduce you to the FrontPage Editor’s basic features. In Lesson 2, you will explore FrontPage Editor features in more depth.

Û To Open the Home Page in the FrontPage Editor

Navigation button
  1. In the FrontPage Explorer, click the Navigation button on the Views bar.

  2. Double-click the home page in the Navigation pane or select the page and choose Open on the FrontPage Explorer’s Edit menu.

    The home page opens in the FrontPage Editor.


Editing the Home Page

When the home page is opened in the FrontPage Editor, note the page elements that have been applied by the FrontPage theme you selected in the previous section: the page has a textured background image, a page banner with the page’s title, and a navigation bar with linked buttons pointing to the other pages in the Personal Web.

To add text on the page, simply begin typing as you would in a new word processing document.

Û To Add Text to the Home Page

The home page of a Web site should have a greeting for your visitors (people that will “surf” to your site after it has been published on the World Wide Web).

  1. Type Welcome to my Web site! on the home page, then press ENTER.

    Pressing ENTER creates a new paragraph on the page.

  2. On the new line, type Please make sure you take a look at the other pages at my site. and then press ENTER.

    You can later replace this text with a personal greeting in your own words, along with a description of what your site has to offer.

Your page should now look like this:


Saving the Page

Before continuing, it is a good idea to save your work.

Û To Save the Current Page

  1. On the FrontPage Editor’s File menu, choose Save As.

    The Save As dialog box is displayed.

    You can choose to save the current page to your FrontPage web, to the World Wide Web, to your file system, or as a page template. You can also change the page title and the URL of the page in the Save As dialog box. URL stands for Uniform Resource Locator. It is the unique name that will be used by a Web browser to locate and display the page.

  2. Click OK without making any changes.

    FrontPage saves the current page.


Editing the “Interests” Page

The second page in your FrontPage web will display a brief, bulleted list of your personal interests. You can later customize this page by adding a more detailed list of your interests, hobbies, or projects.

Û To Open the Interests Page in the FrontPage Editor

  1. On the FrontPage Editor’s File menu, choose Open.

    The Open dialog box is displayed. This dialog box displays the pages and folders in your FrontPage web. You can open pages from the current FrontPage web, files on your local file system, pages on another Web server, or live pages on the World Wide Web.

  2. From the list of files in your FrontPage web, select interest.htm and click OK.

    The Interests page is displayed in the FrontPage Editor.

When the Interests page is opened in the FrontPage Editor, note the page elements that have been applied by the FrontPage theme. As you complete the steps below, you will see two new theme elements on this page: a horizontal line and image bullets.

Û To Add Formatted Text to the Interests Page

  1. Type Here are just some of the things I like to do in my spare time:

    Center button

  2. With the cursor at the end of the line of text you just typed, click the Center button on the FrontPage Editor’s toolbar to center the text.

    When you apply paragraph formatting like centering text, FrontPage creates the correct HTML tags for each paragraph on your current page. HTML code is stored when you save the page.

  3. On the Insert menu, choose Horizontal Line.

    A horizontal line is inserted on the page, just below the text you typed.

In the following steps, you will add a bulleted list to the Interests page. This list will consist of three interests, each followed by descriptive text.

Û To Add a Bulleted List

Bulleted List button
  1. On the FrontPage Editor’s toolbar, click the Bulleted List button.

    FrontPage begins a bulleted list and displays the first bullet.

    Because you previously applied a theme to the Personal Web, the normally plain list bullets are replaced by graphical image bullets.

  2. Type Interest 1: This will be a description of a favorite activity or hobby. and then press ENTER.

    Pressing ENTER ends the current list item and creates the next bullet in the list.

  3. On the next line, type Interest 2: followed by a space, then press ENTER.

  4. On the third line, type Interest 3: followed by a space, then press ENTER two times.

    Pressing ENTER twice ends the current list.

Your screen should now look like this:

Next, you will copy and paste the descriptive text after the first list bullet and paste it behind the text after the second and third bullets. You can copy and paste text in the FrontPage Editor exactly like you do in a Windows word processor.

Û To Copy and Paste Text in the Bulleted List

  1. From the first bullet, select the sentence “This will be a description of a favorite activity or hobby.”

  2. On the Edit menu, select Copy.

    The text is copied to the Windows clipboard.

  3. Next, position the insertion point after “Interest 2:” on the second line of the list and click the left mouse button.

    The cursor appears after the words “Interest 2.”

  4. On the Edit menu, select Paste.

    The text is pasted from the Windows clipboard.

  5. Position the insertion point after “Interest 3:” on the third line of the list and click the left mouse button.

  6. While holding down the CTRL key, press V.

The key combination CTRL+V pastes the copied text after the third list item. FrontPage supports standard Windows keyboard shortcuts.

Your screen should now look like this:

Before continuing, it is a good idea to save your work.

Û To Save the Current Page

Save button
  • On the FrontPage Editor’s toolbar, click the Save button.


Editing the “Photo Album” Page

On the third page in your FrontPage web, you will insert two images — one of a sunset, and one of a metropolitan city skyline. Images add decoration and personality to your Web pages and can be imported from a variety of popular graphics file formats.

Û To Open the Photo Album Page in the FrontPage Editor

  1. On the FrontPage Editor’s File menu, choose Open.

    The Open dialog box is displayed.

  2. From the list of files, select photo.htm and click OK.

    The Photo Album page is displayed in the FrontPage Editor.

When the Photo Album page is opened in the FrontPage Editor, note the page elements that have been applied by the FrontPage theme.

Û To Add Formatted Text to the Photo Album Page

  1. On the Photo Album page, type Here are two cool photographs that came with the FrontPage Clip Gallery.

  2. With the cursor at the end of the line of text you just typed, click the Center button on the FrontPage Editor’s toolbar to center the text.

  3. On the Insert menu, choose Horizontal Line.

  4. Press ENTER.

Your page should now look like this:

Next, you will add two images to the page.

Û To Import Images to the Photo Album Page

  1. On the Insert menu, choose Image.

    The Image dialog box is displayed. In this dialog box, you can select an image to be inserted from the current FrontPage web, from another Web server, from a scanner, from the Microsoft Clip Gallery, or from your local file system.

    File button

  2. In the Image dialog box, click the File button.

    The File button lets you browse your local file system for an image to insert. For this exercise, the image file you want to insert is named sunset.gif.

  3. In the Select File dialog box, navigate to the following folder (assuming you installed FrontPage in the \Program Files folder on your C:\ drive):

    C:\Program Files\Microsoft FrontPage\tutorial\

    If you changed the default installation drive or folder during FrontPage Setup, you will need to adjust the path accordingly.

  4. In the tutorial folder, select the file sunset.gif, then click OK.

    The photograph of a sunset is placed on the page.

  5. Press ENTER to create a new line for the next image.

Your screen should now look like this:

Now repeat steps 1 – 5 in the previous exercise to insert the second image, which is named city.gif. This image is also located in the C:\Program Files\Microsoft FrontPage\tutorial\ folder.

Û To Save the Current Page

Save button
  1. On the FrontPage Editor’s toolbar, click the Save button.

  2. In the Save Embedded Files dialog box, click OK to save the images you inserted.


Editing the “Favorites” Page

The fourth page in your FrontPage web will consist of a brief list of hyperlinks that point to other sites on the World Wide Web. After taking the FrontPage tutorial, you can customize this page by changing the hyperlinks to those of your favorite Web sites.

Û To Open the Favorites Page in the FrontPage Editor

Open button
  1. On the FrontPage Editor’s toolbar, click the Open button.

    The Open dialog box is displayed.

  2. From the list of files, select favorite.htm and click OK.

    The Favorites page is displayed in the FrontPage Editor.

When the Favorites page is opened in the FrontPage Editor, note the page elements that have been applied by the FrontPage theme.

Û To Add Formatted Text on the Favorites Page

  1. On the Favorites page, type Here is a list of my favorite sites on the World Wide Web!

  2. With the cursor at the end of the line of text you just typed, click the Center button on the FrontPage Editor’s toolbar to center the text.

  3. On the Insert menu, choose Horizontal Line.

  4. Press ENTER.

Your page should now look like this:

Next, you will add hyperlinks on the current page. A hyperlink is a pointer from text or from an image to a page or other type of file on the World Wide Web. On World Wide Web pages, hyperlinks are the primary way to navigate between pages and among Web sites.

You will create the first hyperlink from descriptive text, using the FrontPage Editor’s Hyperlink command.

Û To Create Hyperlinks From Text

  1. Type The Microsoft Network and then press ENTER.

  2. Click and drag the mouse over the three words you just typed to select them.

  3. On the Insert menu, choose Hyperlink.

    The Create Hyperlink dialog box is displayed. In this dialog box, you can select the target of the hyperlink. This can be a page or a file in your current FrontPage web, on your local file system, on another Web server, or on the World Wide Web. You can also create an e-mail hyperlink (which you will learn in Lesson 2).

  4. In the URL field, type http://www.msn.com and then click OK.

    “http://” stands for Hypertext Transport Protocol. This is the Internet protocol that allows World Wide Web browsers to retrieve information from Web servers. “www.msn.com” is the URL of “The Microsoft Network.” To learn more about URLs, see “Welcome to the World Wide Web” .

  5. On your keyboard, press the DOWN ARROW key to deselect the text.

    The words “The Microsoft Network” have changed from black default text to colored text and the words are now underlined to indicate the hyperlink. When this page is displayed in a Web browser, clicking this hyperlink will retrieve and display the home page of The Microsoft Network. The color and appearance of the hyperlink on this page is derived from the theme you applied earlier in this lesson.

Next, you will create an automatic hyperlink. This method of creating hyperlinks is quick and easy, because it lets you bypass the Create Hyperlink dialog box.

Û To Create an Automatic Hyperlink

  1. On the Favorites page, type http://www.yahoo.com and then press ENTER.

    “Yahoo!” is a popular Internet service that lets you look for information on the World Wide Web using search keywords.

    As soon as you press the ENTER key, the URL you just typed changes from black to colored text and the address is underlined to indicate the hyperlink. FrontPage, a member of the Office 97 family of products, supports automatic hyperlink creation.

    Since a URL by itself is not always very descriptive, however, you will want to change it to the name of the site the hyperlink points to. You can overtype the text without erasing the hyperlink.

  2. Using the mouse, click and drag over the URL you just typed to select it.

  3. Now type the word Yahoo! to replace the selected text.

    The hyperlink still points to the same URL, but it is now labeled with the site’s name.

Next, you will create a hyperlink using your Web browser. This method of creating hyperlinks is the most accurate, because you actually visit the page the hyperlink will point to.

Note If you do not have access to the World Wide Web while taking the FrontPage tutorial, you should skip the exercise on the following page and proceed to the next section, “Previewing the Personal Web.”

Û To Create a Verified Hyperlink

  1. Press the DOWN ARROW key to move the insertion point to the blank line below the previous hyperlink.

  2. Type Microsoft FrontPage and then press ENTER.

  3. Click and drag the mouse over the words you just typed to select them.

  4. On the Insert menu, choose Hyperlink.

    The Create Hyperlink dialog box is displayed.

    World Wide Web button

  5. In the Create Hyperlink dialog box, click the World Wide Web button.

    The FrontPage Editor launches your Web browser. When you visit the page that the hyperlink should point to and then switch back to FrontPage, the URL field will contain the address of the target page.

  6. In your Web browser’s Address (or Location) field, type http://www.microsoft.com/frontpage and then press ENTER.

    The Web browser displays the Microsoft FrontPage home page, where you can learn more about FrontPage, download new software, and find solutions to common questions.

  7. On your keyboard, press ALT+TAB (or click the FrontPage Editor tile on the Windows task bar) to switch back to the FrontPage Editor’s Create Hyperlink dialog box.

    The URL of the Microsoft FrontPage home page is now entered into the URL field in the Create Hyperlink dialog box.

  8. Click OK.

  9. On your keyboard, press the DOWN ARROW key to deselect the text.

The words “Microsoft FrontPage” are now underlined to indicate the hyperlink.

Your page should now look like this:

Û To Save the Current Page

Save button
  • On the FrontPage Editor’s toolbar, click the Save button.


Previewing the Personal Web

Now that the Personal Web is finished, you can display it in your Web browser to preview your site’s layout and appearance. You can also navigate between the four pages and test the hyperlinks you created. Previewing a FrontPage web works just like browsing to a site on the World Wide Web.

You will learn how to publish your site on the World Wide Web in Lesson 3.

Û To Preview the Home Page in a Web Browser

  1. In the FrontPage Editor, click Window on the menu bar.

    The list of pages appears. Assuming that you did not close any of the pages used in this lesson, you should see the Home Page, the Interests page, the Photo Album page, and the Favorites page listed here.

  2. Click the Home Page to bring the home page back into view.

    If you previously closed the home page, simply open it again to display it in the FrontPage Editor.

  3. On the File menu, choose Preview in Browser.

    Preview in Browser displays the active page in your Web browser. This lets you see exactly how the page will appear in your favorite Web browser before you publish your FrontPage web. You must have at least one Web browser installed on your system for this feature to work.

  4. In the Preview in Browser dialog box, click on the Web browser you want to use, and then click Preview.

    The home page is displayed in your Web browser. Click the buttons on the navigation bar to display the other pages in your Personal Web.

    An Faster Way to Preview Pages While Editing If you have Microsoft Internet Explorer installed on your system (see “Before You Begin”), you can immediately preview the pages in your FrontPage web by selecting the FrontPage Editor’s Preview tab.


What’s Ahead

You have been introduced to the FrontPage Explorer and FrontPage Editor, the Web site management and page editing components that make up Microsoft FrontPage.

In the FrontPage Explorer, you learned how to create a new Web site and how to add pages and apply a graphical theme.

In the FrontPage Editor, you learned how to add text and formatting to a page, and how different page components can enhance the appearance of a FrontPage web.

In Lesson 2, you will learn more about Web page design using the FrontPage Editor, including forms and form fields, image maps, and advanced hyperlinks.


Finishing Lesson 1

You can continue with Lesson 2 now, or close Microsoft FrontPage and continue the FrontPage tutorial at a later time.

Û To Close Microsoft FrontPage

  1. On the FrontPage Editor’s File menu, choose Exit.

    The FrontPage Editor closes.

  2. On the FrontPage Explorer’s File menu, choose Exit.

The FrontPage Explorer closes.


Next Steps

To | See
Learn about Web page design in the FrontPage Editor | “Lesson 2”


Web Page Design in the FrontPage Editor

In Lesson 1 of the FrontPage tutorial, you learned how to create the Personal Web and how the FrontPage Explorer and the FrontPage Editor are both used for web creation.

The FrontPage Editor is a powerful tool for designing interactive pages and creative HTML documents. As you enter text, place images, create tables and lists, design forms, and change the looks of your pages, the FrontPage Editor displays them as they will appear in a Web browser. All HTML code is created in the background and you don’t need to manually edit any code.

In the following lesson, you will use the FrontPage Editor to add a practice page to the Personal Web, where you will create and customize page elements and designs. After completing this lesson, you will have a good understanding of the FrontPage Editor’s features and capabilities.

In this lesson, you will learn how to:

  • Open a FrontPage Web

  • Add a new page

  • Add text and images

  • Save changes made to a page

  • Create an e-mail hyperlink

  • Create an image map

  • Place formatted text over images

  • Create and format a table and a numbered list

  • Add a marquee

  • Add a form

  • View and test page elements


Opening a FrontPage Web

You will use the FrontPage web you created in Lesson 1 for the remainder of this tutorial. Before you can add the Tutorial Practice page to the Personal Web, you must first open it in the FrontPage Explorer.
Note If the Personal Web is already open, skip the following steps.

Û To Open a FrontPage Web

  1. Click the Windows Start button, point to Programs, then click Microsoft FrontPage.

  2. When the FrontPage Explorer opens, choose Open an Existing FrontPage Web in the Getting Started dialog box.

  3. From the list of FrontPage Webs, choose Personal Web and click OK.

    Note Depending on the type of Web server and operating system you are using, the FrontPage Explorer may display the Name and Password Required dialog box. If you are not prompted for your name and password, skip the remaining steps below and proceed to the next section.

  4. If you are an administrator of this FrontPage web, enter your administrator name in the Name field. If you are an author of this FrontPage web, enter your author name.

    For more information about FrontPage Web permissions, see “Administering FrontPage Webs”.

  5. In the Password field, type your password, then click OK.

    The FrontPage web is displayed in the FrontPage Explorer.


Adding a Page to a FrontPage Web

The Personal Web consists of the home page and three linked pages. You learned how to add these pages to your FrontPage web using the Navigation View in the FrontPage Explorer.

You will now add a new page called “Tutorial Practice,” using the FrontPage Editor. This page will serve as a practice page on which you can freely experiment with the exercises in this lesson. When the page has been created, you will save it to your Personal Web.

Û To Add a New Page

Show FrontPage Editor button
  1. On the FrontPage Explorer’s Tools menu, choose Show FrontPage Editor or click the Show FrontPage Editor button on the FrontPage Explorer’s toolbar.

    The FrontPage Editor opens and a displays “New Page 1,” a blank page that contains common theme elements. The theme you applied to the Personal Web in Lesson 1 is automatically applied to new pages you create in the FrontPage Editor.

  2. On the FrontPage Editor’s File menu, choose Save As.

    The Save As dialog box opens.

  3. In the Title field, type Tutorial Practice.

  4. In the URL field, change the file name to tutorial.htm.

  5. Click OK to save the page to your FrontPage web.

    Note Although it has been saved to your FrontPage Web, you will not directly link the Tutorial Practice page to the other pages in the Personal Web’s structure. The Tutorial Practice page is intended as a temporary workspace for this lesson, which can be deleted when you have successfully completed the FrontPage tutorial.

Since the Tutorial Practice page used in this lesson does not require navigation bars to the other pages in the Personal Web, you will hide the shared borders before continuing with the exercises in this lesson.

Û To Hide Shared Borders and Navigation Bars

  1. On the FrontPage Editor’s Tools menu, choose Shared Borders.

    The Page Borders dialog box is displayed. In this dialog box, you can override the default border settings for the current FrontPage web.

  2. In the Page Borders dialog box, choose Set for this Page Only.

  3. Clear the Top and Left check boxes so that no borders are selected, then click OK.

The page borders and navigation bars are now hidden and only the theme’s background image remains visible.


Inserting Files

In Lesson 1, you added text to your pages by typing it on the page using the FrontPage Editor. There may be times, however, when it will be easier to transfer content to your Web pages from other documents.

With the FrontPage Editor, you can insert the following types of text files into your pages:

  • ASCII Text (TXT)

  • Rich Text Format (RTF)

  • Hypertext Markup Language (HTM or HTML)

  • Word Processing (including Microsoft Word)

  • Spreadsheet (including Microsoft Excel)

The file you will insert in this lesson is a standard text file.

Û To Insert a Text File on a Page

With the Tutorial Practice page still open in the FrontPage Editor, ensure the insertion point is at the top left of the page.

  1. On the FrontPage Editor’s Insert menu, choose File.

    The Select File dialog box is displayed. The file you want to insert is named tutorial.txt.

  2. In the Select File dialog box, change the Files of Type field to “Text Files (*.txt).”

  3. Next, navigate to the following folder (assuming you installed FrontPage in the \Program Files folder on your C:\ drive):

    C:\Program Files\Microsoft FrontPage\tutorial\

    If you changed the default installation drive or folder during FrontPage Setup, you’ll need to adjust this path accordingly.

  4. Select the file tutorial.txt, then click Open.

  5. In the Convert Text dialog box, choose Normal Paragraphs and click OK.

FrontPage imports the contents of the text file and places it on the current page.

Û To Save the Current Page

  • On the FrontPage Editor’s File menu, choose Save.

The page is saved to the current FrontPage web.


Collecting Feedback from Your Site

In Lesson 1, you learned how to create simple hyperlinks from text on a page that point to other pages in your FrontPage web. Aside from connecting pages within your FrontPage web, a hyperlink can also open pages on the World Wide Web or interact with other programs such as an electronic mail application or a newsgroup reader.

In the steps below, you will create a text hyperlink that launches an e-mail form on the user’s computer when the user clicks the hyperlink in a Web browser. This type of hyperlink is useful to request feedback from the people that view your FrontPage web after it has been published.

Û To Create an E-mail Hyperlink

  1. On the Tutorial Practice page, press the ENTER key to create some space after the inserted text.

  2. Type Please send me feedback about my Web site!

  3. Double-click the word “feedback” to select it.

    The FrontPage Editor supports standard Windows selection shortcuts.

    Create or Edit Hyperlink button

  4. Click the Create or Edit Hyperlink button on the FrontPage Editor’s toolbar.

    Toolbar buttons offer convenient shortcuts to FrontPage menu commands.

    E-Mail button

  5. In the Create Hyperlink dialog box, click the E-mail button.

  6. In the Create E-mail Hyperlink dialog box, type your e-mail address (for example, someone@microsoft.com).

    Your personal e-mail address was established for you by your Internet Service Provider when you first obtained your connection to the Internet.

  7. Click OK.

    The URL field in the Create Hyperlink dialog box should now contain “mailto:someone@microsoft.com” (where the example shown here should be your real e-mail address on your screen).

  8. Click OK.

The word “feedback” has changed text color and is now underlined to indicate the hyperlink.

Later in this lesson, you will view the Tutorial Practice page in a Web browser, where you will be able to test the hyperlink you created here.

Û To Save the Current Page

Save button
  • On the FrontPage Editor’s toolbar, click the Save button.

The page is saved to the current FrontPage web.


Creating Image Maps

In the first lesson, you learned how easy it is to place images on Web pages. Now you will create an image map — an image with one or more hyperlinks.

When an image is formatted as an image map, a user can click on certain regions of the image and trigger image “hotspots.” These hotspots launch the hyperlinks that have been added to the HTML by the FrontPage Editor.

Before you can create an image map, you must first insert the image that you will use.

Û To Insert an Image

  1. Press the DOWN ARROW key to move the insertion point to the blank line below the feedback hyperlink.

  2. On the FrontPage Editor’s Insert menu, choose Image.

    The Image dialog box is displayed.

    File button

  3. In the Image dialog box, click the File button.

    The image file you want to insert is named blackbrd.gif.

  4. In the Select File dialog box, navigate to the following folder (assuming you installed FrontPage in the \Program Files folder on your C:\ drive):

    C:\Program Files\Microsoft FrontPage\tutorial\

    If you changed the default installation drive or folder during FrontPage Setup, you’ll need to adjust the path accordingly.

  5. Select the file blackbrd.gif, then click OK.

    The blackboard image is displayed on the page.

The blackboard image you placed on the current page has a black background, which does not fit the theme’s light background image. You will now make the image border color transparent, so it will blend in with the white background color of the Tutorial Practice page.

Û To Make an Image Color Transparent

  1. Click the image of the blackboard to select it.

    An image is selected when it is outlined with rectangular file handles. When you select an image, the image toolbar is activated.

    Make Transparent button

  2. Next, click the Make Transparent button on the image toolbar.

  3. Move the mouse pointer over the image.

    The pointer changes to a pencil eraser.

  4. Click the left mouse button anywhere on the black background behind the blackboard in the image.

    The background of the blackboard image is now transparent, allowing the white background of the page to show through.

Now you will create the hotspots on the image to complete the image map.

Û To Create Image Hotspots

  1. Click the image of the blackboard to select it.

    Rectangle button

  2. Next, click the Rectangle button on the image toolbar.

    The Rectangle button creates a rectangular “hotspot” on an image. A hotspot is an area on an image that contains a hyperlink.

  3. Move the mouse pointer over the image.

    The pointer becomes a pencil.

  4. Move the pencil to the upper-left corner of the words “Interests.”

  5. Click and hold the left mouse button, then drag the rectangle until it outlines the words “Interests.”

    When you let go of the mouse button, the Create Hyperlink dialog box is displayed. If you let go of the mouse button too soon, you can always adjust the hotspot region after completing the remaining steps.

  6. In the Create Hyperlink dialog box, select the file interest.htm, then click OK.

    The text “Interests” on the blackboard image is now a hyperlink.

    Hotspots Can Be Resized If you want to adjust the size and position of the hotspot, move the mouse over the hotspot borders until you see the resize pointer (a double-headed arrow). You can then click and drag the hotspot borders into position. The associated hyperlink will be retained.

Now experiment on your own and create additional image map hyperlinks from the remaining two lines of text on the blackboard image.

Create a hyperlink from the words “Photo Album” to the page called photo.htm, and a hyperlink from the word “Favorites” to the page called favorite.htm.

Later in this lesson, you will view the Tutorial Practice page in a Web browser, where you will be able to test the image map.

Before continuing, it is a good idea to save your work. You have imported the blackbrd.gif image from your local file system onto a page. FrontPage will save this image to the FrontPage Web so it will be available later when the Personal Web is published in Lesson 3.

Û To Save the Current Page and Image

Save button
  1. On the FrontPage Editor’s toolbar, click the Save button.

  2. In the Save Embedded Files dialog box, click OK to save the image you inserted.

    The blackboard image you have placed on your current page is added to your FrontPage Web and the current page is saved.


Placing Text over Images

In the FrontPage Editor, you can place formatted text over any image. This feature is useful for creating graphical banners, labeling image buttons, and creating text on image maps.

Û To Place Text on an Image

  1. On the Tutorial Practice page, place the insertion point after the blackboard image, then press the ENTER key twice.

  2. On the FrontPage Editor’s Insert menu, choose Image.

    The Image dialog box is displayed.

  3. In the Image dialog box, select the file sunset.gif, then click OK.

    The image sunset.gif was already added to your Personal Web in Lesson 1, so you can insert it directly from your current web.

  4. Next, click the sunset image you just inserted to activate the image toolbar.

    Text button

  5. On the image toolbar, click the Text button.

    A text field with file handles and a flashing cursor appears over the center of the image.

  6. Type the word Sunset.

    The word appears centered in the text field. The default text color is black and the default font formatting is 12-point Arial Bold.

The text color is much too dark for the image you inserted. The next step is to make the text stand out from the image.

Û To Format Image Text

  1. Double-click the word Sunset to select it.

    Text Color button

  2. On the format toolbar, click the Text Color button.

    The Color dialog box appears.

  3. Click on a bright color for the image text, such as white, and then click OK.

  4. On the Format menu, choose Font.

    The Font dialog box appears.

  5. In the Font field, choose Times New Roman.

  6. In the Font Style field, choose Bold.

  7. In the Size field, choose 4 (14 pt), then click OK to apply the formatting changes.

  8. To make the larger size text fit the text box, click and drag a corner size handle until the word “Sunset” is fully displayed.

You can move the text box back to the center (or any part) of the image by clicking and dragging the word with the mouse button.

When you place formatted text over an image on the current page, FrontPage does not modify the original image. When you save the page, FrontPage stores a combination of the image and the image text in a separate, new image file.

Provided that you previously allowed FrontPage to save the original image to your FrontPage Web (by clicking Yes in the Save Embedded Files dialog box), you can revert to it at a later time.

Before continuing, it is a good idea to save your work.

Û To Save the Current Page

Save button
  • On the FrontPage Editor’s File menu, choose Save.

The page is saved to the current FrontPage web.


Creating a Table

Tables are a collection of cells that are organized in rows and columns. You can use tables to organize and group information systematically, or you can use tables with invisible borders to organize the layout on a page.

Û To Create a Table

  1. On the Tutorial Practice page, place the insertion point after the sunset image, then press the ENTER key twice to create some space.

  2. On the Table menu, choose Insert Table.

    The Insert Table dialog box is displayed.

  3. In the Rows field, enter 6.

  4. In the Columns field, enter 2.

  5. In the Border Size field, enter 0.

    You will keep the default settings for the Alignment, Cell Padding, Cell Spacing and Specify Width values. You can always go back and change these settings at a later time.

  6. Click OK.

    FrontPage creates a table with six rows and two columns.

    Table Grid vs. Table Borders When inserting a table with a border size of zero, the FrontPage Editor displays a table grid to help you design the layout of the table. This grid is only a guide; when the page is displayed in a Web browser, the table grid will not be shown.

    If you want the table to appear with borders, right-click anywhere within the table in the FrontPage Editor and choose Table Properties. In this dialog box, you can increase the Border Size value.


Entering Text in a Table

You enter text in a table by typing directly in the cells. For this exercise, you will use the table you just inserted to create a simple file description list of the pages that are part of your Personal Web.

Û To Add Text in a Table

  1. Click in the top left cell of the table and type the title of the first column:

    Web Page File Names

  2. Next, type the file names of the five pages in your Personal Web in the remaining cells in the left column. Use the DOWN ARROW key to move down to the next cell after you enter each filename.

    default.htm

    interest.htm

    photo.htm

    favorite.htm

    tutorial.htm

  3. Click in the top right cell of the table and type the title of the second column:

    Page Descriptions

  4. Next, type a brief description next to each of the five file names. Use the DOWN ARROW key to move down to the next cell after you enter each file description.

    The home page of the Personal Web

    A list of my personal interests

    Some of the cool pictures that came with FrontPage

    A list of my favorite World Wide Web sites

    The page I am practicing my tutorial lesson on

  5. Using the mouse, click and drag over “Web Page File Names” and “Page Descriptions” to select the top table row.

    Bold button

  6. On the format toolbar, click the Bold button.

    The column headers are formatted with bold type. This makes it easier to distinguish the column labels from the other cells.

  7. Next, move the mouse pointer over the middle of the table, where the vertical borders of the left and right columns meet.

    The pointer changes to a double-headed horizontal arrow.

  8. Click and hold the left mouse button and drag the column border to the left until the two columns are closer together on the page.

Dynamic table resizing is easy to do with FrontPage and works with rows as well as with columns.

Your table should now look like this:

Û To Save the Current Page

Save button
  • On the FrontPage Editor’s File menu, choose Save.

The page is saved to the current FrontPage web.


Creating Lists

Another way to group and organize information is by using lists. Web pages can have two types of lists — numbered and bulleted. Numbered lists contain text preceded by numbered steps, just like the procedures in this tutorial. Bulleted lists contain text preceded by bullets or image bullets. You use a bulleted list if the list items need not be listed in any particular order.

In Lesson 1, you created bulleted lists on the “Interests” and “Favorites” pages. You will now create a numbered list.

Û To Create a Numbered List

  1. On the Tutorial Practice page, place the cursor after the text “The page I am practicing my tutorial lesson on” in the last table cell, then press CTRL+ENTER.

    The key combination CTRL+ENTER creates a new line below the table.

  2. Press the ENTER key to create some space below the table.

  3. Select “Heading 2” from the Change Style drop-down list on the FrontPage Editor’s toolbar.

  4. Next, type Steps for using FrontPage on this line and press ENTER.

    You have created a Heading 2 text paragraph.

    Numbered List button

  5. Click the Numbered List button on the toolbar.

    FrontPage adds a new line with a “1.” at the beginning.

  6. Type Launch the FrontPage Explorer and press the ENTER key.

    FrontPage adds a new line with a “2.” at the beginning.

  7. Next, type the remaining items for the list, and press the ENTER key after each one:

    Create or open a FrontPage web

    Launch the FrontPage Editor

    Create or edit pages in your FrontPage web

    Save your changes

    Publish the FrontPage web to your Web site

  8. Press the ENTER key twice after typing the last item.

Pressing ENTER twice ends the current list.

The list you created should now look like this:

Û To Save the Current Page

Save button
  • On the FrontPage Editor’s File menu, choose Save.

The page is saved to the current FrontPage web.


Adding an Active Page Element

With FrontPage, you can add Active Page elements such as hover buttons, marquees, search forms, page counters, and video clips. These elements can make your pages more interesting and useful.

In this exercise, you will add a marquee to your current page. A marquee is a region on a page that displays scrolling text when the page is viewed in a Web browser, such as Microsoft Internet Explorer. Marquees are a fun way to create moving text and headlines on your home page. They can be used to draw attention to news and events.

Û To Add a Marquee

  1. On the Tutorial Practice page, press the ENTER key twice to create some space below the numbered list.

  2. Select “Heading 1” from the Change Style drop-down list on the FrontPage Editor’s toolbar.

  3. Type Welcome to my Personal Web!

  4. Select this text and click the Bold button on the format toolbar.

    Formatting of marquee text must occur before you insert a marquee region. If the current FrontPage web has a theme applied, text color, size, and font may change dynamically.

  5. On the Insert menu, point to Active Elements, then click Marquee.

    The Marquee Properties dialog box is displayed. In this dialog box, you can adjust several marquee properties, including the speed and direction of movement, as well as marquee size and background color.

  6. On the Background Color drop-down list, choose Navy.

  7. Click OK.

FrontPage adds a marquee region to the current page.

Later in this lesson, you will view the Tutorial Practice page in a Web browser, where you will be able to view the marquee you created here.

Û To Save the Current Page

Save button
  • On the FrontPage Editor’s File menu, choose Save.

The page is saved to the current FrontPage web.


Adding a Feedback Form

In Lesson 1, you learned how to make an e-mail hyperlink from text. Clicking this hyperlink will launch an e-mail form on the user’s computer.

Another way of collecting feedback on the World Wide Web is to place a feedback form on your page. This lets people who visit your page send you feedback without the need to open their e-mail application.

Û To Add a Feedback Form to Your Page

  1. On the Tutorial Practice page, press the ENTER key to create some space below the marquee.

  2. Type Please send me feedback about my Web site:

  3. On the Insert menu, point to Form Field, then click Scrolling Text Box.

FrontPage inserts a form containing a Scrolling Text Box and Submit and Reset push buttons.

The default properties of a feedback form specify that the submitted feedback (the form results) be saved to a default location in your FrontPage Web. In the next section, you will view the Tutorial Practice page in a Web browser, where you will be able to test the feedback form and view the saved results file.

Û To Save the Current Page

Save button
  • On the FrontPage Editor’s File menu, choose Save.

The page is saved to the current FrontPage web.


Viewing the Tutorial Page in a Web Browser

Now it is time to look at how the Tutorial Practice page you created will look in a Web browser.

Û To Preview a Page in the Web Browser

Preview in Browser button
  1. On the FrontPage Editor’s toolbar, click the Preview in Browser button.

    The Tutorial Practice page is displayed in your default Web browser.

  2. Scroll down to locate the sentence “Please send me feedback about my Web site!” and note the word “feedback.”

    The word “feedback” is displayed in color and with underline formatting. As soon as you move the mouse over the word, the pointer changes to a hand. This indicates a hyperlink you can click on.

    If you have a properly configured e-mail application installed on your computer, clicking the word will open a new e-mail message window, with your e-mail address filled in as the recipient. Type a message into the message form and send it. If no message window appears, cancel the operation by acknowledging any notifications that may appear.

  3. Next, scroll down to the blackboard image map and click on the words “Interests.”

    The hyperlink you created from the image map finds and displays the page describing your personal interests.

    5. Click your Web browser’s Back button to return to the Tutorial Practice page.

    If you created additional hyperlinks from the words “Photo Album” and “Favorites,” repeat step 3 and 4 above by clicking on the appropriate image map hyperlink. In each case, click your Web browser’s Back button to return to the Tutorial Practice page.

  5. Scroll down to the table you created.

    Note that the file names and their descriptions are properly aligned on the page. Your Web browser does not display the table grid that you saw in the FrontPage Editor while editing the table. This is because you inserted a table with a Border Size of zero.

  6. Scroll down past the marquee and locate the second occurrence of the sentence “Please send me feedback about my Web site!” (located above the Scrolling Text Box and the Submit and Reset push buttons).

    You will now test this feedback form by entering some text and submitting the comments to a form results file.

  7. Click in the Scrolling Text Box form field to activate the insertion point.

  8. Type Wow, this is really neat!

    If you make a mistake while typing, the Reset push button clears the text in the Scrolling Text Box form field. You can then start over and enter new text.

    Clicking the Submit push button processes the text in the form field and at once sends it to the default results file. You can specify the path and file name of this results file in the Form Properties dialog box.

  9. To send your comments, click the Submit push button.

    Note Depending on which Web browser you are using, a security alert may be displayed, cautioning about sending information over an unsecured connection. This is nothing to be alarmed about, as long as you haven’t entered any personal information such as credit card numbers, your telephone number, or your home address into the form field. To finish sending the comments from the Feedback form, simply acknowledge the warning message.

    After the feedback form is submitted, your Web browser will display a Form Confirmation page, advising you that the information was sent successfully.

  11. On the Form Confirmation page, click Return to the Form.

    “Return to the form” is a hyperlink which will take you back to the Tutorial Practice page in your Web browser.


Viewing the Feedback Results File

The text you entered in the feedback form while previewing the Tutorial Practice page in your Web browser is stored in a file that is added to your FrontPage web. By default, this file is located in a hidden folder that cannot be accessed by a Web browser. No one but the administrator or author of the FrontPage Web can view this information.

Û To View the Feedback Results File

  1. On your keyboard, press ALT+TAB (or click the FrontPage Explorer tile on the Windows task bar) to switch back to the FrontPage Explorer.

  2. On the FrontPage Explorer’s View menu, choose Refresh.

    The Refresh command reloads the current FrontPage Web. It is used to update the current display of files and pages that may have been added or updated while working in the FrontPage Editor.

  3. Click the Folders button on the Views bar.

  4. In the All Folders pane, click the _private folder to select it.

    By default, text submitted through the feedback form that you placed on your page in this lesson is stored in the _private folder in your FrontPage Web.

    Next, double-click the file form_results.txt file shown in the Contents pane.

  5. The file is opened and displayed in your default text editor, where you can see the text you typed into the form from the Web browser (“Wow, this is really neat!”).

  6. Close the text editor.


Finishing Lesson 2

You have successfully completed the second lesson of the FrontPage tutorial. To learn more about these and other features after you complete the third and final tutorial lesson, be sure to read the corresponding chapters in Part 3 of this manual.

Û To Exit the FrontPage Editor

  • On the FrontPage Editor’s File menu, choose Exit.

    The FrontPage Editor closes.

You can continue with Lesson 3 now, or close Microsoft FrontPage and complete the FrontPage tutorial at a later time.

Û To Exit the FrontPage Explorer

  • On the FrontPage Explorer’s File menu, choose Exit.

The FrontPage Explorer closes.


Next Steps

To | See
Learn how to organize and publish your FrontPage web | “Lesson 3”


Publishing Your FrontPage Web

In Lesson 1 of the FrontPage tutorial, you learned how to use the FrontPage Explorer to create a new FrontPage web, and how to edit its pages by adding text, images, formatted lists, and hyperlinks using the FrontPage Editor.

In Lesson 2, you created a practice page, on which you placed a text file, created a feedback form, made an image map, added a table, and inserted a marquee.

You will now return to the FrontPage Explorer to prepare your FrontPage Web for publication on the World Wide Web. Before you publish a FrontPage web, you will want to make sure your pages and files are organized, your hyperlinks are working, and your pages are free of spelling errors. The FrontPage Explorer can help you complete and track these important tasks.

In this lesson, you will learn how to:

  • Organize your files and folders

  • Check spelling on all pages

  • Find and replace text on all pages

  • Verify hyperlinks

  • View and edit the task list

  • Publish a FrontPage web


The Folders View

In Lesson 1, you learned how to use the Navigation view to create the structure of the Personal Web and how to preview and apply professional-looking graphics using the Themes view.

Now that the Personal Web has been created, and you have several pages and files in your web, you will use some of the other FrontPage Explorer views to help you organize your FrontPage web.

You can safely and easily rearrange the pages and files in your FrontPage web using the Folders view, a split-screen display of the files in your FrontPage web. Similar to the Windows 95 (or Windows NT) Explorer, the left side, called the All Folders pane, shows a hierarchical list of the folders in your FrontPage web. Clicking on a folder in the All Folders pane displays its contents on the right side, called the Contents pane.

In the following steps, you will group the Personal Web’s image files and move them to the “images” folder.

Normally, moving pages and files from one folder to another would break the hyperlinks between your pages. However, if you move files in the FrontPage Explorer’s Folders view, FrontPage updates every page and hyperlink in your FrontPage web to track the new location of files and folders that have been moved.

Û To Move Image Files to the Images Folder

  1. Open the Personal Web you created for this tutorial.

    Folders button

  2. On the Views bar in the FrontPage Explorer, click the Folders button.

  3. In the All Folders pane, select the top-level folder.

  4. In the Contents pane, click the Type column label.

    Clicking on a column label sorts the files in the Contents pane by that criteria. The first click on a column label sorts the list in ascending order; clicking it a second time sorts it in descending order.

    The list of files is now grouped by file type, with all GIF images at the top, followed by the HTM files (pages) below.

  5. In the Contents pane, click the first GIF image file at the top of the list to select it.

  6. Next, while holding down the SHIFT key on your keyboard, click the last GIF image file in the list.

    In the Folders view, FrontPage supports all standard Windows selection shortcuts, such as SHIFT+CLICK for selecting ranges of files, and CTRL+CLICK for selecting noncontiguous files.

  7. Click and hold the right mouse button while the pointer is over any of the selected GIF files.

  8. Next, drag the pointer over to the “images” folder in the All Folders pane.

  9. When the “images” folder is selected, release the mouse button and choose Move Here from the shortcut menu.

    FrontPage moves the selected GIF image files to the “images” folder and automatically updates all hyperlinks to the files in the current FrontPage web.

Similarly, you can choose to group sound files, movie clips, and other types of files in their own folders. You can create new folders in the Folders view as needed.

Û To Create a New Folder

  1. In the All Folders pane of the Folders view, click the folder in which you want to create a new subfolder.

    Folders can be expanded and collapsed in the All Folders pane to bring their subfolders into view. Click the plus (+) and minus (–) signs next to a folder’s name to display or hide its subfolders.

  2. On the File menu, point to New and then click Folder.

    FrontPage creates a new folder with a temporary name.

  3. While the folder’s temporary name (“New_Folder”) is selected, type a new name for the folder, then press ENTER.

    The new folder is renamed and you can now drag and drop files into it.


The Hyperlink Status View

The FrontPage Explorer manages hyperlinks automatically when you move or rename files and folders. It also provides commands for testing and repairing hyperlinks in your FrontPage web.

The Hyperlink Status view in the FrontPage Explorer lists the status of broken internal and all external hyperlinks in the current FrontPage web. When you choose the Hyperlink Status view, the status of internal hyperlinks is available at once, but external hyperlinks are not immediately verified because they point to pages outside of your FrontPage web and, depending on network traffic, can take a long time to verify.

Broken hyperlinks are shown with a red “Broken” status and unverified hyperlinks are shown with a yellow “Unknown” status. When an unverified or broken hyperlink has been verified or repaired, it is displayed in the list with a green “OK” status (if Show All Hyperlinks is selected from the View menu).

Note If you do not have access to the World Wide Web while taking the FrontPage tutorial, you should skip the following exercise. Verifying external hyperlinks requires an active connection to the Internet.

Save and Close Any Open Pages Before Verifying Hyperlinks FrontPage may not be able to determine the validity of hyperlinks on a page if that page is currently open in the FrontPage Editor. Before verifying hyperlinks in the FrontPage Explorer, save and then close all open pages in the FrontPage Editor.

Û To Verify Hyperlinks in the Current FrontPage Web

  1. In the Hyperlink Status view, choose Verify Hyperlinks on the Tools menu.

    The Verify Hyperlinks dialog box is displayed. In this dialog box, you can specify whether FrontPage should check all hyperlinks or selected hyperlinks only.

  2. Click Start to begin verifying all hyperlinks.

    The FrontPage Explorer’s status bar displays the current hyperlink being verified. External hyperlinks may temporarily change to a yellow “Verifying…” status to indicate that the hyperlink is being verified.

When FrontPage has finished checking hyperlinks, the FrontPage Explorer’s status bar will display the total number of broken hyperlinks.


Spell Checking

While the FrontPage Editor can check the spelling of the open page, the FrontPage Explorer can check the spelling of all (or selected) pages in the current FrontPage web.

The Spelling command works on those page elements that can be edited directly on the page. Other text, such as page titles added in the Page Properties dialog box or text contained in FrontPage components, are not included in the Spelling command.

To check the most current version of pages in your FrontPage web, you should first save and then close any open pages in the FrontPage Editor.

Û To Check Spelling in the FrontPage Explorer

  1. On the FrontPage Explorer’s Tools menu, choose Spelling.

    The Spelling dialog box is displayed. In this dialog box, you can specify whether FrontPage should check the spelling of all pages or of selected pages only.

  2. In the Spelling dialog box, leave All Pages selected and click the Add a Task for Each Page With Misspellings option.

    FrontPage will add a task to the Tasks view for each page on which misspelled text is found. You will learn about FrontPage web tasks in the next section.

  3. In the Spelling dialog box, click Start to begin the spell check.

    FrontPage displays the progress of the spell check in the Spelling dialog box.

    When the operation has been completed, “Finished checking pages” will appear and the number of tasks that were added to the Tasks view will be displayed.

  4. In the Spelling dialog box, click Close.

    The spell check is complete.


Replacing Text on Pages

The FrontPage Editor’s Replace command makes it easy to find and replace content on selected pages in your FrontPage web. Text such as page titles added in the Page Properties dialog box or text contained in FrontPage components is not included in the Replace command.

Before replacing text on pages, you should first save and then close any open pages in the FrontPage Editor.

Û To Replace Text on All Pages in the Current FrontPage Web

  1. On the FrontPage Explorer’s Tools menu, choose Replace.

    The Replace in FrontPage Web dialog box is displayed. In this dialog box, you can specify text to be found and the text it is to be replaced with. You can choose to replace text on all pages in your FrontPage web or on selected pages only.

  3. In the Replace in FrontPage Web dialog box, type the following into the Find What field:

    Welcome to my Web site

  4. Next, type the following into the Replace With field:

    Thanks for visiting my Web site

  5. Click OK.

    The Find Occurrences dialog box is displayed. In this dialog box, FrontPage reports its progress, as well as the option to proceed with the replacements.

  6. In the Find Occurrences dialog box, select “Home Page” in the list of pages and click Edit Page.

    The FrontPage Editor opens the home page and displays the Replace dialog box.

  7. Click Find Next to find the search text, then click Replace to replace the text.

    The greeting on the home page should now read “Thanks for visiting my Web site!”

  8. In the Replace dialog box, click Cancel.

    Clicking Cancel closes the Replace dialog box. It does not undo any replacements that have already been made.

  9. Save the page and close the FrontPage Editor.

    The greeting on the home page has been successfully changed.


The Tasks View

The Tasks view displays the list of all outstanding tasks associated with a FrontPage web. Tasks are items that need your attention before you publish a FrontPage web.

In the previous exercises, you added tasks to a list when you deferred certain actions. For example, when you checked the spelling of the pages in your FrontPage web, you chose to add a new task for each page containing misspellings. By adding tasks to the list, you can complete corrections all at once.

If you are working in a web development environment, such as an intranet, the Tasks view makes it easy to track tasks and assign them to the correct authors.

Û To Complete a Task in the Tasks View

  1. On the Views bar in the FrontPage Explorer, click the Tasks button.

    Tasks button

    The task list is displayed.

  2. In the task list, click the Modified Date column label.

    The list is sorted by the date the tasks were modified.

    You can sort tasks by Status, Task, Assigned To, Priority, Linked To, Modified Date, and Description.

  3. Find the first task on the list that reads “Fix Misspelled Words” and double-click that task to open it.

    The Task Details dialog box is displayed. This dialog box provides a summary of the task you’re viewing. You can set the priority of the task, assign it to another FrontPage author on your network, or complete the task and remove it from the list.

  4. In the Task Details dialog box, click Do Task.

    The FrontPage Editor is displayed and the first misspelled word is highlighted.

  5. In the FrontPage Editor, correct the spelling on the page, then save and close the page.

Although it is not required that you complete every task before publishing your FrontPage web, it is a good idea to review this list when you are finished making changes to your FrontPage web. The Tasks view helps you manage your FrontPage web by flagging important reminders for you.


Publishing the Personal Web

When your FrontPage web is ready to be published on the World Wide Web — or on your company’s intranet — the FrontPage Explorer makes it easy for you to transfer the pages and files to the World Wide Web while automatically verifying the addresses of pages and the paths to your files.

Note If you do not want to actually publish the Personal Web to your Web server, you can use the following exercises as reference without actually completing the steps.

Û To Publish the Current FrontPage Web

  1. Close all open pages in the FrontPage Editor.

  2. Publish button

  3. In the FrontPage Explorer, click the Publish button on the toolbar.

    The Publish FrontPage Web dialog box is displayed. In this dialog box, specify the location on the World Wide Web or your corporate intranet to which you want to publish your FrontPage web. You need Internet access through an Internet Service Provider before you can publish to the World Wide Web.

    Your Internet Service Provider can tell you this information. See also “Create Your Web Site with Microsoft FrontPage 98”.

  4. In the Publish FrontPage Web dialog box, click OK.

    The FrontPage Explorer publishes the FrontPage web from your computer to the intranet Web server or World Wide Web server you specified.

If FrontPage detects that you are publishing to a Web server that does not have the FrontPage Server Extensions installed, it will launch the Microsoft Web Publishing Wizard to publish your FrontPage web via the FTP file transfer protocol.

If the Web server to which you are publishing your FrontPage web has the FrontPage Server Extensions installed, your FrontPage web will have full functionality when it is published.

If you publish your FrontPage web to a Web server that does not have the FrontPage Server Extensions installed, certain FrontPage Components, such as the Search component, will not work.


Finishing Lesson 3

Congratulations, you have successfully completed the FrontPage tutorial. You are now ready to create and design your very own FrontPage webs.

Û To Close Microsoft FrontPage

  1. On the FrontPage Editor’s File menu, choose Exit.

    The FrontPage Editor closes.

  2. On the FrontPage Explorer’s File menu, choose Exit.

The FrontPage Explorer closes.


Next Step

To | See
Read about the Internet and the World Wide Web | “FrontPage and the World Wide Web”


The Internet

The Internet is a computer network that connects millions of computers globally and provides world-wide communications to businesses, homes, schools, and governments.

The Internet has grown explosively in the 1990s. There are now more than twelve million server computers on the Internet, each providing some type of information or service. The number of users of the Internet is more difficult to measure. Since each service on the Internet is used by many people, many millions of users are currently online. The number of users and services on the Internet continues to grow as the variety of the services increases.

Perhaps the most popular Internet service, the World Wide Web, has accelerated the growth of the Internet by giving it an easy to use, point and click, graphical interface. Users are attracted to the World Wide Web because it is interactive, because it is easy to use, and because it combines graphics, text, sound, and animation into a rich communications medium.


How the Internet Began

The beginning of Internet technology can be traced to 1969, when the Advanced Research Projects Agency, funded by the U.S. Department of Defense, conducted research on networking. Their goal was to design a network that allowed computers on different types of networks to communicate with each other.

During the 1960s and 1970s, many computer networking technologies were created, each based on a particular hardware design. Some of these networks, called Local Area Networks (LANs), connect computers over short distances, using cables and hardware installed on each computer. Other larger networks, called Wide Area Networks (WANs), connect many computers over larger distances, using transmission lines similar to those used in telephone systems.

Although LANs and WANs made it much easier to share information within organizations, the information stopped at the boundaries of each network. Each networking technology moved information around in a different way, often based on the design of its hardware. A particular LAN technology could only work with specific computers, and most LAN and WAN technologies were incompatible with each other.

The Internet was designed to interconnect the different types of networks and allow information to move freely among users, regardless of the machines or networks they used. It did this by adding special computers, called routers, to connect LANs and WANs of different types. The connected computers needed a common protocol, a shared set of rules describing how to transmit data. The new networking protocol was called TCP/IP. Together, TCP/IP and the system of connected networks formed the Internet.


TCP/IP

TCP/IP is the software used on the Internet to pass information from machine to machine and from network to network. It contains two components, Internet Protocol (IP) and Transmission Control Protocol (TCP).

IP breaks up information and puts it into software packets that can move across networks. As long as machines on each end of the connection understand IP, they can accept packets from other computers and they can send packets along. A computer that wants to send information on the Internet uses IP to divide the information into packets. A computer that receives information reassembles it from the packets it receives.

TCP works with the IP protocol to guarantee that information is transmitted correctly across the Internet. The TCP software makes sure that the packets of information get properly reassembled when they reach their Internet destination. TCP also requests that lost or damaged packets be resent to the destination computer.


IP Addressing

Each computer on the Internet is assigned a unique numerical address, called its IP address. Each packet moving around the Internet contains the IP addresses of the sender computer and the destination computer. Using the IP addresses, the routers move the packets across the Internet until they reach their destination machines.

Where does your IP address come from? When an organization connects to the Internet, it gets a set of IP addresses from the Internet authority. Your Internet service provider or system administrator will assign your machine an IP address. If you are using a PPP/SLIP account, your PPP/SLIP provider will assign your computer an IP address.


Servers and Clients

Every computer program that communicates on the Internet is either a server or a client.

A server offers a service to other machines on the network. For example, a file server contains files of interest to users around the network — the service it offers is the storage and retrieval of the files. There are thousands of file servers on the Internet, some offering files of a particular type, such as artwork (a file can contain an image), weather maps, or tourism information.

A client requests a service from a server. Most services are designed so that specialized client software must be running to interact with the server. For example, to get a file from a file server, a client program on your machine must format and send the request to a program running on the server. The server program locates the file on the server machine and sends a copy of it back to the client program which saves it or opens it for immediate use. The client and the server use a common method for communicating and for passing the file from one machine to another, called a protocol.


What’s on the Internet?

Here are some of the popular services on the Internet:

FTP (File Transfer Protocol) FTP is an Internet service that transfers files from one computer to another. Some FTP servers require that you obtain an account before you have permission to copy files from the server. Other FTP servers have a special account, called “anonymous,” through which unregistered users can access files on the servers.

electronic mail (e-mail) Electronic mail is the postal system of the Internet. It lets you send text messages to any recipient that has an e-mail address. Modern e-mail services allow the embedding of sound, video, and image files in e-mail messages.

bulletin boards Bulletin boards, also called newsgroups or discussion groups, work similarly to electronic mail. However, instead of writing messages to individual users, participants in a bulletin board post their messages to a news server. On the news server, messages called articles are stored, often in hierarchical directories. Users participate in bulletin board services by reading messages and posting responses to them. Client software that can view a bulletin board service is called a newsreader.

Gopher Gopher is an Internet browsing service organized as a series of menus. Gopher menu items can be files on the current server or they can point to menus on other Gopher servers. By navigating a series of Gopher menus, you travel around the Internet until you locate the information that you want.

World Wide Web The World Wide Web is the most popular and fastest growing Internet service. It uses hypertext links called hyperlinks to locate and retrieve pages from World Wide Web servers. World Wide Web pages combine sound, graphics, animation, text, and software programs into dynamic documents. Users view the World Wide Web from Web browsers, client programs that can display the HTML (HyperText Markup Language) in which pages are written.


Intranets

An intranet is a network that exists exclusively within an organization and that is based on Internet technology. It delivers an organization’s informational resources to each member’s desktop quickly and inexpensively but protects the information from unauthorized access. Because an intranet is based on Internet technology, it can have thousands of users across many locations and still be private.

An intranet can be set up inside a firewall, a software mechanism that blocks unwanted access to the intranet from outside while giving the users of the intranet access to the global Internet.

Some of the ways organizations use intranets are:

  • To give access to databases

  • To distribute and upgrade software

  • To distribute electronic documentation

  • To provide a forum for discussions

  • To offer online training

  • To administer payroll and benefits packages

Using World Wide Web technology, an organization can make its intranet easy to use. Microsoft FrontPage is an ideal tool for creating, maintaining, and administering intranets.


Next Steps

To | See
Learn more about the World Wide Web | “Welcome to the World Wide Web”
Start learning about Microsoft FrontPage | “FrontPage Webs and the Microsoft FrontPage Explorer”


Welcome to the World Wide Web

The World Wide Web is the graphical Internet service that provides a network of interactive documents and the software to access them. It is based on documents called pages that combine text, pictures, forms, sound, animation, and hypertext links called hyperlinks. To navigate the World Wide Web, users “surf” from one page to another by pointing and clicking on hyperlinks in text or graphics.

The World Wide Web is many things to its millions of users. It is used as a marketplace, art gallery, library, community center, school, publishing house, and whatever else its authors, including you, create.


Pages

The basic document of the World Wide Web is a page. Pages are written in an evolving language called HTML (Hypertext Markup Language). An HTML page contains text along with tags, embedded commands that supply information about the page’s structure, appearance, and contents.

Some HTML tags build structural descriptions of page items, such as tables and forms, which are made up of many elements. Web browsers (programs that display pages) use this information to determine how to display the page elements in relation to each other. For example, the HTML tags that describe a table specify the number of rows it has, the number of cells in a row, and so forth.

Along with describing the structural relationships among page elements, some HTML tags also contain attributes. Attributes provide details about a particular tag. For instance, the tag that inserts an image on a page has an attribute that supplies the name of the image to insert. Some attributes supply preferences about the layout of the page element. For example, a table has attributes that describe its border width and the padding between its cells.

Do I need to learn HTML to use FrontPage? No. The FrontPage Editor creates the HTML in the background, adding tags and filling in attributes based on your choices. You create and edit pages using a familiar, word-processor interface. You can add or edit HTML by hand, but only if you want to.

How do I change an element’s attributes in FrontPage? In FrontPage, every item that you can insert on a page has a dialog box displaying its properties. You can edit an item’s properties dialog box to change its attributes. When you close the properties dialog box, FrontPage translates your selections into HTML.

What is a home page? A home page is the top-level page on your Web site and usually contains an introduction to the site, along with hyperlinks to other pages. It is displayed by default when a user connects to your Web server. Some Web servers support multiple home pages.


Web Browsers and Web Servers

Because it is an Internet service, the World Wide Web is based on clients and servers. A World Wide Web client is called a Web browser or simply a browser, and a World Wide Web server is called a Web server or sometimes just a server. Web browsers and Web servers use a set of communications rules called Hypertext Transfer Protocol (HTTP).

A Web browser is a program that navigates through the World Wide Web and displays pages. The Web browser requests a page from a server based on its Internet address. It retrieves the document from the server and displays the contents.

As HTML evolves, Web browsers are evolving with it, adding more advanced functionality. For example, Microsoft Internet Explorer displays ActiveX Controls and runs VBScript programs and Java applets.


All Web Browsers Do Not Display HTML in the Same Way

HTML tags and attributes are interpreted differently by different types of Web browsers. The appearances of the various page elements may differ from Web browser to Web browser. However, the structural relationship between elements will be the same — table cells will be inside their rows, and headings will appear larger than the paragraphs that follow them.

When editing in FrontPage, you can preview a page in a Web browser using the Preview in Browser command. When you choose this command, it opens the Preview in Browser dialog box which lists the Web browsers installed on your computer. Select a Web browser and FrontPage launches it with the current page displayed.

A server on the World Wide Web stores pages and sends them to a browser when requested. Web servers are not simply file servers, however. They also run programs, called Common Gateway Interface (CGI) programs or CGI scripts, based on requests from Web browsers.

CGI scripts run on the server and usually return some HTML for the Web browser to display. For example, when a user fills in a form on a page to register for a service, the form is often processed by a CGI script that could:

  • Enter the user’s name and other information into a database on the server

  • Compose an HTML page that thanks the user by name for the information

Send the page back to the Web browser to be displayed

Do I need to create my own CGI scripts? No. Built-in FrontPage components provide rich functionality that would otherwise require complex CGI programming. Insert them on your page to add interactive features such as navigation bars, threaded discussion groups, full text searches, and form processing.


Hyperlinks

A hyperlink is a pointer from a World Wide Web page to another file on the World Wide Web. The destination of the hyperlink is most often another World Wide Web page, but it can also be a multimedia file or even a program.

Hyperlinks are embedded directly in text or images on a page, and they give textual or graphical cues about where they lead. For example, a text hyperlink from the phrase “Microsoft FrontPage” and an image hyperlink from the Microsoft FrontPage logo both would indicate that the hyperlink goes to a page describing Microsoft FrontPage.

Web browsers usually underline text hyperlinks and display them in a specific color. Hyperlinks in images are usually invisible. However, users can tell when the pointer is over a hyperlink because it changes appearance, usually to a pointing hand.

When a user clicks on a hyperlink to a page, the browser gets the page from the correct server and displays it. When a user clicks a hyperlink to another type of file, the browser gets the file from the server and opens it in an associated program. For example, most Web browsers open WAV files in a sound-playback application.


URLs

A Uniform Resource Locator (URL) gives the location of a file on the World Wide Web and also identifies the Internet service, such as FTP or the World Wide Web, that will handle the file. When a hyperlink is inserted on a page, the destination of the hyperlink is encoded as a URL.

The first part of a URL is the protocol, which tells a Web browser the Internet service that will handle the file. A protocol is separated from the rest of the URL by a colon. Some of the protocols you can use in FrontPage are:

  • ftp This indicates that the file is on an FTP server. A sample ftp URL is ftp://ftp.microsoft.com/file.doc

  • mailto This indicates a person’s e-mail address. A sample mailto URL is mailto:someone@microsoft.com. When a user clicks a mailto URL, the Web browser opens an e-mail form addressed to the specified person.

  • file This indicates that the file is in the file system of a computer on the network. A sample file URL is file://sample.host/file.doc, which indicates that the file is on the network computer sample.host. The URL file:///dir/file.doc does not specify a computer. It indicates that the file is on the same computer as the Web browser.

  • http This indicates that the file is on a World Wide Web server. A sample http URL is http://www.microsoft.com/index.htm

Since you will be doing most of your hyperlinking using the http protocol, let’s examine http URLs in more detail.

The second part of an http URL is the network location, which is a unique name that identifies an Internet server. A network location has two or more parts, separated by periods, as in www.microsoft.com

The third part of an http URL is the path. The path identifies the folders containing the file. If a file is stored in the root folder of a server, its URL will not have a path.

The fourth part of an http URL is the file name. If there is no file name, the Web browser looks for a default page, usually named index.htm

After the file name, an http URL can have a bookmark. A bookmark is a named location on a page that can be the target of a hyperlink. A bookmark can be applied to a set of characters or it can exist on a page separately from any text. When a Web browser hyperlinks to a bookmark, it displays the page starting at the location of the bookmark. In a URL, a bookmark is preceded by a number sign character, as in http://www.microsoft.com/index.htm#mark

Any URL can be absolute or relative. An absolute URL is the full Internet address of a page or file, including the protocol, network location, and optional path and file name. For example, http://www.microsoft.com/news.htm is an absolute URL.

A relative URL is a URL with one or more of its parts missing. Web browsers take the missing information from the page containing the URL. For example, if the protocol is missing, the Web browser uses the protocol of the current page, and if the network location is missing, the Web browser uses the current page’s network location.

The most common type of relative URL has only a partial path and a file name, but no network location. If a page uses this type of relative URL to hyperlink to another page and both pages are moved to another server, the hyperlink will still work if the relative positions of the pages remains the same on the new server. For example, the relative URL products.htm points to a page in the same folder as the page containing the hyperlink. If both pages are moved to the same folder on a different server, the URL will still be correct.

FrontPage generates relative URLs automatically when you create hyperlinks between pages in your FrontPage web. If you rename or move a page, FrontPage updates all the relative URLs in your FrontPage web that point to that page. By automatically generating all relative URLs, FrontPage saves you time and ensures that your Web site will be portable.


Next Steps

To | See
Learn more about FrontPage webs | “FrontPage Webs and the Microsoft FrontPage Explorer”
Learn more about pages | “The Microsoft FrontPage Editor”
Learn more about hyperlinks | “Creating Hyperlinks and Bookmarks”


FrontPage Webs and the Microsoft FrontPage Explorer

The Microsoft FrontPage Explorer is a tool for creating, organizing, administering, and publishing FrontPage webs. Using the FrontPage Explorer, you create the structure or layout of your Web site, arrange its files and folders, import and export pages and files, test and repair hyperlinks, administer access privileges, and launch the FrontPage Editor to design and edit the contents of your Web pages.

You also use the FrontPage Explorer to publish completed FrontPage webs on your computer, your organization’s intranet, or the World Wide Web.

A FrontPage web contains HTML pages, images, documents, and other files and folders that make up a Web site. Authors can create, delete, open, edit, and close FrontPage webs using the FrontPage Explorer and FrontPage Editor on a client computer. FrontPage webs can be stored on a remote Web server, a Web server running on the same computer as the client program, or in the client computer’s file system.

A FrontPage web also contains a number of support files that provide added functionality with sophisticated features such as navigation bars, hyperlink recalculation and repair, full text index generation, consistent design elements from themes, automatic table of contents generation, and built-in forms handling.

In order to fully benefit from certain FrontPage components, you should create and maintain FrontPage webs on a Web server that has the FrontPage Server Extensions installed. These are a set of programs and scripts that support FrontPage authoring and extend the functionality of your Web server.

Root Web vs. Sub-Webs In FrontPage, the root web is a top-level web stored on a Web server or in a folder on a computer’s file system. It is called <Root Web> by default. Authors and administrators can open the root web in the FrontPage Explorer; users can browse to the root web by supplying the address of the Web server in a Web browser (without specifying the name of a specific page or sub-web), such as http://localhost.

All other FrontPage webs are stored below the root web, as sub-webs. A sub-web is a complete FrontPage web that is a subdirectory of the root web. Sub-webs can only exist one level below the root web. Each sub-web can have many levels of subdirectories, making up its content.


What Can You Do in the FrontPage Explorer?

Here are some of the key features of the FrontPage Explorer:

Create FrontPage Webs FrontPage includes web templates and wizards that help you create professional-looking Web sites. For example, you can create a corporate presence on the World Wide Web with the Corporate Presence Wizard; launch a Customer Support site with the Customer Support Web template; host a discussion group with the Discussion Web Wizard; or publish a project management web with the Project Web template.

Import Existing Web Sites If you have an existing Web site, you can easily convert it to a full-featured FrontPage web with the FrontPage Explorer’s Import Web Wizard.

In a few steps, this wizard imports your pages, images, and files, while preserving the web’s structure as well as its hyperlinks.

Import and Export Files You can import files to your FrontPage web. You specify a folder in your file system to import its contents. You can also export files from your FrontPage web to your file system.

Display FrontPage Web Structure You can display and maintain the files, folders, hyperlinks, and layout of a FrontPage web by selecting any of the FrontPage Explorer’s seven views. Each view gives you a different perspective of a FrontPage web, designed to assist you in maintaining FrontPage webs from their creation until their publication to a Web server.

Apply Shared Borders and Navigation Bars In the FrontPage Explorer, you can apply one or more shared borders — page regions that are reserved for content that is to appear consistently throughout your pages. Shared borders usually contain navigation bars — hyperlinks to the other pages in the current FrontPage web. When you create a FrontPage web in the FrontPage Explorer’s Navigation view, FrontPage can create shared borders and navigation bars that are automatically updated whenever you add, move, or delete pages from the web’s structure.

Apply a Theme FrontPage includes a gallery of professionally designed graphics and color schemes — called themes — that can be applied to any FrontPage web. Themes enhance the appearance of list bullets, fonts, navigation bars, horizontal lines, and page backgrounds, and they lend an attractive and consistent appearance to any FrontPage web.

Launch the FrontPage Editor and Other Applications Double-click an HTML page in the FrontPage Explorer and it will open for editing in the FrontPage Editor. In the FrontPage Explorer, you can also associate other editors for other file types in your FrontPage web. When you double-click a file that has been associated with an editor, it will open in that editor.

Publish FrontPage Webs When your FrontPage web is ready to be published on the World Wide Web — or on your organization’s intranet — the FrontPage Explorer’s Publish command transfers the pages and files to the World Wide Web or a Web server while automatically verifying the addresses of pages and the paths to your files.

Test and Repair Hyperlinks If you use the FrontPage Explorer to rename or move a file in your FrontPage web, all hyperlink references to that file are automatically updated within the FrontPage web, including hyperlinks from Microsoft Office 97 documents. You can also verify and repair broken hyperlinks, including hyperlinks to external World Wide Web sites. In a multi-authoring environment, you can refresh hyperlinks to incorporate and view recent changes made to the FrontPage web by other authors.

Track Tasks Using the Tasks view in the FrontPage Explorer, you can track and complete any unfinished FrontPage web tasks (such as spell-checking corrections) on all pages. Clicking a task can take you right to the page that needs work. Some tasks are generated automatically as you create and maintain a FrontPage web; you can add other tasks and assign them to other FrontPage authors.

Administer FrontPage Webs In multi-user environments, you can protect a FrontPage web from unauthorized access by requiring a logon username and password for browsing or authoring access.


Opening a FrontPage Web

When you first open the FrontPage Explorer, it displays the Getting Started dialog box, a quick starting point from which you begin your work in FrontPage.

Previously opened FrontPage webs will appear in the list of recently opened webs in this dialog box. Select a FrontPage web from the list and click OK to open it.

If the FrontPage web you want to open is not yet on the list, click the More Webs button. This will display the Open FrontPage Web dialog box, where you can select a Web server or disk location from the drop down list (or type a new location directly into the field). Click the List Webs button to find all FrontPage webs at that location. To open a FrontPage web, double-click its name in the list.


Creating FrontPage Webs

You create new FrontPage webs in the New FrontPage Web dialog box, which is displayed by choosing Create a New FrontPage Web in the Getting Started dialog box, or by choosing New FrontPage Web on the FrontPage Explorer’s File menu.

Click the wizard or template you want to use to view a description of it just below the list box.

In the New FrontPage Web dialog box, you have three options for creating a new FrontPage web:

  • One Page Web creates a FrontPage web with a single page (the home page). Use this option to create a new web site from scratch, with no generic or pre-existing content.

  • Import an Existing Web will launch the Import Web Wizard, which is used to import an existing web into a new FrontPage web. The wizard will guide you through the process of importing an existing Web site.

  • From Wizard or Template lists the web wizards and web templates you can choose from to create a new FrontPage web with suggested content.

A web wizard is an interactive tool that guides you through the creation of a FrontPage web. Based on your responses to a series of questions, web wizards create professional-looking, but generic FrontPage webs that you can customize. If applicable, FrontPage webs created by wizards may contain pre-designed forms, tables, images, navigation bars, hyperlinks, and other page elements.

A web template is a generic FrontPage web, modeled after popular World Wide Web site styles. You customize a FrontPage web created from a web template by adding, deleting, or editing its pages as needed.

Adding Custom FrontPage Web Wizards and Templates With the Microsoft FrontPage Software Developer’s Kit, you can create custom FrontPage web wizards and templates and add them to the FrontPage Explorer’s New FrontPage Web dialog box.

The FrontPage Software Developer’s Kit is available in the \SDK folder on the Microsoft FrontPage 98 CD-ROM.


FrontPage Explorer Views

Views in the FrontPage Explorer provide different ways of looking at your FrontPage web, so that you can effectively manage your site.

You can choose the view that best suits your needs — from the early steps of web creation, to the moment your FrontPage web is ready to be published on the World Wide Web.

You can choose to display:

  • the file and folder structure of your FrontPage web

  • a complete listing of all the files in your FrontPage web

  • the navigation layout of your FrontPage web

  • the hyperlink relationships in your FrontPage web

  • the status of internal and external hyperlinks

  • the gallery of FrontPage themes that can be applied

  • a list of web tasks for the current FrontPage web

The seven buttons on the FrontPage Explorer’s Views bar provide a quick way to switch the display of your FrontPage web.


The Folders View

To display the file and folder structure of a FrontPage web, choose the Folders view. In this view, you can manage files and folders much in the same way as you would in the Windows 95 (or Windows NT) Explorer.

The left side of the Folders view, called the All Folders pane, shows a hierarchical list of the folders in your FrontPage web. Clicking on a folder in the All Folders pane displays its contents in the Contents pane. Using the plus (+) and minus (–) signs in the All Folders pane, you can expand and collapse folders to show or hide their subfolders.

The Contents pane displays information about the individual files. Clicking on a column header sorts the list by that column; clicking the column header a second time reverses the sort order.

You can right-click any file to display a shortcut menu, from which you can open, cut, copy, rename, or delete the selected file. From the shortcut menu, you can also view properties or add a web task for the selected file.

To arrange files and folders, simply drag and drop them between folders using the mouse. You can drag and drop single files or any selection of files. When you move or rename files or folders, FrontPage will update any hyperlinks that point to them.


The All Files View

Choose this view to see a complete list of all the files in the current FrontPage web, including information about each individual file. The All Files view does not show folders, but lists all of the files located in the folders and subfolders of your FrontPage web. Clicking on a column header sorts the list by that column; clicking the column header a second time reverses the sort order.

You can right-click any file to display a shortcut menu, from which you can open, cut, copy, rename, or delete the selected file. From the shortcut menu, you can also view properties or add a web task for the selected file.


Navigation View

The Navigation view is most useful for constructing a new Web site, because it provides a graphical outline of your site’s structure and can automatically create navigation bars that point to the most important pages in your FrontPage web.

The Navigation view has a split-screen view that displays the structure of your FrontPage web in the upper half of the screen (the Navigation pane), and a familiar Windows Explorer-like file and folder list in the lower half of the screen (the Files pane).

The structure of the FrontPage web is displayed as a diagram, similar to an organizational chart. The home page is at the top, with its linked pages on the next levels.

For larger Web sites, creating a consistent and intuitive structure can take hours of work. If you create your FrontPage web in the Navigation view, then FrontPage can do this work for you.

To learn more about the Navigation view and how a FrontPage web structure is created, take “The FrontPage Tutorial”.


Hyperlinks View

This view displays the hyperlinks connecting your pages and files, and a hierarchical list of the pages in your FrontPage web — starting with the home page. The title of each page is displayed to the right of each page icon.

When you click a file or page in the left pane (the All Pages pane), it becomes the center of the right pane (the Hyperlinks pane). All of the pages and files that are the targets of the page’s hyperlinks are displayed to the right of the page or file, and the hyperlinks are drawn as arrows to the pages or files. If a page or other document that is the target of a hyperlink has a plus sign next to it, you can expand the view and display the hyperlinks from it by clicking the plus sign. Clicking a minus sign collapses the view of a page or document’s hyperlinks.

The Hyperlinks pane also indicates the images on a page and the files that are included on a page by displaying a line between the page and the included images or files.

Hyperlink Details You can obtain more information about a hyperlink by pointing to it in the Hyperlinks pane of the Hyperlinks view. A tool tip will appear, which describes the type of the hyperlink (such as “Hyperlinks for ‘Default.htm’” or “Broken Hyperlink”).


Hyperlink Status View

For a report on the status of the hyperlinks in the current FrontPage web, choose this view. Internal hyperlinks point to pages or files in the current FrontPage web, while external hyperlinks point to pages, sites, or files outside of your FrontPage web or local file system.

When you switch to the Hyperlink Status view, internal hyperlinks are verified at once and displayed only if they are broken. External hyperlinks, however, are not immediately verified because they point to pages outside of your FrontPage web and, depending on network traffic, can take a long time to verify.

Broken hyperlinks are shown with a red “Broken” status and unverified hyperlinks are shown with a yellow “Unknown” status. When an unverified or broken hyperlink has been verified or repaired, it is displayed in the list with a green “OK” status. You can use the Verify Hyperlinks command on the FrontPage Explorer’s Tools menu to verify external hyperlinks in your FrontPage web.

Once you have verified all of the hyperlinks in your FrontPage web, you can use the Hyperlink Status view to repair any broken hyperlinks. You can edit each hyperlink directly, edit the page containing the hyperlink, or add a web task to fix the hyperlink. These options are available from the Edit Hyperlink dialog box, which is displayed when you double-click a broken hyperlink in the FrontPage Explorer’s Hyperlink Status view.

For more information, see “Creating Hyperlinks and Bookmarks”.


Themes View

Use this view to preview and apply professional-looking graphics to your FrontPage web. A FrontPage theme consists of unified design elements and color schemes for bullets, fonts, images, navigation bars, and other page elements. When applied, a theme gives the pages and navigation bars in your FrontPage web an attractive and consistent appearance.

The Theme Preview pane in the Themes view lets you preview sample page elements as they will appear on your Web pages. You can preview a theme before applying it by selecting it from the list of available themes. FrontPage includes over 50 themes.

Before applying a theme, you can select options that change the appearance of the theme’s components. For example, selecting Vivid Colors will apply brighter colors to text and graphics, selecting Active Graphics will animate certain theme components, and selecting Background Image will apply a textured background image to the pages in your FrontPage web.


Tasks View

This view displays a list of tasks associated with a FrontPage web. Tasks are items that may need your attention before you publish your FrontPage web. If you are working in a multi-user environment, such as an intranet, you can assign tasks to other authors.

You can add tasks to the Tasks view, as well as modify task names, descriptions, and who the task is assigned to. Certain FrontPage Explorer web wizards and some of the FrontPage Editor’s commands can add tasks and link them to the appropriate page or file. For example, when you check the spelling in the pages in your FrontPage web, you can choose to add a new task for each page containing misspellings. You can open the pages that require corrections by double-clicking a task, and then clicking Do Task in the Task Details dialog box.

To monitor all tasks in a FrontPage web — including completed tasks — you can enable Task History from the FrontPage Explorer’s Views menu while in the Tasks view.

While it is not necessary to complete every task before you publish your FrontPage web, it is a good idea to review the list of tasks when you are finished making changes to your FrontPage web. The Tasks view helps you manage your FrontPage web by flagging important reminders for you.

Shared Borders and Navigation Bars

Shared borders are a useful way to present recurring information in a consistent manner. In the FrontPage Explorer, you can specify that one or more shared borders be included on all pages that are part of the FrontPage web’s navigational structure (as displayed in the Navigation view). You can also add shared borders for individual pages, using the FrontPage Editor.

If you enable shared borders, FrontPage will automatically create navigation bars that help users navigate your Web site.


Shared Borders

Shared borders are typically used on every page in a FrontPage web. When you edit the contents of a shared border, the changes apply to all pages in the current FrontPage web that use shared borders. For example, adding your name (or the name of your organization) to the Top shared border on one page will cause all other pages in that FrontPage web to display the same name, in the same location.

If a FrontPage web is not created in the Navigation view, you can enable shared borders by choosing Shared Borders on the Tools menu in the FrontPage Explorer. In the Shared Borders dialog box, select the shared borders you want to include on your pages (top, left, right, and/or bottom).

Note You cannot insert Shared Borders on a frames page.

You can edit the contents of shared borders in the FrontPage Editor, where you also have greater control over the visual appearance of shared borders. For more information, see “The Microsoft FrontPage Editor”.

Navigation Bars

To navigate through your Web site, users will follow hyperlinks in a Web browser from one page to another. FrontPage manages these hyperlinks for you with navigation bars —page regions that provide access to other pages in your FrontPage web, using textual or graphical hyperlinks.

Navigation bars can be added automatically when you create a new FrontPage web in the FrontPage Explorer’s Navigation view, or when you create a FrontPage web from a web wizard or template. You can also insert navigation bars on individual pages using the FrontPage Editor. For more information, see “The Microsoft FrontPage Editor”.

Typically, navigation bars are placed inside a shared border, which displays the navigation bar on every page in the FrontPage web that includes that shared border. If you change the FrontPage web’s structure in the FrontPage Explorer’s Navigation view, FrontPage will update the hyperlinks on the navigation bar automatically.


Publishing a FrontPage Web

When your FrontPage web is ready to be published on the World Wide Web — or on your organization’s intranet — the FrontPage Explorer’s Publish command will publish the pages and files to the Web server you specify, while automatically verifying the addresses of your pages and the paths to your files.

When you press the Publish button on the FrontPage Explorer’s toolbar (or select Publish FrontPage Web from the FrontPage Explorer’s File menu), the Publish FrontPage Web dialog box is displayed.

In this dialog box, you specify the location on the World Wide Web (or the location of your organization’s intranet Web server) to which you want to publish your FrontPage web. You need Internet access through an Internet Service Provider before you can publish to the World Wide Web. Your Internet Service Provider will give you an Internet address (a URL) to publish to. See also “Create Your Web Site with Microsoft FrontPage 98”.

If the Web server to which you are publishing your FrontPage web has the FrontPage Server Extensions installed, then your FrontPage web will have full FrontPage functionality when it is published.

If FrontPage detects that you are publishing to a Web server that does not have the FrontPage Server Extensions installed, some FrontPage Components, such as the FrontPage Search Form, will not work. If the FrontPage Server Extensions are not present on the target Web server, FrontPage launches the Microsoft Web Publishing Wizard, which will publish your FrontPage web via the FTP file transfer protocol. All hyperlinks to pages and files will be retained.


Administering FrontPage Webs

If you create and edit FrontPage webs directly on a World Wide Web or intranet server, FrontPage offers a set of useful administrative tools for setting web permissions and limiting access to FrontPage webs from specified computers.

You set permissions for a FrontPage web in the FrontPage Explorer, using the Permissions command on the Tools menu. This displays the Permissions dialog box.

For each FrontPage web on your Web server, you can set the following types of permissions:

  • Browsing permission gives a user, group of users, or specific workstations permission to view the FrontPage web after it has been published on the World Wide Web or your organization’s intranet.

  • Authoring permission gives a user, group of users, or specific workstations permission to open the FrontPage web in the FrontPage Explorer and edit pages and files in the FrontPage Editor.

  • Administering permission gives a user, group of users, or specific workstations permission to administer the current FrontPage web. An administrator can set permissions for other users and computer workstations.

    Web Permissions and the Root Web The root web is the top-level web on your Web server. All other FrontPage webs on the Web server inherit their permissions from the root web by default. In the FrontPage Explorer, you can assign unique permissions for any FrontPage web in the Settings tab of the Permissions dialog box.

FrontPage web permissions are hierarchical. This means that a user with administrative permissions also has authoring and browsing permissions; a user with authoring permissions also has browsing permissions. When you set permissions for administering, authoring, or browsing a FrontPage web, the Web server requests a name and password for any task that requires permissions; however, you may not see the prompt because some Web servers will authenticate your name and password using another method.

On some Web servers, you can also set permissions for computer workstations, based on their IP addresses. You can set permissions for a group of computers using the asterisk character (*) to create an IP address mask. For example, the IP address mask 127.*.*.* applies to all computers with IP addresses beginning with 127. In this scenario, a user, author, or administrator must not only have sufficient permissions to access the FrontPage web, but must also be working on a computer that has the appropriate level of group permissions. By default, all computers have permissions to browse to a FrontPage web.

Note You should not use IP address restrictions on computer networks that do not support fixed IP addresses.

When using Microsoft Internet Information Server or some versions of the Microsoft Personal Web Server, you can set permissions for users or groups of users that are known to the Web server. With these Web servers, you cannot use FrontPage to add new users or groups, or to set passwords. You must use the operating system’s features for controlling Web access.

With some versions of the Microsoft Personal Web Server, however, you cannot set permissions for users or groups of users that are known to the Web server. With these versions, all users on the network can browse to your FrontPage webs, and authoring is permitted only from the computer on which the Web server itself is installed.

If you use any other type of Web server, you must first add administrators, authors, and users, and then assign names and passwords before you can assign permissions.


Using FrontPage Webs

Here are some commonly used FrontPage web procedures. For a full set of web procedures, see “Using FrontPage Webs” in the Contents tab of the Microsoft FrontPage online Help system.

Û To Open the FrontPage Explorer

FrontPage Explorer button

Do one of the following:

  • Click the Windows Start button, point to Programs, then click Microsoft FrontPage.

  • On the FrontPage Editor’s Tools menu, choose Show FrontPage Explorer, or click the FrontPage Explorer button.

Û To Create a New FrontPage Web

  1. On the FrontPage Explorer’s File menu, point to New and choose FrontPage Web.

  2. In the New FrontPage Web dialog box, select the type of FrontPage web you want to create. Choose one of the following:
    • One Page Web to create a FrontPage web from scratch, with no generic or pre-existing content.

    • Import an Existing Web to launch the Import Web Wizard, which will guide you through the process of importing an existing Web site.

    • From Wizard or Template to create a FrontPage web with suggested content.
  3. Enter a descriptive title for your new FrontPage web in the Choose a Title for Your FrontPage Web field.

  4. Click OK.

  5. If you are prompted for your administrator name and password, enter them in the Name and Password Required dialog box, and click OK.

    Note FrontPage will suggest a location for the new FrontPage web based on the currently selected Web server or folder. To choose a custom location, click Change in the New FrontPage Web dialog box to display the Change Location dialog box. In this dialog box, enter a new location for your FrontPage web and specify whether a secure connection is required.

Û To Open a FrontPage Web

  1. On the FrontPage Explorer’s File menu, choose Open FrontPage Web.

  2. In the Getting Started dialog box, click More Webs to display the Open FrontPage Web dialog box.

  3. If your FrontPage web is on a Web server, select the Web server from the drop-down list in the Select a Web Server or Disk Location field or type the Web server’s network location directly into the field. If the FrontPage web is in a folder on your local file system, type in the full path and folder name.

  4. Click List Webs.

    The FrontPage Explorer displays a list of the FrontPage webs on the Web server or folder you selected.

  5. Select the FrontPage web you want to open, then click OK.

  6. If you are prompted for your author name and password, enter them in the Name and Password Required dialog box, and click OK.

Û To Import Files to a FrontPage Web

To quickly import a file or a selection of files to the current FrontPage web, drag them into the FrontPage Explorer’s Folders view.

To import files to an import list, from which you can rename the files and later import them into the FrontPage web, do the following:

  1. On the FrontPage Explorer’s File menu, choose Import.

    In the Import File To FrontPage Web dialog box, you can add one or more files to the import list without importing them. The files remain on the list until you choose to import or remove them. Adding a folder to the import list will add all the files it contains (as well as those of its subfolders) to the import list.

  2. Click Add File.

  3. In the Add File to Import List dialog box, point to the folder where the file you want to import is stored. Select the file, then click Open.

  4. To add the entire contents of a folder to the import list, click Add Folder in the Import File To FrontPage Web dialog box.

  5. In the Browse For Folder dialog box, locate and select the folder, then click OK.

  6. To change the URL of any file before importing it (either to rename it or change the file’s folder in the FrontPage web), click Edit URL in the Import File To FrontPage Web dialog box.

  7. In the Edit URL dialog box, type a URL relative to the root of the current FrontPage web in the File Location Within Your FrontPage Web field, then click OK.

    For example, if you type the URL folder2/sample.htm, the page will be saved in folder2 below the root folder of the current FrontPage web.

  8. To save the import list and import the files in the list at a later time, click Close in the Import File to FrontPage Web dialog box. To start importing the files to the current FrontPage web, click OK.

    While files are being imported, you can interrupt the process by clicking Stop. However, any files that have already been imported will not automatically be removed from your FrontPage web.

Û To Rename a FrontPage Web

  1. On the FrontPage Explorer’s Tools menu, choose Web Settings.

    The FrontPage Web Settings dialog box is displayed.

  2. In the Configuration tab, type the new FrontPage web name in the Web Name field.

  3. To change the title of the FrontPage web, type the new title in the Web Title field.

  4. Click OK.

Û To Add Pages to a FrontPage Web

Do one of the following:

  • In the FrontPage Explorer, switch to either the Folders View, the All Files view, or the Navigation view. On the File menu, point to New, then choose Page, or click the New Page button on the toolbar to create new pages.

  • In the FrontPage Explorer, import pages or entire folders from your file system to the current FrontPage web using the Import command on the File menu.

  • In the FrontPage Editor, create new pages and add them to the current FrontPage web using the Save As command on the File menu.

  • In the FrontPage Editor, open pages from the World Wide Web using the Open command on the File menu, then add them to the current FrontPage web using the Save As command on the File menu.

Û To Create a New Folder

  1. In the FrontPage Explorer, do one of the following:
    • In the All Folders pane of the Folders view, click the folder to which you want to add a new folder.

    • In the Files pane of the Navigation view, double-click the folder to which you want to add a new folder.
  2. On the FrontPage Explorer’s File menu, point to New, then choose Folder.

    The FrontPage Explorer creates a new folder, labeled “New_Folder.”

  3. Type a new name for the folder, then press ENTER.

Û To Open a Page From the FrontPage Explorer

Select the page in the Folders view, All Files view, or Navigation view and do one of the following:

  • Double-click the page.

  • Press ENTER.

  • On the Edit menu, choose Open.

If the FrontPage Editor is already open, click and drag the page from the FrontPage Explorer to the FrontPage Editor.

Û To Export a File from a FrontPage Web

  1. In the FrontPage Explorer’s Folders view, All Files view, Navigation view, or Hyperlinks view, select the page or file that you want to export.

  2. On the File menu, choose Export.

  3. In the Export Selected As dialog box, use the Save In box and the file list to point to the folder in your file system in which you want to store the page or file.

  4. To change the file name, edit it in the File Name field.

  5. Click Save to export the file.

Û To Publish the Current FrontPage Web

  1. On the FrontPage Explorer’s File menu, choose Publish FrontPage Web or click the Publish button on the FrontPage Explorer’s toolbar.

  2. In the Publish FrontPage Web dialog box, specify the location to which you want to publish the current FrontPage web.

    You can choose from the drop-down list or enter a new location by typing directly into this field. To publish to a folder on your local file system, type in the full path and name of the folder. If you specify a folder that does not exist, FrontPage will offer to create it.

  3. Click OK.

If you are publishing the root web, select Include Child Webs to publish the other FrontPage webs on the same Web server or, if the root web is in a folder, to publish the other FrontPage webs in the same folder.

Note If FrontPage detects that you are publishing to a Web server that does not have the FrontPage Server Extensions installed, it will launch the Microsoft Web Publishing Wizard to publish your FrontPage web.


Next Steps

To | See
Learn more about FrontPage webs | “Using FrontPage Webs,” in the Contents tab of the Microsoft FrontPage online Help system
Learn about the FrontPage Editor | “The Microsoft FrontPage Editor”


The Microsoft FrontPage Editor

The Microsoft FrontPage Editor is a tool for creating, designing, and editing World Wide Web pages. As you add text, images, tables, form fields, and other elements to your page, the FrontPage Editor displays them as they would appear in a Web browser.

You do not need to learn HTML to use the FrontPage Editor because it creates all the HTML code for you. The FrontPage Editor generates all the popular HTML tags, including extensions such as cascading style sheets, frames, and ActiveX Controls.

If you want to edit the HTML code directly you can use the FrontPage Editor’s HTML view. In this view, you can enter text, edit HTML tags, and use standard word-processing commands such as cutting, pasting, and find and replace.

Although it is a powerful tool, the FrontPage Editor is easy to use because of its familiar, word-processor interface.


What Can You Do in the FrontPage Editor?

Here are some of the key features of the FrontPage Editor:

Create Pages You can create new HTML pages based on built-in wizards and templates. The FrontPage Editor offers many choices of page formats, or you can create your own templates.

Design and Lay Out Pages You can apply one of the many FrontPage themes, created by professional designers, to give your pages a dynamic, colorful appearance. You can also add and design borders for your pages and insert navigation bars, which guide your users around your Web site.

Convert Files to HTML You can open files of many popular types, and the FrontPage Editor converts them to HTML. Some of the file types you can open are Microsoft Word 2.0 and 6.0, Microsoft Word 6.0 for MS-DOS, Microsoft Word 95 and 97, Microsoft Excel 4.0 and 5.0, Microsoft Excel 95 and 97, and WordPerfect 6.x. The FrontPage Editor preserves hyperlinks in Microsoft Office documents.

Open HTML Files You can open any HTML file in the FrontPage Editor. All the HTML tags on the page are preserved.

Type and Edit Text You can insert text in all HTML styles, create multilevel lists, change text size and color, and apply formatting such as centering a heading or making text italic. Using cascading style sheet support, you can control margins, line spacing, colors, fonts faces and sizes.

Create and Test Hyperlinks Using a point-and-click interface, you can create hyperlinks to pages and files in your FrontPage web or to pages and files on the World Wide Web. Point to a page and FrontPage creates the correct hyperlink syntax for you automatically.

Create and Edit Image Maps You can insert an image of almost any type, and the FrontPage Editor converts it into GIF or JPEG format. Click an image and it opens for editing in your favorite image-editing program. Create an image map by adding hotspots, areas in an image containing hyperlinks. Using FrontPage image-editing commands, you can crop, rotate, and resize an image, make it black and white, give it beveled edges, and change its brightness and contrast. FrontPage includes the Microsoft Clip Gallery, a large library of images chosen for World Wide Web sites.

Create and Edit Forms You can create forms containing text fields, check boxes, radio buttons, drop-down lists, and push buttons. When you create a form, the default FrontPage form handler automatically saves form information to a file or sends it to an e-mail address. You can select from a set of FrontPage form handlers or add you own custom form handler to a form.

Create and Edit Tables Using the FrontPage table-editing commands, you can create a table, insert rows and columns, align them, and create background colors, using a point-and-click interface.

Use FrontPage Components and Other Active Page Elements You can add powerful functionality to your page by inserting FrontPage components. They add interactive features such as navigation bars, threaded discussion groups, full-text searches, and form handlers that would otherwise require complex programming. For example, the Table of Contents component automatically creates an HTML outline of your FrontPage web with hyperlinks to each page, and the Banner Ad Manager replays a sequence of images using effects similar to a rotating billboard.

Create and Edit Frames Pages You can create new frames pages, edit the appearance of your frames, and assign initial pages to each frame, all using a point-and click interface. FrontPage displays your frames pages in WYSIWYG style and generates the HTML.

Add Advanced Features You can insert ActiveX Controls, plug-ins, and Java applets in the FrontPage Editor. You can launch a script-editing session and create and insert JavaScript scripts and Microsoft Visual Basic® Scripting Edition scripts.


Learning About the FrontPage Editor

This chapter will give you an overview of the FrontPage Editor and describe page design and text and table editing in the FrontPage Editor. To learn about other FrontPage Editor features, see the following chapters:

  • “Creating Hyperlinks and Bookmarks”, describes creating and editing hyperlinks using the FrontPage Editor.

  • “Images and Image Maps”, describes the FrontPage Editor’s comprehensive set of tools for editing images and for creating image maps.

  • “Creating Active Pages”, describes the built-in FrontPage components that you can insert to add dynamic functionality to your pages.

  • “Forms and Form Fields”, describes how you create forms using the FrontPage Editor and how you collect information from forms using the FrontPage form handlers.

  • “Creating and Using Frames”, describes creating frames and frames pages using the FrontPage Editor.


Creating and Opening Pages

In the FrontPage Editor, you can create a new page by:

  • Selecting a page wizard

  • Selecting a template

A page wizard creates a page based on your responses to a series of questions. For example, the Form Page Wizard creates a customized page with a form for collecting information from visitors to your Web site.

A template is a page that you use as a model for the layout or contents of a new page. Some templates serve a particular purpose, such as a Survey Form or a Press Release. These templates contain suggested layouts, contents, and comments that describe how to complete the page. Other templates, such as Two Column Page or Centered Column, are only for page layout.

Here are some of the page templates that FrontPage provides:

  • The Table of Contents template creates a page with links to every page in your FrontPage web, displayed in an outline.

  • The Frequently Asked Questions template creates a Frequently Asked Questions (FAQ) page.

  • The Guest Book template creates a page where visitors to your FrontPage web can leave there comments in a public guest book.

  • The Search Page template creates a page where users can search for pages in your FrontPage web containing specified keywords.

  • The Two-column Staggered Body template lays out your page in a “checkerboard” pattern.

  • The Centered Body template lays out your page in a single, centered column.

    Can I add my own templates? You can turn any open page into a template. From the File menu choose Save As, and click As Template. Once you have added the template, it will be available in the list with the other Microsoft FrontPage templates.

FrontPage also includes templates for frames pages. A frames page is a page that subdivides a Web browser’s window into regions called frames. Each frame can display a separate, scrollable page. Creating frames pages is described in “Creating and Using Frames”.


Creating Pages

You create a new page in the FrontPage Editor using the New command on the File menu. When you select this command, FrontPage opens the New dialog box, which displays all the built-in templates and wizards and any templates that you have added:

When you select a template or wizard in the New dialog box, it is displayed in the Preview field.

Once you have selected the template or wizard on which to base your page, click OK, and FrontPage creates the page and opens it in the FrontPage Editor.


Opening Pages

In the FrontPage Editor, you can open a page from:

  • An open FrontPage web

  • Your file system

  • The World Wide Web

To open any page choose Open from the File menu. FrontPage displays the Open dialog box.

Up One Level button

The Open dialog box displays the contents of the current FrontPage web. Click a folder to view the pages contained in that folder. To go up a level, click the Up One Level button. When you select a page, its location is displayed in the URL field. Click OK to open the page.

File button

To open a page from your local network’s file system, click the File button in the Open dialog box. The Select File dialog box opens. Select the file and click Open. FrontPage opens the file.

World Wide Web button

To open a page from the World Wide Web, click the World Wide Web button in the Open dialog box. FrontPage starts your Web browser. Visit the page you want to open and return to FrontPage. The location of the page you visited is displayed in the Open dialog box’s URL field. Click OK to open the page.

Open a Page by Following a Hyperlink In the FrontPage Editor, you can open a page by following a text or image hyperlink to that page. Just point at the hyperlink and press CTRL+CLICK. FrontPage follows the hyperlink and opens the target page.

In the FrontPage Editor, you can add pages to your FrontPage web by first opening them from your file system or the World Wide Web and then saving them using the Save As command on the File menu. The FrontPage Editor prompts you to save each image, control, sound file, or other page element to your FrontPage web. This is a great way of incorporating content into your FrontPage web, but be careful — some logos or icons on pages you open from the World Wide Web may be protected by copyright law.


Designing Pages

The FrontPage Editor contains many features that help you design your pages. You can apply a built-in theme to a page. You can assign border regions to a page and edit them, insert navigation bars and banners, and set properties on a page, such as background color or sound.

A common way to lay out a page is to create a table to lay out the page and add all content inside the table’s cells. For a discussion of table-editing in FrontPage, see “Creating and Editing Tables”.


Themes

Themes enliven your pages. They are collections of design elements — bullets, background patterns, table borders, fonts, and graphics — that you can apply to an entire FrontPage web or a to single page. A page with a theme applied to it has a consistent, professional appearance. Everything on it, from its bullets to its background pattern, fits together. When you insert new bullets, horizontal lines, banners, navigation bars and other graphical elements in a page that has a theme applied to it, they match the theme. Also, if a theme has been applied to a FrontPage web, any new pages that you create will use the theme.

FrontPage comes with over 50 built-in themes in a range of styles from conservative to flashy. For a full description of the FrontPage Explorer’s Themes view, see “FrontPage Explorer Views”.

You can change the theme for a page in the FrontPage Editor. Choose Theme on the FrontPage Editor’s Format menu. In the Choose Theme dialog box, click Use Selected Theme and choose a theme from the list. You can specify whether or not to use a bright set of colors, an active set of banners, buttons, and bullets, and a textured page background.


Shared Borders

Pages can include shared borders, which usually contain navigation bars (graphical elements that contain hyperlinks to other pages). FrontPage maintains a single set of borders — top, bottom, left, and righ — for the entire FrontPage web.

You can include shared borders on pages in two ways:

  • In the FrontPage Explorer you can specify that one or more shared borders should be included in all pages that are part of the FrontPage web’s navigational structure (as displayed in the Navigation view). Choose Shared Borders on the Tools menu and, in the Shared Borders dialog box, select the shared borders to include. For example, if you specify the Top border in this way, it will appear on all pages that are part of the FrontPage web’s navigational structure.

  • In the FrontPage Editor you can specify to include one or more shared borders on the currently opened page. Choose Shared Borders on the Tools menu, and, in the Shared Borders dialog box, click Set for this page only and select the shared borders to include.

You edit the contents of shared borders in the FrontPage Editor. Click inside it on a page and edit the region as you would edit any other part of the page. When you save the page, all edits to shared borders are also saved.

Each shared border is used throughout a FrontPage web. When you edit it, you are changing its appearance on every page that it is included in. For example, if you add your e-mail address to the Bottom shared border in one page, all other pages that include the Bottom border will now display your e-mail address.


Navigation Bars

The structure of a FrontPage web links together the most important pages in your FrontPage web. It is displayed in the FrontPage Explorer as a diagram, similar to an organization chart or a “family tree.” The home page is at the top, its “child” pages at the next level, the children of those pages at the next level, and so on.

For example, a corporate FrontPage web’s Home Page might point to a set of child pages that describe different divisions of the corporation. Each division’s page could point to one or more child pages that describe the products made by that division. Together, the Home Page, division pages, and product pages form the navigational structure of the FrontPage web.

You design and create the structure of a FrontPage web in the FrontPage Explorer’s Navigation view. For a description of the Navigation view, see “FrontPage Explorer Views”.

To navigate the structure of a FrontPage web, users follow hyperlinks from one page to another. FrontPage manages these hyperlinks for you with navigation bars. A navigation bar is a graphical page element that contains hyperlinks to other pages in the FrontPage web’s structure.

In the FrontPage Explorer, you can add navigation bars to any FrontPage web that you create from a wizard or template, except a web created using the Discussion Web Wizard. You can also insert navigation bars in the FrontPage Editor using the Navigation Bar command on the Insert menu. You can configure a navigation bar by double-clicking it and editing the Navigation Bar Properties dialog box.

In the example web below, My Page has a parent page (the Home Page), two “peer” pages (Page 2 and Page 3), and two child pages (Page 4 and Page 5):

When you insert a navigation bar on My Page, you can configure it to contain hyperlinks to its child pages (Page 4 and Page 5). This is shown in the Navigation Bar Properties dialog box as follows:

You can also configure the navigation bar to point to a page’s peers by clicking Same level. On My Page, this would create hyperlinks to Page 1 and Page 2. You can optionally select other pages to point to from the navigation bar, such as the home page of the FrontPage web. The graphical “tree” diagram in the Navigation Bar Properties dialog box is updated to show where in the FrontPage web’s structure the hyperlinks point to:

You can also configure a navigation bar to contain hyperlinks to:

  • Its parent level. This is the current page’s parent page and all of the parent page’s peers.

  • The back and next pages. These are the pages to the left and right of the current page.

  • The top level. This is the home page and any other top level pages you have defined in the Navigation view.

In most cases, you should insert a navigation bar inside a shared border. A navigation bar in a shared border is displayed on every page in the FrontPage web that includes that shared border. The hyperlinks on the navigation bar are adjusted on each page containing it, depending on where the page is in the FrontPage web’s structure.

If you want a navigation bar to appear only on a single page, insert the navigation bar directly on that page outside of any shared borders.

Deleting a Page That a Navigation Bar Points To When a page is deleted from a FrontPage web’s structure, hyperlinks to the page from all navigation bars are also deleted. When all the hyperlinks on a navigation bar have been removed, the navigation bar remains on your page but it is not visible in Web browsers.


Setting Page Properties

Each page has properties that you can set in the FrontPage Editor. These properties affect the page’s appearance, give information to Web browsers about how to display the page’s hyperlinks, and specify other page settings.

To set the properties of the current page in the FrontPage Editor, choose Page Properties on the File menu. Some important page properties are:

  • The title, a descriptive word or phrase that is displayed in a browser’s title bar when the page is displayed. The title is also displayed in the FrontPage Editor and is used in many Microsoft FrontPage commands.

  • The background image or watermark, an image that is displayed on the page behind the page’s contents.

  • The background color, the color that is displayed behind the page’s contents.

  • The text color, the color of the page’s text.

  • The hyperlink color, the color in which all hyperlinks on the page are displayed before they are visited. (A hyperlink is visited after the user has clicked it.)

  • The background sound, a sound file that you associate with the page.

You can specify another page in the FrontPage web to use as the source for the current page’s background and colors. Using a single page in your FrontPage web as the source of background and color properties gives the pages in your FrontPage web a consistent, recognizable appearance.

Note that when you apply a theme to a page, the design properties of the page, such as its background colors, background image, text colors and hyperlink colors, are applied automatically by FrontPage. You therefore cannot use the Page Properties dialog box to specify these properties, and you cannot specify to use another page as the source of background and colors.


The FrontPage Editor’s Views

The FrontPage Editor has three views: a Normal, HTML, and Preview view. If you are editing a frames page, it adds two more views: Frames Page HTML, and No Frames. For descriptions of the Frames Page HTML, and No Frames views, see “Creating and Using Frames”.

The Normal view is the primary FrontPage Editor view. This is the view that you use to create your pages and view them in WYSIWYG mode. The complete set of FrontPage Editor commands and toolbars is available in this view.

In the FrontPage Editor’s HTML view, you can edit the page’s HTML directly. In this view, you can enter HTML tags and your page’s contents, and you can use standard word-processing commands such as cutting, pasting, finding, and replacing. HTML attributes and their values are color coded so that you can distinguish them more easily.

If you have the Microsoft Internet Explorer version 3.0 or higher Web browser installed on your computer, the FrontPage Editor adds a Preview. This view shows your page the way it appears in Internet Explorer. Use this view as a quick way to view your Web page as your users will see it.


Editing Text

In the FrontPage Editor, you enter and format text, create lists, specify paragraph styles, and adjust the indentation and alignment of your paragraphs using a familiar word-processor interface. FrontPage automatically generates HTML that reflects the paragraph styles and formats you chose. FrontPage also includes standard word processing commands, such as finding and replacing text, a spelling checker and a thesaurus.

Minimizing White Space Between Lines of Text Each time that you press ENTER, FrontPage creates a new paragraph. Most Web browsers add white space before and after each paragraph. To start a new line of text without adding white space, press SHIFT+ENTER to insert a line break. Because Web browsers do not add extra white space between lines separated by line breaks, your lines will be spaced more closely together.

Using the File command on the FrontPage Editor’s Insert menu, you can insert the contents of a file onto your page. If the file is not an HTML file, the FrontPage Editor converts it to HTML. You can insert many types of files, including Microsoft Word, Microsoft Excel, and WordPerfect. You can paste or, when supported, drag selections from one of these applications onto a page in the FrontPage Editor. If you paste or drag a range of cells from a Microsoft Excel spreadsheet, they are added to the page as a new table.


Creating and Editing Tables

Web page authors use tables in two ways:

  • To display side-by-side information.

    From a simple phone list to a complex spreadsheet, inserting your data in tables with clearly labeled columns makes it easy for users to understand your information.

  • To lay out your page.

    You can achieve many design effects on your page by first creating a table and then placing the contents of the page inside the table’s cells. Using tables, you can define mastheads, sidebars, captions, and use other common “desktop publishing” techniques.

    FrontPage comes with many built-in templates that use tables to lay out your page. When you create a new page, you can preview these templates in the New dialog box. By saving a table-based page as a template, you can store your own page design and use it to create other pages.


Creating Tables

To create a table in the FrontPage Editor:

  • Use the Insert Table command on the Standard toolbar. This command is also on the Tables menu.

  • Use the Draw Table command on the Tables toolbar.

The Insert Table command on the Standard toolbar quickly creates a table with regularly-spaced rows and columns. To use this command, click the Insert Table button and drag the number of rows and columns that you want the table to have.

If you choose Insert Table command on the Tools menu, the FrontPage Editor displays the Insert Table dialog box. This lets you set initial properties for the table at the same time that you choose the number of rows and columns in the table. The Insert Table command will create a table anywhere on the page, including inside a table cell.

Draw Table button

The Draw Table command on the Table toolbar lets you draw a table with irregularly spaced rows and columns. To create a new table with this tool, click the Draw Table button, then click and drag on the page. This creates the outside border of the table.


Creating New Cells

You can create new cells by drawing new cells borders. To draw a cell border, make sure that Draw Table is selected on the Tables toolbar, then drag a line within any table cell. The cell is divided horizontally or vertically where you dragged.

To split cells evenly, use the Split Cells command on the Table menu and the Tables toolbar.

You can insert a new row or column using the Insert Rows or Columns command on the Table menu, or by clicking the Insert Rows or Insert Columns button on the Tables toolbar.


Other Table Editing Techniques

Here are some other table-editing techniques:

  • Drag any cell border to resize the cell.

Eraser button

  • Use the Eraser tool on the Tables toolbar to delete one or more cell borders.

  • Add a caption to a table using the Insert Caption command on the Table menu.

  • Delete cells using the Delete Cells command on the FrontPage Editor’s Table menu.

  • Convert text to a table using the Convert Text to Table command on the FrontPage Editor’s Table menu.

See the FrontPage Online Help system for more table-editing procedures.

Why does FrontPage sometimes prevent me from erasing borders? FrontPage generates tables that conform to HTML syntax. In HTML, some arrangements of cells are not permitted. If you try to erase a border in a way that the syntax of HTML does not allow, FrontPage will not erase the border.


Setting Table Properties

You can complete the design of your table by setting properties on the entire table and on selected cells.

The Table Properties command opens the Table Properties dialog box. Use this dialog box, to set the alignment of the table on the page, specify a table border and select its color, choose a background color or image for the table, and precisely specify the table’s size.

The Cell Properties command opens the Cell Properties dialog box. This dialog box is similar to the Table Properties dialog box, but lets you override global table properties for the currently selected cells.


Editing an Item’s Properties

Every item on a page has properties that are encoded in the HTML that FrontPage generates to describe the item. Some items’ properties are used by Web browsers to determine how to display them. For example, a character has font properties that control its size and font style, and a paragraph has properties that control its alignment on the page.

Properties do not all control the appearance of items. For example, a form has a property that specifies how it will be processed, and an image has a property that assigns it a default hyperlink.

In the FrontPage Editor, you edit any item’s properties in its properties dialog box. For example, you can edit an image’s properties in the Image Properties dialog box or a Radio Button form field’s properties in the Radio Button Properties dialog box. To open an item’s properties dialog box, select the item and press ALT+ENTER. You can also open a selected item’s properties dialog box from the shortcut menu. For example, when you select a Radio Button field, the Form Field Properties command appears in the Radio Button’s shortcut menu.

Because of the way HTML is designed, an item you see on the page is often part of other larger items. For example, a character in a table is a member of a paragraph, a table cell, a table, and a page. In the FrontPage Editor, you can view a list of all the relevant properties dialog boxes for a selected item by clicking the right mouse button to open its shortcut menu.

In FrontPage 98, every page element’s properties dialog box has a Style button that opens a Style dialog box. The Style dialog box lets you assign cascading style sheet attributes to any page element. Cascading style sheets lets authors of HTML documents have more precise control over a page element’s indentation, colors, alignment, spacing, and other properties.

Note that cascading style sheets are not supported by all Web browsers. If a Web browser does not recognize a cascading style sheet attribute it will ignore it. Cascading style sheets will be supported in the newest versions of the Microsoft Internet Explorer and Netscape browsers.


Using Pages

Here are some commonly used page procedures. For the full set of page procedures, see “Using Pages” in the Contents tab of the Microsoft FrontPage online Help system.

Û To Create a New Page

  1. In the FrontPage Editor, choose New on the File menu.

  2. In the New dialog box, select a template or wizard on which to base the new page.

    The template or wizard is displayed in the Preview field.

  3. Click OK.

    If the page is based on a wizard, follow the wizard’s instructions to finish creating the page.

Û To Open a Page in the FrontPage Editor

Open button

  1. Click the Open button.

  2. In the Open dialog box, do one of the following:
    • To open a page from the current FrontPage web, click a page. To browse the contents of a folder, double-click it. After selecting the page, click OK.

File button

  • To open the page from your file system, click the File button, and choose a file in the Select File dialog box.

World Wide Web button

  • To open a page from the World Wide Web, click the World Wide Web button. FrontPage starts your Web browser. Visit the page you want to open and return to FrontPage. The location of the page you visited is displayed in the Open dialog box’s URL field. Click OK to open the page.

Û To Save a Page to the Current FrontPage web

Save button

  1. If the page was opened from the current web or from the World Wide Web, in the FrontPage Editor, choose Save on the File menu, or click the Save button. If the page was opened from a file, choose Save As on the File menu.

  2. If you are saving the page to the FrontPage web for the first time, in the Title field, type a descriptive page title.

  3. If you are saving the page to the FrontPage web for the first time, in the URL field, type a URL relative to the root of the currently open FrontPage web, or accept the URL that FrontPage supplies as a default. For example, if you type the URL folder2/sample.htm, the page will be saved in the folder folder2 below the root folder of the current FrontPage web.

  4. Click OK.

  5. If the page has been opened from a file or from the World Wide Web, you are prompted to save any images, ActiveX Controls, sound files, and other objects on the page to the FrontPage web.

Û To Save a Page to a File

  1. In the FrontPage Editor, choose Save As on the File menu.

File button

  1. Click the File button.

  2. Use the Save In box and the box that lists files and folders to point to the folder where you want to store the page as a file.

  3. Specify the file name.

  4. Click Save. You are prompted to save any images, ActiveX Controls, sound files, and other objects on the page to the folder containing the file.

Û To Apply One Page’s Background Style and Colors to Another Page

You can display a page using the same background style and colors as another page in your FrontPage web. The page will use the background image, background color, and all link and text colors from the page that you specify.

You cannot use the background style and colors of another page if a theme has been applied to the current page.

  1. In the FrontPage Editor, open the page that you want to display using another page’s styles.

  2. On the File menu, select Page Properties.

  3. In the Page Properties dialog box, choose the Background tab, and click Get Background and Colors from Page.

  4. Click Browse and select the page from the Current Web dialog box.

  5. Click OK.

Û To Create a Template Page

In the FrontPage Editor, you can save a page as a template. After you have saved the template, it will be displayed along with the standard FrontPage page templates in the Page tab of the New dialog box.

  1. In the FrontPage Editor, choose Save As on the File menu.

  2. Click As Template.

  3. In the Save As Template dialog box, enter a page title for the template in the Title field, enter a name for the page in the Name field, and enter a brief description of the template in the Description field.

  4. Click OK.

If you applied a theme before saving the page as a template, the template will apply the theme as follows:

  • If you applied the theme to the original page by choosing the Use Theme From Current Web option, when you create a new page from the template, the new page will automatically apply the theme (if any) from the current FrontPage web.

    For example, if the original page applied the “Canvas” theme from its web, and you use the resulting template to create a new page in a new FrontPage web which uses the “Safari” theme, the new page will automatically apply the “Safari” theme instead of “Canvas.”

  • If you applied the theme to the original page by choosing the Use Selected Theme option, when you create a new page from the template, the new page will apply the same theme as the original page.

For example, if the original page applied the “Canvas” theme to that page only, and you use the resulting template to create a new page in a new FrontPage web which uses the “Safari” theme, the new page will apply the “Canvas” theme instead of “Safari.” You can still apply the Safari theme to the new page using the Theme command on the Format menu.

Û To Create a Bulleted List

A bulleted list presents an unordered list of items. Generally, browsers render bulleted lists as paragraphs separated by blank space, prefixed by bullets.

Bulleted List button

  1. In the FrontPage Editor, click the Bulleted List button on the Format toolbar.

  2. Enter a list item, then press ENTER to continue the list.

  3. Press ENTER twice to end the list.

    Note To reformat existing text as a bulleted list, select one or more paragraphs, then click the Bulleted List button.

Û To create a Numbered List

A numbered list presents an ordered list of items, such as steps in a procedure. Generally, browsers render numbered lists as paragraphs separated by blank space, prefixed by numbers.

Numbered List button

  1. In the FrontPage Editor, click the Numbered List button on the Format toolbar.

  2. Enter a list item, then press ENTER to continue the list.

  3. Press ENTER twice to end the list.

    Note To reformat existing text as a numbered list, select one or more paragraphs, then click the Numbered List button.

Û To Create a New Paragraph

In the FrontPage Editor, do one of the following:

  • To create a new paragraph on a new page, start typing on the page. The FrontPage Editor applies the Normal paragraph style by default.

  • To create a new paragraph after the current paragraph, position the insertion point at the end of the current paragraph, then press ENTER.

  • To divide the current paragraph, position the insertion point inside the paragraph, then press ENTER.

The FrontPage Editor creates a new paragraph in the same style, starting with the text to the right of the insertion point.

Û To Create a New Line

  • To start a new line of text without adding white space, press SHIFT+ENTER.

This inserts a line break. Because Web browsers do not add extra white space between lines separated by line breaks, your lines will be displayed more closely together.

Û To Apply a Theme to a Page

  1. On the FrontPage Editor’s Format menu, choose Theme.

  2. In the Choose Theme dialog box, click Use Selected Theme, and choose a theme from the list.

  3. Select any of the following options:
    • Click Vivid Colors to specify a bright set of colors for the theme.

    • Click Active Graphics for a lively set of banners, buttons, bullets, and other graphical elements.

    • Click Background Image for a textured page background. If this is not selected, the page background will be a basic color.

Û To Assign Shared Borders to a Page

  1. On the FrontPage Editor’s Tools menu, choose Shared Borders.

  2. In the Shared Borders dialog box, click Set for this page only.

  3. Select one or more of the shared borders: Top, Bottom, Left, and Right.

  4. Click OK.

Û To Edit a Shared Border

  1. In the FrontPage Editor, open any page with shared borders.

  2. Click inside the shared border region. For example, to edit the Left shared border, click on the left border of the page.

    When you click in a shared border regions, its outline becomes darker.

  3. Make any edits in the shared border region.

  4. Choose Save on the File menu.

    Any edits you made to the page and to all shared borders on the page are saved.

Û To Insert a Navigation Bar on a Page

  1. In the FrontPage Editor, move the insertion point to where you want to place the navigation bar. To put a navigation bar in a shared border region, click inside that region.

  2. On the Insert menu, choose Navigation Bar.

    In the Navigation Bar Properties dialog box, configure the navigation bar.

  3. Click OK to insert the navigation bar.

Û To Insert a Table

Tables have columns and rows of cells that can contain text, images, forms, or other page elements. You can use tables for laying out a page or to arrange data systematically.

To quickly create a table with the same number of cells in each row and column, using mostly default settings, follow the procedure below.

  1. In the FrontPage Editor, move the insertion point where you want to create the table.

    Insert Table button

  2. Click the Insert Table button on the standard toolbar, then drag until FrontPage displays the number of rows and columns you want.

    To quickly create a table with irregular rows and columns, follow the procedure below.

    In the FrontPage Editor, move the insertion point where you want to create the table.

    Draw Table button

  3. On the Table menu, choose Draw Table or click the Draw Table button on the table toolbar.

  4. To draw the outside border of the table, drag from the upper-left corner to the lower-right corner of the table.

  5. To make cells, draw vertical and horizontal lines within the table.

    Eraser button

  6. Click the Eraser button on the table toolbar to remove any lines you do not want.

    To set the properties of a table when you create it, follow the procedure below. Whenever you specify new table properties, they will appear as the new default the next time you insert a table using the menu command or the toolbar button.

  7. In the FrontPage Editor, move the insertion point where you want to create the table.

  8. On the Table menu, choose Insert Table.

  9. In the Rows field, specify the number of rows you want.

  10. In the Columns field, specify the number of columns you want.

  11. In the Alignment field, choose where you want the table positioned on the page.

  12. In the Border Size field, enter how wide you want the border to be, in pixels.

  13. To change the table’s cell padding, enter a number in the Cell Padding field.

  14. To change the table’s cell spacing, enter a number in the Cell Spacing field.

  15. To change the table’s width, do one of the following:
    • Select in Pixels, then type the width you want the table to be, in pixels.

    • Select in Percent, then type a percentage of the width of the screen.
  16. Click OK.


Next Steps

To | See
Learn more about hyperlinks and bookmarks | “Creating Hyperlinks and Bookmarks”
Learn more about image maps | “Images and Image Maps”
Learn more about frames and frames pages | “Creating and Using Frames”
Learn more about forms | “Forms and Form Fields”
Learn more about active page elements | “Creating Active Pages”
Learn more about tables | “Working With Tables,” in the Contents tab of the Microsoft FrontPage online Help system
Learn more about adding ActiveX Controls, Java applets, JavaScript and Visual Basic scripts | “Advanced FrontPage Features”


Creating Hyperlinks and Bookmarks

FrontPage has a complete interface for creating, editing, and verifying hyperlinks. In the FrontPage Editor, you can create hyperlinks to pages and files in your current FrontPage web or to pages anywhere on the World Wide Web.

Using FrontPage, you can create hyperlinks without having to know the Internet addresses of the pages or files you are linking to. You can just browse the current FrontPage web or the World Wide Web, point to the page or file, and the FrontPage Editor fills in the correct hyperlink text.

This section describes creating hyperlinks from text. However, you also use many of the techniques described here when you create hyperlinks from images. To learn about creating hyperlinks from images, see “Images and Image Maps”. For a general overview of hyperlinks and URLs, see “Welcome to the World Wide Web” 96. For a discussion of frames, special pages that control where pages that you link to are displayed, see “Creating and Using Frames”.


Creating Hyperlinks in FrontPage

A hyperlink is a pointer from text or from an image to a page or other type of file on the World Wide Web. In World Wide Web pages, hyperlinks are the primary way to navigate between pages and among Web sites. When you create a text hyperlink, the FrontPage Editor underlines the text and displays it in a special color to indicate the presence of the hyperlink.

The most common hyperlink is from one page to another in the same FrontPage web. This gives users a way to move around the pages within your Web site. To create a hyperlink to a page or file within the current FrontPage web, choose Hyperlink on the Insert menu. The Create Hyperlink dialog box lists all the pages, other files, and folders in your FrontPage web. Double-click a folder to view its contents. Select the page or file that you want to create a link to (called the target) and click OK.

Open Page Symbol

FrontPage uses the open page symbol in the Create Hyperlink dialog box to identify currently opened pages. You can browse a list of any open page’s bookmarks in the Bookmark field of this dialog box.

In the URL field of the Create Hyperlink dialog box, FrontPage includes a drop-down list of special values that you can use to quickly create hyperlinks to pages in your FrontPage web.

The value… | creates a hyperlink to…
Home Page | The home page of the FrontPage web.
Up One Level | The parent, in the FrontPage web’s navigational structure, of the page you are currently editing.
Previous Page | The left peer, in the FrontPage web’s navigational structure, of the page you are currently editing.
Next Page | The right peer, in the FrontPage web’s navigational structure, of the page you are currently editing.

To learn about the navigational structure of FrontPage webs, see “FrontPage Webs and the Microsoft FrontPage Explorer”.

To quickly create a hyperlink in the current FrontPage web… Drag a page or other file from the FrontPage Explorer and drop it anywhere on a page in the FrontPage Editor. The FrontPage Editor creates a hyperlink to that page or file.

World Wide Web button

Authors often want to give users of their FrontPage web a way to surf to pages at other locations on the World Wide Web, for example in a list of favorite Web sites. To create a hyperlink to a page on the World Wide Web, choose Create Hyperlink and click the World Wide Web button in the Create Hyperlink dialog box. This opens your Web browser. Surf to a page that you want to link to, and return to the Create Hyperlink dialog box using ALT+TAB. The location of the page will be displayed in the URL field. Click OK to create a hyperlink to the page.


What is a URL?

On the World Wide Web, the key component of a hyperlink is its Uniform Resource Locator, or URL. A URL is text that supplies the Internet address of a resource on the World Wide Web, along with the protocol by which the resource is accessed, such as http://www.microsoft.com/. The most common URL type is http, which gives the Internet address of a World Wide Web page. Some other URL types are mailto, which sends electronic mail, and file, which indicates that the file is in the file system of a computer on the network. You can easily create any type of URL using FrontPage.

New Page button

If you get an idea for a new page while editing another page in the FrontPage Editor, you can create a hyperlink to the new page before you have created it. To do this, click the New Page button in the Create Hyperlink dialog box, then select a page template or wizard in the New Page dialog box and click OK. The FrontPage Editor creates a new page and puts a hyperlink to it in the page that you were editing. To postpone editing the new page, choose Just add web task in the New Page dialog box. The FrontPage Editor closes the new page, creates a hyperlink to it, and adds a task to the Tasks list in the FrontPage Explorer to edit the page later.

Along with creating World Wide Web (http) hyperlinks in the Create Hyperlink dialog box, you can easily create other types of hyperlinks:

mailto button

  • You can create mailto hyperlinks in the Create Hyperlink dialog box by clicking the mailto button and typing an e-mail address. When a user follows a mailto hyperlink in your FrontPage web, the Web browser will prompt the user for a message and send the message to the e-mail address specified in the hyperlink. Not all Web browsers support mailto URLs.

File button

  • You can create file hyperlinks in Create Hyperlink dialog box by clicking the File button. This displays the standard Select File dialog box. Locate the file in your file system and click OK. FrontPage creates a hyperlink to the file you selected. Note that file hyperlinks in a published FrontPage web will be relative to the file system on the Web browser’s computer. This will make your FrontPage web less portable, because it is unlikely that the same file will exist on computers of all users that browse your FrontPage web.

  • You can create any type of URL by typing it directly into the URL field of the Create Hyperlink dialog box.


Create Hyperlinks As You Type

FrontPage will automatically create hyperlinks for you as you type URLs in a page. For instance, you might type this sentence in the FrontPage Editor:

“Check out http://www.microsoft.com/frontpage for the latest information about FrontPage.”

As soon as you hit the spacebar after typing http://www.microsoft.com/frontpage, the FrontPage Editor will format the URL into a hyperlink to that location. To remove the hyperlink from the text, select the hyperlink and choose Unlink on the Edit menu.


Creating and Using Bookmarks

A bookmark is a location on a page that you label so that it can be the target of a hyperlink. Bookmarks give you control over which part of a page is displayed when a user follows a hyperlink to that page. When a user follows a hyperlink to a bookmark, the Web browser displays the page starting at the bookmark’s location instead of at the top of the page.

In the FrontPage Editor, a bookmark is indicated by a dashed underline beneath text. In a URL, a bookmark is preceded by a number sign (#) as in http://www.microsoft.com/index.htm#mark.

To create a table of contents for a page’s topics, create a bookmark at each topic on the page, and then create hyperlinks to each of the bookmarks from the top of the same page.

Create a table of contents quickly You can quickly create a table of contents for a set of topics on a page. With the right mouse button, drag the heading of each topic to the top of the page. Release the mouse button and select Link Here from the displayed menu. The FrontPage Editor creates a hyperlink to the topic where you released the right mouse button. Do this for each topic to create your table of contents.

To create a bookmark in the FrontPage Editor, either at selected text or at the insertion point, choose the Bookmark command on the Edit menu. Choose a Bookmark Name or, if you are creating the bookmark at selected text, use the suggested name, and click OK.

Open Page icon

If a selected page in the Create Hyperlink dialog box is opened in the FrontPage Editor, the page’s bookmarks are listed in the Bookmark field. (Pages that are opened in the FrontPage Editor are indicated in the Create Hyperlink dialog box by the Open Page icon.) You can create a hyperlink to a bookmark on an open page by clicking the page and then choosing its bookmark from the list in the Bookmark field.

To create a hyperlink to a bookmark in a page that is not opened, select the page in the Create Hyperlink dialog box, then type the name of the bookmark in the Bookmark field.


Managing Hyperlinks in the FrontPage Explorer

FrontPage automatically manages hyperlinks in your FrontPage web. For example, when an author moves a page from one folder to another in a FrontPage web or renames a page, FrontPage automatically update all hyperlinks to that page from every other page and Microsoft Office document in the FrontPage web. Along with automatic hyperlink management, the FrontPage Explorer includes the Hyperlink Status view, in which you can test and repair hyperlinks in a FrontPage web.

The Hyperlink Status view displays a list of all the internal and external hyperlinks in the current FrontPage web. (An internal hyperlink links to a page or file within the current FrontPage web. An external hyperlink points to a page or file outside of your FrontPage web.) You can select the Hyperlink Status view by choosing Hyperlink Status on the View menu.

When you first select the Hyperlink Status view, the FrontPage Explorer checks all internal hyperlinks before displaying the hyperlink list. The FrontPage Explorer does not check external hyperlinks at first because it can take a long time to access each page or file over the Internet.

The status of each hyperlink is displayed in the Hyperlink Status view:

  • OK indicates that the hyperlink is good. Note that good hyperlinks inside your FrontPage web are not displayed by default. You can view them by selecting Show All Hyperlinks in the View menu.

  • Broken indicates that the hyperlink is bad. A bad hyperlink indicates either an incorrect URL or a missing page or file.

  • Unknown indicates that the hyperlink is external and has not been checked yet.

  • Added task indicates that the hyperlink is either broken or has not been verified yet, and a related task has been added to the Tasks view.

You can use the Hyperlink Status view to repair broken hyperlinks:

  • To edit a selected broken hyperlink, choose Edit Hyperlink from the shortcut menu, and repair the hyperlink. Click Browse to browse the World Wide Web for the hyperlink target.

  • To verify one or more selected hyperlinks, choose Verify from the shortcut menu.

  • To edit the page containing a selected hyperlink, choose Edit Page from the shortcut menu. This opens the page in the FrontPage Editor.

  • To add a task to the Tasks view to fix or verify one or more selected hyperlinks, choose Add Task from the shortcut menu.

Why are images displayed in the Hyperlink Status view? When you insert an image on a page in the FrontPage Editor, you are not placing the image directly on the page. Instead, you are creating a hyperlink from the page to the image. A hyperlink to an image can be broken, for instance if you delete the image from your FrontPage web. You can use the commands in the Hyperlink Status view to repair broken links to images in the same way that you repair other types of hyperlinks.


Using Hyperlinks and Bookmarks

Here are some commonly used FrontPage hyperlink and bookmark procedures. For the full set of FrontPage hyperlink procedures, see “Creating and Using Hyperlinks and Bookmarks” in the Contents tab of the Microsoft FrontPage online Help system.

Û To Create a Text Hyperlink to a Page or File in the Current FrontPage Web

Create or Edit Hyperlink button

  1. In the FrontPage Editor, select text that will identify the hyperlink.

  2. On the Insert menu choose Hyperlink, or click the Create or Edit Hyperlink button.

  3. In the Create Hyperlink dialog box, click a page or file to make it the target of the hyperlink. To browse the contents of a folder, double-click it.

  4. To link to a bookmark on the page you selected, type the name of the bookmark in the Bookmark field. You can create a hyperlink to a bookmark on an open page by first selecting the page and then choosing its bookmark from the list in the Create Hyperlink dialog box.

  5. If you want the page that is the target of the hyperlink to appear in a frame in a frameset, select the frame in the Target Frame field.

  6. Click OK.

Û To Create a Text Hyperlink to a New Page

You can create a text hyperlink to a new page. FrontPage first creates the new page and then creates a hyperlink to it.

Create or Edit Hyperlink button

New Page button

  1. In the FrontPage Editor, select text that will identify the hyperlink.

  2. On the Insert menu choose Hyperlink, or click the Create or Edit Hyperlink button.

  3. In the Create Hyperlink dialog box, if you want the page that is the target of the hyperlink to appear in a frame in a frameset, select the frame in the Target Frame field.

  4. Click the New Page button.

  5. In the Page tab of the New dialog box, select the template to use to create the new page.

  6. To create the new page and add a task to the FrontPage Explorer’s Tasks view reminding you to finish the page later, click Just add web task.

  7. Click OK.

Û To Create a Text Hyperlink to a Page on the World Wide Web

Create or Edit Hyperlink button

World Wide Web button

  1. In the FrontPage Editor, select text that will identify the hyperlink.

  2. On the Insert menu choose Hyperlink, or click the Create or Edit Hyperlink button.

  3. In the Create Hyperlink dialog box, click the World Wide Web button.

    Your Web browser will be displayed.

  4. In your Web browser, go to the page or file that you want to be the target of your hyperlink, and type ALT+TAB to return to the FrontPage Editor.

    The location of the page you visited will be in the URL field.

  5. If you want the page that is the target of the hyperlink to appear in a frame in a frameset, select the frame in the Target Frame field.

  6. Click OK.

Û To Create a Text Hyperlink from the FrontPage Explorer

You can create a text hyperlink from an open page in the FrontPage Editor to another page in your FrontPage web using the FrontPage Explorer.

  1. In the FrontPage Explorer, in the Folders, All Files, Navigation, or Hyperlinks view, select the page or file to which you want to create a hyperlink by clicking and holding the left mouse button.

  2. Drag the page or file from the FrontPage Explorer to the FrontPage Editor.

    If the FrontPage Editor is minimized, drag over the FrontPage Editor tile in the Windows task bar, pause for a moment, and the FrontPage Editor will be activated.

  3. Move the pointer to the line at which you want to create the hyperlink and release the left mouse button.

FrontPage creates a hyperlink to the page or file.

Û To Follow a Text Hyperlink Forward

  • Hold down CTRL and click on the hyperlink, or click in the hyperlink and choose Follow Hyperlink from the shortcut menu.

The FrontPage Editor opens the target page for editing and makes it the active page. If the hyperlink points to a bookmark, the FrontPage Editor will jump to that bookmark.

If the target page is not in the current FrontPage web, FrontPage opens a copy of the page. You can save the page, including all images and other objects on the page, to the current FrontPage web or to a file.

Û To Change a Text Hyperlink

  1. In the FrontPage Editor, place the pointer anywhere in the text containing the hyperlink or select any part of the hyperlink.

  2. To change the text of the hyperlink, edit it in place.

    Create or Edit Hyperlink button

  3. To change the target of the hyperlink, on the Edit menu choose Hyperlink, or click the Create or Edit Hyperlink button.

  4. Edit the hyperlink in the Edit Hyperlink dialog box.

Û To Create a Bookmark

  1. In the FrontPage Editor, optionally select one or more characters of text.

  2. On the Edit menu, choose Bookmark.

  3. In the Bookmark Name field, enter the name of the bookmark, or accept the name that FrontPage suggests. You can include spaces in the bookmark name.

  4. Click OK.

Û To Visit a Bookmark

You can visit a bookmark on the current page without creating a hyperlink to it. You can visit a bookmark on another page only if there is a hyperlink to that bookmark from the current page.

  1. To visit a bookmark on the current page, in the FrontPage Editor’s Edit menu, choose Bookmark.

  2. In the Other Bookmarks on this Page field, select the bookmark to visit.

  3. Click Goto.

    The FrontPage Editor displays the page at the bookmark that you selected.

  4. Close the Bookmark dialog box by clicking OK or Cancel.

To visit a bookmark on another page, in the FrontPage Editor, place the pointer anywhere in a hyperlink to a bookmark and choose Follow Hyperlink on the shortcut menu. The FrontPage Editor displays the new page at the bookmark.

Û To Check the Status of Hyperlinks

  • In the FrontPage Explorer’s View menu, choose Hyperlink Status.

The Hyperlink Status view becomes active and the status of each hyperlink is displayed:

  • OK indicates that the hyperlink is good.

  • Broken indicates that the hyperlink is bad.

  • Unknown indicates that the hyperlink is external and has not been verified yet. To verify the hyperlink, select it, and choose Verify on the shortcut menu.

  • Added task indicates that the hyperlink is either broken or has not been verified yet, and a related task has been added to the list in the Tasks view.

Û To Verify External Hyperlinks

An external hyperlink is a hyperlink to a page or file outside the current FrontPage web. To verify external hyperlinks:

  1. In the FrontPage Explorer’s View menu, choose Hyperlink Status.

  2. To select a set of hyperlinks to verify, use CTRL+CLICK (for non-adjacent hyperlinks) or SHIFT+CLICK (to select a range of hyperlinks).

  3. In the FrontPage Explorer’s Tools menu, choose Verify Hyperlinks.

  4. Click Verify selected hyperlinks or Verify all hyperlinks.

    5. Each hyperlink is verified in sequence. The status of each hyperlink is displayed in the Hyperlink Status view:

    • OK indicates that the hyperlink has been checked and is good.

    • Broken indicates that the hyperlink has been checked and is bad.

    • Verifying indicates that the hyperlink is currently being verified.

    • Added task indicates that the hyperlink is either broken or has not been checked yet, and a related task has been added to the list in the Tasks view.
  5. To stop verifying hyperlinks, click the Stop button on the FrontPage Explorer’s toolbar. Then, to continue verifying hyperlinks, in the Tools menu, choose Verify Hyperlinks and choose Resume verification.

Note that you can also check the status of internal hyperlinks, which are verified automatically, in the Hyperlink Status view.


Next Steps

To | See
Learn more about hyperlinks and bookmarks | “Creating and Using Hyperlinks and Bookmarks,” in the Contents tab of the Microsoft FrontPage online Help system
Learn about images and image maps | “Images and Image Maps,”
Learn about frames and framesets | “Creating and Using Frames”


Creating and Using Frames

Frames and frames pages organize the display of pages in a Web site into regions in a Web browser’s window. Using frames pages to organize your content is one way of “orienting” users in your Web site.

The FrontPage Editor has a complete set of templates for creating frames pages. After you have created a frames page, you can create new frames or resize the current ones just by clicking and dragging.


What are Frames Pages?

Frames pages are HTML pages that divide the Web browser’s window into named regions called frames. In each frame a Web browser can display a different page. You control displaying a page in a frame by creating a hyperlink to the page and specifying the frame as the target of the hyperlink.

Without frames, when a user clicks a hyperlink on a page, the page containing the hyperlink is replaced by the page that the hyperlink points to; one page is displayed in place of another. With frames, when a user clicks a hyperlink on a page, the page containing the hyperlink does not have to disappear. Instead, the page that the hyperlink points to can be displayed in a separate target frame.

In a simple frames page there are two frames: one frame contains a page made up of a list of hyperlinks, and the other frame displays the pages that the hyperlinks point to. When a user clicks a hyperlink in the first frame, the page that the hyperlink points to is displayed in the second frame. The frame containing the hyperlinks is a “table of contents” or “channel selector” for the other frame.

For example, if a real estate agency wanted to create a page that describes properties for sale, the author could create a frames page. The “table of contents” frame would contain the list of properties and, as users click hyperlinks in this frame, the other frame would display each of the properties for sale.

Like any other HTML page, a frames page is displayed by a Web browser when a user follows a hyperlink to it. If your FrontPage web’s home page is a frames page, it will be displayed by Web browsers when users first surf to your Web site.

When you create a frames page, you assign each frame an initial page. The initial page is the page that Web browsers display in a frame when the frames page is first displayed. For example, if a frame is designed to display a table of contents page, you would assign it an initial page containing a list of hyperlinks. When a user surfs to the frame set, the page listing the hyperlinks will appear in its frame, and the user will click entries in this list to view pages in another frame.

Any page can have a default target frame. This is the name of a frame in which to display pages pointed to by hyperlinks on the page. When you set the initial page for a frame in a frames page, FrontPage may automatically assign another frame in the same frames page as the default target page for the initial page, based on the template you used to create the frames page. You can view and modify the default target frame for a page in the Page Properties dialog box.

A hyperlink can have a target frame that overrides the page default. You assign a hyperlink a target frame in the Create Hyperlink dialog box. If the target frame for a hyperlink is the special target Page Default, the hyperlink will use the page’s default target frame.

Should I Use Shared Borders and Navigation Bars With Frames? When you use frames pages and frames to organize your Web site, you should not use shared borders and navigation bars. These are alternate ways to organize the structure of your FrontPage web. They cannot be used effectively together.


Creating Frames Pages

You create a new frames page in the FrontPage Editor using the New Frames Page command on the Frame menu. When you choose this command, FrontPage opens the New dialog box. You create a frames page by selecting a template in the Frames tab of this dialog box. Once you have created a frames page, you can add or remove frames and reposition borders in the FrontPage Editor to customize the frames page.

Creating or Resizing Frames To quickly resize a frame, click and drag one of its borders. To create a new frame, hold down CTRL and drag one of the borders.

Along with listing all frames page templates, the Frames tab displays a preview of each frames page and a description of how the frames page could be used. For example:

  • Banner and Contents creates a banner frame at the top, in which you display your corporate logo or other general information. The left frame is the contents frame. This is where the page containing hyperlinks is displayed. The right frame is the main frame. Each time that a user clicks a different hyperlink in the contents frame, the page displayed in the main frame will change.

  • Header creates a contents frame on top and a main frame beneath it. The contents frame could contain an image map containing hyperlinks to pages that will be displayed in the main frame.

When the FrontPage Editor displays a new frames page, each frame is displayed as a bordered region with the following three buttons:

  • Set Initial Page sets the initial page. This is the page that is displayed in a frame when a frames page is first displayed in a Web browser.

    When you click Set Initial Page, FrontPage displays the Create Hyperlink dialog box. When you set an initial page, you are actually creating a hyperlink to the page. See “Creating Hyperlinks and Bookmarks”, for details on using the Create Hyperlink dialog box.

  • New Page creates a new page and sets it as the initial page for the frame.

    When you click New Page, FrontPage creates a blank new page, opens it in the frame, and makes it the initial page for the frame. When you save the frames page, FrontPage prompts you for a name and title for the page.

  • Help displays a help topic explaining how initial pages and frames work.


Creating Hyperlinks to Pages in Frames

To create a hyperlink to a page and display that page in a target frame, choose Hyperlink on the Insert menu. You create the hyperlink as described in “Creating Hyperlinks in FrontPage”.

Modify button

If you are creating a new hyperlink, FrontPage displays the page’s default target frame in the Target Frame field of the Create Hyperlink dialog box. To set a unique target frame for a hyperlink, click the Modify button in the Create Hyperlink dialog box. FrontPage displays the Target Frame dialog box.

In the Target Frame dialog box, the FrontPage Editor displays a “map” of the frames page that you can use to select a target frame for the hyperlink. To assign a target frame for a hyperlink, click a frame in this map. When you click a frame, its name is displayed in the Target Setting field. To use the page’s default target frame, click Page Default in the Common Targets field. You can make the target frame you selected the default target frame for the current page by clicking Make default for hyperlinks on this page.

Along with displaying your active frames page, the Target Frame dialog box lists common target frames for a hyperlink. These are a set of frames features (most of them advanced) used by Web browsers that support frame pages. You select a common target frame in the Common Targets field. The common target frames are:

  • Page Default sets the target frame of the hyperlink to the current page’s default target frame. This is the recommended setting.

  • Same Frame sets the target frame of the hyperlink to the frame that the hyperlink is in. Use this setting to override the page’s default target frame. For example, to create a hyperlink to a bookmark on the current page, specify the Same Frame target.

  • Whole Page sets the target frame of the hyperlink to be the entire Web browser window.

  • New Window specifies that a new instance of the Web browser should be launched on the desktop, and the page that is the target of the hyperlink should be displayed in the new instance of the Web browser.

  • Parent Frame specifies to display the page that is the target of the hyperlink in the frame that contains the current frameset tag. This is an advanced feature.


Frames Views

The FrontPage Editor has five views. Three views — Normal, HTML, and Preview — are available for all pages. (See “The FrontPage Editor’s Views” for details). When you edit a frames page, there are two additional views: No Frames and Frames Page HTML.

Frames pages can define alternative HTML for Web browsers to display if they do not support frames and frames pages. You use the No Frames view to edit the alternative HTML for the currently open frames page.

In the FrontPage Editor, you can display a different page in each frame of the currently open frames page. Using the HTML view, you can edit the HTML for all of the pages that are opened in your frames page. To edit the HTML of the frames page itself, use the Frames Page HTML view.


Using Frames Pages and Frames

Here are some commonly used FrontPage frames page and frame procedures. For the full set of FrontPage frames procedures, see “Creating and Using Frames” in the Contents tab of the Microsoft FrontPage online Help system.

Û To Create a Frames Page

  1. In the FrontPage Editor, choose New on the File menu.

  2. In the New dialog box, in the Frames tab, select a frames template.

    The template is displayed in the Preview field, and a description of the template is displayed in the Description field.

  3. Click OK.

The frames page is created and opened.

Û To Specify the Initial Page of a Frame

  • If an initial page has not been set, click Set Initial Page directly in the frame, and then in the Create Hyperlink dialog box choose the page to use as the initial page. You can also click New Page directly in the frame to create a blank new page and set it as the initial page for the frame.

  • If an initial page has been set for the active frame, choose Set Initial Page on the Frame menu, and then in the Create Hyperlink dialog box choose the page to use as the initial page.

Û To Open a Page in a Frame

  1. In the FrontPage Editor, with a frames page open, choose Open on the File menu.

  2. In the Open dialog box, select the page or file that you want to open.

  3. Click Open in current frame.

  4. Click OK.

Û To Create a Hyperlink to Display a Page in Another Frame

  1. In the FrontPage Editor, choose Hyperlink on the Insert menu.

  2. In the Create Hyperlink dialog box, select the page or file that you want to link to.

    FrontPage displays the current page’s default target frame in the Target Frame field of the Create Hyperlink dialog box.

    Note Steps 4 through 6 describe how you can change the target frame for a hyperlink. Go to step 7 if you want to use the page’s default target frame.

    Modify button

  3. To change the target frame for the hyperlink, click the Modify button in the Create Hyperlink dialog box.

    FrontPage displays the Target Frame dialog box.

  4. The FrontPage Editor creates a “map” of the frames page that you can use to select a new target frame. This map is displayed in the Current Frames Page field. To assign the target frame of a hyperlink, click the frame in this map.

    When you click a frame, its name is displayed in the Target Setting field.

  5. To make the target frame you selected the default target frame for the current page, click Make default for hyperlinks on this page.

  6. After selecting the target frame, click OK.

  7. In the Create Hyperlink dialog box, click OK to create the hyperlink to the target frame.

Û To Resize a Frame

  • Open the frames page in the FrontPage Editor and click and drag any frame border.

Û To Split a Frame

  • Open the frames page in the FrontPage Editor, hold down CTRL, and drag any frame border.

Û To Delete a Frame

  • In the FrontPage Editor, select the frame and on the Frame menu choose Delete Frame.

Û To Display Frame Borders

  1. With a frames page open in the FrontPage Editor, choose Frames Page Properties on the Frame menu.

  2. In the Frames tab of the Frames Page Properties dialog box, click Show Borders.

    Borders between frames will be shown when the frames page is displayed in a Web browser.

Û To Adjust the Spacing Between Frames

  1. With a frames page open in the FrontPage Editor, choose Frames Page Properties on the Frame menu.

  2. In the Frames tab of the Frames Page Properties dialog box, enter a value in the Frames Spacing field.

This specifies the amount of padding, in pixels, between frames when the frames page is displayed in a Web browser. The default for most Web browsers is 2 pixels.


Next Steps

To | See
Learn more about hyperlinks and bookmarks | “Creating Hyperlinks and Bookmarks”
Learn about images and image maps | “Images and Image Maps”
Learn more about frames and frame pages | “Creating and Using Frames,” in the Contents tab of the Microsoft FrontPage online Help system


Images and Image Maps

On the World Wide Web, authors use images on their pages to provide information or decoration, to communicate their personal style or that of their organization, to display graphic artwork or pictures of products, and to create image maps, which are images containing one or more hyperlink areas.

FrontPage has a complete set of tools for using images in FrontPage webs. In FrontPage, you can easily import images to your FrontPage web and insert them on pages, align them with text, create and edit image maps, and use images in page design.

FrontPage also includes image editing commands that let you change the appearance of your image. You can crop, rotate, and resize an image, make it black and white, give it beveled edges, and change its brightness and contrast.

Along with its comprehensive set of image mapping and editing commands, FrontPage includes the Microsoft Clip Gallery, a tool for previewing and inserting clip art, pictures, sounds, video clips, and animations. If you already have the Clip Gallery on your PC, FrontPage will add images and videos designed for Web pages to it.

In FrontPage, you create hyperlinks from image maps using a similar method to the one described for text hyperlinks in “Creating Hyperlinks and Bookmarks”. For a full discussion about creating hyperlinks using FrontPage, read that topic first. For a general overview of hyperlinks and URLs, see “Welcome to the World Wide Web”.


Importing and Saving Images

In the FrontPage Explorer, you can import an image or an entire folder of images to the FrontPage web, using the Import command on the File menu. You can also drag and drop image files from a desktop folder into the FrontPage Explorer or FrontPage Editor. When you drag an image that is not in the GIF or JPEG format into your FrontPage web, it is automatically converted to the GIF format (for images with 8 bits or less of color) or the JPEG format (for images with more than 8 bits of color). Images that you import using the Import command are not automatically converted.

Besides importing images in the FrontPage Explorer for later use, you can save images to a FrontPage web using the FrontPage Editor. When you save a page on which you have inserted an image from your file system, the FrontPage Editor will prompt you to save the image to the current FrontPage web. Also, when you open a page from the World Wide Web or from your file system and save it to the current FrontPage web, the FrontPage Editor prompts you to save any images that are not already in the current FrontPage web. If you save a page to a folder in your file system instead of to a FrontPage web, FrontPage will save the images on the page to the same folder.

When you create a FrontPage web, the FrontPage Explorer creates a folder called images. It is convenient to import all of your images to this folder so that you can easily locate them in your FrontPage web when you want to use them.

It is often convenient to import several images at once for later use in your pages. However, images take up space in your FrontPage web, so it’s a good idea to delete any images that you are not using before publishing a FrontPage web. Images that are not used on any pages in a FrontPage web are listed with the label Yes in the Orphan column of the All Files view in the FrontPage Explorer.


Inserting Images

You insert images on a page in the FrontPage Editor, using the Image command on the Insert menu. You can insert an image from the current FrontPage web, your file system, the World Wide Web, or the Microsoft Clip Gallery that FrontPage provides. You can also insert an image by dragging and dropping it from the Windows desktop or by cutting and pasting it from another application.

When you insert an image on a page in the FrontPage Editor, you are not actually placing the image directly on the page. You are creating a hyperlink from the page to the image, and both the image and the page must be in the same FrontPage web. This ensures that when you publish your FrontPage web and a user visits the page, the Web browser will follow the hyperlink to the image and retrieve it from the FrontPage web for display.

Images on pages can be in either of the image formats supported by Web browsers: Graphics Interchange Format (GIF) or Joint Photographic Expert Group format (JPEG). GIF is a method for encoding compressed pictures that contain up to 8 bits of color, and JPEG is commonly used on the World Wide Web for 24-bit color images. When you insert an image that is not in the GIF or JPEG format, it is automatically converted to the GIF format (for images with 8 bits or less of color) or the JPEG format (for images with more than 8 bits of color).

Along with inserting images you can insert video clips and other types of animated files. The Clip Gallery can import and insert into your document video and animation clips with file formats that can be played by the Windows 95 Media Player (for example, those with file name extension .avi).

When you choose the Image command, FrontPage displays the Image dialog box. You can insert an image from the current FrontPage web, your file system, the World Wide Web, or the Clip Gallery:

  • To insert an image from the current FrontPage web, locate the image in its folder in the Image dialog box, and double-click the image.

    From File button

  • To insert an image from your file system, click the From File button in the Image dialog box, locate the image in your file system, and click OK.

    World Wide Web button

  • To insert an image from the World Wide Web, click the World Wide Web button in the Image dialog box. This opens your Web browser. Browse to the image that you want to insert, and return to the Image dialog box using the Windows task bar or by pressing ALT+TAB. The image’s URL is displayed in the Image dialog box. Click OK to insert the image. When you insert an image from the World Wide Web, it is inserted from its current location on the World Wide Web. You are not prompted to import images inserted from the World Wide Web.

  • To insert clip art, click the Clip Art button of the Image dialog box. This opens the Clip Gallery, a tool for previewing and inserting clip art, pictures, sounds, video clips, and animations. You can also use the Clip Gallery to organize your clips by category or keyword so that it is easy to find the one you want. You can add new clips to the Gallery from other programs or from a special Microsoft site on the Web.

    How do I create a wallpaper effect on a page? A common effect in Web pages is to tile the background of a page with an image, giving the background the appearance of wallpaper. To do this in the FrontPage Editor, select Background on the Format menu. Click Specify Background and Colors, click Background Image, then select the background image in the Select Background Image dialog box and click OK, then click OK to close the Page Properties dialog box.


Viewing and Setting Image Properties

Images have properties that you can set in the FrontPage Editor. These properties specify the image’s type, give information to browsers about how to display the image, control how the image aligns with text, and set the image’s default hyperlink.

To set an image’s properties in the FrontPage Editor, select the image and choose Image Properties on the Edit menu. Some important image properties are:

  • The image source, which is the URL or, if the image is not on a server, the file name of the image.

  • The image type, GIF or JPEG. You can convert an image from one type to another in the Image Properties dialog box.

  • The image dimensions, including its width and height in pixels, and its size in bytes.

  • The image alignment. When you insert an image, it is placed at the insertion point and is treated, for display purposes, like a character in text. By setting its alignment, you can control how the image aligns with text and other images. For example, the alignment selection left places the image in the left margin and wraps the text that follows the image down the image's right side.

  • The image border thickness, which sets a border of the specified thickness in pixels around the image.

  • The alternate low-resolution image, which is a small-sized image that some browsers display while the larger-sized main image is being loaded from the Web server.

  • The image alternate text, which is displayed by browsers when image display is disabled or not available.

  • The image default hyperlink, which is the hyperlink to follow when a user clicks in any area in the image not covered by a hotspot. You can browse your FrontPage web from the Image Properties dialog box and change this hyperlink.

  • The number of times to repeat, for video clips.

  • When to start playing, for video clips.


Image Maps

Image maps are images containing hyperlinks. A well-designed image map gives users visual cues about where each hyperlink will take them. For example, an image map for a tourism bureau could be an actual map of a geographical region. By clicking on a place of interest on the map, a uses could follow a hyperlink to a topic describing the hotels and tourist attractions there. A business could use an image map to display pictures of its products. By clicking on a product, a potential customer could follow a hyperlink to a topic describing it.

The FrontPage Editor includes a complete interface for creating image maps. You simply insert the image on the page, and then use commands on the Image Toolbar to create your hotspots, which are graphically defined areas in an image that contain hyperlinks.

Creating hotspots is easy:

  • To draw a circle, click the Circle button, point to the center of the circle, and drag until the circle is the size you want.

  • To draw a rectangle, click the Rectangle button, point to the first corner of the rectangle, and drag the rectangle until it is the size you want.

  • To draw a polygon, click the Polygon button, point to the first corner of the polygon, then click to place each corner of the polygon. Double-click to finish the polygon.

  • To draw a text hotspot, click the Text button and type text in the rectangular region. After typing the text, move or resize the hotspot. You can assign a text hotspot a hyperlink or use it as a label on an image.

When you finish drawing a circular, rectangular, or polygonal hotspot, the Create Hyperlink dialog box opens automatically. To open the Create Hyperlink dialog box for a text hotspot, double-click the edge of the hotspot. For details on creating hyperlinks and using the Create Hyperlink dialog box, see “Creating Hyperlinks and Bookmarks”.

By default, image maps in published FrontPage webs use the FrontPage Server Extensions to process hyperlinks. Because the processing occurs on a Web server, they are called server-side image maps. Along with the default image map style, you can specify that FrontPage should generate image maps in the following formats: NCSA, CERN, and Netscape. To override the default image map style in the FrontPage Explorer, select the Web Settings command in the Tools menu, and select the image map style from the Style list in the Advanced tab.

If you are going to publish your FrontPage web on a server that does not have the FrontPage Server Extensions and does not have built-in support for NCSA, CERN, or Netscape server-side image maps, you can instruct FrontPage to generate client-side image maps. These are image maps that encode the destination URL of each hotspot directly on the page. Client-side image maps do not require any processing from your server to respond to clicks on the image map, so they are more efficient for the server and faster for the user. However, some older browsers do not support client-side image maps. To set client-side image mapping, in the FrontPage Explorer select the Web Settings command in the Tools menu and click Generate client-side image maps in the Advanced tab. If you select this setting and also select a server-side image map style, FrontPage will generate both types of image maps.


Image Editing

Along with commands that create hotspots, the Image toolbar contains commands that edit images. When you edit an image using one of these commands, you change its appearance or its size.

Saving an edited image changes the image permanently in your FrontPage web. When you save a page containing an edited image, FrontPage prompts you to save the image. If the image is used in more than one place in your FrontPage web, FrontPage prompts you to save a copy of it. If you do not save a copy of an image after editing it, the image’s appearance will change on every page on which it is used.


Cropping an Image

You crop an image using the Crop button on the Image toolbar. When you crop an image you shrink it by excluding all parts of the image outside of a rectangular area.

When you select Crop, FrontPage displays a cropping rectangle superimposed on the image. Resize the cropping rectangle and press Enter to crop the image.


Resampling an Image

You resample an image using the Resample command on the Image toolbar. Resampling an image changes the file size of the image to match the current size in which it is displayed. You can resample an image to a larger or smaller size.

Before you select Resample, resize the image by selecting one of its resizing handles and stretching or shrinking it. Then click the Resample button to resample the image at the new size.

What does resizing without resampling do? Although you can click an image and drag one of its selection handles to resize it, doing this does not change the underlying file size of the image. It only changes the HTML tags that tell Web browsers how to display it. For example, if you have a large image that you drag to a small size, it will be displayed at the smaller size by Web browsers but it will not take less time to load, because its underlying representation has not changed. To improve download performance, you must drag the image to a smaller size and then resample it at the smaller size.


Making a Color in an Image Transparent

A transparent color replaces one color in an image and lets the background of the page show through the image where that color was. An image can have only one transparent color. If an image already has a transparent color, selecting a new transparent color returns the existing transparent color to its original color.

You can make a color transparent in an image using the Make Transparent button. This changes the pointer to the Make Transparent pointer. Click a color to make it transparent.

If an image is a JPEG image, the FrontPage Editor prompts you to convert the image to GIF format when you make a color transparent. Transparency is not supported in JPEG images.


Washing Out an Image

You can washout an image using the Washout button on the Image toolbar. Washing out an image reduces its brightness and contrast. This is especially useful for creating background images.


Converting an Image to Black and White

You can convert an image to black and white using the Black and White button on the Image toolbar. Changing a color image to black and white converts the image’s color values to gray-scale values. Black and white images take less time to load than color images of the same size.

You convert an image to black and white by selecting it and clicking the Black and White button.


Rotating an Image

You rotate an image by selecting it and clicking one of the four rotation buttons:

  • Rotate Left rotates an image 90° counter-clockwise.

  • Rotate Right rotates an image 90° clockwise.

  • Flip turns an image upside-down.

  • Reverse reverses an image sideways.


Adjusting an Image’s Contrast

You can change an image’s contrast using the More Contrast and Less Contrast buttons on the Image toolbar. Increasing contrast sharpens an image’s features; decreasing contrast dulls them. With an image selected, click the More Contrast and Less Contrast buttons repeatedly to gradually adjust contrast.


Adjusting an Image’s Brightness

You can change an image’s brightness using the More Brightness and Less Brightness buttons on the Image toolbar. With an image selected, click the More Brightness and Less Brightness buttons repeatedly to gradually adjust brightness.


Adding a Beveled Edge

A beveled edge frames the border of an image using a three-dimensional effect. You can apply a beveled edge to an image by selecting the image and clicking the Bevel button on the Image toolbar.


Resetting an Image

If you do not like the results of a set of image editing commands, you can undo them using the Reset command on the Image toolbar. This command undoes all image editing commands that have been applied to an image since the last time it was saved or, for a new image, since it was inserted on the page.

Can I edit a page’s background image? Yes. Image editing commands work on a page’s background image when no images on the page are selected. You can use the following commands on the background image: Washout, Black and White, Rotate Left, Rotate Right, Reverse, Flip, More Contrast, Less Contrast, More Brightness, Less Brightness, Bevel, and Reset. If the background image is used on other pages, you are prompted to save a copy of it.


Using GIF Images for Bulleted Lists

You can use a GIF image as the bullet characters in a bulleted list. To select a GIF image to use as bullets, select an item in a list and chose List Properties from the shortcut menu. In the Image Bullets tab of the List Properties dialog box, click Use images from current theme or click Specify Image, then click Browse to select the image in the Image dialog box.

When you use GIF images as bullets, the bulleted list is formatted in HTML as a table.


Creating Thumbnail Images

A thumbnail is a small version of an image on a page that contains a hyperlink to a full-sized version of the same image. Putting a thumbnail image on a page with a hyperlink to its full-sized counterpart reduces the amount of information to download over the network before the complete page can be viewed in a Web browser. Users who want to view the full-sized image linked to a thumbnail can click the thumbnail. The Web browser then follows the hyperlink, causing the full-sized image to be loaded over the network and displayed.

You can quickly create a thumbnail image in the FrontPage Editor. Select the image on a page and choose AutoThumbnail on the Tools menu. FrontPage creates the thumbnail image, inserts it in place of the larger image, and creates a hyperlink to the full-sized image from the thumbnail image.


Using Images and Image Maps

Here are some commonly used FrontPage image and image map procedures. For the full set of FrontPage image and image map procedures, see “Using Images and Image Maps” in the Contents tab of the Microsoft FrontPage online Help system.

Û To Insert an Image from a File

When you insert an image from a file, the FrontPage Editor prompts you to import the image to your FrontPage web when you save the page.

You can insert the following types of images: GIF, JPEG (including progressive JPEG), Bitmap, PNG, Photoshop 3.0, WinFax, Kodak PhotoCD, Kodak FlashPix, TIFF, Windows Metafile, Sun Raster, Encapsulated PostScript, PCX, and Targa.

When you insert an image that is not in the GIF or JPEG format, it is automatically converted to the GIF format (for images with 8 bits or less of color) or the JPEG format (for images with more than 8 bits of color).

  1. In the FrontPage Editor, click the page where you want to insert the image.

  2. On the Insert menu, choose Image.

    From File button

  3. In the Image dialog box, click the From File button.

  4. In the Select File dialog box, use the Look In box and the box that lists files and folders to point to the file and folder where the image is stored. Choose a file type from the Files of Type drop-down field to list all the files of that type. Select the image you want to insert, then click OK.

Û To Insert an Image from the Current FrontPage Web

You can insert the following types of images: GIF, JPEG (including progressive JPEG), Bitmap, PNG, Photoshop 3.0, WinFax, Kodak PhotoCD, Kodak FlashPix, TIFF, Windows Metafile, Sun Raster, Encapsulated PostScript, PCX, and Targa.

When you insert an image that is not in the GIF or JPEG format, it is automatically converted to the GIF format (for images with 8 bits or less of color) or the JPEG format (for images with more than 8 bits of color).

  1. In the FrontPage Editor, click the page where you want to insert the image.

  2. On the Insert menu, choose Image.

  3. In the Image dialog box, select an image to insert it. To browse the contents of a folder, double-click it.

  4. Click OK.

Û To Insert an Image from the World Wide Web

When you insert an image from the World Wide Web, the image is always retrieved from its location on the World Wide Web. You are not prompted to import images inserted from the World Wide Web.

  1. In the FrontPage Editor, click the page where you want to insert the image.

  2. On the Insert menu, choose Image.

    World Wide Web button

  3. Click the World Wide Web button.

    This opens your Web browser.

  4. In your Web browser, surf to the image that you want to insert and then return to the Image dialog box.

  5. Click OK to insert the image.

Û To Import an Image to a FrontPage Web

When you import an image, you place a copy of it in your FrontPage web. To quickly import one or more images to the current FrontPage web, drag them from your desktop into the Folders, All Files, Navigation, or Hyperlinks view of the FrontPage Explorer. To import images to an import list, from which you can rename them and import them into the FrontPage web, do the following:

  1. In the FrontPage Explorer, on the File menu, choose Import.

  2. To add an image to the import list, click Add File. In the Add File to Import List dialog box, use the Look In box and the box that lists files and folders to point to the folder where the image is stored. Select the image, and click Open.

    To add the entire contents of a folder to the import list, click Add Folder. In the Browse For Folder dialog box, locate and select the folder, and click OK.

  3. To change the URL of any image before importing it, either to rename it or to change the image’s directory in the FrontPage web, click Edit URL to open the Edit URL dialog box.

    In the File location within your FrontPage web field, type a URL relative to the root of the current FrontPage web. For example, if you type the URL images/picture.gif, the image will be saved in the folder images below the root folder of the current FrontPage web. After changing the URL, click OK.

  4. To import the images and other files on the import list to the FrontPage web, click OK. While files are being imported, you can stop the process by clicking Stop.

Û To Create a Circular Hotspot

A hotspot is a region on an image that is a hyperlink.

  1. In the FrontPage Editor, select the image.

    The Image toolbar automatically displays when you select an image.

    Circle button

  2. Click the Circle button.

  3. Point inside the image.

    The pointer becomes a pencil.

  4. Point to the center of the circular hotspot you want to create.

  5. Drag the circular hotspot until it is the size you want.

    When you release the mouse button, the Create Hyperlink dialog box opens.

  6. In the Create Hyperlink dialog box, specify the target of the hyperlink.

Û To Create a Rectangular Hotspot

A hotspot is a region on an image that is a hyperlink.

  1. In the FrontPage Editor, select the image.

    The Image toolbar automatically displays when you select an image.

    Rectangle button

  2. Click the Rectangle button.

  3. Point inside the image.

    The pointer becomes a pencil.

  4. Point to the first corner of the rectangle you want to create, then click.

  5. Drag the rectangle until it is the size you want.

    When you release the mouse button, the Create Hyperlink dialog box opens.

  6. In the Create Hyperlink dialog box, specify the target of the hyperlink.

Û To Create a Polygonal Hotspot

A hotspot is a region on an image that is a hyperlink.

  1. In the FrontPage Editor, select the image.

    The Image toolbar automatically displays when you select an image.

    Polygon button

  2. Click the Polygon button.

  3. Point inside the image.

    The pointer becomes a pencil.

  4. Click where you want the first corner of the polygon to be, then click to place each corner of the polygon.

  5. Double-click to finish the polygon.

    The Create Hyperlink dialog box opens.

  6. In the Create Hyperlink dialog box, specify the target of the hyperlink.

Û To Create a Text Hotspot

You can create a text hotspot on a GIF image.

  1. In the FrontPage Editor, select the image.

    The Image toolbar automatically displays when you select an image.

    Text button

  2. Click the Text button on the Image toolbar.

    A rectangular region appears on the image with a cursor in it.

  3. Type the text you want.

    You can type a single line of text only.

  4. To wrap the text, resize the text region by clicking and dragging its resize handles. Move the region by clicking and dragging any border.

  5. Double-click an edge of the rectangle.

    The Create Hyperlink dialog box opens.

  6. In the Create Hyperlink dialog box, specify the target of the hyperlink.

Û To Select a Hotspot

  1. In the FrontPage Editor, click the image. The hotspots become visible.

  2. Click a hotspot to select it or drag over a portion of the image to select more than one hotspot.

  3. Use TAB and SHIFT+TAB to move between hotspots.

Û To Set an Image’s Default Hyperlink

An image's default hyperlink is the target of a hyperlink for any area that does not have a hotspot.

  1. Click the image to select it.

  2. On the Edit menu, choose Image Properties.

  3. In the General tab, enter the default hyperlink’s target as a URL in the Location field or click Browse to specify the default hyperlink’s target in the Create Hyperlink dialog box.

  4. After creating the hyperlink, click OK to close the Image Properties dialog box.

Û To Edit an Image

  • From the FrontPage Explorer or Editor, double-click an image to open it in its associated image-editing program.

  • In the FrontPage Editor, select the image and use any of the image editing commands on the Image toolbar.

Û To Add Text to an Image

  1. In the FrontPage Editor, select an image.

    The Image toolbar automatically displays when you select an image.

    Text button

  2. Click the Text button on the Image toolbar.

    If the image is a JPEG image, the FrontPage Editor prompts you to convert the image to GIF format, because text is not supported on JPEG images. If FrontPage converts the image, the number of colors in the image may be reduced and the image file may become larger.

  3. Type the text into the rectangular region that is displayed on the image.

  4. Resize the text region by clicking and dragging its resize handles, or move the region by clicking and dragging any border.

Adding text to an image does not change the image file in your FrontPage web.

Û To Insert Clip Art

FrontPage includes the Microsoft Clip Gallery, a tool for previewing and inserting clip art, pictures, sounds, video clips, and animations.

  1. In the FrontPage Editor, click the page where you want to insert the clip art.

  2. On the Insert menu, choose Clipart.

    This opens the Microsoft Clip Gallery.

  3. In the Clip Gallery select an image, picture, sound file, or video, and click Insert.

Û To Make a Color in an Image Transparent

Making a color in an image transparent lets the background of the page show through the image where that color was. An image can have only one transparent color. If an image already has a transparent color, selecting a new transparent color returns the current transparent color to its original color.

  1. In the FrontPage Editor, select an image.

    The Image toolbar automatically displays when you select an image.

    Make Transparent button

  2. Click the Make Transparent button. The pointer changes to the Make Transparent pointer.

  3. In the image, click a color to make it transparent.

    If the image is a JPEG image, the FrontPage Editor prompts you to convert the image to GIF format, because transparency is not supported in JPEG images. If FrontPage converts the image, the number of colors in the image may be reduced and the image file may become larger.

Û To Crop an Image

When you crop an image, you exclude all parts outside of a rectangular area.

  1. In the FrontPage Editor, select the image.

    The Image toolbar automatically displays when you select an image.

    Crop button

  2. Click the Crop button on the Image toolbar.

    FrontPage displays a cropping rectangle superimposed over the image.

  3. Resize the cropping rectangle and press Enter.

Û To Resample an Image

Resampling an image changes the file size of the image to match the current size in which it is displayed. You can resample an image to a larger or smaller size.

  1. In the FrontPage Editor, select the image.

    The Image toolbar automatically displays when you select an image.

  2. Select one of the resizing handles and stretch or shrink the image.

    Resample button

  3. Click the Resample button on the Image toolbar.

Û To Convert an Image to Black and White

  1. In the FrontPage Editor, select the image.

    To convert the page’s background image you do not need to select it.

    Black and White button

  2. Click the Black and White button on the Image toolbar.

Û To Rotate an Image

  1. In the FrontPage Editor, select the image.

    To rotate the page’s background image you do not need to select it.

  2. Do one of the following:

Rotate Left button

  • To rotate an image 90° counter-clockwise, click Rotate Left on the Image toolbar.

Rotate Right button

  • To rotate an image 90° clockwise, click Rotate Right on the Image toolbar.

Flip button

  • To turns an image upside-down, click Flip on the Image toolbar.

Reverse button

  • To reverse an image sideways, click Reverse on the Image toolbar.

Û To Adjust an Image’s Contrast

  1. In the FrontPage Editor, select the image.

    To adjust the page’s background image you do not need to select it.

    More Contrast button

  2. Do one of the following:
    • To increase contrast, click More Contrast on the Image toolbar.

    Less Contrast button

    • To decrease contrast, click Less Contrast on the Image toolbar.

Continue using these buttons until the contrast is correct.

Û To Adjust an Image’s Brightness

  1. In the FrontPage Editor, select the image.

    To adjust the page’s background image you do not need to select it.

    More Brightness button

  2. Do one of the following:
    • To increase brightness, click More Brightness on the Image toolbar.

    Less Brightness button

    • To decrease brightness, click Less Brightness on the Image toolbar.

Continue using these buttons until the brightness is correct.

Û To Washout an Image

Washing out an image reduces its brightness and contrast. This is especially useful for page-background images.

  1. In the FrontPage Editor, select the image.

    To washout the page’s background image you do not need to select it.

    Washout button

  2. Click the Washout button on the Image toolbar.

Û To Add a Beveled Edge to an Image

A beveled edge slants the border of an image, producing a three-dimensional effect.

  1. In the FrontPage Editor, select the image.

    To bevel the page’s background image you do not need to select it.

    Bevel button

  2. Click the Bevel button on the Image toolbar.

Û To Reset an Image

If you do not like the results of one or more image editing commands, you can undo them. This undoes all image editing commands that have been applied to the image since the last time it was saved or, for a new image, since it was inserted on the page.

  1. In the FrontPage Editor, select the image.

    To reset the page’s background image you do not need to select it.

    Reset button

  2. Click the Reset button on the Image toolbar.

Û To Create a Thumbnail Image

A thumbnail image is a small version of an image on a page that contains a hyperlink to a full-size version of the same image.

  1. In the FrontPage Editor, select the image.

  2. On the Tools menu, choose AutoThumbnail.

FrontPage creates the thumbnail image, inserts it in place of the larger image, and creates a hyperlink to the full-sized image from the thumbnail image.


Next Steps

To | See
To learn more about images and image maps | “Using Images and Image Maps,” in the Contents tab of the Microsoft FrontPage online Help system
To learn more about hyperlinks | “Creating Hyperlinks and Bookmarks”


Creating Active Pages

Active pages are pages that change based on user actions and that have a dynamic, engaging appearance. Using ActiveX, Java, Plug-ins, CGI scripting, and other methods, Web designers have created new and exciting tools for making Web pages come alive. Because FrontPage comes with a full set of active page elements, you can take advantage of these latest active page techniques, including Dynamic HTML, without having to write a line of code.

This topic gives you a tour of the FrontPage components and other active page elements that you can insert on your pages using the FrontPage Editor.


Hover Buttons

Hover buttons are animated buttons. When the mouse pointer moves over a hover button, or when a hover button is clicked, the button comes alive. It glows, changes colors, or displays some other effect to attract the user. You assign a hyperlink to a hover button and specify its text message. You can also display an image on a hover button.

You create a hover button on the Insert menu by pointing to Active Elements and then clicking Hover Button. In the Hover Button dialog box, you supply the button text and the hyperlink, and you select the type of effect and the effect’s colors. Along with text, you can display an image on a Hover Button.

The best way to configure a hover button is to create one and preview it, trying various effects and color schemes until it matches your needs. To preview a hover button, choose Preview in Browser on the FrontPage Editor’s File menu.


Banner Ad Manager

Banner ads are dynamic “billboards” that display series of images. As each new image in the series is displayed, a visual transition effect is applied by the Web browser, so that the transition from one image to the next occurs seamlessly. You can associate a hyperlink with a banner ad.

For example, you can use a banner ad to generate interest in a service on the World Wide Web, and invite the user to learn more about the service by clicking on the ad. Even if you do not associate a hyperlink with a banner ad, you can use it to design a compelling visual presentation on your page.

You create a banner ad on the Insert menu by pointing to Active Elements and then clicking Banner Ad Manager. In the Banner Ad Manager dialog box, you supply a series of images, the amount of time to display each image, and a hyperlink, and you select the type of transition effect. The Banner Ad Manager dialog box has controls for adding images to the presentation, removing them, and rearranging their order.

The best way to select the right transition effect for a banner ad is to create one and preview it, trying various effects until one matches your needs. To preview a banner ad, choose Preview in Browser on the FrontPage Editor’s File menu.


Marquees

A marquee is a region on a page that displays a horizontally scrolling text message, much like a theater marquee or stock ticker. Use a marquee to draw a user’s attention to a line of text, such as a headline or attention-grabbing announcement.

You create a marquee on the Insert menu by pointing to Active Elements and then clicking Marquee. In the Marquee dialog box, you supply the marquee text, background color, type of marquee effect, marquee speed, and other properties.

As with other active page elements, the best way to configure a marquee is to create one and preview it, trying various effects and color schemes until it matches your needs. To preview a marquee, use the FrontPage Editor’s Preview tab (if you have Microsoft Internet Explorer, version 3.0 or higher, installed) or choose Preview in Browser on the FrontPage Editor’s File menu.


Hit Counters

A Hit Counter is a FrontPage component that keeps a count of how many users have visited the page it is on. By putting a Hit Counter on the Home Page of your FrontPage web, you can keep track of how many users have visited your Web site.

You create a Hit Counter on the Insert menu by pointing to Active Elements and then clicking Hit Counter. In the Hit Counter Properties dialog box, select a counter style. This is a GIF image containing the digits zero through nine. Reset a hit counter by clicking Reset Counter To and supplying the number to reset the counter to.

To supply a custom GIF image containing a customized set of the digits zero through nine, enter the relative URL of the image in the Custom Image field. If you supply a custom image, be sure to space the ten digits evenly.

For an overview of FrontPage components, including descriptions of other FrontPage components, see “Introducing FrontPage Components”.


Dynamic HTML Features

Dynamic HTML gives authors enhanced control of the elements on their pages. When you have applied one of the FrontPage Dynamic HTML commands to text or graphics, Microsoft Internet Explorer 4.0 and other Web browsers that support Dynamic HTML will animate the text or graphics or apply other effects that you select. Because it does not require fetching information from the Web server, Dynamic HTML is very efficient, and presents the user with a lively, compelling page without requiring time-consuming network activity.

The FrontPage Editor includes the following Dynamic HTML features:

  • animation

  • page transitions

  • outlining

  • form enhancements

This topic describes animation, page transitions, and outlining. For information on Dynamic HTML form enhancements, see “Forms and Form Fields”.


Animation

You can apply Dynamic HTML animation to any selected page element. FrontPage includes many animation effects that cause the element to “fly” into view from a corner or side of the page, or that cause the element to appear in some other eye-catching way, such as spiraling into view.

You animate one or more selected page elements on the Format menu by pointing to Animation and then clicking the effect you want, such as Zoom In or Fly From Top.


Page Transition Effects

You can apply a page transition effect to the active page. These are movie-like effects that can occur when the user surfs to your page or away from it. You can further limit a transition effect to happen only when the user enters or leaves your Web site.

You apply a page transition effect on the Format menu by pointing to Page Transition. In the Page Transitions dialog box, select the event, such as entering your Web site, that will trigger the effect, and select the type of effect.

To choose a page transition effect, create one and preview it. You can preview a transition effect in the FrontPage Editor’s Preview tab (if you have Microsoft Internet Explorer, version 4.0 installed) or by choosing Preview in Browser on the FrontPage Editor’s File menu (if you have Microsoft Internet Explorer, version 4.0 or another Web browser that supports Dynamic HTML installed).


Outlining

Outlining is a dynamic method for displaying multilevel lists. When a list has outlining enabled and an item in the list has a sub-list indented below it, the sub-list is not displayed unless the user clicks on the list item above it. Clicking on the list item a second time hides the sub-list. By letting users expand and contract a list, you make the list more interactive and also save space in the Web browser window.

You apply outlining to a list by selecting any item in the list and choosing List Properties from the shortcut menu. In any tab of the List Properties dialog box, click Enable Collapsible Outlines. Outlining is applied to the list containing the currently selected item along with any sub-lists of the list.


Introducing FrontPage Components

FrontPage components are dynamic objects that you insert on your pages. They provide complex functionality to your FrontPage web that would otherwise require you to write scripts and install them on the Web server.

Most FrontPage components do some processing and then generate HTML. The HTML that a FrontPage component generates depends on conditions in your FrontPage web at the time the component is activated. For example, a FrontPage Search Form generates an HTML list of hyperlinks to all the pages in a FrontPage web that contain a word submitted by a user. The Search Form supplies this HTML list to the Web browser which displays it to the user.

Some FrontPage components are only activated when a user visits the page in a Web browser. For example, a Search Form is activated when a user submits the form. Other FrontPage components are only activated when an author is using FrontPage. For example, a FrontPage Table of Contents generates an HTML table of contents when an author adds the table of contents and saves the page.

You can insert some FrontPage components on a page and you can associate others with a form. This topic describes the following FrontPage components:

  • Table of Contents

  • Search Form

  • Include Component

  • Scheduled Image

  • Scheduled Include Page

  • Substitution Component

For details on FrontPage components that you can associate with forms, see “Forms and Form Fields”.

You insert most FrontPage components on a page in the FrontPage Editor using the FrontPage Component command on the Insert menu. This command opens the Insert FrontPage Component dialog box, which lists most FrontPage components. After selecting a FrontPage component and clicking OK, you can configure the FrontPage component by editing its dialog box. (Other FrontPage components are available on the Insert menu or on the Active Elements sub-menu.) After you configure the FrontPage component and close its dialog box, the FrontPage Editor inserts the FrontPage component on the page.

WebBot Pointer

When you insert a FrontPage component on a page, the FrontPage Editor displays a placeholder representing it. You can cut, copy, and paste this placeholder, but you cannot click inside it to edit text. When you drag the pointer over a FrontPage component on a page, the pointer becomes the FrontPage “WebBot” pointer.

You can edit a FrontPage component by changing any setting in its properties dialog box. To open a FrontPage component’s properties dialog box, double-click the component on the page or point to the component and open its properties dialog box from the shortcut menu.

Can I add my own FrontPage components to FrontPage? Yes. Using the FrontPage Software Developer’s Kit, you can create your own FrontPage components and add them to the FrontPage Editor. The FrontPage Software Developer’s Kit is on the Microsoft FrontPage CD-ROM, in the \SDK folder.

The following FrontPage components require that the FrontPage Server Extensions are installed on the Web server on which the FrontPage web is published:

  • Search Form

  • Confirmation Field

  • Default FrontPage form handler

  • Registration form handler

  • Discussion form handler

The FrontPage Server Extensions are a set of programs that support authoring and administering FrontPage webs, along with browse-time FrontPage functionality. They are available for the Microsoft Internet Information Server (IIS) and other popular Windows and UNIX web servers.

When a Web server has the FrontPage Server Extensions installed, FrontPage web authoring and administration is available from a PC or Macintosh computer that can communicate with the Web server over the Internet or an intranet and that has the FrontPage Explorer and Editor installed. The browse-time functionality of the Server Extensions is available from any Web browser on the Internet or an intranet.

For full documentation of the FrontPage Server Extensions, see the FrontPage Server Extensions Resource Kit, in the \SERK folder of your Microsoft FrontPage CD-ROM.

How do I Get the FrontPage Server Extensions? If you are not sure if the FrontPage Server Extensions are available for your Web server, visit http://www.microsoft.com/frontpage. This Web site also has information about how to download and install the FrontPage Server Extensions.


Table of Contents

The Table of Contents component creates an outline of your FrontPage web with hyperlinks to each page in it. When your FrontPage web is published, users can find what they are looking for using the table of contents. The FrontPage Table of Contents updates this outline whenever any page is added, deleted, or renamed in the FrontPage web.

When you create a FrontPage Table of Contents you can specify:

  • The page to use as the starting point of the table of contents. Typically this is your home page, but you can start your table of contents on any page in your FrontPage web.

  • The size of the table’s heading.

  • Whether or not to show each page only once. If you choose to show pages more than once, each page will appear in the table of contents once for each other page in the FrontPage web that has a hyperlink to it.

  • Whether or not to show orphan pages. Orphan pages cannot be reached by following hyperlinks starting from the home page. By displaying orphan pages in your table of contents, you provide users with a way to find them.

  • Whether or not to rebuild the table of contents each time a page is edited in your FrontPage web. If you do not want experimental changes to your FrontPage web to be reflected in the table of contents, you can specify not to rebuild the table of contents each time you edit a page.

You can also create a table of contents for your FrontPage web by creating a new page in the FrontPage Editor and selecting the Table of Contents template. This creates a page containing a FrontPage Table of Contents component configured to create hyperlinks to every page in your FrontPage web.


Search Forms

The FrontPage Search Form creates a form to use to search your FrontPage web. When a user enters one or more words and submits a Search Form, it searches your entire FrontPage web and returns a list of hyperlinks to each page containing the words.

When you create a Search Form you can specify:

  • The appearance of the search form. You can specify the labels for the buttons that submit and clear the form and the label and width of the text entry field.

  • The pages in the FrontPage web to search. To configure the Search Form to search all the pages in the web that are not stored in hidden directories — directories preceded by the underscore character — enter All. Alternatively, if the FrontPage web has a discussion group, you can specify to search only the entries in a single discussion group by supplying the name of the discussion group directory. (A discussion group directory is also preceded by an underscore character and is hidden from users.)

  • Additional information to display. You can configure the Search Form to display a score value, indicating the quality of the match, along with the size of the page containing the match and the date the page was last edited.

The text search engine used by the Search Form accepts queries formed using the words and, or, not, the asterisk character, and parentheses. For example:

  • A search for “FrontPage Editor” finds pages in the FrontPage web containing FrontPage or Editor.

  • A search for “FrontPage or Editor” also finds pages in the FrontPage web containing FrontPage or Editor.

  • A search for “FrontPage and Editor” finds pages in the FrontPage web containing both FrontPage and Editor.

  • A search for “FrontPage not Editor” finds pages in the FrontPage web containing FrontPage and not containing Editor.

  • A search for “FrontPage and (Editor or Explorer)” finds pages in the FrontPage web containing FrontPage and either Editor or Explorer.

  • A search for “Front*” finds pages in the FrontPage web containing words starting with Front.

You can also create a Search Form for your FrontPage web by creating a new page in the FrontPage Editor and selecting the Search Page template. This creates a page containing a Search Form along with some details on how to use it.


Include Components

The three FrontPage Include components — the Scheduled Include Page component, Scheduled Image component, and Include Page component — are all replaced by a page or file in your FrontPage web. The two scheduled FrontPage components are only active during a time period that you specify.

You use FrontPage Include components to give the pages in your FrontPage web a unified appearance and to simplify maintenance of your FrontPage web. For example, you can create an informational page containing your address, phone number, and e-mail address and include it throughout your FrontPage web. Then, if you change your address on this informational page, it will automatically be updated on every page that has it included.

When you create an Include Page component or FrontPage Scheduled Include component, you specify the location of the page to include. When you create a FrontPage Scheduled Image component, you specify the location of an image.

For FrontPage Scheduled Include components and FrontPage Scheduled Image components you also can specify:

  • The date and time to start and stop including the page or image.

  • An alternate image or page to include when a user visits the page outside of the specified time period.

FrontPage Scheduled Include components and FrontPage Scheduled Image components are activated when you make any change to your FrontPage web. To ensure proper timing of these FrontPage components, make some change to your FrontPage web daily.


Timestamps

The FrontPage Timestamp inserts a date and timestamp that either corresponds to the last time the page was edited and saved to the Web server or the last time the page was automatically updated. (A page is automatically updated to recalculate its hyperlinks or FrontPage components.)

Putting a timestamp on your page lets users know how recently the page has been modified. A recent timestamp means that the material is new, motivating users to read it. Also, by checking the page’s timestamp, users can determine if the page has changed since the last time they viewed it.

When you create a Timestamp, you can choose the format in which to display the date and time from a list of standard formats.


Substitution Components

The FrontPage Substitution Component inserts text on the page that is the value of a variable in your FrontPage web. There are four built-in variables that you can insert:

  • Author is replaced by the name of the author who created the page.

  • ModifiedBy is replaced by the name of the author who most recently modified the page.

  • Description is replaced by a description of the current page.

  • Page-URL is replaced by the page’s URL.

Along with inserting built-in variables, you can use the FrontPage Substitution component to insert any variables you have added to a FrontPage web, using the Web Settings command in the Tools menu of the FrontPage Explorer. For example, you could add a variable to store your fax number and use a Substitution Component to insert it on pages in your FrontPage web. When you change the value of the variable (for example, your fax number) FrontPage will update the Substitution Component on all pages, updating your fax number.

Some FrontPage web wizards add variables to FrontPage webs that you can also insert on a page.


Using Active Page Elements

Here are some commonly used active page element and FrontPage component procedures.

Û To Create a Hover Button

  1. In the FrontPage Editor, click the page where you want to insert the hover button.

  2. On the Insert menu, choose Active Elements and point to Hover Button.

  3. If you want the button to display text, enter the text in the Button Text field.

  4. To create a hyperlink from the button, type a URL in the Link To field, or click Browse and select a hyperlink target in the Select Hover Button Hyperlink dialog box.

  5. Select a Button Color, Background Color, Effect, and Effect Color.

  6. To play a sound file when a user clicks the hover button, click Custom and, in the Play Sound section, enter the URL of a sound file in the On Click field. To play a sound file when a user moves the mouse pointer over the hover button, enter the URL of a sound file in the On Hover field. Click OK to close the Custom dialog box.

  7. To display a custom image in place of hover button text, click Custom and, in the Custom Image section, enter the URL of an image in the Button field. To display an image when a user moves the mouse pointer over the hover button, enter the URL of an image in the On Hover field. Click OK to close the Custom dialog box.

  8. Click OK.

Û To Create a Banner Ad

  1. In the FrontPage Editor, on the Insert menu, point to Active Elements and then click Banner Ad Manager.

  2. In the Banner Ad Manager dialog box, for each image in the series, click Add and, in the Add Image for Banner Ad dialog box, select the image from the current FrontPage web, your file system, or the World Wide Web.

  3. To change the position of an image in the banner ad, select the image and click Move Up or Move Down.

  4. In the Effect field, select the transition effect.

    The best way to select the right transition effect for a banner ad is to create one and preview it, trying various effects until one matches your needs. To preview a banner ad, use the FrontPage Editor’s Preview tab (if you have Microsoft Internet Explorer, version 3.0 or higher, installed) or choose Preview in Browser on the FrontPage Editor’s File menu.

  5. To create a hyperlink from the Banner Ad, enter a URL in the Link To field, or click Browse and select a hyperlink target in the Select Banner Ad Hyperlink dialog box.

  6. Optionally adjust the Banner Ad’s width, height, and the amount of time to display each image.

  7. Click OK.

Û To Insert a Marquee

A marquee is a region on a page that displays a horizontally scrolling text message.

  1. In the FrontPage Editor, place the insertion point on a blank line of text, or select the text that you want to display in the marquee.

  2. On the Insert menu, point to Active Elements, then click Marquee.

    The Marquee Properties dialog box is displayed.

  3. In the Text box, enter the line of text that the marquee should display. If you selected text on the page in step one, the Text box contains the selected text.

  4. Adjust the values for direction, movement speed, behavior, alignment, size, repetitions, and background color.

  5. Click OK.

  6. To preview the marquee as it will appear when the page is browsed on the World Wide Web, on the File menu, choose Preview in Browser.

Û To Insert a Hit Counter

  1. In the FrontPage Editor, place the insertion point where you want to create the Hit Counter.

  2. On the Insert menu point to Active Elements and then click Hit Counter.

  3. In the Hit Counter Properties dialog box, in the Counter Style field, select a counter style.

    This is a GIF image containing the digits zero through nine.

  4. To reset the hit counter click Reset Counter To and enter the number to reset the counter to.

  5. To supply a GIF image containing a customized set of the digits zero through nine, enter the relative URL of the image in the Custom Image field. Be sure to space these digits evenly in the custom image.

  6. Click OK.

Û To Animate One or More Page Elements

  1. In the FrontPage Editor, select the text, graphics, or other page elements to animate.

  2. On the Format menu, choose Animation and then click the effect you want, such as Zoom In or Fly From Top.

    Animation is displayed on Microsoft Internet Explorer 4.0 or on other Web browsers that support Dynamic HTML.

Û To Create a Page Transition Effect

You can apply a page transition effect to the active page.

  1. In the FrontPage Editor, on the Format menu choose Page Transition.

  2. In the Page Transitions dialog box, in the Event field, select the event, such as entering your Web site, that will trigger the effect.

  3. In the Page Transitions dialog box, in the Transition Effect field, select the transition effect you want to apply.

  4. In the Page Transitions dialog box, in the Duration field, select the amount of time, in seconds, that you want the effect to last.

  5. Click OK.

    Transition effects are displayed on Microsoft Internet Explorer 4.0 or on other Web browsers that support Dynamic HTML.

Û To Create a Collapsible Outline

  1. In the FrontPage Editor, select any item in a list and choose List Properties from the shortcut menu.

  2. In any tab of the List Properties dialog box, click Enable Collapsible Outlines.

    Dynamic outlining is applied to the list containing the currently selected item along with any sub-lists of the list.

Û To Create a Table of Contents

  1. In the FrontPage Editor, click the page where you want to create a table of contents.

  2. On the Insert menu, choose Table of Contents.

  3. In the Page URL for Starting Point of Table field, type the relative URL of the page to list as the starting page in the table of contents.

    If you do not know the relative URL of the page, click Browse to open the Current Web dialog box, then click the page that you want to use as the starting point of the table of contents.

  4. In the Heading Size field, select the paragraph style for the caption of the table of contents.

  5. To show each page once in the table of contents, click Show Each Page Only Once.

  6. To display pages in your FrontPage web that are not the targets of hyperlinks, click Show Pages With No Incoming Hyperlinks.

    Note The starting point page is always displayed.

  7. To specify that the table of contents should be recalculated whenever any page in the FrontPage web is edited, click Recompute Table of Contents When Any Other Page Is Edited.

  8. Click OK.

Û To Create a Search Form

A Search Form is a one-line text box in which users type words to find in your FrontPage web. When the user submits the form, it creates a list of links to pages containing one or more of the words.

  1. In the FrontPage Editor, click where you want to create the search form.

  2. On the Insert Menu, point to Active Elements and then click Search Form.

    The Search Form Properties dialog box opens.

  3. In the Search Form Properties tab, in the Label for Input field, enter the label for the one-line text box field or accept the default.

  4. In the Search Form Properties tab, in the Width in Characters field, enter the width in characters of the one-line text box field or accept the default.

  5. In the Search Form Properties tab, in the Label for “Start Search” Button field, enter the label for the push button that starts the search or accept the default.

  6. In the Search Form Properties tab, in the Label for “Clear” Button field, enter the label for the push button that clears the form or accept the default.

  7. In the Search Results tab, in the Word List to Search field you can indicate that the entire FrontPage web should be searched for the word or that a single discussion group directory should be searched. (Discussion group directories are defined in the Directory field of the Discussion tab in the Settings for Discussion Form Handler dialog box.)
    • Specify All to search all of the FrontPage web except discussion group directories.

    • Specify a single discussion group directory, such as _internet to limit the search to that directory.
  8. In the Search Results tab, choose any of the following fields to include additional information in the search results:
    • Score indicates the quality of the match.

    • File Date indicates the date and time the document containing the match was most recently modified.

    • File Size indicates the size of the document containing the match, in kilobytes.
  9. Click OK.

Û To Include a Page in Another Page

  1. In the FrontPage Editor, click the page where you want to include the contents of another page.

  2. On the Insert menu, choose FrontPage Component.

  3. In the Insert FrontPage Component dialog box, choose Include Page and click OK.

  4. In the Page URL to Include field, type the relative URL of the page to include. Click Browse and click a page or file in the Current Web dialog box to include it.

  5. Click OK.

Û To Include an Image in a Page During a Time Period

  1. In the FrontPage Editor, click the page where you want to include an image during a specified time period.

  2. On the Insert menu, choose FrontPage Component.

  3. In the Insert FrontPage Component dialog box, choose Scheduled Image and click OK.

  4. In the Image to Include field, type the relative URL of the image to include it. Click Browse and in the Image dialog box, click an image to include it.

  5. In the Starting Date and Time fields, specify the year, month, day, and time after which the image should be included.

  6. In the Ending Date and Time fields, specify the year, month, day, and time after which the image should no longer be included.

  7. In the Optional Image to Include Before or After the Given Dates field, type the relative URL of an image to include if the current date and time is not within the specified time period. Click Browse then click an image in the Current Web dialog box to include it.

  8. Click OK.

Û To Include a Page in Another Page During a Specified Time Period

  1. In the FrontPage Editor, click the page where you want to include the contents of another page during a specified time period.

  2. On the Insert menu, choose FrontPage Component.

  3. In the Insert FrontPage Component dialog box, choose Scheduled Include Page and click OK.

  4. In the Page URL to Include field, type the relative URL of the page to include. Click Browse and in the Current Web dialog box, click a page or file to include it.

  5. In the Starting Date and Time fields, specify the year, month, day, and time after which the page should be included.

  6. In the Ending Date and Time fields, specify the year, month, day, and time after which the page should no longer be included.

  7. In the Optional Page URL to Include Before or After the Given Dates field, type the relative URL of a page to include if the date and time is outside of the specified time period. Click Browse then click a page or file in the Current Web dialog box to include it.

  8. Click OK.

Û To Timestamp a Page

  1. In the FrontPage Editor, click the page where you want to insert the timestamp.

  2. On the Insert menu, choose Timestamp.

  3. In the Display field of the Timestamp Properties dialog box, choose which event the timestamp will record:
    • Date This Page Was Last Edited

    • Date This Page Was Last Automatically Updated
  4. In the Date Format field, select the date format from the drop-down list.

  5. In the Time Format field, select the time format from the drop-down list.

    You must select either a date format, a time format, or both.

  6. Click OK.

Û To Insert a Variable

  1. In the FrontPage Editor, click the page where you want to insert the variable.

  2. On the Insert menu, choose FrontPage Component.

  3. In the Insert FrontPage Component dialog box, choose Substitution and click OK.

  4. In the Substitute With drop-down list, select a standard variable or one that an author has added to the FrontPage web.

  5. Click OK.

The variable is inserted and its value — which is set in the Parameters tab of the FrontPage Web Settings dialog box — is displayed in the style of the paragraph containing it.


Next Steps

To | See
Learn more about FrontPage components | The Index tab of the Microsoft FrontPage online Help system
Learn about FrontPage components that handle forms | “Forms and Form Fields”


Forms and Form Fields

A form is a collection of form fields on a page along with a form handler, a method of collecting information from the form. Forms are a key to making your FrontPage web interactive. Users can “talk back” to your FrontPage web by filling in forms in your FrontPage web and submitting them. The layout of a form can include form fields, text in all paragraph styles, tables, images, and most other objects that can be inserted on a page. In FrontPage, you create forms using a simple point-and-click interface.

A user fills in a form by typing into text fields, clicking radio buttons and check boxes, and selecting options from drop-down menus. The user then submits the form by clicking a button, usually labeled “Submit.” When this happens, FrontPage appends the contents of the form to a file in your FrontPage web. This is the file you will periodically open to gather the collected information from the form. You can also configure a form to send its data to your e-mail address.

A form’s handler is not visible to a user but is associated with a form by FrontPage. It is invoked when a user submits the form. FrontPage automatically assigns a default form handler to each form that you create. You can also select from a set of FrontPage form handlers or add you own custom form handler to a form.

The uses of forms on the World Wide Web are always evolving. Some typical uses are:

  • To collect names, addresses, telephone numbers, e-mail addresses, and other information to register users for a service or event.

  • To collect feedback about a Web site.

  • To gather information for the purchase of an item or service. For example you can design your form to collect size, color, and quantity information for clothes purchases. You can also collect payment information, such as credit card type, number, and expiration date.

  • To moderate a discussion forum about a topic of your choice. Using the FrontPage Discussion Web Wizard, you can create an entire FrontPage discussion web. Using forms, users submit articles, create new areas for discussion (called threads) or add their comments to existing threads.


Creating Forms

You can put a form field anywhere on the page where you can type text. On the Insert menu select Form Field and click the type of form field that you want. You can also create form fields using the Forms toolbar:

In FrontPage, you make a new form by creating a form field anywhere on the page outside of other forms. (To help you see the boundaries of forms, the FrontPage Editor can display them as dotted lines.)

To create a form, do the following:

  • Insert the fields

  • Lay out the form

  • Set the properties of each field.

You lay out a form the way you lay out text. To label a field, click to the left of the field and start typing: the field moves to the right to make room for the text. Press Enter to create a new line in a form. You can align the form fields using the Align Left, Center, and Align Right commands on the FrontPage Editor’s standard toolbar. To control a form’s layout more precisely, insert a table inside a form’s boundaries and use it to control the placement of form fields and labels.

Form fields have properties, including Width in Characters, which specifies the width of a text box field, Initial Value, which specifies the contents of a field when a user first sees it, and Initial State, which specifies whether some types of fields are selected by default. Each type of form field has a unique properties dialog box, in which you configure it. To open a field’s properties dialog box, double-click the field.

When you create a new form, FrontPage adds two Push Button fields to the form, one labeled “Submit” and the other labeled “Reset.”

  • The submit button is automatically associated with FrontPage’s default form handler. When a user fills in the form in a Web browser and clicks this button, this form handler processes the information in the form. For a description of the default FrontPage form handler, see “Processing Forms”. For a description of assigning a different form handler to a form, see “Processing Forms”.

  • The reset button resets the contents of the form’s fields to their initial values.


Text Box Fields

Text box fields give users a way to enter text in a form. There are two types of text box fields: one-line text boxes and scrolling text boxes.

One-line text boxes are single-line form fields into which users can type text. Use a one-line text box for a single line of information, such as a user’s name or address. You can also configure a one-line text box as a password field. Most Web browsers will display the contents of a password field back to a user as asterisk characters, to protect the confidentiality of the text.

Scrolling text boxes are multiple-line form fields into which users can type many lines of text. Use a scrolling text box for information of unlimited length, such as general comments or questions about your product or organization.

When a form containing a scrolling or one-line text box field is submitted by a user in a Web browser, the name and the contents of the text box field are sent to the form handler.


Radio Button Fields

Radio button fields present a user with a choice that can be made by clicking on a button. Radio buttons are displayed in a set, one of which is selected by default. Selecting a new button cancels the currently selected radio button; only one radio button in a set can be selected at a time.

For example, in a survey form, a set of radio buttons could represent age ranges, and users could be prompted to click the button that corresponds to their age range.

When you set the properties of a radio button field, you assign it a group name, a value, and an initial state: selected or not selected. All radio buttons in a group must share the group name. When a form containing a set of radio buttons is submitted by a user, the group name and the value of the selected button is sent to the form handler.


Check Box Fields

Check box fields present the user with a choice that can be made by clicking a check box. Unlike radio buttons, more than one check box in a set can be selected.

For example, in a product order form, a set of check boxes could represent individual products. A user could order one or more products by clicking the appropriate check boxes.

When you configure a check box field, you assign it a name, a value, and an initial state: selected or not selected. Although related check box fields in a set do not have to share a common group name, it is often convenient to give them each the same name and differentiate them by their values. When a form containing check boxes is submitted by a user, the name of each selected check box, along with the its value, is sent to the form handler.


Drop-Down Menu Fields

A drop-down menu field presents the user with a list of choices in drop-down menu style.

You can set the properties of a drop-down menu field to let the user select many choices. This is an alternative method to using a set of check box form fields. You can also set the properties of a drop-down menu field to limit the user to one choice. This is an alternate method to using a set of radio button fields. Drop-down menu fields take up less room in a form than check boxes or radio buttons, because the choices are usually not displayed in a Web browser until a user clicks the field.

When you configure a drop-down menu field, you assign it a name and height and you create a set of choices. You create each choice by clicking Add in the Drop-Down Menu Properties dialog box. Each choice has a name, an optional value, and an initial state: selected or not selected. Once you have added choices, you can easily rearrange them in the Drop-Down Menu Properties dialog box.

When a form containing a drop-down menu field is submitted by a user, the name of the form, followed by a list of the selected choices, is sent to the form handler. Selected choices are sent to the form handler by their names or their values if you assigned them.

Drop-down menus are not displayed the same way by all Web browsers. Also, most Web browsers’ display of a drop-down menu is affected by the menu’s height and the number of selections a user can make.


Push Button Fields

A push button field submits a form to a form handler or resets a form to its initial state. Because FrontPage automatically adds a Submit and Reset Push Button field to each new form, you only need to create a Push Button field if the default fields have been deleted.

When you configure a push button field, you can supply a label, which is displayed on the button and sent to the form handler as the field’s value, and a name, which is also sent to the form handler. Naming and labeling push button fields is useful if you are using a custom form handler that processes a form based on which button is clicked.


Image Fields

An image form field is similar to a Push Button field because it submits a form to a form handler. However, when submitting a form when a user clicks an Image field, a Web browser also sends the form handler the x and y coordinates of the point in the image where the user clicked. Using this coordinate information, a custom form handler could process a form based on where in the image that user clicked. You cannot configure an Image form field to reset a form to its initial state.

You can use an image form field instead of a submit button in a form processed by a FrontPage form handler. However, FrontPage form handlers do not process forms based on the coordinate information that is sent with Image form fields.


Form Field Validation

When you set the properties of a form field you can set field validation rules that limit what a user can enter in the field. For example, in a one-line text box, you can make a rule that a user must type an integer into the field with a value in the range 0 – 100. You set field validation rules for a form field by opening its properties dialog box, clicking Validate to open the field’s validation dialog box, and setting rules that limit what a user can type into the field.

The FrontPage Editor can generate validation scripts in the JavaScript or Visual Basic Script (VBScript) languages, which both run on the Web browser computer. You can specify the type of validation script that the FrontPage Editor should generate in the Advanced tab of the FrontPage Web Settings dialog box in the FrontPage Explorer.

The validation script checks the contents of the field when the user submits the form in a Web browser and, if they do not conform to the rules that you set, displays an error message. A backup script will also run on the Web server computer to validate the fields, in case the Web browser computer does not support the scripting language you choose.

You can validate the following types of fields:

  • One-line text box

  • Scrolling text box

  • Radio button

  • Drop-down menu


Validating Text Box Fields

You can set field validation rules for one-line and scrolling text boxes. For both types of text box, you can set rules that limit the data type to text, integers, or real numbers.

If you limit a field to text, you can add other rules that specify whether alphabetic characters, numeric characters, white space, or specific punctuation characters are allowed. You can also limit the length of an entry and supply a range of values in which text must fall. Text ranges follow the rules of alphabetical order.

If you limit a field to integers, you can limit the punctuation that can be used in the integer, the length of the number, and the range of integer values to accept.

If you limit a field to real numbers, you can limit the punctuation that can be used in the number, the character to use as the decimal symbol, the length of the entry, and the range of numeric values.


Validating Radio Button Fields

You can design a set of radio buttons that are all initially not selected. You can set a validation rule for that group of radio buttons that specifies whether a user must choose one of the radio buttons in the group before submitting the form.


Validating Drop-down Menu Fields

There are two sets of validation rules for drop-down menu fields. One set applies to fields that allow multiple selections, the other set applies to fields that allow only one selection.

If you configure a drop-down menu field to allow multiple selections, you can set a validation rule that requires at least one item to be selected when the user submits the form. You can further limit the use of the drop-down menu by specifying either a minimum or maximum number of allowable choices or both.

If you configure a drop-down menu field to allow one selection, you can set a validation rule that requires the user to make a choice.

A common trick in drop-down menus is to make the first choice an instruction, not a choice, as in the following menu: “Select seating preference, window, aisle, middle, any.” If you want to use this method in FrontPage, you can set a validation rule for either single or multiple-choice drop-down menu fields that prohibits the user from selecting the first item in the menu.


Processing Forms

A form is processed by a form handler that is associated with the form. The way a form handler processes a form depends on the form handler’s design. Some form handlers enter form field data into a database. Others do some processing and generate HTML that the Web browser displays. For example, a form that is a mathematical calculator could accept numbers from a user and send them to a form handler which calculates a result, formats it in HTML, and sends it back to a Web browser for display.

FrontPage includes a set of form handlers that process forms for most common uses. You can use FrontPage form handlers to collect information from your form and store it in a variety of formats, register users for your FrontPage web, or support a discussion group on your web. Advanced users can create their own form handlers and assign them to forms in FrontPage.

When you create a form, FrontPage assigns its default form handler to your form. This general purpose form handler saves the form’s information to a file in your FrontPage web. See “Processing Forms”, for details.

FrontPage also includes a set of advanced FrontPage form handlers. You select one of these form handlers using the Form Properties dialog box. Along with the default form handler, you can assign the following FrontPage form handlers to a form:

  • Registration Form Handler, to register users so that they can access a service implemented as a Web site.

  • Discussion Form Handler, to support participation in an online discussion.

Note that FrontPage automatically saves form results only on Web servers containing the FrontPage Server Extensions. These extensions are available for most popular Web servers at http://www.microsoft.com.

If you do not want to use one of the FrontPage form handlers, you can assign a custom form handler that you have created. FrontPage supports custom form handlers that have been created using one of the following methods:

  • Internet Server Application Program Interface (ISAPI)

  • Netscape Server Application Program Interface (NSAPI)

  • Common Gateway Interface (CGI)

  • Active Server Page (ASP)

You use the Form Properties dialog box to change the settings of your current form handler or to change form handlers. To open this dialog box, right-click anywhere in the form and choose Form Properties from the shortcut menu.

When Send to is selected in the Form Properties dialog box, the default form handler is in use and the results file, which is the file that will contain the saved form information, is displayed in the File Name field. To send form information in e-mail, type the e-mail address in the E-mail Address field. To select an advanced form handler, click Send to other and choose the form handler from the drop-down list.

To configure the form handler, click Options. This opens the configuration dialog box for the form handler you selected. The default form handler’s configuration dialog box is called Options for Saving Results of Form.


The Default Form Handler

FrontPage automatically assigns its default form handler to a new form. The default form handler can save form information to a file in the current web, in the root web, or in your file system. It can also send form information to an e-mail address. You specify where to save form information in the Form Properties dialog box:

  • To save form information to a file in the current web, specify the URL of the file relative to the top-level folder of the current web, as in _private/my_results.txt. This is done automatically by the default form handler.

  • To save form information to a file in the root web, you must use the special folder _vti_log in the root web. Specify the URL of a file in this folder relative to the top-level folder of the current web, as in ../vti_log/my_results.txt.

  • To save form information to a file in your file system, specify the complete path of the file, as in c:\my_results\results.txt.

    Can I save form information in any way that I want? No. Depending on the policy of your Internet service provider, you may not be able to save form information to a file system or to a FrontPage web. Ask your Internet service provider for file-saving guidelines.

The default form handler saves the information from your form as text with commas separating values. You can also save information in one of the following formats:

  • HTML using normal text paragraphs with line endings.

  • HTML using a definition list.

  • HTML using a bulleted list.

  • HTML using formatted text with line endings.

  • Text formatted for easy reading.

  • Text with tabs separating values.

  • Text with space characters separating values.

To change the format of the results file, click Options in the Form Properties dialog box; this opens the Options for Saving Results of a Form dialog box. Then, in the File Format field of the File Results tab, select a new format. Saving form data to a text format is faster than saving to an HTML format.

The default form handler automatically generates a confirmation page that is displayed by a Web browser when a user has submitted the form. This page thanks the user for submitting the form and displays the data that was received. You can specify a different confirmation page in the Confirmation Page tab of the Options for Saving Results of Form dialog box. However, if you do this, you must create the confirmation page yourself, using FrontPage Confirmation Field components.

In the Saved Fields tab of the Options for Saving Results of Form dialog box, you can save specify additional information to save, such as the date and time the form was submitted, and the type of Web browser that was used to access the page. In the File Results tab, you can also specify an optional second file for saving the information from a form. This is useful if you want to generate one set of information in text format and another in HTML format.


Registering Users for Your FrontPage Web

You can create a form that registers users for your FrontPage web. When a user visits a FrontPage web that requires registered users, the Web server prompts the user for a name and password before it releases the FrontPage web for display in a Web browser.

The FrontPage form handler that adds a user and password to the list of users with permission to access a FrontPage web is the Registration Form Handler. You must create forms handled by Registration Form Handlers in the root FrontPage web (the FrontPage web named “<Root Web>” by default).

A user registers for access to a FrontPage web by supplying a name and password to a form handled by a Registration Form Handler. Along with adding the user and password to the list of users with permission to use the FrontPage web, Registration Form Handlers can save other information from the form in the same way as the default form handler.

By default, all FrontPage webs on a Web server have the same permissions for administrators, authors, and users as the root FrontPage web. When you create a FrontPage web that will require users to register before using it, you must open the FrontPage web and specify that it does not inherit its permissions from the root web, but instead has its own set of permissions. You can do this by opening the FrontPage web for which you are registering users and choosing the Permissions command in the Tools menu of the FrontPage Explorer. In the Settings tab, click Use unique permissions for this web and then click the Apply button. Next, in the Users tab, click Only Registered Users Have Browse Access and click the Apply button.

Once you have configured your FrontPage web to accept only registered users, you can add the user registration form to any page in your root web. (If you do not add the form on the home page of the root web, make sure you have a hyperlink to it from the home page, so users can find it.) Along with Push Button fields for submitting and resetting the form, a registration form should have the following fields:

  • a one-line text box field for entering a user’s name

  • a one-line text box field for entering a user’s password

The easiest way to add a user-registration form to the root web is to create a new page and select the User Registration template. This template contains a complete user registration form along with explanatory text that you can modify. Once you have created a user registration page, you must open the page, open the Form Properties dialog box, click the Options button, and specify the FrontPage web for which you are registering users. In the FrontPage web name field, type in the name of the FrontPage web that requires registered users, and click OK twice to close all dialog boxes.


Creating a Discussion Group

In a discussion group, an index contains hyperlinks to articles on some topic of interest submitted by users of a FrontPage web. If the index is threaded, a response to an article creates a hyperlink to the new article, indented below a hyperlink to the original article. Users can either create new threads or respond to previously submitted articles. In either case, all articles are available through the index. The FrontPage form handler that lets users participate in a discussion group is a Discussion Form Handler.

The Discussion form handler collects information from a form, formats it as an HTML page, and adds the page to a table of contents and to a text index. In addition, the Discussion form handler has all the features of the default form handler: it can gather information from the Discussion form and store it in a variety of formats. When a user submits a form in a Web browser, a Discussion form handler first creates a discussion group page and table of contents, then optionally appends the form information to the specified file in a specified format.

The easiest way to create and moderate a discussion group is to create a FrontPage web using the Discussion Web Wizard. This wizard creates a FrontPage web with a discussion form handled by a Discussion Form Handler, along with a table of contents, Search Form, confirmation page, threaded replies, and frames. The Discussion Web Wizard is one of the choices in the New FrontPage Web dialog box in the FrontPage Explorer.

As the moderator of a discussion group, you may want to edit or delete pages submitted by discussion group participants. These pages are hidden in the FrontPage Explorer by default. To view and edit the articles, choose Web Settings in the Tools menu of the FrontPage Explorer. In the Advanced tab, click Show documents in hidden directories and click OK. To refresh the view of the FrontPage web, choose Refresh in the View menu. Pages created in the discussion group will be named 0001.htm, 0002.htm, and so on.

Do not delete articles. Instead, open them in the FrontPage Editor and type a standard message replacing the article body, such as “[Deleted Article].” This will protect forward and backward hyperlinks to other articles in the thread, while effectively removing offensive articles.


Dynamic HTML Features

Dynamic HTML gives authors enhanced control of the elements on their pages. Because it does not require fetching information from the Web server, Dynamic HTML is very efficient and presents the user with a lively, compelling page without requiring time-consuming network activity. FrontPage Dynamic HTML form features are supported by Microsoft Internet Explorer 4.0 and other Web browsers that recognize Dynamic HTML.

The FrontPage Editor includes the following Dynamic HTML features for forms:

  • tab ordering

  • form field labeling

  • access keys

This topic describes Dynamic HTML in forms. For information on other FrontPage Dynamic HTML features, see “Creating Active Pages,” on page 208.


Tab Ordering

Tab ordering lets a user of your form select the form's fields using the TAB key on the computer's keyboard. You create the tab order for a each field in a form by entering a unique value in the Tab order field of the field's properties dialog box.


Labeling

Dynamic HTML form labels are text labels a user can click to select a form field. For example, when a check box field has a form label defined, a user can select the check box by clicking it directly or by clicking its label. To define a label for any field, type the label before or after the field, select the field and its label, choose Form Field on the Insert menu, and click Label.


Access Keys

A form field's access key is the keyboard key corresponding to an underlined letter in the field's label. In Web browsers that support Dynamic HTML, a user can select a field that has an access key by clicking ALT+key, where key is a single underlined letter in the field's label. For example, if a check box field has the label “small”, a user could select the check box field by typing ALT+S.

To assign an access key to a form field, type a label before or after the field and underline the single access key character, select the field and its label, choose Form Field on the Insert menu, and click Label.


Using Forms and Form Fields

Here are some commonly used FrontPage form and form field procedures. For a full set of FrontPage procedures, see “Creating and Configuring Forms” and “Creating and Editing Fields” in the Contents tab of the Microsoft FrontPage online Help system.

Û To Create a Form

In the FrontPage Editor, you can create a new form anywhere on a page outside of an existing form.

  • At the insertion point, create any form field. On the Insert menu select Form Field and select the type of field that you want.

    FrontPage creates a new form containing the field that you selected and two Push Button fields, one for submitting the form and one for resetting it. If the field you created was a Push Button field, FrontPage does not add the additional fields.

    New forms are assigned the FrontPage default form handler.

Û To View a Form’s Properties

  • Right-click anywhere in the form and choose Form Properties from the shortcut menu.

Û To Add a Field to a Form

  1. In the FrontPage Editor, click in the form where you want to place the field.

    Note To create a new line in the form, press ENTER.

  2. At the insertion point, create the form field. Use the Form Field command on the Insert menu or select the field from the Forms toolbar.

  3. To add accompanying text, click before or after the field and type directly into the form.

Û To Change a Form’s Handler

  1. In the FrontPage Editor, right-click anywhere in the form.

  2. From the shortcut menu, select Form Properties.

  3. Do one of the following:
    • To select the default form handler, click Send to and type a filename, e-mail address, or both.

    • To select an advanced form handler, click Send to other and choose the form handler from the drop-down list.
  4. To configure the form handler, click Options, edit the appropriate tabs, and click OK.

  5. Click OK to close the Form Properties dialog box.

Û To E-mail a Form’s Contents

You can configure the default form handler to send the contents of a form to an e-mail address.

  1. Right-click anywhere in the form and choose Form Properties from the shortcut menu.

  2. In the Form Properties dialog box, make sure that Send to is selected.

  3. In the E-Mail Address field, type the e-mail address.

    When a user submits the form, its contents will be sent to this address. E-mail must be available on the Web server machine for this option to work.

  4. Click OK.

Û To Create a One-Line Text Box Field

Use a one-line text box to accept one line of information from a user.

When a form containing a one-line text box field is submitted submitted in a web browser, the name and the contents of the text box field are sent to the form handler.

One-Line Text Box button

  1. In the FrontPage Editor, on the Insert menu, choose Form Field and point to One-Line Text Box, or on the Forms toolbar click the One-line Text Box button.

    The one-line text box field is created at the insertion point. If the insertion point is inside a form, the one-line text box field is added to the form. To create a new form containing a one-line text box field, insert a one-line text box field outside of any currently defined forms.

  2. Type the label of the field directly into the form.

    Note The FrontPage Editor creates one-line text box fields with default properties. Double-click the field to open its properties dialog box and edit any of its properties.

Û To Create a Scrolling Text-Box Field

Use a scrolling text box to accept multiple lines of information from a user.

When a form containing a scrolling text box field is submitted in a web browser, the name and the contents of the field are sent to the form handler.

Scrolling Text Box button

  1. In the FrontPage Editor, on the Insert menu, choose Form Field and select Scrolling Text Box, or on the Forms toolbar click the Scrolling Text Box button.

    The scrolling text box field is created at the insertion point. If the insertion point is inside a form, the scrolling text box field is added to the form. To create a new form containing a scrolling text box field, insert the scrolling text box field outside of any currently defined forms.

  2. Type the label of the field directly into the form.

    Note The FrontPage Editor creates scrolling text box fields with default properties. Double-click the field to open its properties dialog box and edit any of its properties.

Û To Create a Check Box Field

Use a series of check boxes to present a list of items, one or more of which can be selected by the user.

When a form containing check boxes is submitted in a web browser, the name of each selected check box, along with the value assigned to it, is sent to the form handler as a name-value pair.

Check Box button

  1. In the FrontPage Editor, on the Insert menu, choose Form Field and select Check Box, or on the Forms toolbar click the Check Box button.

    The check box field is created at the insertion point. If the insertion point is inside a form, the check box field is added to the form. To create a new form containing a check box field, insert a check box field outside of any currently defined forms.

  2. Type the label of the field directly into the form.

    Note The FrontPage Editor creates check box fields with default properties. For example, check box fields are not selected by default. Double-click the field to open its properties dialog box and edit any of its properties.

Û To Create a Radio Button Field

Use a series of radio buttons with the same name to present a list of items to the user, only one of which can be selected at a time.

When a form containing a set of radio buttons is submitted in a web browser, the group name and the value assigned to the selected button is sent to the form handler.

Radio Button button

  1. In the FrontPage Editor, on the Insert menu choose Form Field and select Radio Button, or on the Forms toolbar click the Radio Button button.

    The radio button field is created at the insertion point. If the insertion point is inside a form, the radio button field is added to the form. To create a new form containing a radio button field, insert the field outside of any currently defined forms.

  2. Type the label of the field directly into the form.

    Note The FrontPage Editor creates radio button fields with default properties. The first radio button you create in a form is given the group name “R1” and is selected by default. Each subsequent radio button that you create is given the group name of the radio button that immediately precedes it in the form. If no radio button precedes a new button, it is given the group name of the radio button that immediately follows it in the form. Double-click a radio button field to open its properties dialog box and edit any of its properties. To create a set of radio buttons, repeat steps 1 – 2, using the same group name for each radio button.

Û To Create a Drop-Down Menu Field

Use a drop-down menu to present a list of items one or more of which can be selected from a menu or a scrolling list. You can configure the drop-down menu to allow only one selection or many selections.

When a form containing a drop-down menu is submitted in a web browser, the name of the form, followed by a list of names of the selected choices, is sent to the form handler.

The drop-down menu is created at the insertion point. If the insertion point is inside a form, the drop-down menu is added to the form. To create a new form containing a drop-down menu, insert a drop-down menu outside of any currently defined forms.

Drop-Down Menu button

  1. In the FrontPage Editor, choose Form Field on the Insert menu and select Drop-Down Menu, or on the Forms toolbar click the Drop-Down Menu button.

  2. Click the drop-down menu field to select it, and on the Edit menu choose Form Field Properties.

  3. In the Name field enter a name for the drop-down menu.

    Note The name you assign is not displayed on the form. To label a field, you type the label directly in the page.

  4. For each menu choice that you want to add to the menu, select Add, and do the following in the Add Choice dialog box:
    • In the Choice field, enter the name of the choice.

    • To specify a value for the menu choice, click Specify Value and enter an optional value to send to the form handler. If you specify a value, it replaces the name of a menu choice in the field’s name-value pair.

    • In the Initial State field, indicate the initial state of the menu choice: Selected or Not Selected.

    • Click OK.

The menu items are displayed in the order in which you created them.

  1. To modify the menu, do any of the following:
    • To remove a selected choice, click Remove.

    • To modify a selected choice, click Modify and edit the Modify Choice dialog box.

    • To move a selected choice up in the menu, click Move Up.

    • To move a selected choice down in the menu, click Move Down.
  2. In the Allow Multiple Selections field, select Yes to allow more than one menu item to be selected at a time. Select No to permit only one selection at a time.

  3. In the Height field, set the height of the menu. Based on your selection, the menu will be displayed as follows:
    • If Height is greater than one and Allow Multiple Selections is Yes, most Web browsers display the menu as a scrollable list with full-height scroll arrows.

    • If Height is greater than one and Allow Multiple Selections is No, most Web browsers display the menu as a scrollable list.

    • If Height is one and Allow Multiple Selections is No, most Web browsers display the menu as a drop-down list.

    • If Height is one and Allow Multiple Selections is Yes, most Web browsers display the menu as a scrollable list with half-height scroll arrows. This type of menu may be difficult to use.
  4. Click OK.

  5. Type the label of the menu into the form.

Û To Create a Push Button Field

Use a push button field to let users submit or reset a form. When a form is submitted, its data is passed to a form handler.

You can insert more than one push button on a single form. If you do this, assign each push button a distinct name. When the form is submitted in a web browser, the name of the selected button, along with its label, is passed to the form handler of the form as a name-value pair.

Push Button button

  1. In the FrontPage Editor choose Form Field on the Insert menu and select Push Button, or on the Forms toolbar click the Push Button button.

    The push button field is created at the insertion point. If the insertion point is inside a form, the push button field is added to the form. If the insertion point is outside a form, a new form is created when you insert the push button field.

  2. To label the push button on the page, type a label next to the push button in the form.

    Note The FrontPage Editor creates Push Button fields with default properties. Double-click the field to open its properties dialog box and edit any of its properties.

Û To Copy a Form Field

  1. In the FrontPage Editor, click the field to be copied.

  2. On the Edit menu, choose Copy.

  3. Click where you want to paste a copy of the field.

  4. On the Edit menu, choose Paste.

If the insertion point is outside of any forms, FrontPage creates a new form containing the field. If the insertion point is inside a form, the field is added to the form.


Next Steps

To | See
To learn more about forms and form fields | “Creating and Editing Fields,” and “Creating and Configuring Forms,” in the Contents tab of the Microsoft FrontPage online Help system


FrontPage Database Integration

More and more organizations are publishing their databases on corporate intranets and on the World Wide web to offer convenient access to data for employees and customers alike. The benefits of making existing information widely and easily available quickly become evident: a retail business can create an online product catalog that tells customers which items are currently in stock; a computer software company can give its customers round-the-clock self-help information and troubleshooting tips through an online knowledge base; and human resources departments in any organization can post directories of up-to-date employee information right on the company intranet.

With FrontPage, you can easily create custom database queries on dynamic, richly formatted Web pages, providing visitors to your Internet or intranet site with information at their fingertips.


Before You Begin

FrontPage database integration is based on Active Server Pages (ASP). An Active Server Page is an HTML document that contains embedded server-side scripting. Web servers compatible with ASP can execute these server-side scripts. On the client side, an ASP is a standard HTML document, viewable on any platform using any Web browser.

Before you can integrate a database into a FrontPage web, you must follow a series of steps that take place outside of FrontPage. These include configuring your Web server and workstation, and building (and modifying) Structured Query Language (SQL) queries in a database management tool such as Microsoft Access. The examples provided in this chapter will refer to the Northwind Traders database, a sample database in Microsoft Access MDB format. However, you can use any database with an available Open Data Base Connectivity (ODBC) compliant driver to publish data on a Web site.

Using the FrontPage Database Region Wizard, you can submit SQL queries to an ODBC-compliant database accessible from the Web server computer. When a user visits your Web site and submits search criteria, the query runs based on the values of SQL parameter fields. The results are then combined with an Active Server Page, which acts as a custom form handler, and returned to the Web browser for display. The search form and the Active Server Page that displays the query results are both created in the FrontPage Editor.

Publishing a database on a Web site using FrontPage requires an ASP-compatible Web server, such as the Microsoft Internet Information Server family of Web servers, which consists of the Microsoft Internet Information Server (IIS) for Windows NT Server, the Microsoft Peer Web Services for Windows NT Workstation, and the Microsoft Personal Web Server for Windows 95. Check with your server administrator or Internet Service Provider to see whether your Web server supports this technology.

Importing the Database File

Before you can properly configure the Web server and workstation, you need to import your database file to your FrontPage web.

Û To Import a Database File to a FrontPage Web

  1. Launch the FrontPage Explorer and open the FrontPage web that is to contain your database.

  2. On the FrontPage Explorer’s File menu, choose Import to display the Import File to FrontPage Web dialog box.

  3. Click the Add File button, then point to the folder where you saved your database (for example, northwind.mdb).

  4. Click Open to add the file to the import list.

  5. Next, click OK to import the file to your FrontPage web.

Before proceeding, decide on a permanent location for the imported database file. Drag and drop the file to the folder in your FrontPage web where you want to store the database file.

Securing the Database File To keep your database file from being downloaded in a Web browser, move it to its own folder in the root level of your FrontPage web. You can then secure this folder by right-clicking it in the FrontPage Explorer’s Folders view and choosing Properties, where you can deselect the Allow Files to be Browsed option.


Web Server Configuration

With the help of your server administrator or Internet Service Provider, you must first define the ODBC Data Source Name (DSN) for the database you will use for queries in a Web browser. This name will also be defined on the workstation on which you will create the Active Server Pages, and it will be required by the FrontPage Editor’s Database Region Wizard when you create the results page.

If you are hosting your FrontPage web through an Internet Service Provider (ISP), you must first request ODBC database service and have a Data Source Name configured on the ISP’s Web server. You may need to contact your ISP to determine whether database service is available and whether there is an additional fee for its use.

If database service is available on your Web server, you will need to tell your ISP the following information:

  • the exact URL to the database file on your Web site

  • the type of database you are using (for example, Microsoft Access, Microsoft FoxPro, etc.)

  • the requested name of the DSN

Your ISP will configure the Web server and then notify you with the final name to use as your DSN.

If Your ISP Does Not Support Active Server Pages If your ISP’s Web server does not support Active Server Pages, you will not be able to use the database features FrontPage 98 offers. To help you choose from a comprehensive directory of Internet Service Providers who offer Web servers that support Active Server Pages, visit the FrontPage home page on the World Wide Web, at http://www.microsoft.com/frontpage.

If you are a server administrator or ISP who needs to define a DSN on a server, use the definition procedure on the following page. In this case, perform the steps on the server computer, not on the workstation.


Workstation Configuration

When the Data Source Name has been defined on the Web server, and the database file has been imported to your FrontPage web, you can proceed to configure the DSN on the workstation.

Û To Configure the DSN on the Workstation

  1. In the Windows NT or Windows 95 Control Panel, double-click the 32-bit ODBC (ODBC on some systems) icon to display the ODBC Data Source Administrator dialog box.

  2. In the System DSN tab, click Add to specify a new Data Source Name.

  3. For this example, select Microsoft Access Driver (*.mdb).

  4. Click Finish.

    The ODBC Microsoft Access 97 Setup dialog box is displayed.

  5. Enter the DSN in the Data Source Name field.

    The name you enter here should match the DSN that was specified by your server administrator or ISP on the Web server.

  6. Click Select.

  7. In the Select Database dialog box, point to the disk location of the database file you imported to your FrontPage web (for example, C:\inetpub\wwwroot\northwind.mdb), then click OK.

  8. Click OK to close the ODBC Microsoft Access 97 Setup dialog box.

  9. Click OK to close the ODBC Data Source Administrator dialog box.

When the Data Source Name has been defined on the Web server, and the database file has been imported to your FrontPage web, the next step is to build a query using your database management tool.


Building Your Query

Before you can build a query to use on the search page, you need to decide:

  • What data do I want to present to the user?

  • What criteria will the user be able to specify in a search form?

  • What data should be returned on the results page?

To illustrate how a database query is created, the following example will use Microsoft Access as the database management tool.

Û To Create an SQL Query in Microsoft Access 97

  1. Launch Microsoft Access 97 and open the Northwind Traders sample database file (northwind.mdb).

  2. In the Northwind : Database dialog box, click the Queries tab.

    Northwind Traders contains a set of pre-defined queries.

  3. Double-click the Sales by Category query to display a the query results.

    The field names used in this query are Category ID, Category Name, Product Name, and Product Sales.

    Category ID is an internal code for the employees of Northwind Traders that will have no meaning to users searching for sales data in a Web browser. You will therefore remove it from the final query.

  4. On the Microsoft Access View menu, choose Design View to modify the query.

  5. In the lower half of the Design View, deselect the check box below the CategoryID entry in the table.

  6. On the View menu, choose Datasheet View.

    The query is resubmitted and the new results now only show the fields you want to include. The Category ID field has been successfully omitted.

  7. On the View menu, choose SQL View.

    This option switches the current query view to the actual SQL language query that Microsoft Access generated to create the search results.

Leave the SQL View window displayed. You will return to Microsoft Access in the next section, where you will copy and paste this code into the FrontPage Database Region Wizard.


Formatting the Results Page

The next step is to create and format the Active Server Page that will display the query results in a Web browser. You can add the database region to an existing page in your FrontPage web, or add the region on a blank page that you can later customize.

Û To Insert a Database Region on the Results Page

Show FrontPage Editor button

  1. On the FrontPage Explorer’s Tools menu, choose Show FrontPage Editor, or click the Show FrontPage Editor button on the toolbar.

    The FrontPage Editor is displayed.

  2. Open or create the page that will display the database search results in the Web browser and position the cursor where you want the query results table to be displayed.

  3. On the FrontPage Editor’s Insert menu, point to Database, then click Database Region Wizard.

  4. When the Database Region Wizard is displayed, proceed to the panel containing the ODBC Data Source Name (DSN) field, then enter the DSN in this field.

    The name you enter here should match the DSN that was specified on the Web server and on your workstation.

  5. Leave the Username and Password fields blank for this example and click Next.

    You may need to specify a username and password if your actual database file or database server have been secured.

  6. Switch to Microsoft Access and select the entire code text in the SQL View window

  7. On the Edit menu, choose Copy.

  8. Switch back to the Database Region Wizard and paste the SQL code into the Enter the SQL String for the Query input field by clicking Paste SQL From Clipboard.

  9. Click Next.

  10. Click the Add Field button.

    The Add Field dialog box is displayed. In this dialog box, you enter an actual database field name. While Microsoft Access shows “friendly” names for database fields, the FrontPage Database Region Wizard requires you to enter the actual database field name (without spaces). To look up the actual field names, switch to the Design View in Microsoft Access.

  11. Type CategoryName (without a space between the two words), then click OK.

    CategoryName is the first field you are adding from the Northwind Traders sample database. Repeat steps 10 – 11 for the ProductName and ProductSales fields.

  12. Click Finish to create the database region.

    FrontPage inserts a database region placeholder icon on the current page where your results table will be displayed when users display the page in a Web browser.

When the actual page is fetched by the Web browser, the results table will be expanded to contain the database query results. Each database field will be a column in the table and each returned database record is displayed as a row in the table.


Saving the Active Server Page

Before you can use the formatted results page, you must save it as an Active Server Page, which is a file with an .asp extension.

On the FrontPage Editor’s File menu, choose Save As. In the Save As dialog box, type the file name for this page is the URL field, but be sure to retain the .asp file extension. For this example, name the page “results.asp.” In the Title field, enter a descriptive page title, such as “Database Query Results,” then click OK to save the page.

You must also enable the folder containing the results page to run queries and Active Server Page code when the page is fetched. To do this, select the Folders View in the FrontPage Explorer, then click the folder that contains the “results.asp” page. On the FrontPage Explorer’s Edit menu, choose Properties. In the folder’s Properties dialog box, select the Allow scripts to be run or Allow scripts or programs to be run option and click OK.

Note Allowing programs to be run inside your FrontPage web may make your Web server less secure. Check with your server administrator or Internet Service Provider before allowing programs to be run.

Preparing for Criteria

You will now modify the query to accept search criteria. To filter the query by specific criteria, each database field value must be entered into the query’s SQL. For example, the Sales by Category query used in the Northwind Traders example includes all products. It is more useful to be able to view only those products in the category the user is interested in seeing, such as a list of products with the classification “Beverages.” In order to achieve this, a criteria parameter is added to the category name.

SQL queries support criteria by using WHERE statements to restrict what database records are returned. You must edit the SQL text to contain a WHERE statement that references the name of a database field in an HTML form. This form will be used to enter a parameter value, which will be sent to the query.

In this example, we will define the form field to be the product category. Entering a category into the form field will return product name and product sales information for all products in the specified category.

Û To Add a Parameter Form Field for the Product Category

  1. On the results page, right-click the placeholder icon for the database region and choose Database Region Properties from the shortcut menu.

  2. Click Next to proceed to the Enter the SQL String for the Query input field, then locate the WHERE statement in the SQL text.

    If you followed the previous examples by pasting the SQL query from Microsoft Access, the text should read:

    WHERE (((Orders.OrderDate) Between #1/1/95# And #12/31/95#))
  3. Add an additional criteria value by manually editing the WHERE statement, as shown below. Be sure to include the single quote where shown:
    WHERE ((Categories.CategoryName = '((Orders.OrderDate) Between #1/1/95# And #12/31/95#))
  4. Next, position the insertion point after the single quote you just typed and click the Insert Form Field Parameter button.

  5. Type a name for the form field that you are going to create.

    To avoid confusion, it is helpful to use a form field name that is similar or the same as the database field name. For this example, type in CategoryName. Make a note of the name that you have chosen since you will use it later.

  6. Click OK.

    The SQL text will be automatically modified to include the field name:

    WHERE ((Categories.CategoryName = '%%CategoryName%% ((Orders.OrderDate) Between #1/1/95# And #12/31/95#))
  7. Complete the criteria by typing a closing single quote and an AND operator after the parameter that was added in the previous step:
    WHERE ((Categories.CategoryName = '%%CategoryName%%') AND ((Orders.OrderDate) Between #1/1/95# And #12/31/95#))
  8. Click Finish to apply the changes.

When you are finished modifying the query, save your changes to the page. Remember to save the page as an Active Server Page by retaining the .asp file extension.

Note Some database management tools may generate SQL text with double quotes. If you are pasting SQL text containing double quotes into the Database Region Wizard, you will need to manually change them to single quotes before closing the wizard.


Formatting the Search Form

Before you can test the results page, you must also design the page that will be used to search your database for criteria specified by a user.

Û To Format the Search Form

  1. In the FrontPage Editor, open or create the page you will use to obtain criteria input from the user, then position the cursor where you want the search form to be displayed.

  2. On the FrontPage Editor’s Insert menu, point to Form Field, then click One-Line Text Box.

    By default, text box form fields are placed on the page with Submit and Reset buttons.

  3. Double-click the one-line text box to open the Text Box Properties dialog box.

  4. In the Name field, replace the default with a proper name value.

    The name value you enter here must match the name that you entered in the second step of the Database Region Wizard. In our example, the name used was CategoryName.

  5. Text box fields should also have a descriptive label that tells users what information it will accept. Place the insertion point just before the left border of the text box, then click the mouse button to activate the cursor.

  6. Type the words Enter the Product Category:, then press the spacebar.

    You can use more than one parameter field in the same form, provided that the SQL text was modified accordingly to accept more than one parameter in the query.

Next, you must configure the form so that it will correctly link the search field to the database file and display the results using your Active Server Page.

Û To Configure a Custom Form Handler

  1. In the FrontPage Editor, right-click the one-line text box and choose Form Properties from the shortcut menu.

    Normally, the default FrontPage form handler can process data submitted through form fields. For ODBC database integration, however, you must specify your Active Server Page as the form handler.

  2. In the Form Properties dialog box, select Send to Other and choose the Custom ISAPI, NSAPI, CGI or ASP Script option.

  3. Next, click the Options button to specify additional options for this custom form handler.

  4. In the Action field, type results.asp — the file name of the results page you previously created.

  5. Ensure that the Method field contains “POST,” then click OK to close the Options for Custom Form Handler dialog box.

  6. Click OK once more to close the Form Properties dialog box.

Before you can use the search form on this page, you must save it to your current FrontPage web as an HTML file. On the FrontPage Editor’s File menu, choose Save As. In the Save As dialog box, type the file name for this page is the URL field. For this example, name the page “search.htm.” In the Title field, enter a descriptive page title, such as “Database Lookup.” Click OK to save the page.


Testing the Query

Before you publish the search form and results pages you just created, you will want to make sure that the SQL query string works correctly (that is to say, the results returned in the Web browser match those displayed in Microsoft Access’ Datasheet view).

To test a query, you will need to launch Microsoft Internet Explorer (or another Web browser). If you have not yet installed Internet Explorer, you can install it from the Microsoft FrontPage 98 CD-ROM.

Note You cannot test a query using the FrontPage Editor’s Preview tab. The FrontPage Editor does not execute queries or Active Server code. They are executed only when the page is fetched by a Web browser.

To test the query, browse to the page containing the search form, then enter “Seafood” into the search form. Click the Submit button. The results page should be displayed in the Web browser, showing the same database records that Microsoft Access returned for the same query. Return to the search form and enter “Beverages” to see different results.

When the search mechanism is working properly, you can further format and customize the appearance of the search form and results pages, but remember to retain the .asp extension for the results page and the .htm extension for the page containing the search form.


Modifying SQL Queries

If testing the query returns results that you did not intend to display, or if they do not match the search results in your database management tool, you can make changes to the existing SQL query in the database region on your results page. You can also add, remove, or rearrange the columns on the results page.

To modify the query, open the results page in the FrontPage Editor. Right-click the placeholder icon for the database region and choose Database Region Properties from the shortcut menu.

When the Database Region Wizard opens, proceed to the Enter the SQL String for the Query input field. Although you can manually edit the code in this field, it is strongly recommended that you regenerate an SQL query in Microsoft Access, switch to the SQL view, and then copy and paste the new code into FrontPage using the Paste SQL From Clipboard button in the Database Region Wizard.

Note Clicking the Paste SQL From Clipboard button clears the paste buffer and replaces the entire contents of the SQL query input field. Any parameter that you manually inserted after pasting must be re-inserted into the new SQL text.


Next Steps

To | See
Learn more about Active Server Pages | The Active Server Pages Roadmap (Microsoft Internet Information Server online documentation)
Learn more about SQL Queries | Your local bookstore for reference materials on Structured Query Language (SQL)
Find an Internet Service Provider | The FrontPage home page at http://www.microsoft.com/frontpage
Learn about Web development using Microsoft Visual InterDev | Your local Microsoft reseller or the product documentation available at http://www.microsoft.com


Advanced FrontPage Features

Using the advanced features that are built into the FrontPage Editor, you can take advantage of the latest developments in Web browser technology. You can add your own ActiveX controls, Design Time controls, scripts, plug-ins, or Java applets. You can use Microsoft Visual SourceSafe® to control the versions of your pages, and you can protect your content using built-in Secure Sockets Layer support.

Here is a tour of some of the advanced features included in FrontPage 98.


ActiveX Controls

ActiveX controls are software components that provide dynamic features on your pages. For example, a stock ticker control could be used to add a live stock ticker to a page, or an animation control could be used to add animation features. For more detailed information about ActiveX controls, and to see a gallery of free controls that are available on the World Wide Web, visit http://activex.microsoft.com/

In the FrontPage Editor, you insert an ActiveX control into your page on the Insert menu by pointing to Advanced and then clicking ActiveX Control or Design Time Control. To insert a control, you must first have it installed on your machine. If you choose the ActiveX Control command and the Pick a Control dropdown list in the ActiveX Control Properties dialog box is empty, you do not yet have any ActiveX controls installed on your system.

After you pick the control to insert, you can adjust the control’s settings in the ActiveX Control Properties dialog box. For example, all standard size and alignment options for objects that can be placed on a page are available. You can also specify an Alternate Representation that users will see if their Web browser does not support ActiveX controls.

Once you’ve picked an ActiveX control from the Pick a Control dropdown list in the ActiveX Control Properties dialog box, you can set control-specific options by clicking Properties, in the ActiveX Control Properties dialog box. This opens a dialog box with options that are specific to the ActiveX control that you want to insert. As you change the control-specific values, you can click Apply to immediately see the impact of those changes on the appearance of the ActiveX control. Some ActiveX controls also come with documentation that describes the control’s properties.

The ActiveX Control Properties dialog box includes a Network Location section. You can use this section to specify where a Web browser should look on the World Wide Web for the ActiveX control or its associated data if the control is not yet installed on the user’s computer. This is often the Web site of the ActiveX control’s vendor or your own Web site.


Java Applets

Java applets are similar to ActiveX controls. They are software components written in a programming language called Java that provide dynamic features on your Web page. A software vendor might choose to create a product as a Java applet because its interpreted nature lets it run on several different hardware platforms.

Inserting a Java applet is similar to inserting an ActiveX control. Java doesn’t support a customized property-setting interface, so a generic one is provided for you.

In the FrontPage Editor, you insert a Java applet into your page on the Insert menu by pointing to Advanced and then clicking Java Applet. In the Java Applet Properties dialog box, type in the name of the applet source file that you want to insert. Java applet source files usually have a .CLASS extension. Enter any general size and alignment options properties, and then use the Applet Parameters section to set particular properties for a control. Since Java does not provide a mechanism for displaying the valid properties and values are for a given control, you’ll need to consult the documentation that comes with the Java applet and input the right property names and legal values for each property.

When you’re done configuring the Java applet, click OK, and FrontPage inserts an actual-size placeholder icon on the page to retain your page layout. You preview a Java applet in the FrontPage Editor’s Preview tab (if you have Microsoft Internet Explorer, version 3.0 or higher, installed) or by choosing Preview in Browser on the FrontPage Editor’s File menu.


Plug-Ins

Plug-ins are platform-specific components for pages. Originally designed for Netscape Navigator 2.0, they are supported in Microsoft Internet Explorer 3.0 and higher as well. If you have a plug-in that you want to insert on the page, in the FrontPage Editor, on the Insert menu, point to Advanced and then click Plug-In. Enter a reference to the plug-in data file you want to use, and set the optional size and alignment parameters. When you press OK, a placeholder graphic will be inserted for the plug-in. You preview a plug-in in the FrontPage Editor’s Preview tab (if you have Microsoft Internet Explorer, version 3.0 or higher, installed) or by choosing Preview in Browser on the FrontPage Editor’s File menu.


Scripting

Scripting is a type of programming language that you can use to write custom code for your Web page. This is an advanced FrontPage feature that requires knowledge of programming. Scripting is useful for custom Web-based solutions development. It provides a full object model for the Web browser and the objects on the current page. This makes it easy to write code that manipulates elements on the page without knowing the details of the HTML or how the objects are implemented.

FrontPage provides a range of scripting features that are compatible with JavaScript and Visual Basic Script. In the FrontPage Editor, you insert a script into your page on the Insert menu by pointing to Advanced and then clicking Script. The Script command lets you easily insert scripting code inline on your page. You pick the scripting language you want, type in the script code, and click OK. The script will appear on your page as a small icon. You can double-click this icon at any time to edit the script.

You can also use the Script Wizard to create script code that is specifically designed to handle events that occur on objects (such as ActiveX controls) on your page. The Script Wizard includes an online Help system.

As a simple example, you can insert a push button using the FrontPage Editor’s Push Button command, on the Forms toolbar. In the Push Button Properties dialog box, click Normal and click OK. Right click on the button and choose Script Wizard. This launches the FrontPage Script Wizard. Click from the list to select the button object. Click to select the OnClick event. Now switch to code-writing mode and type in the statement MsgBox "Thanks for clicking!"

To test the script, choose the Preview in Browser command on the FrontPage Editor’s File menu. Click on the button to view the message.

Microsoft Visual SourceSafe Integration

Microsoft Visual SourceSafe is a visual version control system that is available separately from FrontPage. If you install Microsoft Visual SourceSafe version 5.0 or higher on your Web server, FrontPage will automatically detect it and provide some new commands in the FrontPage Explorer.

In the FrontPage Explorer’s Tools menu, use the Web Settings command, and select the Configuration tab. In the Source Control Project edit box, enter the name of the Visual SourceSafe project that you want to associate with the current FrontPage web. Visual SourceSafe project names begin with “$\” as in “$\myproj.” To create a new Visual SourceSafe project to use with a FrontPage web, type in its name. You can only create one new level of a Visual SourceSafe project using this technique. For example, if only the root Visual SourceSafe project ($\) exists, you can type $\webs, but not $\webs\myweb.

When you associate your FrontPage web with a new Visual SourceSafe project, the FrontPage server extensions will communicate with Visual SourceSafe to create a new project on the server, and place all of the files in your current FrontPage web under version control.

After associating your FrontPage web with a Source Safe project, you can use the Check-Out command on the Edit menu to exclusively edit a file in the FrontPage web. You can make changes to the page or file in the FrontPage Editor, save it, and use the Check-In command on the Edit menu to make the changes available to other authors working on the FrontPage web. Or, if you make a mistake, you can use the Undo Check-Out command to revert back to the version you had before you checked the file out.


Microsoft Visual SourceSafe Integration

Microsoft Visual SourceSafe is a visual version control system that is available separately from FrontPage. If you install Microsoft Visual SourceSafe version 5.0 or higher on your Web server, FrontPage will automatically detect it and provide some new commands in the FrontPage Explorer.

In the FrontPage Explorer’s Tools menu, use the Web Settings command, and select the Configuration tab. In the Source Control Project edit box, enter the name of the Visual SourceSafe project that you want to associate with the current FrontPage web. Visual SourceSafe project names begin with “$\” as in “$\myproj.” To create a new Visual SourceSafe project to use with a FrontPage web, type in its name. You can only create one new level of a Visual SourceSafe project using this technique. For example, if only the root Visual SourceSafe project ($\) exists, you can type $\webs, but not $\webs\myweb.

When you associate your FrontPage web with a new Visual SourceSafe project, the FrontPage server extensions will communicate with Visual SourceSafe to create a new project on the server, and place all of the files in your current FrontPage web under version control.

After associating your FrontPage web with a Source Safe project, you can use the Check-Out command on the Edit menu to exclusively edit a file in the FrontPage web. You can make changes to the page or file in the FrontPage Editor, save it, and use the Check-In command on the Edit menu to make the changes available to other authors working on the FrontPage web. Or, if you make a mistake, you can use the Undo Check-Out command to revert back to the version you had before you checked the file out.


Microsoft Index Server

Microsoft Windows NT Server, versions 4.0 and later, support the Microsoft Index Server. This NT service provides rich and efficient indexing of pages and other files on your Windows NT Server. If you are running Microsoft Internet Information Server (IIS) as your Web server, FrontPage will automatically take advantage of the Index Server, if installed, when you use the FrontPage Search Form. You will notice increased performance, support for multiple languages, and indexing of Microsoft Office document files.


Secure Sockets Layer Support

Secure Sockets Layer (SSL) allows software to communicate with Web servers in a secure, encrypted manner. Many Web sites that conduct electronic commerce use SSL to securely transmit credit card numbers from a customer’s Web browser to the Web server.

If you are creating a FrontPage web on a Web server that supports SSL, then FrontPage can take advantage of SSL in the following ways:

  • To communicate securely between your computer and the Web server. This means that no one will be able to intercept and read the information you are sending back and forth between your computer and the Web server.

  • To create secure hyperlinks in Web pages. Secure hyperlinks begin with https:// instead of the standard http://

To determine if you are running against a Web server that supports SSL, ask the Web server’s administrator or webmaster. If you are running against one of the following Web servers, then you can probably take advantage of SSL: Microsoft Internet Information Server, Netscape Commerce Server, Netscape Enterprise Server, and O’Reilly WebSite Professional. However, since your Web server administrator or webmaster may have disabled SSL support, you should check to be sure.

If you’re not sure if you are running a Web server that supports SSL and you have no one to ask, you can try starting the FrontPage Explorer and creating a new blank web. Give the FrontPage web a name, and check the box labeled “Connect Using SSL.” If you do not receive an error message, then SSL is available.


Next Steps

To | See
Learn more about advanced FrontPage features | The FrontPage online Help system, or browse the FrontPage section of http://www.microsoft.com/


Glossary

A

absolute URL The full Internet address of a page or other World Wide Web resource. The absolute URL includes a protocol, such as “http,” network location, and optional path and file name. For example, http://example.microsoft.com/ is an absolute URL. See also URL.

active hyperlink A hyperlink that is currently selected in a Web browser. Some Web browsers indicate the active hyperlink by changing its color.

active page The page currently being edited in the FrontPage Editor.

ActiveX control A component that can be inserted in a page to provide functionality not directly available in HTML, such as animation sequences, credit-card transactions, or spreadsheet calculations. ActiveX controls can be implemented in a variety of programming languages from Microsoft and third parties.

address A paragraph style usually used to render URLs on a page or to supply signatures or other indications of authorship. Address paragraphs are usually displayed in italics and are sometimes indented. See also network location.

All Files View The FrontPage Explorer view that displays all the files in a FrontPage web in a single list, along with information about each file, such as name, size, and file type. Views in the FrontPage Explorer provide different ways of looking at the information in your FrontPage web, so that you can effectively manage your site.

All Folders Pane In the FrontPage Explorer’s Folders view, the left portion of the screen, which shows all the folders and files in the current FrontPage web.

All Pages Pane In the FrontPage Explorer’s Hyperlinks view, the left portion of the screen, which shows all the pages in the current FrontPage web.

animated GIF A file containing a series of GIF (Graphics Interchange Format) images that are displayed in rapid sequence by some Web browsers, giving an animated effect. See also GIF.

anchor See bookmark.

anonymous FTP A file transfer (FTP) service in which any user can copy files by logging on with the name “anonymous.” See also FTP.

applet See Java applet.

article A single entry in a discussion group or newsgroup. An article can be a response to a previous article.

ascender The part of a lowercase letter that rises above the main body of the letter.

ASCII (American Standard Code for Information Interchange) The predominant method for encoding 7-bit characters on a Personal Computer. HTML tags and URLs must be in ASCII.

ASP (Active Server Page) A method for creating programs that run on a Web server, first available on the Microsoft Internet Information Server 3.0. See also IIS.

aspect ratio The ratio of an image’s width to its height.

authentication database A database on a server that matches user names to passwords.

B

background sound A sound file that you associate with a page. When the page is displayed in a Web browser, the sound file plays or repeats the number of times that you specify.

banner An image, usually displayed at the top of each page in a Web site, containing text and design elements.

Banner Ad Manager A FrontPage component that shows each of a series of designated images for a specified number of seconds, then transitions to the next image using any of several transition effects.

base URL A URL that you can assign to a page to convert relative URLs on that page into absolute URLs. A base URL should end with a document name part, such as http://example.microsoft.com/sample.htm, or a trailing slash, such as http://example.microsoft.com/subdir/. See also absolute URL.

baseline In text, the imaginary line drawn along the bottom of the main body of the letters. Descenders descend below the baseline. In a table, the cell property that aligns the baseline of text in a cell with the baseline of the tallest text in the row.

basic authentication An authentication protocol supported by Microsoft Internet Explorer. There is no encryption in this protocol.

bevel A three-dimensional effect applied to the border of an image. The FrontPage Editor’s image toolbar contains a Bevel command.

BMP The standard bitmap image format on Windows-compatible computers. Bitmap images can be saved for Windows or OS/2 systems and support 24-bit color.

bookmark A named location on a page that can be the target of a hyperlink. A bookmark can be applied to a set of characters or it can exist on a page separately from any text. Bookmarks allow authors to link to a specific section of a target page. In a URL, a bookmark is preceded by a pound-sign character (#). Also called anchor.

broken hyperlink In the FrontPage Explorer, a hyperlink that does not correctly point to a page or other Internet file. A broken hyperlink either indicates an incorrect URL or a missing page or file.

browser See Web browser.

bulleted list A paragraph style that creates a single list element, usually indicated by a bullet character. Also called an unordered list.

bulletin board An electronic forum that hosts posted messages and articles related to a common subject.

C

cascading style sheet An HTML syntax that gives authors precise control over the formatting of text in Web pages. Formatting information is stored in a Web site in style sheets, and can be applied to whole pages or parts of pages.

cell The smallest component of a table. In a table, a row or column contains one or more cells.

cell padding The space between the contents and inside edges of a table cell.

cell spacing The amount of space between cells in a table. Cell spacing is the thickness, in pixels, of the walls of each cell.

CERN image map dispatcher The program HTIMAGE.EXE, which handles server-side image maps in the Personal Web Server when the image map style is set to “CERN” in the FrontPage Explorer.

CGI (Common Gateway Interface) A standard method of extending Web server functionality by executing programs or scripts on a Web server in response to Web browser requests. A common use of CGI is in form processing, where the browser sends the form data to a CGI script on the server, and the script integrates the data with a database and sends back a results page as HTML.

change style dropdown A dropdown list on the FrontPage Editor’s toolbar from which you can choose a format for the currently selected paragraphs or apply a style from a style sheet.

channel A push technology that allows users to subscribe to a Web site to browse offline, automatically display updated pages on their screen savers, and download or receive notifications when pages in the Web site are modified. Channels are available only in browsers that support channel definitions, such as Microsoft Internet Explorer version 4.0.

Channel Definition Format (CDF) file A file that enables users to access your FrontPage web as a channel in browsers that support channel definitions, such as Microsoft Internet Explorer version 4.0. The CDF file provides an index of resources available on your channel and a recommended schedule for updating the channel on the user’s computer. The FrontPage Channel Definition Wizard uses your input to create a CDF file that allows users to subscribe to your FrontPage web as a channel, a screen saver, or a desktop component, as well as receive e-mail notification when specific files change.

check box A form field that can be chosen by clicking a box. When a box is selected, it is usually displayed with a check mark or X. Check boxes are usually grouped to represent a set of choices. Users can select more than one check box in a form. See also radio button.

child page A page that is part of the navigation structure of a FrontPage web and that is linked to a parent page. A child page is accessed from its parent page by following a link from a navigation bar on the parent page. Web content on a child page often provides more detailed information related to the content on the parent page. See also navigation bar, peer page.

child web A named subdirectory of the root web that is a whole FrontPage web and is separate from the root web. Any number of child webs can be under the root web. Each child web can have many levels of subdirectories, making up its content. Note that child webs only go to one level. FrontPage does not support creating child webs within child webs.

class selector In a cascading style sheet style-definition (or style rule), a subset of a selector that controls whether the same selector can be used for slightly different styles in different situations. In FrontPage you can define or apply class selectors by clicking the Style button on the element’s Properties dialog box, and then defining or applying the class selector in the Style dialog box.

client On the Internet, a program that requests files or services from a server.

client-side image map An image map that encodes the destination URL of each hotspot directly in a page. Client-side image maps do not require processing from a server to follow the hyperlinks on the image map, so they are more efficient. However, not all Web browsers support client-side image maps.

client-side program On the Internet, a program that is run on a client computer rather than on a server computer. Client-side programs do not communicate over the Internet.

clip art A collection of icons, buttons, and other useful image files, along with sound and video files that can be inserted into pages.

clipboard A temporary storage area on a computer for cut or copied items.

code page See HTML character encoding.

column In a table, a vertical collection of cells.

comment Text that you can view in the FrontPage Editor but that will not be displayed by a Web browser. Comment text appears purple in the FrontPage Editor and retains the character-size and other attributes of the current paragraph style.

Confirmation Field A FrontPage component that is replaced with the contents of a form field. It is useful on a form confirmation page, where it can echo a user’s name or any other data entered into a field.

confirmation page A page that is displayed in a Web browser after a form has been submitted by a user. The confirmation page usually displays the user’s name and other data from the form. You specify a form’s confirmation page in the form handler’s dialog box.

Contents Pane In the FrontPage Explorer’s Folders view, the right portion of the screen, which shows the files contained in the folder selected in the All Folders pane.

converter A program that converts a text file, or a portion of a text file, from one format to another. For example, FrontPage includes a Microsoft Word to HTML converter. See also filter.

crop To reduce the size of an image by eliminating all portions outside of a resizable box that is dragged over the image. The FrontPage Editor’s image toolbar contains a Crop command.

current FrontPage web The FrontPage web currently opened in the FrontPage Explorer.

custom dictionary A list of words not in the standard dictionary but that an author wants accepted by the spelling checker as correct.

D

Database Region Wizard A FrontPage wizard that guides an author through creating a connection to a database, forming a database query, and associating a query with one or more form fields on a page. End users browsing the page can then query the database based on parameters they enter in the form.

default image hyperlink In an image map, the hyperlink to follow when a user clicks in an area where there are no hotspots on the image.

definition The HTML style of the second paragraph of a pair of paragraphs composing a definition list entry. The first paragraph in the pair is the term.

definition list A list of alternating term and definition paragraphs. Definition lists are often used to implement dictionaries in FrontPage webs. See also term and definition.

descender The part of a lowercase letter that descends below the main body of the letter; the part of a lowercase letter below the baseline of the letter.

Design-time control An ActiveX control that is used while designing or editing a page. Design-time controls that are installed on the client computer are listed in the FrontPage Editor. See also ActiveX.

desktop component In a Web browser’s desktop, a small screen region that displays summary or update information about a Web site which has been subscribed to as a channel. For example, a desktop component might display a stock ticker, a list of news stories, or a pop-up broadcast message. Desktop components are available only in browsers that support channel definitions, such as Microsoft Internet Explorer version 4.0.

Discussion Form Handler A FrontPage form handler that allows users to participate in an online discussion. The Discussion Form Handler collects information from a form, formats it into an HTML page, and adds the page to a table of contents and to a text index. In addition, the Discussion Form Handler gathers information from the form and stores it in one of a selection of formats.

discussion group A FrontPage web that supports interactive discussions by users. Users submit topics or responses by entering text in a form. Users can search the group using a search form or access articles using a table of contents.

discussion group folder A folder in a FrontPage web containing all the articles in a discussion group. The name of a discussion group folder begins with an underscore character and is created automatically by FrontPage. Discussion group directories are not normally visible from the FrontPage Explorer. However, they can be searched by a FrontPage Search Form.

Distributed Password Authentication Microsoft `istributed Password Authentication (DPA), which provides an advanced, distributed method of user authentication, allowing for single user logon. DPA support is provided by the Microsoft Membership System and is optimized for the needs of Internet service providers and online services.

domain name See network location.

drop-down menu field A form field that presents a list of selections in drop-down menu style. A drop-down menu form field can be configured to permit the selection of many fields or a single field.

E

editor An interactive program that can create and modify files of a particular type. For example, the FrontPage Editor is an HTML editor.

E-mail (electronic mail) A service for sending messages over a computer network.

E-mail Form Handler See Save Results Form Handler.

embedded files Images, sounds, and video clips that have been inserted on a page in the FrontPage Editor from files or from the clipboard. You are prompted to save any embedded files when you save the active page.

embedded style sheet A cascading style sheet that is embedded on a page. Styles in an embedded style sheet can be applied only to the page containing the style sheet, and will either extend or override styles defined in any external style sheet that is linked to the page.

emphasis text The HTML character style used for mild emphasis. Certain Web browsers display emphasized text as italic.

EPS (Encapsulated PostScript) An extension of the PostScript graphics file format developed by Adobe Systems. EPS lets PostScript graphics files be incorporated into other documents. FrontPage supports importing EPS files.

Ethernet A commonly used type of local area network (LAN).

executable folder A folder in a FrontPage web from which scripts and executable programs can be run on a Web server. You can make a folder executable in the FrontPage Explorer. Web server administrator’s may prohibit the use of executable folders.

extended attribute An HTML attribute not directly supported in FrontPage. In the FrontPage Editor, you can add extended attributes to most elements on the page.

external hyperlink A hyperlink to any page or file that is outside the current FrontPage web.

external style sheet A cascading style sheet in a file with a .css file extension. The .css file is comprised solely of style rules in valid .css syntax, without any surrounding HTML tags. By defining styles in one or more external style sheets and linking them to pages in your web, you ensure consistency of appearance throughout those pages. If you change a style in the external style sheet, the change will be reflected in all of the pages linked to that style sheet.

F

FAQ (Frequently Asked Questions) A common type of document on the Internet that contains a list of questions and answers on a common theme. On the World Wide Web, questions are often hyperlinks to the answers.

file A named collection of information that is stored on a computer. Also, an Internet protocol that refers to files on a disk or Local Area Network. You can create hyperlinks to files (file://) in the FrontPage Editor.

file server A computer running on a network that stores files and provides access to them. Also called server. See also Web server.

file type The format of a file, commonly indicated by its filename extension. Computer applications usually work on a limited set of file types.

Files Pane In the FrontPage Explorer’s Navigation view, the lower half of the screen, which displays a familiar Windows Explorer-like file and folder list of the current FrontPage web.

In the FrontPage Explorer’s Folders view, the right portion of the screen, which displays the contents of the selected folder in the All Folders pane.

filter A tool that converts an image or a file.

finger An Internet program that displays information about the users currently logged on to a computer.

firewall A method of protecting the files and programs on one network from users on another network. A firewall blocks unwanted access to a protected network while giving the protected network access to networks outside of the firewall. A company will typically install a firewall to give users access to the Internet while protecting their internal information. FrontPage allows users to author FrontPage webs on the Internet even from within a protected network.

folder A named storage area on a computer containing files and other folders.

Folders View In the FrontPage Explorer, the view of a FrontPage web that shows how the content of the FrontPage web is organized. You can create, delete, copy, and move folders in the Folders view. Views in the FrontPage Explorer provide different ways of looking at the information in your FrontPage web, so that you can effectively manage your site.

form A set of data-entry fields on a page that are processed on a server. The data is sent to the server when a user submits the form by clicking on a button or, in some cases, by clicking an image.

form field A data-entry field on a page. A user supplies information in a field either by typing text or by selecting a field.

form handler A program on a server that executes when a user submits a form. A FrontPage form is associated with a form handler in the Form Properties dialog box.

formatted text A monospaced paragraph style in which all white space (such as tabs and spaces) is displayed by a Web browser. In other text styles, extra white space may be ignored by a Web browser.

format toolbar The FrontPage Editor toolbar containing commands that reformat selected paragraphs or text.

forms toolbar The FrontPage Editor toolbar containing commands for creating form fields.

frame A named sub-window of a frames page. A frame appears in a Web browser as one of a number of window regions in which pages can be displayed. A frame may be scrollable and resizable, and may have a border. You display a page in a frame by creating a hyperlink to the page and specifying the frame as part of the hyperlink.

frames page A page that subdivides a Web browser’s window into regions called frames that can independently display pages. See also frame.

Frames Page HTML View The view in the FrontPage Editor that shows the HTML of the frames page currently being displayed. See also frames page.

FrontPage component A built-in FrontPage object that is evaluated and executed when an author saves the page or, in some cases, when a user browses to the page. Most FrontPage components generate HTML. FrontPage components include Search Forms, which provide full text-searching capability in a FrontPage web, Popup Menus, which create popup menus on a page, and Save Results Form Handlers, which gather information from a form and store it in a file or send it to an e-mail address. See also WebBot component.

FrontPage component cursor In the FrontPage Editor, the robot-shaped cursor that is displayed when you move the mouse pointer over an area of a page containing a FrontPage component. See also FrontPage component.

FrontPage Editor The FrontPage tool for creating, editing, and testing Web pages.

FrontPage Explorer The FrontPage tool for creating, viewing, modifying, and administering FrontPage webs.

FrontPage Server Extensions A set of programs and scripts that support FrontPage authoring and extend the functionality of a Web server. The FrontPage Server Extensions are available for the Microsoft Internet Information Server and other popular Windows and UNIX Web servers. If you are not sure if your Web server is supported, visit http://www.microsoft.com/frontpage/

FrontPage web A home page and its associated pages, images, documents, multimedia, and other files stored on a Web server or on a computer’s hard drive. A FrontPage web also contains files that support FrontPage functionality and that allow a web to be opened, copied, edited, and administered in the FrontPage Explorer.

FrontPage web name The name of a FrontPage web. A FrontPage web name corresponds to a folder name on a Web server and is subject to the length, character restrictions, and case sensitivity of that server.

FrontPage web structure The set of relationships among the pages in a FrontPage web as defined in the FrontPage Explorer’s Navigation view. A well-defined structure gives a user a sense of position in a FrontPage web. When a navigation bar is inserted on a page that is part of a FrontPage web’s structure, FrontPage automatically creates hyperlinks to the pages that are below that page in the structure (child pages), above that page in the structure (parent pages) and equal to that page in the structure (peer pages). See also navigation bar, Navigation Pane, Navigation View.

FrontPage web title A descriptive name for a FrontPage web. The FrontPage web title is displayed in the title bar of the FrontPage Explorer window when the FrontPage web is open. A FrontPage web title must start with a letter and can have a maximum of 31 characters.

FTP (File Transfer Protocol) The Internet service that transfers files from one computer to another, over standard phone lines. You can create ftp hyperlinks (ftp://) in the FrontPage Editor.

G

gateway script See CGI.

GIF (Graphics Interchange Format) A graphical file format commonly used to display indexed-color images on the World Wide Web. GIF is a compressed format, designed to minimize file transfer time over standard phone lines. See also interlaced GIF.

gopher The Internet protocol where files are displayed in a hierarchical menu and are retrieved based on user input. You can create gopher hyperlinks (gopher://) in the FrontPage Editor.

H

heading A paragraph style that is displayed in a large, bold typeface. The size of a heading is related to its level: Heading 1 is the largest, Heading 2, the next largest, and so on. Use headings to name pages and parts of pages.

hidden field A form field that is invisible to a user but supplies data to a form handler. Each hidden field is implemented as a name-value pair. When a form is submitted by a user, its hidden fields are passed to the form-handler along with name-value pairs for each visible form field.

hidden folder A folder in a FrontPage web that has a name beginning with an underscore character, as in _hidden. By default, pages and files in hidden folders cannot be viewed in a Web browser.

home page The starting point for a Web site. It is the page that is retrieved and displayed by default when a user visits the Web site. The default home-page name for a server depends on the server’s configuration. On many Web servers it is index.html or default.htm. Some Web servers support multiple home pages.

horizontal line A horizontal graphic element on a Web page often used to separate sections of the page.

host See server.

host name See network location.

hotspot A graphically defined area in an image that contains a hyperlink. An image with hotspots is called an image map. In Web browsers, hotspots are invisible. Users can tell that a hotspot is present by the changing appearance of the pointer.

hover button An animated button on a Web page that is activated when the mouse pointer is moved over the button or when the button is clicked.

HTIMAGE.EXE The CERN image map dispatcher. This program handles server-side image maps when the image map style is set to “CERN.”

HTML (HyperText Markup Language). The standard language for describing the contents and appearance of pages on the World Wide Web. The FrontPage Page Editor reads and writes HTML files. Knowledge of the HTML language is not required to use FrontPage.

HTML attribute A name-value pair used within an HTML tag to assign additional properties to an object being defined. FrontPage assigns some attributes automatically when you create an object such as a paragraph or image map. You can assign other attributes by editing the Properties dialog box.

HTML character encoding A standard table which associates a numeric index with each character in a character set. The table is used when you create a Web page for use in a specific language. Also called code page.

HTML Markup A FrontPage component that is replaced with any arbitrary text you supply. This text is substituted for the FrontPage component when the page is saved to the server as HTML. Use HTML Markup to insert non-standard HTML commands on a page.

HTML tag A symbol used in HTML to identify a page element’s type, format, and appearance. The FrontPage Editor automatically creates HTML tags to represent each element on a page.

HTML View The view in the FrontPage Editor that displays a page’s HTML. You can directly edit a page’s HTML in this view.

HTTP (HyperText Transport Protocol) The Internet protocol that allows World Wide Web browsers to retrieve information from servers.

hyperlink A pointer from text or from an image map to a page or other type of file on the World Wide Web. On Web pages, hyperlinks are the primary way to navigate between pages and among Web sites.

Hyperlink Status View A view in the FrontPage Explorer that graphically shows the status of the hyperlinks in your FrontPage web. The list includes both internal and external hyperlinks, and graphically indicates whether the hyperlinks have been verified or whether they are broken. Views in the FrontPage Explorer provide different ways of looking at the information in your FrontPage web, so that you can effectively manage your site.

Hyperlinks Pane In the FrontPage Explorer’s Hyperlinks view, the right portion of the screen, which shows the hyperlinks to the selected page and from the selected page in the All Pages pane.

Hyperlinks View A view in the FrontPage Explorer that graphically shows the hyperlinks among pages and other files in your FrontPage web along with the hyperlinks from your FrontPage web to other World Wide Web sites. Views in the FrontPage Explorer provide different ways of looking at the information in your FrontPage web, so that you can effectively manage your site.

hypertext Originally, any textual information on a computer containing jumps to other information. The hypertext jumps are called hyperlinks. On Web pages, hypertext is the primary way to navigate between pages and among Web sites. Hypertext on Web pages has been expanded to include hyperlinks from text and hyperlinks from image maps.

I

ID selector In a cascading style sheet style-definition (or style rule), a selector that is used to define a style for an individual page element, usually as an inline style. In FrontPage, you can define or apply ID selectors by clicking the Style button on the element's Properties dialog box, and then defining or applying the ID selector in the Style dialog box.

IIS (Internet Information Server) Microsoft’s high-performance, secure, and extensible Internet server based on Windows NT Server. IIS supports the World Wide Web, FTP, and gopher.

image A picture or graphics file that can be inserted on a Web page and displayed in a Web browser. FrontPage lets you import images in the following formats: GIF, JPEG (standard and progressive), BMP (Windows and OS/2), TIFF, TGA, RAS, EPS, PCX, and WMF. Imported images are converted to GIF format (for images containing up to 256 colors) or JPEG format (for images containing over 256 colors) when the page is saved to the current FrontPage web.

image alignment In FrontPage, the specification of how images and text are aligned with each other on a page. You specify image alignment in the FrontPage Editor.

image bullet Images used as the bullet characters in a bulleted list. The FrontPage Editor supports image bullets.

image form field A form field that displays an image in a form. By clicking the image, a user either submits or clears the form.

image map An image containing one or more invisible regions, called hotspots, which are assigned hyperlinks. Typically, an image map gives users visual cues about the information made available by clicking each part of the image. For example, a geographical map could be made into an image map by assigning hotspots to each region of interest on the map.

image toolbar The FrontPage Editor toolbar that contains commands to modify or enhance images. You also use the image toolbar to create image hotspots. See also hotspot.

IMAGEMAP.EXE The NCSA image map dispatcher. This program handles server-side image maps when the image map style is set to “NCSA.”

Include Page component A FrontPage component that is replaced with the contents of another page in the FrontPage web. This lets you update parts of many pages in one step.

initial page The page that is initially displayed in a frame when a user browses to a frames page containing the frame. In the FrontPage Editor you can assign the initial page to a frame. See also frames page.

inline image An image that is embedded in a line of text rather than in its own window. In FrontPage, images are inline by default.

inline style A method of applying cascading style sheet properties and values to an element on a page, such as a table, image, or ActiveX control. You can use this method even if the page is not linked to an external style sheet or does not contain an embedded style sheet. In FrontPage, you can create and apply an inline style by clicking the Style button on the element’s Properties dialog box, and then setting the inline style properties on the Style dialog box.

interlaced GIF A GIF image that is gradually displayed in a Web browser, showing increasingly detailed versions of the entire image until all of the data has finished downloading. See also GIF.

internal hyperlink A hyperlink to any page or file that is part of the current FrontPage web.

internal web A World Wide Web site created within an organization and accessible only to members of that organization on an intranet.

Internet The global computer network, composed of thousands of Wide Area Networks (WANs) and Local Area Networks (LANs) that uses TCP/IP to provide world-wide communications to homes, schools, businesses, and governments. The World Wide Web runs on the Internet.

Internet address See network location.

Internet Explorer The Microsoft Web browser for Windows 95, Windows NT, and Macintosh. When Internet Explorer is installed, FrontPage offers additional functionality, such as dynamic page and themes preview from within the FrontPage Editor. Internet Explorer version 3.0 offers ActiveX, Java, and plug-in support. Internet Explorer version 4.0 adds support for cascading style sheets, Dynamic HTML, and the Channel Definition Format (CDF).

Internet Information Server (IIS) Microsoft’s high-performance, secure, and extensible Internet server based on Windows NT Server. IIS supports the World Wide Web, FTP, and gopher.

intranet A computer network that is internal to an organization and supports Internet applications, especially the World Wide Web. Most intranets are configured so that their users can access the entire Internet without allowing users of the Internet access to the computers on the intranet. See also firewall.

IP (Internet Protocol) Internet software that divides data into packets for transmission over the Internet. Computers must run IP to communicate across the Internet. See also TCP.

IP address (Internet Protocol address) The standard way of identifying a computer that is connected to the Internet, much the way a telephone number identifies a telephone on a telephone network. The IP address is four numbers separated by periods, and each number is less than 256, for example, 192.200.44.69. Your Web server administrator or Internet Service Provider will assign your computer an IP address.

IP address mask (Internet Protocol address mask) A range of IP addresses defined so only computers with IP addresses within the range are allowed access to an Internet service. To mask a portion of the IP address, replace it with the asterisk wild card character (*). For example, 192.44.*.* represents every computer on the Internet with an IP address beginning with 192.44.

ISAPI (Internet Server Application Programming Interface) A Web server application-development interface, developed by Process Software and Microsoft Corporation, that can be used in place of CGI.

J

Java A general-purpose programming language created by Sun Microsystems. Java can be used to create Java applets. A Java program is downloaded from the Web server and interpreted by a program running on the computer running the Web browser.

Java applet A short program written in Java that is attached to a Web page and executed by the computer on which the Web browser is installed.

JavaScript A cross-platform, World Wide Web scripting language developed by Netscape Communications. JavaScript code is inserted directly into an HTML page.

JPEG (Joint Photographic Expert Group) A graphical file format used to display high-resolution color images on the World Wide Web. JPEG images apply a user-specified compression scheme that can significantly reduce the large file sizes usually associated with photo-realistic color images. A higher level of compression results in lower image quality, whereas a lower level of compression results in higher image quality. See also progressive JPEG.

L

LAN (Local Area Network) A computer network technology designed to connect computers separated by a short distance. A LAN can be connected to the Internet and can also be configured as an intranet.

line break A special character that forces a new line on a page without creating a new paragraph.

link See hyperlink.

list A group of paragraphs similarly formatted to indicate membership in a set or in a sequence of steps. In the FrontPage Editor you can create numbered lists or bulleted lists, menus, directories, or definitions.

M

mailto The Internet protocol used to send electronic mail. You can create e-mail hyperlinks in the FrontPage Editor.

marquee A region on a page that displays a horizontally scrolling text message.

menu list A list of short paragraph entries formatted with little white space between them.

meta tag An HTML tag that must appear in the <head> portion of the page. Meta tags supply information about a page but do not affect its appearance. A standard meta tag, “generator,” is used to indicate the type of editor that created the HTML page.

Microsoft Image Composer A powerful image editing application integrated with FrontPage that lets you create original artwork or modify existing images.

MIME type (Multipurpose Internet Mail Extensions type) A method used by Web browsers to associate files of a certain type with applications that display files of that type.

multi-hosting The ability of a Web server to support more than one Internet address and more than one home page. Also called multi-homing.

N

name-value pair The name of a form field and the value of the field at the time the form is submitted. Each field in a form can have one or more name-value pairs, and the form itself can have one or more name-value pairs.

navigation bar A graphical or textual page element that incorporates navigation hyperlinks to pages that are part of a FrontPage web’s structure. You design the FrontPage web’s structure in the FrontPage Explorer’s Navigation view. See also FrontPage web structure, Navigation View.

Navigation Pane In the FrontPage Explorer’s Navigation view, the upper half of the screen, which shows the structure of your FrontPage web in a graphical representation.

Navigation view The FrontPage Explorer view that is used to create, display, print, and change the navigation structure of a FrontPage web. The Navigation view includes folder-like view, from which you can drag-and-drop pages into your site structure.

NCSA image map dispatcher The program IMAGEMAP.EXE, which handles server-side image maps when the image map style is “NCSA” and you are using the FrontPage Personal Web Server.

nested frames page A frames page containing another frames page inside one of its frames. See also frames page, frame.

nested list A list that is contained within a member of another list. Nesting is indicated by indentation in most Web browsers. When you create one list element within another list element in FrontPage, the new list element is automatically nested.

network location In a URL, a unique name that identifies an Internet server. A network location has two or more parts, separated by periods, as in my.network.location. Also called host name and Internet address.

news The Internet protocol for retrieving files from an Internet newsgroup. You can create news hyperlinks (news://) in the FrontPage Editor.

No Frames view The page view in the FrontPage Editor that displays the alternate HTML of a frames page. This is the HTML for Web browsers that do not support frames pages to display.

normal text The default paragraph style of the FrontPage Editor, intended for use in text paragraphs.

Normal view The default WYSIWYG page view of the FrontPage Editor that displays a page as it would appear in a Web browser.

NSAPI (Netscape Server Application Programming Interface) A Web server application development interface, developed by Netscape Communications Corporation.

NTLM (NT LanMan) The Windows NT Challenge/Response authentication protocol. This protocol uses encryption for secure transmission of passwords.

numbered list The HTML paragraph style that presents an ordered list of items.

O

OLE (Object Linking and Embedding) An object system created by Microsoft. OLE lets an author invoke different editor components to create a compound document.

ordered list See numbered list.

one-line text box A labeled, single-line form field in which users can type text.

P

page A single document on a Web site written in HTML language. You can use the FrontPage Editor to create and modify pages without having to learn HTML.

page template A pre-designed but generic Web page you can use to create new custom pages. Some of FrontPage’s page templates provide typical page content, while others provide common page layouts.

page title A text string identifying a page. The page title is displayed in the FrontPage Explorer and is used by many FrontPage Editor and FrontPage Explorer commands.

paragraph style In the FrontPage Editor, the paragraph style specifies the type of font to use in a paragraph, the font’s size, and other attributes related to text on a page. Paragraph style also specifies whether to use bullets and numbering and controls indentation and line spacing.

parent page A page in a FrontPage web that is part of the navigation structure of a FrontPage web and is linked to one or more pages called child pages. A child page is accessed from its parent page by following a link from a navigation bar on the parent page. See also navigation bar, peer page.

password A string of characters that allows a user access to an Internet service, if the service requires it.

path The portion of a URL that identifies the folders containing a file. For example, in the URL http://my.web.site/hello/world/greetings.htm, the path is /hello/world/.

PCT (Personal Communications Technology) An enhanced version of Secure Socket Layer. See also Secure Socket Layer.

PCX A graphical file format that compresses its image data with RLE-type compression, used by early versions of Windows Paintbrush. FrontPage can import PCX files.

peer pages A set of pages that are part of the navigational structure of a FrontPage web and share a common parent page. See also FrontPage web structure.

plug-in One of a set of software modules that integrate into Web browsers to offer a range of interactive and multimedia capabilities.

Popup Menu A FrontPage component that implements a popup menu on the Web page. Each item on the popup menu is a hyperlink. Using this popup menu, users can navigate the FrontPage web. You can create a Popup Menu in the FrontPage Editor.

port One of the network input/output channels of a computer running TCP/IP. On the World Wide Web, port usually refers to the port number a server is running on. A single computer can have many Web servers running on it, but only one server can be running on each port. The default port for Web servers is 80.

PPP (Point to Point Protocol) An Internet standard for transmitting data over serial links between computers.

progressive JPEG An enhancement to the JPEG image format specification that allows an image to be gradually displayed in a Web browser, showing increasingly detailed versions of the entire image until all of the data has finished downloading. While this is similar to interlaced GIF images, progressive JPEG images can retain the high quality of 24-bit color and offer the same efficient compression as standard JPEG. See also JPEG.

properties The characteristics of an item in a FrontPage web, such as the title and URL of a FrontPage web or the name and initial value of a form field. You can also specify properties for page elements such as tables, images, and scrolling marquees.

protocol A method of accessing a document or service over the Internet, such as File Transfer Protocol (FTP) or HyperText Transfer Protocol (HTTP). Also called type.

proxy server An Internet server that acts as a firewall, mediating traffic between a protected network and the Internet. See also firewall.

publish The process of making your FrontPage web public on the World Wide Web or an intranet. You publish your FrontPage web using the FrontPage Explorer.

push button A form field that lets a user submit a form or reset a form to its initial state.

R

radio button A form field that presents a user with a selection that can be chosen by clicking on a button. Radio buttons are presented in a list, one of which is selected by default. Selecting a new member of the list deselects the currently selected item. See also check box.

RAS The Raster image file format developed by Sun Microsystems.

registered user A user of a Web site whose name and password has been recorded within the Web site. In a FrontPage web, you can register users with a FrontPage Registration Form Handler.

Registration Form Handler A FrontPage form handler that allows users to automatically register themselves for access to a service implemented as a World Wide Web site. The Registration Form Handler adds the user to the service’s authentication database, then gathers optional information from the form and stores it in one of many supported formats.

relative URL The Internet address of a page or other World Wide Web resource relative to the Internet address of the current page. A relative URL gives the path from the current page to the destination page or resource. A relative URL can include a protocol. For example, the relative URL doc/sample.htm refers to the page sample.htm in the folder doc, below the current folder.

resample The changing of the pixel dimensions (and therefore file size) of an image. An image can be resampled down (its number of pixels is decreased) or resampled up (its number of pixels is increased). When you resample an image down, pixel information is deleted from the image. When you resample an image up, new pixel information is created based on the color values of the existing pixels. Resampling and image down and then resampling it up to the original resolution will cause the quality of the image to deteriorate. The FrontPage Editor includes a Resample command.

root web The FrontPage web that is provided by a Web server by default. To access the root web, you supply the URL of the server without specifying a page name or sub-web. FrontPage is installed with a default root web named <Root web>. All FrontPage sub-webs are contained by the root web. See also sub-web.

row In a table, a horizontal collection of cells.

RTF (Rich Text Format) A method of encoding text formatting and document structure using the ASCII character set. By convention, RTF files have an .rtf filename extension. You can open RTF files in the FrontPage Editor and have them converted to HTML.

S

Save Results Form Handler A FrontPage form handler that gathers information from a form and stores it in one of a selection of formats or sends the information to an e-mail address. When a user submits the form, the Save Results Form Handler appends the form information to a file on the server in a specified format.

Scheduled Image A FrontPage component that is replaced on the page by an image during a specified time period. When the time period has expired, the image is no longer displayed. This is useful for displaying graphical information that has a limited lifetime, such as the announcement of a new product or service.

Scheduled Include Page component A FrontPage component that is replaced with the contents of a file in a FrontPage web during a specified time period. When the time period has expired, the contents of the file are no longer displayed. This is useful for displaying textual information that has a limited lifetime.

script A type of computer code than can be directly executed by a program that understands the language in which the script is written. Scripts do not need to be compiled to be run.

scrolling text box A labeled, multiple-line form field in which users can type one or more lines of text.

Search Form A FrontPage component that creates a form that provides full text-searching capability in your FrontPage web when the FrontPage web is browsed. When a user submits a form containing words to locate, the Search Form returns a list of hyperlinks to the pages in your FrontPage web containing matches for the words.

Secure Socket Layer (SSL) A low-level protocol that enables secure communications between a Web server and FrontPage or a Web browser.

selection bar In the FrontPage Editor, an unmarked column along the left edge of body text that is used to select lines of text by clicking the left mouse button.

selector In a cascading style sheet style-definition (or style rule), the HTML element linked to a particular set of style properties and values.

server A computer that offers services on a network. On the World Wide Web, a server is a computer that runs the Web server software which responds to HTTP protocol requests. Also called host.

server name See network location.

server-side image map An image map that passes the coordinates of the mouse pointer to a CGI handler routine on the server. Server-side image maps require your server to compute the target URL of the hyperlink based on the mouse pointer coordinates.

server-side include A feature provided by some Web servers that automatically inserts text onto pages when they are fetched by a Web browser.

SGML An ISO (International Standards Organization) markup language for representing documents on computers. HTML is based on SGML concepts.

shared borders Page regions reserved for content that you want to appear consistently throughout your pages. Shared borders usually contain navigation bars — hyperlinks to the other pages in the current FrontPage web. When you create a FrontPage web in the FrontPage Explorer’s Navigation view, shared borders and navigation bars are automatically created and updated, even when you add, move, or delete pages from the web’s structure.

size handle The black rectangle displayed on a selected form field, image, or hotspot. When you select a size handle, the cursor becomes a bi-directional arrow. Click and drag a size handle to reshape a form field, image, or hotspot.

SLIP (Serial Line Internet Protocol) An Internet standard for transmitting data over serial links between computers.

special character A character not included in the standard 7-bit ASCII character set, such as the copyright mark (©). In FrontPage, you can add special characters using the FrontPage Editor.

standard toolbar The FrontPage Editor toolbar containing the most commonly used menu commands.

status bar The area at the bottom of the FrontPage Editor or FrontPage Explorer that displays information about the currently selected command or about an operation in progress.

strong text The HTML character style used for strong emphasis. Certain browsers display this style as bold.

style Styles are used in a webs to control the type of font, alignment and spacing of text, appearance of background pages, and other HTML attributes. A collection of styles is called a style sheet. See also cascading style sheet.

sub-web A named subdirectory of the root web that is a complete FrontPage web. Each FrontPage sub-web can have independent administration, authoring and browsing permissions from the root web and other sub-webs. In addition, searches implemented through the FrontPage Search Form are limited to the sub-web, and FrontPage only manages hyperlinks within the sub-web. Any number of sub-webs can be created under the root web. FrontPage does not support creating sub-webs within sub-webs. However, each sub-web can have many levels of subdirectories, organizing its content. See also root web and FrontPage web.

Substitution component A FrontPage component that is replaced by the value of a selected page or web variable.

T

table One or more rows of cells on a page used to organize the layout of a page or arrange data systematically. In FrontPage, you can place anything in a table cell, including text, images, and forms.

table cell See cell.

Table of Contents A FrontPage component that creates an outline of your FrontPage web, with hyperlinks to each page. The Table of Contents updates this outline each time a FrontPage web’s contents change.

table toolbar The FrontPage Editor toolbar that contains commands for creating and modifying tables.

tag See HTML tag.

tag selection In the FrontPage Editor, a method of selecting a group of paragraphs and other objects on a page. Use tag selection to select the members of a list, an entire form, or a FrontPage component. To tag select a set of objects, move the cursor to the left of the objects until the cursor becomes the tag selection cursor (an arrow pointing to the upper-right), and then double-click.

target frame The name of a frame in which to display the target page of a hyperlink. Typically, a hyperlink from one frame of a frames page will supply as its target frame another frame of the frames page.

task An item associated with a FrontPage web representing one action you need to perform to complete a FrontPage web. Some tasks are automatically generated by FrontPage wizards. You can also add your own tasks. Tasks are displayed in the FrontPage Explorer’s Tasks view.

Tasks View The FrontPage Explorer view that maintains a list of the tasks required to complete a FrontPage web, along with lists of broken hyperlinks and unlinked items in the FrontPage web. Views in the FrontPage Explorer provide different ways of looking at the information in your FrontPage web, so that you can effectively manage your site.

TCP (Transmission Control Protocol) Internet networking software that controls the transmission of packets of data over the Internet. Among its tasks, TCP checks for lost packets, puts the data from multiple packets into the correct order, and requests that missing or damaged packets be resent. Computers must run TCP to communicate with Web servers.

template A set of pre-designed formats for text and images on which new pages and new FrontPage webs can be based. After a page or web is created using a template, you can customize the page or web.

term The first of a pair of paragraphs formatted as a definition list entry. The second paragraph is the definition.

TGA (TARGA) A photo-realistic image format designed for systems with a Truevision display adapter.

theme A theme applies professionally designed, graphical page elements to the pages in a FrontPage web. FrontPage offers a gallery of over 50 themes that consist of similar design elements for bullets, fonts, images, navigation bars, and other page elements. When applied, a theme gives pages and navigation bars in a FrontPage web an attractive and consistent appearance. You apply a theme in the FrontPage Explorer’s Themes view.

Themes View The FrontPage Explorer view that lets you add graphic page elements, such as bullets and backgrounds, to your FrontPage web. You can choose from a gallery of available FrontPage themes and apply them to all pages in the current FrontPage web to give your site a consistent, professional appearance and navigation structure. You can also enable, disable, or override theme formatting for individual pages in the FrontPage Editor.

thumbnail A small version of an image on a Web page, usually containing a hyperlink to a full-size version of the image.

TIFF (Tagged Image File Format) A high-resolution, tag-based image format. TIFF is used for the universal interchange of digital images.

Timestamp A FrontPage component that is replaced by the date and time a page was last edited or updated.

transition effect One of a set of page-display effects, such as Dissolve and Fade To Black, that are available in some Web browsers. Transition effects can be configured to occur when a user visits or leaves a page. You can apply a transition effect to a page using the FrontPage Editor.

type See protocol.

TWAIN Developed by a consortium of imaging hardware and software manufacturers, TWAIN is a cross-platform interface for acquiring electronic images captured by TWAIN-compliant scanners, digital cameras, and still-frame video capture boards.

typewriter font The text style that emulates fixed pitch (monospaced) typewritten text. Typewriter font is useful for computer code examples and for presenting sample input from a user.

U

UNIX A multi-user, multitasking operating system that exists in various forms and implementations, typically used on proprietary computer workstations. Many Web servers run on UNIX systems.

unordered list See bulleted list.

URL (Uniform Resource Locator) A string that supplies the Internet address of a Web site or resource on the World Wide Web, along with the protocol by which the site or resource is accessed. The most common URL type is http://, which gives the Internet address of a Web page. Some other URL types are gopher://, which gives the Internet address of a Gopher directory, and ftp://, which gives the network location of an FTP resource.

V

variable Information about a FrontPage web or page that can be displayed by FrontPage form handlers or FrontPage Substitution components when a page is browsed. FrontPage includes standard web and page variables. Authors can define new variables in the FrontPage Explorer.

VBScript Microsoft Visual Basic Scripting Edition, a subset of the Microsoft Visual Basic programming system. Microsoft Internet Explorer version 3.0 and higher, along with other Web browsers, can read VBScript programs embedded in HTML pages. VBScript programs can be executed either on the Web server, or on the computer on which the Web browser is installed. In the FrontPage Editor, you can insert and edit VBScript code.

veronica An automated Internet search service available through gopher. See also gopher.

video clip A short video sequence that can be embedded into a Web page. Video clips can be inserted into FrontPage using ActiveX Controls, VBScripts, Java applets, or plug-ins.

Views bar The vertical bar at the left of the FrontPage Explorer window. The buttons on the Views bar let you switch to different views of your FrontPage web, such as Folders view or Hyperlinks view. Views in the FrontPage Explorer provide different ways of looking at the information in your FrontPage web, so that you can effectively manage your site.

virtual server One of multiple Web sites running on the same server, each with a unique domain name and IP address. A Web server that supports virtual servers is called a multi-hosting Web server.

visited hyperlink A hyperlink on a page that has been activated. Visited hyperlinks are usually displayed in a unique color by a browser.

Visual SourceSafe A document source-control system developed by Microsoft. FrontPage integrates with Visual SourceSafe if both applications are installed on the same computer.

W

WAIS (Wide Area Information Service) Supports searching over the Internet.

WAN (Wide Area Network) A computer network that spans a long distance and uses specialized computers to connect smaller networks.

washout An image editing effect available in the FrontPage Editor. Applying the Washout tool to an image file creates a low-resolution, high-contrast version of the image. A washed-out image can be used as a watermarked background on your pages, without the need to make manual resolution, color, and contrast adjustments in an image editing program.

watermark An image that appears on the backgrounds of pages in a Web site to decorate and identify the pages, but which does not scroll as the page scrolls. Not all Web browsers support watermarks.

Web browser A client application that fetches and displays Web pages and other World Wide Web resources to the user. FrontPage includes Microsoft Internet Explorer, a popular Web browser.

WebBot component A dynamic object on a page that is evaluated and executed when an author saves the page or, in some cases, when a user browses to the page. Most WebBot components generate HTML. Many built-in FrontPage components, such as Search Forms, Banner Ad Manager, and Save Results Form Handlers, are implemented as WebBot components. The FrontPage Software Developer’s Kit (SDK) contains instructions for adding custom WebBot components to the FrontPage Editor.

WebBot component cursor In the FrontPage Editor, the robot-shaped cursor that is displayed when you move the FrontPage cursor over an area of a page containing a FrontPage component. See also WebBot component.

Wizard A FrontPage program that creates FrontPage webs or Web pages, based on choices the user selects in the wizard’s input panels.

WMF (Windows Meta File) A vector graphics format for Windows-compatible computers used mostly for word processing clip art.

World Wide Web The graphical Internet hypertext service that uses the HTTP protocol to retrieve Web pages and other resources from Web servers. Pages on the World Wide Web usually contain hyperlinks to other pages, documents, and files.

WYSIWYG (What You See Is What You Get). An editing interface in which a file being created is displayed as it will appear to an end-user. The FrontPage Editor is a WYSIWYG editor.


FrontPage 98 Server Extensions Resource Kit

Microsoft FrontPage 98
Server Extensions Resource Kit

Welcome to the FrontPage 98 Server Extensions Resource Kit, your guide to understanding, installing, and maintaining the FrontPage Server Extensions on your Web server. This kit covers all Web servers that are supported by the FrontPage Server Extensions, including Windows NT and UNIX platforms.

The latest version of the Server Extensions Resource Kit is posted on the FrontPage Server Extensions home page. Please check this link often for updates to the Server Extensions Resource Kit along with notices of new versions of the FrontPage Server Extensions, news for webmasters and Web Presence Providers, and additional tips and utilities for using and maintaining the FrontPage Server Extensions.

  • Introduction to the FrontPage Server Extensions
  • Security Considerations
  • Installing the FrontPage Server Extensions
  • Administration Tasks and Procedures
  • Troubleshooting Problems
  • Appendices


An Overview of the FrontPage Server Extensions

  • What Are the FrontPage Server Extensions?
  • FrontPage Webs
  • FrontPage Authoring Support
  • FrontPage Administrative Support
  • FrontPage Browse-Time Support
  • Publishing FrontPage Webs
  • FrontPage Product Architecture
  • FrontPage Extensibility
  • FrontPage Client and Server Extensions Compatibility
  • FrontPage Server Extensions: Supported Platforms
    •

    What Are the FrontPage Server Extensions?

    The FrontPage Server Extensions are a set of programs on the Web server that support:

    • Authoring FrontPage webs. For example, when an author moves a page from one folder to another in a FrontPage web, the Server Extensions automatically update all hyperlinks to that page from every other page and Microsoft Office document in the FrontPage web, directly on the Web server machine.
    • Administering FrontPage webs. For example, a FrontPage web administrator can specify which users can administer, author or browse a FrontPage web.
    • Browse-time FrontPage web functionality. For example, users of a FrontPage web can participate in a discussion group. The Server Extensions will maintain an index of hyperlinks to articles in the discussion, separate discussion threads, tables of contents, and search forms to locate pages of interest.

    A FrontPage web is a project containing all the pages, images, and other files that make up a Web site. For a full description of FrontPage webs, see FrontPage Webs.

    The design of the FrontPage client and Server Extensions minimizes the need for costly file transfers over the Internet. When an author using the FrontPage Explorer opens a FrontPage web from a Web server containing the Server Extensions, information about the FrontPage web, such as its hyperlink map, is downloaded to the client machine so that the FrontPage Explorer can display the information. However, the full set of pages and other files that comprise the FrontPage web remain on the Web server machine. A page is only downloaded over the Internet when it is opened for editing in the FrontPage Editor. This is a very efficient mechanism: an entire Web site can be changed directly on a Web server at the cost of downloading and editing a single file.

    When a Web server machine has the FrontPage Server Extensions, FrontPage web authoring and administering functionality is available from a PC or Macintosh computer that has the FrontPage client program and that is on the Internet or an a local Intranet. The browse time functionality of the Server Extensions is available from any Web browser on the Internet or Intranet.

    Communications between a client computer and a Web server containing the Server Extensions uses the same open, ubiquitous HTTP protocol that Web browsers on a client computer use to interact with a Web server. No file-sharing access on the Web server machine is needed, nor are FTP or telnet access required. No proprietary file system sharing calls are necessary.

    The Server Extensions are designed to work with any standard Web server using the Common Gateway Interface (CGI), the near-universal Web server extension mechanism. This includes freeware and shareware servers such as those from Apache,CERN and NCSA, and commercial web servers from Netscape, Microsoft, and O’Reilly and Associates. The Server Extensions are designed to be easily ported to all popular hardware and software platforms for cross-platform Web server compatibility. See FrontPage Server Extensions: Supported Platforms for a complete list of the operating systems and Web servers for which the Server Extensions are available.

    On Windows Web servers, the Server Extensions are integrated with Microsoft Visual SourceSafe and support version control and check-ins and check-outs of files from the Web server.

    The Server Extensions are also used by Microsoft Visual InterDev in the same way that they are used by Microsoft FrontPage.

    FrontPage Webs

    FrontPage works with World Wide Web content by managing FrontPage webs. You can think of a FrontPage web as a project. It contains all the pages, images, and other files that make up a Web site. Authors can create, delete, open, and close FrontPage webs using the FrontPage Explorer and FrontPage Editor on a client computer. A FrontPage web can be stored on a remote Web server computer, a Web server running on the same computer as the client program, or in the client computer's file system.

    Many of the features of a FrontPage web require the FrontPage Server Extensions to be on the server containing the FrontPage web. Some of the features of FrontPage webs that are supported by the FrontPage Server Extensions are:

    • A full hyperlink map of all files in a FrontPage web. The FrontPage Explorer displays hyperlinks using this hyperlink map. When a FrontPage web is copied from one Web server to another, the entire hyperlink map is recalculated.
    • A full-text index of all Web pages in a FrontPage web. This lets end-users search a FrontPage web for pages containing words or phrases.
    • A persistent structure that authors can create and manipulate. This structure defines the key pages in a FrontPage web and the relationships among these pages. Authors operate on the structure of a FrontPage web in the FrontPage Explorer. When the structure of a FrontPage web is changed, affected pages are updated to reflect the changes.
    • Web themes. A theme is a set of color-coordinated page elements, including background colors, text colors, bullets, borders, and horizontal lines. By applying a theme to a FrontPage web, an author can easily give a FrontPage web a consistent, attractive appearance. When a new theme is applied to a FrontPage web, all pages are automatically updated to use it.
    • A Tasks list containing the tasks needed to complete a FrontPage web. Tasks are linked to the pages on which they occur.
    • Unique security settings. Each FrontPage web can be made available to a different group of administrators, authors and end-users.

    FrontPage supports two kinds of FrontPage webs: root webs and sub-webs. A root web is a FrontPage web that is the top level content directory of a Web server or, in a multihosting environment, of a virtual Web server. It can have many levels of subdirectories, containing it’s content. There can be only one root web per Web Server or virtual Web server.

    A single root web can support a number of sub-webs. A sub-web is a complete FrontPage web that is a subdirectory of the root web. Sub-webs can only exist one level below the root web. Each sub-web can have many levels of subdirectories, making up its content. Sub-webs cannot have sub-webs.

    Even though sub-webs appear below the root web in the Web server's file system and URL space, the root web does not include the content in its sub-webs. This separation of content is done by the FrontPage Server Extensions.

    The root web and all sub-webs on a server have separate copies of the Server Extensions installed, or have stub executables of the Server Extensions programs. Having separate Server Extensions copies for each FrontPage web lets the Web server enforce different end-user, author, and administrator permissions on each FrontPage web, since FrontPage uses the Web server's built-in security mechanism to control access.

    FrontPage webs can be implemented on a Web server and accessed by Web browsers in the following ways:

    • As private domain names, such as "www.mycompany.com." These are usually implemented as virtual servers on the same physical server machine using multihosting. Private domain name customers each get their own root web and have the option of creating sub-webs.
    • As a common or shared domain but with private virtual servers, as in "www.mycompany.myprovider.com," where "myprovider.com" is a shared domain and "www.mycompany" is a private virtual server. Private virtual server customers on a shared domain each get their own root web and have the option of creating sub-webs.
    • As a URL on an Internet service provider's server machine, as in "www.myprovider.com/mycompany." URL customers get a single sub-web.

    FrontPage Authoring Support

    In FrontPage, authors create Web pages and entire Web sites using FrontPage on a client computer (a PC or Macintosh). The FrontPage client programs are the FrontPage Explorer and the FrontPage Editor.

    • The FrontPage Explorer is the FrontPage tool for creating, designing, viewing, maintaining, and publishing FrontPage webs. Various views in the FrontPage Explorer provide different ways of looking at and modifying the contents of a FrontPage web.

    • The FrontPage Editor is the FrontPage tool for creating, editing, and testing World Wide Web pages. As an author adds text, tables, forms, images, controls and other elements to a page, the FrontPage Editor displays it in WYSIWYG style, as it would appear in a Web browser. The FrontPage Editor is fully integrated with the FrontPage Explorer.

    Much of the FrontPage Explorer and Editor's functionality is supported by the FrontPage Server Extensions. Some examples are:

    • Saving documents to FrontPage webs.
    • Creating, copying, and publishing FrontPage webs.
    • The Tasks view, containing a list of tasks needed to complete a FrontPage web.
    • FrontPage web-structure editing. An author defines the structure of a FrontPage web in the FrontPage Explorer's Navigation View and inserts navigation bars in the FrontPage Editor. FrontPage navigation bars automatically create the hyperlinks that express the FrontPage web's structure. If the author changes the structure in the Navigation View, all FrontPage navigation bars automatically update these hyperlinks.
    • FrontPage components (also called WebBot components). FrontPage includes a rich set of active components that update pages when a change occurs in the FrontPage web. For example, the Table of Contents component keeps an updated table of contents of the entire FrontPage web. When an author moves a page, the table of contents is updated. Another FrontPage component, the Include component, inserts the contents of one page into another. If the inserted page changes, all pages that include it are automatically updated.
    • Hyperlink map. A FrontPage web's hyperlink map is browsable in the FrontPage Explorer's Hyperlink View. Using this map, FrontPage updates affected hyperlinks in the FrontPage web when a page is moved or renamed.
    • Themes. Authors select FrontPage web themes in the FrontPage Explorer, or they can apply a theme to a single page in the FrontPage Editor. When the theme for a FrontPage web changes, FrontPage automatically updates every page in the FrontPage web to use the new theme.

    FrontPage Administrative Support

    The FrontPage Server Extensions provides a set of web-administration tools that can be used remotely from the FrontPage Explorer. These tools provide access control and general Web-administration functionality. The Server Extensions support three levels of access control of FrontPage webs: administrator, author, and browser.

    • Administering permission gives a user, group of users, or a computer permission to administer the FrontPage web.
    • Authoring permission gives a user, group of users, or a computer permission to open the FrontPage web in the FrontPage Explorer and edit its pages and files.
    • Browsing permission gives a user, group of users, or a computer permission to browse the FrontPage web when it is published on the Internet or on an intranet.

    For a full discussion of FrontPage Server Extension administrative capabilities, along with a general discussion of Server Extensions security issues, see The FrontPage Server Extensions: Security Considerations.

    FrontPage Browse-time Support

    FrontPage browse-time support occurs when a user views a page in a FrontPage web from a Web browser. Browse-time support is implemented in the FrontPage Server Extensions as FrontPage components (also called WebBot components).

    A FrontPage component is an active object that is inserted on an HTML page using the FrontPage Editor. It has a persistent state that is encoded as HTML comments. FrontPage components typically produce as their output HTML that is inserted in the surrounding HTML page. FrontPage components can be active at authoring-time, while the FrontPage Editor and Explorer are in use, or at browse-time. For example, the Include component is an authoring-time component that includes the contents of one page in another.

    Some browse-time FrontPage components are:

    Search Form
    The Search Form uses the full text index created by the Server Extensions. It appears as a form on a page. When a user submits a Search Form containing words to locate, the Search Form returns hyperlinks to all pages in a FrontPage web that contain the words.
    E-mail Form Handler
    The E-mail Form Handler gathers information from a form, formats the information, and sends it to an e-mail address.
    Discussion Form Handler
    The Discussion Form Handler lets users participate in an online discussion. It collects information from a form, formats it into an HTML page, and adds the page to a table of contents and to a text index.

    When a user browses an HTML page containing a browse-time FrontPage component, the Server Extensions do whatever processing is required and then generate a new HTML page to display the results of the operation. For example, a Search Form will generate an HTML list of hyperlinks to pages and an E-mail Form Handler will generate a page confirming that a form's contents have been processed and sent to an e-mail address.

    An HTML page with no browse-time FrontPage components does not use the Server Extensions when a user browses the page. Instead, the normal Web server page-retrieval process occurs.

    Publishing FrontPage Webs

    Publishing a FrontPage web means making the FrontPage web available to users for browsing from a Web server, either on an intranet or on the Internet. The Internet and intranet cases typically use different methods of publishing.

    In Internet publishing, the most common method is for an author to create a FrontPage web on a Web server installed on the client computer. (When the FrontPage client program is installed, FrontPage optionally installs a Web server with the Server Extensions on the client computer.) Then, when the FrontPage web is completed and tested, the author publishes it to an Internet service provider's Web server using the FrontPage Explorer's Publish FrontPage Web command. Authoring on a local Web server is efficient because it does not require an author to be connected to an Internet service provider while working on a FrontPage web.

    The Publish FrontPage Web command copies the FrontPage web from a source (desktop) Web server to a destination (production) Web server in batch mode. Only new or changed pages and files are copied by default. Pages and files deleted from the source FrontPage web are also deleted from the destination web.

    When an author publishes a FrontPage web using the Publish FrontPage Web command, the home page is renamed, if necessary, to match the naming-convention on the destination Web server. Also, all FrontPage components in the FrontPage web are regenerated to take advantage of platform-specific functionality. For example when a FrontPage web is published to an IIS server containing Microsoft Index Server, any Search Forms are configured to use the Index Server.

    In Intranet publishing, the most common method does not require the Publish FrontPage Web command. Instead, an author works directly on a Web server machine on an internal network, which is typically used to share information inside an organization. In this method, whenever a page is opened from the Web server and edited, the change is published to the intranet when it is saved from the FrontPage Editor.

    FrontPage Product Architecture

    The FrontPage client system communicates with a Web server via the FrontPage Explorer. The library dedicated to communicating from the client is the WEC (Web Extender Client), a private FrontPage library. This library communicates via WinSock and TCP/IP. Wizards and custom applications on the client communicate with the Editor and Explorer using OLE automation.

    The FrontPage client tools communicate with the Server Extensions using HTTP, the same protocol used to communicate between Web browsers and Web servers. FrontPage implements a remote procedure call (RPC) mechanism on top of the HTTP "POST" request, so that the FrontPage client can request documents, update the Tasks list, add new authors, and so on. The Web server sees "POST" requests addressed to the Server Extensions CGI programs and directs those requests accordingly. FrontPage correctly communicates between client and server through firewalls (proxy servers). FrontPage does not use or require the HTTP "PUT" request. As described in the HTTP specification, "PUT" sends a document to a Web server. However, few Web servers implement "PUT." Therefore, FrontPage uses the universally-implemented HTTP "POST" request for all communications with the Server Extensions.

    For most web servers, the Server Extensions are accessed by the Web server using the Common Gateway Interface (CGI), the near-universal Web server extension mechanism. The implementation of CGI differs somewhat among Web servers and platforms. For example, most Unix web servers invoke a CGI extension by running it in a separate fork, whereas some Windows NT web servers support a Dynamic Link Library (DLL) variant of CGI-style communication that incurs less overhead. But the information flow is similar for all CGI implementations: user-driven values and environment parameters are passed to the CGI extension using a block of name/value pairs, and the CGI extension program returns a result in HTML format.

    The Server Extensions are divided into three libraries:

    • admin.dll for FrontPage web administration
    • author.dll for FrontPage web authoring support
    • shtml.dll for browse-time support

    FrontPage Extensibility

    FrontPage is extensible in the following areas:

    • Web wizards and page wizards
    • Web themes and page themes
    • menu commands
    • FrontPage components

    The Microsoft FrontPage Software Developer's Kit, which is included on the FrontPage CD-ROM in the \SDK folder, contains full documentation for adding these features, including examples and sample code.

    FrontPage Client and Server Extensions Compatibility

    The FrontPage Server Extensions exist for FrontPage client versions 1.1, FrontPage 97, and FrontPage 98. Each FrontPage client release is accompanied by a new Server Extensions release that supports the new features of the client. For example, the current release, FrontPage 98, is accompanied by a new FrontPage 98 Server Extensions release. It is always most effective to use the most up-to-date versions of the FrontPage client and the Server Extensions.

    Each new release of the Server Extensions is backward compatible with previous FrontPage client versions so that it continues to support the client's functionality at each earlier level. For example, a FrontPage 97 client can open and edit a FrontPage web from a Web server that has the FrontPage 98 Server Extensions installed with no loss of functionality in the FrontPage 97 client. However, the client will not be able to access new Server Extensions functionality added for the FrontPage 98 client such as applying themes to a FrontPage web or creating and saving a FrontPage web structure.

    A FrontPage client can also open and edit FrontPage webs on a Web server containing an earlier version of the Server Extensions. However, the client will not be able to use its newer features, because they will not be supported by the earlier version of the Server Extensions.

    Bug fixes and patches are occasionally issued for the current released version of the Server Extensions . Older versions of the Server Extensions do not receive these occasional updates. However, patches to the current version of the Server Extensions will work with earlier versions of the FrontPage client.

    FrontPage Server Extensions: Supported Platforms

    The following table provides the complete list of operating systems and Web servers for which the FrontPage Server Extensions are available.

    On the following operating systems: | The FrontPage Server Extensions are available for the following Web servers:
UNIX Digital UNIX 3.2c, 4.0 (Alpha) BSD/OS 2.1 (Intel x86) BSD/OS 3.0 (Intel x86) Linux 3.03 (Red Hat Software) (Intel x86) HP/UX 9.03, 10.01 (PA-RISC) IRIX 5.3, 6.2 (Silicon Graphics) Solaris 2.4, 2.5 (SPARC) SunOS 4.1.3, 4.1.4 (SPARC) | Apache 1.1.3, 1.2 CERN 3.0 NCSA 1.5.2 (we do not support 1.5a 0r 1.5.1) Netscape Commerce Server 1.12 Netscape Communications Server 1.12 Netscape Enterprise Server 2.0, 3.0 Netscape FastTrack 2.0
Windows NT Server, Windows NT Workstation, and Windows 95 . Intel x86 Win 32 . . . . . . . . Windows NT Server 4.0 or higher, Windows NT Workstation 4.0 or higher | Internet Information Server 2.0 or higher, including IIS 4.0 Microsoft Peer Web Services (on Windows NT Workstation) Netscape Commerce Server 1.12 Netscape Communications Server 1.12 Netscape Enterprise 2.0 and 3.0 Netscape FastTrack 2.0 O'Reilly WebSite Microsoft Personal Web Server (on Windows 95) FrontPage Personal Web Server Microsoft Internet Information Server2.0 or higher, including IIS 4.0 Microsoft Peer Web Services (on Windows NT Workstation)


Security Considerations

This chapter of the Server Extensions Resource Kit describes general Web hosting security issues and how FrontPage protects Web server security on UNIX-based Web servers and on the Internet Information Server (IIS) Web server for Windows NT. This chapter has three sections:

  • General Web-Hosting Security Issues
  • FrontPage Security on UNIX-based Systems
  • FrontPage Security on IIS Systems

General Web Hosting Security Issues

Regardless of what software you are running, the two major security issues when you host Web sites from your computer are:

  • Protecting your computer from unauthorized users

    Hosting Web sites, even on an intranet, opens your host computer to a wider community of users. Authentication is the process of allowing users access to the Web service based on usernames and passwords or based on IP addresses. Restricting users by IP address is less secure, because clever users can "spoof" an IP address and gain access to the host computer.

  • Protecting your computer from programs that run on the host computer

    Programs can run on your computer based on the content of a Web site for many reasons. For example:

    • An HTML page that "includes" or "substitutes" another page can cause a program to be run on the host computer.
    • Marking directories executable to allow a script to run on the host computer can allow a program to do anything within the limits of the host computer's resource protection scheme.
    • Saving HTML in general introduces risk. HTML pages can contain embedded controls, scripts, applets, and other programs that can cause programs to run on a host computer. Form handlers can introduce a further risk, because users can submit HTML commands from within form fields, causing programs to be run when the page containing the form results is browsed. (FrontPage form handers do not allow this.)

FrontPage Security Strategy

FrontPage addresses these security issues by using the built-in security mechanisms of the host computer. Using the FrontPage Server Extensions requires no changes to the host computer's security method. You do not have to recompile any Web-server programs and there are no custom filters or other security modifications.

  • On UNIX-based Web servers, the server maintains a list of accounts, with usernames and passwords, and a list of groups of users with various levels of permissions for using the services of the Web server. The accounts and groups maintained by the Web server are separate from the list of users and groups with access to the host computer's file system. Access to a Web server's content, CGI (Common Gateway Interface) scripts, and configuration files is controlled by entries in access files. By creating access files throughout the Web server's content, different sets of users, with varying levels of permissions, can be given access to different areas of the server. FrontPage relies on this mechanism to add FrontPage web administrators, authors, and end-users with the proper permissions to the Web server's account list and to protect content and programs in FrontPage webs.

    For a full discussion of FrontPage security on UNIX-based Web servers, see FrontPage Security on UNIX-based Systems.

  • On IIS Web Servers, each HTTP request to IIS from a Web browser or the FrontPage client runs under a user account on the Windows NT operating system hosting IIS. Windows NT maintains account lists of local users and groups and of users and groups in a domain. The operations that are performed during the execution of HTTP requests are limited by the capabilities granted to that user account on the Windows NT Server. Windows NT File System (NTFS) allows the association of an access-control list (ACL) with any file or folder. An ACL contains users and groups with sets of permissions that allow a user or group to read, write, execute, or delete that file or folder. FrontPage implements Web security on IIS by changing the ACLs for all files and folders in each FrontPage web.

    For a full discussion of FrontPage security on IIS-based Web servers, see FrontPage Security on IIS Systems.

FrontPage Security on UNIX-based Systems

UNIX Security Concepts

The UNIX Security Model
UNIX Authentication

The FrontPage Server Extensions on UNIX Web Servers

FrontPage Server Extensions File Structure
FrontPage Access File Settings
Setting Permissions on Web Content
Setting the Server Extensions to SUID/SGID
Modifying the Web Server's Configuration File
The Server Extensions Configuration File

UNIX Security Concepts

The UNIX Security Model

In the UNIX security model, the Web server maintains a list of accounts, with usernames and passwords, and a list of groups of users with various levels of permissions to use the services of the Web server. The accounts and groups maintained by the Web server are entirely separate from the list of users and groups with access to the host computer's file system. To fetch files and run scripts and programs on the host computer, the Web server runs as a UNIX account, typically "www."

Access to a Web server's content, CGI scripts, and configuration files is controlled by entries in an access file. On Apache and NCSA Web servers the file is .htaccess, on Netscape servers it is .nsconfig, and on CERN it is .www_acl. These files associate users, groups, and IP addresses with various levels of permissions: GET (read), POST (execute), PUT (write), and DELETE. For example, a FrontPage author would have permission to use HTTP POST commands (to save new content), and a user with browse permissions would be permitted to use HTTP GET commands (to read content).

Multiple access files can be stored on a Web server. Each access file will provide security for the directory containing it and for any of its subdirectories that do not contain their own access files. By creating access files throughout the web server's content, different sets of users with varying levels of permissions, can be given access to different areas of the server.

Because the Web server is running under a UNIX account (such as "www") any process it runs and any files that it accesses must be available under the permissions of that UNIX account. Having all content available under a single UNIX account can cause a security problem because one user's CGI script could read files in another user's content area on the server. With write access, as with the FrontPage client, if a user's CGI script has sufficient permissions to write to a file in the user's own content area, the CGI script could write or overwrite files in other user's content areas in a multi-hosted environment.

To address this security issue (which is common to all CGI scripts including the FrontPage Server Extensions), the SUID (Set User ID) bit of the CGI script's execute-permissions can be set, forcing the Web server to switch to the UNIX user account of the owner of the CGI script when the script is run. Because the script owner's account is not likely to have permission to write to other user's content areas, it protects against unauthorized writing to files.

UNIX Authentication

In UNIX authentication, when a user browses to a page on a Web server, the server receives an HTTP GET request with a username and password. The Web server checks the user's permissions in the appropriate access file. If the GET cannot be executed under the user's authentication, the Web server returns a 401 error, indicating that the user is unauthorized. The client then prompts for a new name and password and resubmits the request. Once the user is authenticated, the Web server attempts to fetch the content from the file system. If UNIX does not allow the Web server access to the file for some reason, it will return a fatal error to the Web server. At this point, the user is not prompted for a new username.

When a client or Web browser sends an HTTP POST request, as is the case when a FrontPage author posts to the FrontPage authoring program author.exe, the Web server again checks the user's permissions in the appropriate access file. If the POST cannot be executed under the user's authentication, the Web server returns a 401 error. The client then prompts for a new name and password and resubmits the request. Once the user is authenticated, the Web server tries to run author.exe. If the SUID bit of author.exe is set, the process runs as the owner of the file. Otherwise, author.exe runs under the Web server's UNIX account.

UNIX Web servers usually communicate with client programs using Basic Authentication. When using Basic Authentication, the Web browser (or the FrontPage Explorer) prompts the user for a username and password. The username and password are then transmitted across HTTP, lightly encoded using a technique known as UUencoding. (Some Web servers use a technique known as MD5, but this method is not supported by FrontPage.)

One security risk of Basic Authentication is that usernames and passwords are transmitted across the network in an easily decoded format. However, Basic Authentication is the only authentication technique that works through a firewall via a proxy server.

The FrontPage Server Extensions on UNIX Web Servers

FrontPage Server Extensions File Structure

In FrontPage, there are three kinds of users defined for every FrontPage web: administrators, authors, and browsers (end-users). All permissions are cumulative; all authors also have browsing permission, and all administrators have authoring and browsing permissions.

Each FrontPage web (including each sub-web) contains copies of three executable scripts. These scripts are created in folders below the top-level folder of a FrontPage web: _vti_bin/_vti_adm/admin.exe for administrative tasks, _vti_bin/_vti_aut/author.exe for authoring FrontPage webs, and _vti_bin/shtml.exe for browse-time FrontPage components such as form handlers. FrontPage performs all authoring and administrative tasks by sending HTTP POST requests to these scripts.

In FrontPage, the list of administrators, authors and browsers is defined on a per-web basis. All FrontPage sub-webs either inherit the permissions (list of administrators, authors and browsers) of the FrontPage root web or use their own, unique permissions. (For a description of the root web and sub-webs, see FrontPage Webs.) As with other CGI programs, the FrontPage Server Extensions must be stored in directories that are marked "Executable," indicating that the directories contain executable files. The document root is the top-level directory in a FrontPage web. The FrontPage Server Extensions are stored in three directories in each document root:

/document root
   /_vti_bin
      shtml.exe
      /_vti_adm
         admin.exe
      /_vti_aut
         author.exe

The server's configuration file needs to be modified to mark the directories _vti_bin, _vti_adm, and _vti_aut as executable directories. A Web server administrator initiates and controls this operation using the FrontPage Server Administrator.

To reduce the total amount of disk space needed to support FrontPage webs, the FrontPage scripts stored in the various _vti_* directories are stub executables. They each invoke a full executable file installed in the directory /usr/local/frontpage/version3.0/exes.

FrontPage Access File Settings

FrontPage creates a directory _vti_pvt for the root web and for each FrontPage sub-web. For each FrontPage web with unique permissions, the _vti_pvt directory contains two files for the FrontPage web that the access file points to:

  • service.pwd contains the list of users and passwords for the FrontPage web.
  • service.grp contains the list of groups (one group for authors and one for administrators in FrontPage).

On Netscape servers, there are no service.grp files. The Netscape password files are:

  • administrators.pwd for administrators
  • authors.pwd for authors and administrators
  • users.pwd for users, authors, and administrators

An access file in the _vti_bin directory controls access to the run-time FrontPage program shtml.exe. If all users have browse permission, this is set in the access file. Otherwise, the access file points to the list of users and groups with browse access. A separate access file in the _vti_adm directory sets POST permissions for the administrative program admin.exe. A third access file in the _vti_aut directory sets the POST permissions on the authoring program author.exe.

When a Web administrator uses the FrontPage Explorer's Permissions command to give a user browse access to a FrontPage web, the user is given an account on the Web server by adding a username and password to the single service.pwd file pointed to from _vti_bin directory's access file. (On Netscape servers the file is users.pwd.) Also when an IP address restriction is set on users of the FrontPage web, this restriction is added to the _vti_bin access file.

When a Web administrator gives a user authoring access to a FrontPage web, the user is given an account on the Web server. This is done by adding the user's name and password to the service.pwd file and to the authors group in the service.grp file pointed to from the access files stored in the _vti_bin and _vti_aut directories. This enables the user to do HTTP POST requests to author.exe and to use the run-time program shtml.exe. (On Netscape servers the process is similar.)

When a Web administrator gives a user administrative access to a FrontPage web, the user is given an account on the web server. This is done by adding the user's name and password to the service.pwd file and to the administrators group in the service.grp file pointed to from the access files stored in the _vti_bin , _vti_aut, and _vti_adm directories. This enables the user to do HTTP POSTs to admin.exe, author.exe, and shtml.exe. (On Netscape servers the process is similar.)

The set of access files for a FrontPage web is illustrated in the following two diagrams. The first diagram shows the access files and UNIX file permissions for the content of a FrontPage web: the directories, files, and executable files that an author creates. The second diagram shows the access files and UNIX file permissions for the FrontPage _vti directories:

For a list of the entire contents of a FrontPage installation, see FrontPage UNIX Files.

Setting Permissions on Web Content

Setting secure access-modes for files and directories in a customer's content directory is a key to maintaining your Web-server security. All files and directories should be owned by the customer's user identifier/group identifier. Suggested UNIX permission settings are shown in the following table:

Single UNIX account per customer | files: | rw- r-- r--
 | directories: | rwx r-x r-x
 | umask: | --- -w- -w-
Multiple UNIX accounts per customer | files: | rw- rw- r--
 | directories: | rwx rwx r-x
 | umask: | --- --- -w-

The permissions for customers with multiple UNIX accounts per customer also apply to an organization that has several UNIX accounts that are part of the same UNIX group. Shared write-access allows any members of the group to write to all shared Web documents.

Setting the Server Extensions to SUID/SGID

Using the FrontPage Server Administrator (fpsrvadm.exe), you can change the execute-permissions of the Server Extensions executables to SUID/SGID. This forces the Server Extensions to execute with the file system permissions of the owner of shtml.exe, author.exe, and admin.exe. When suitable permissions for each customer's content area are applied, the FrontPage Server Extensions (and any other CGI scripts) for one customer are prevented from writing to the content areas of other customers.

Setting the Server Extensions to SUID/SGID for the owner of each web is the recommended configuration for the FrontPage Server Extensions on UNIX servers. Installations of the FrontPage Server Extensions with versions earlier than version 3.0 should be upgraded to use SUID/SGID operation of the Server Extensions and unique ownership of the web content. New installations of the FrontPage Server Extensions that are performed with the fp_install.sh installation script will automatically prompt to configure the Server Extensions for SUID/SGID operation.

The FrontPage Server Extensions do not require root access at any time. However, the FrontPage Server Extensions installation script should be run as root, because it sets EXECUTE privileges of the extensions to SUID. Because it is written in Perl, the Web administrator can review the script before running it on the Web server.

Modifying the Web Server's Configuration File

On some web servers, such as NCSA, CERN and Apache, the FrontPage Server Extensions need to modify the Web server's configuration file to mark directories containing the Server Extensions as "executable." Since the FrontPage Server Extensions run as "www" and the Web-server configuration file is owned and modifiable only by "root," the FrontPage Server Administrator must be manually run as "root" on the host computer to do this. This prevents administrators from remotely creating FrontPage webs, because the Web server's configuration file would need to be owned by "www" or possibly the users of each website, which would compromise the host system's security.

For the Apache web server, FrontPage supplies an optional patch to overcome this limitation. With this patch, copies of the FrontPage Server Extensions CGI executables are not stored in each web but are stored in one centralized location, making it is unnecessary to mark directories in each web executable and making it possible to create new FrontPage webs without server configuration file modifications. The patch to the Apache web server intercepts each call that the FrontPage Explorer makes to the Server Extensions CGI executables, performs security checks, suids to the owner of the web site (thus requiring SUID/SGID operation of the Server Extensions and the web content), and invokes a centralized copy of the Server Extensions CGI executables. See the Installation chapter for more information on the Apache patch.

The FrontPage Server Extensions also read the Web server's configuration file to learn what virtual servers there are, where the content roots are, and what directories are marked executable.

The Server Extensions Configuration File

Some security settings of the FrontPage Server Extensions can be controlled in the Server Extensions configuration file. The configuration file is in /usr/local/frontpage and is named wexxxx.cnf or, on multi-hosted servers, host:xxxx.cnf, where xxxx is the port number of your server and "host" is its name or IP address. The global configuration file /usr/local/frontpage/version 3.0/frontpage.cnf contains the default settings which apply to all FrontPage webs.

See List of UNIX Configuration File Settings for a complete listing of the parameters that you can set in this file.

FrontPage Security on IIS Systems

Windows NT Security Concepts

IIS Security Overview

IIS Authentication
The Anonymous Account
Basic Authentication
Windows NT Challenge/Response
Distributed Password Authentication
 Windows NT Challenge/Response and Network vs. Local Logon Rights

The FrontPage Server Extensions on IIS

The FrontPage DLLs
FrontPage Access Control List Settings
FrontPage and System DLLs
Virtual FrontPage Directories
Restricting Windows NT Account Lists
Making a Directory Unreadable

Windows NT Security Concepts

Windows NT security helps you protect your computer and its resources by requiring assigned user accounts for all operations. You can control access to all computer resources, including Web content, by limiting the user rights of these accounts. Windows NT maintains account lists of local users and groups and of users and groups in the domain.

Every operation on a Windows NT computer identifies who is doing the operation. The username and password that you use to log on to Windows NT identifies who you are and defines what you are authorized to do on that computer.

What a user is authorized to do on a computer is configured in User Manager by setting User Rights in the Policies menu. User rights authorize a user to perform certain actions on the system, including the right to "Log on locally," which is required for users to use Internet Information Server services under Basic Authentication.

NTFS is the recommended file system choice for Windows NT systems that host Web sites. Windows NTFS allows the association of an access-control list (ACL) with any file or directory. An ACL contains users and groups with sets of permissions that control whether or not a user or group can read, write, execute, or delete that file or directory.

Windows NT also supports the File Allocation Table (FAT) file system. Because there are no file permissions maintained there, storing web content in a FAT partition completely bypasses FrontPage and IIS access control. You are warned about this when you attempt to install the FrontPage Server Extensions on a FAT partition. To apply security to a Web site, you must either convert the partition from FAT to NTFS or move the content to an NTFS partition. With either solution you will have to uninstall and reinstall the FrontPage Server Extensions.

For more information on Windows NT Security, see Windows NT Server for IS Professionals.

IIS Security Overview

IIS Authentication

Under IIS design, each HTTP request to IIS from a Web browser (or from the FrontPage client) runs under a user account on the Windows NT computer hosting IIS. The operations that are performed during the execution of that HTTP request are limited by the capabilities granted to that user account on the Windows NT Server.

When IIS receives an HTTP request from a Web browser or from the FrontPage client, it does the following:

  1. IIS validates the user against an account (a user/password) from the Windows NT account list, then "impersonates" that account to process the Web request.

    The request is first attempted as the anonymous account, IUSR_<hostname>. If that execution fails to have sufficient access to complete the request, or if IIS does not have anonymous browsing enabled, then IIS returns error 401 (access denied). At this point, user authentication is performed to allow the remote user to identify themselves using the techniques of Basic Authentication or Windows NT Challenge/Response. If the Web browser or FrontPage client is using Windows NT Challenge/Response, the user may not see a prompt, because the FrontPage client or the Web browser simply supplies the username and password of the logged in user from the client computer.

  2. IIS allows access to a file in the Web server only if the NTFS ACL for the file contains the account being impersonated by the Web server, with the correct permissions.

You can restrict IIS access to only authenticated clients (clients that supply a valid Windows NT username and password), or you can allow anonymous access using the anonymous account. When you use authenticated clients, no access is permitted unless a valid username and password are supplied. Password authentication is useful if you want only authorized individuals to access your Web site or specific portions controlled by NTFS. You can have both anonymous logon access and authenticated access enabled at the same time.

The Anonymous Account

Each Internet service, such as World Wide Web and FTP, maintains a Windows NT username and password that is used to process anonymous requests. The anonymous account for Web services, IUSR_<hostname>, is automatically created by Internet Information Server during its setup. By default, all Web client requests use this account, and clients are given access to Web content using the IUSR_<hostname> account.

When an anonymous account request is received, the WWW service "impersonates" the user configured as the anonymous logon user. The request succeeds if the anonymous logon user has permission to access the requested resource, as determined by the resource's Access Control List (ACL). If the anonymous logon user does not have permission, the request fails. The WWW service responds to a failed anonymous request by requiring that the user provides a valid Windows NT username and password.

Basic Authentication

Basic Authentication is supported by the majority of Web servers on the Internet. When using Basic Authentication, the Web browser (or the FrontPage client) prompts the user for a username and password. The username and password are then transmitted across HTTP, lightly encoded using a technique known as UUencoding. Using this username and password IIS then authenticates the user as the corresponding Windows NT user.

One security risk of Basic Authentication is that usernames and passwords are transmitted across the network in an easily decoded format. However, if your Web site must support authoring by FrontPage 1.1 clients (which do not support NTLM), or if you want to ensure that your Web site is accessible from all browser types, then you must keep Basic Authentication enabled. Furthermore, Basic Authentication is the only authentication technique that works through a firewall via a proxy server. If you are running your Web server over the Internet via a proxy server (as opposed to running it within an intranet) you must use Basic Authentication.

Windows NT Challenge/Response

Windows NT Challenge/Response (also called NTLM) is a more secure authentication method than Basic Authentication. In Windows NT Challenge/Response, the Web browser or FrontPage client first attempts to use the Windows NT credentials used to log on to the computer on which the browser or FrontPage client is running. If those credentials are rejected, Windows NT Challenge/Response will prompt the user for a name and password.

The username and password are securely encrypted in a multiple transaction interaction between the client and Web server. This interaction is secure against network snoopers that attempt to break into systems by monitoring network traffic between a client and a server.

There are some limitations of Windows NT Challenge/Response:

  • Windows NT Challenge/Response Authentication cannot be performed through a firewall via a proxy. In this case, users must use Basic Authentication.
  • Some browsers may not support Windows NT Challenge/Response.
  • Windows NT Challenge/Response does not support delegation to third party servers.

Because Windows NT Challenge/Response Authentication cannot be performed through a firewall, it is most useful on intranets, where communication occurs inside an organization's firewall.

You can have both Basic and Windows NT Challenge/Response authentication enabled. If the Web browser supports Windows NT Challenge/Response, it uses that authentication method. Otherwise, it uses Basic authentication. Windows NT Challenge/Response authentication is currently supported only by Microsoft Internet Explorer 2.0 or later.

Distributed Password Authentication

The FrontPage Server Extensions supports Microsoft Commercial Internet System Membership service, which uses the Microsoft Distributed Password Authentication (DPA) protocol. DPA is a challenge and response authentication protocol that uses passwords and a trusted third-party authentication server. In DPA, a generic user name in the domain is mapped to a set of users maintained in a database. This lets Internet service providers extend the number of users an NT domain can accommodate. Generic usernames, such as "FrontPage_Authors," are available in the FrontPage Permissions dialog box in the same way as other usernames and groups.

FrontPage client machines that use DPA must have Microsoft Internet Explorer 3.0 (or higher) or Netscape Navigator 2.0 or 3.0. If the client machine is running Microsoft Internet Explorer 3.0, the user must install the Microsoft Internet Explorer 3.0x DPA update. If the client machine is running Netscape Navigator 2.0 or 3.0, the user must install the Microsoft Authentication Proxy for Netscape Navigator update.

Windows NT Challenge/Response and Network vs. Local Logon Rights

IIS 2.0 implements Windows NT Challenge/Response and Basic Authentication slightly differently than later IIS versions. When a user is authenticated using Windows NT Challenge/Response, the user is logged on to the Web server computer as a network logon. When Basic Authentication is used, the user is logged on with local logon rights by default, which is similar to logging on for an interactive session at the computer's console.

In most situations, there are no differences between a network logon and a local logon. The one situation for which this makes a difference is delegation applications. A delegation application is one in which part of the Web server's work is delegated to a secondary server process running on a different computer. For example, a Web server that accesses a database server running on a different host computer is a delegation application. If the user has logged on locally, Windows NT security permits those user credentials to be honored by the secondary server. If the user has logged on via the network, those credentials are not honored. Consequently, when using Windows NT Challenge/Response, the database server and Web server must be running on the same host computer.

There are two potential problems caused by Basic Authentication's use of local logon that administrators should be aware of. First, Basic Authentication will not succeed if the user account does not have local logon rights. Even if the FrontPage, IIS, and Windows NT configuration appears to be correct, the lack of local logon rights granted to the user in the Windows NT User Manager will prevent Basic Authentication from authenticating the user. Second, with local logon, if a user can obtain physical access to the host running IIS, the user will be permitted to start an interactive session at the console.

The FrontPage Server Extensions on IIS

The FrontPage DLLs

In FrontPage, there are three kinds of users defined for every FrontPage web: administrators, authors and browsers (end-users). All permissions are cumulative; all authors also have browsing permission, and all administrators also have authoring and browsing permissions.

In FrontPage, the list of administrators, authors and browsers is defined on a per-web basis. All content in a FrontPage web will be accessible to the same set of users and groups. It is not possible to control permissions on a per-file or per-directory basis with FrontPage. All FrontPage sub-webs either inherit the permissions (list of administrators, authors and browsers) of the FrontPage root web or use their own, unique permissions.

Each FrontPage web (including each sub-web) contains copies of three ISAPI DLLs that make up the FrontPage Sever Extensions. These DLLs are created in directories below the top-level directory of a FrontPage web:

  • _vti_bin/_vti_adm/admin.dll for administrative tasks
  • _vti_bin/_vti_aut/author.dll for authoring FrontPage webs
  • _vti_bin/shtml.dll for browse-time FrontPage components such as form handlers.

FrontPage performs all authoring and administrative tasks by sending HTTP POST requests to these DLLs. The FrontPage Server Extensions are stored in separate directories in the customer's document root:

/document root
   /_vti_bin
      shtml.dll
      /_vti_adm
         admin.dll
      /_vti_aut
         author.dll

FrontPage Access Control List Settings

FrontPage implements web security on IIS by changing the access-control lists (ACLs) for all files and directories in each FrontPage web. FrontPage controls who can administer a FrontPage web by setting the ACL on admin.dll, the administrative DLL. Similarly, FrontPage sets authoring permissions by setting the ACLs on author.dll. The default ACL sets browsing permission on Web content and lets all users execute the run-time DLL, shtml.dll.

You set the ACLs for a FrontPage web using the FrontPage Explorer's Permissions command, on the Tools menu. To add new users and groups, this command makes the Windows NT computer account list available. In FrontPage 98, you can set up a restricted list of users and groups that does not expose the entire contents of the Windows NT computer and domain account lists. This lets you protect the confidentiality of your user community. For details, see Restricting Windows NT Account Lists.

FrontPage sub-webs can have unique permissions by maintaining separate access-control lists on their own copies of the admin.dll, author.dll and shtml.dll DLLs. Alternatively, a FrontPage sub-web can inherit the permissions of the root web by keeping the access-control lists on its admin.dll, author.dll and shtml.dll the same as the root web's lists.

The set of ACLS for a FrontPage web is illustrated in the following two diagrams. The first diagram shows the ACLs for the content of a FrontPage web: the directories, files, and executable files that an author creates. The second diagram shows the ACLs for the FrontPage _vti directories.

Note in these diagrams that two sets of permissions are given. The first set applies to the directory, and the second set applies to the files in the directory. For example, the permissions (rx) (r) specify read and execute-permissions on the directory but only read permissions on the files in the directory.

For the complete set of ACLs set on FrontPage files, along with a list of the entire contents of a FrontPage installation, see FrontPage Windows NT File Permissions.

Notes:

  • All FrontPage ACLs have full control (all) (all) for Windows NT Administrators group members and the SYSTEM account.
  • The root web root directory's ACL is the same as the default ACL, except that the interactive and network accounts have (rx), or list files, access to the directory only (not to the content of the directory). This access is required in order to list sub-webs in the FrontPage Explorer. The top-level directory of sub-webs does not require these additional accounts, therefore sub-web root directories use the default ACL.
  • The Executable ACL is applied to directories that are marked with an executable virtual root. For the web server to run application or script files in response to browser requests, the web server's virtual root must be marked executable in addition to having the executable permission on the file's ACL. FrontPage will set up both of these conditions when folders are made executable using the FrontPage Explorer's Folder Properties dialog box.

    The Executable ACL is allowed only if the AllowExecutableScripts=1 setting is present for the FrontPage web in the FrontPage configuration file frontpg.ini (either globally or on a per-web basis). The default for AllowExecutableScripts is off. If AllowExecutableScripts is off for a FrontPage web, the Executable ACL will never be applied and the default ACL is used even if the directory is marked executable. In IIS 2.0 and IIS 3.0, the execute permission granted in the Executable ACL affects all files in a directory, including EXEs, DLLs, and interpreted scripts such as .ASP and .PL files. On IIS 4.0, the execute permission affects only DLLs and EXE files, and, depending on the server configuration, may not affect interpreted script files.
  • The Result File ACL is used only on files that contain the results of a form that uses the FrontPage default form handler. For a Discussion form handler, this ACL is placed on the directory for that discussion. This ACL grants write and delete access to users of the FrontPage web.
  • If, in the FrontPage Explorer's Permissions dialog box, the setting "Everyone has browse access" is selected, anonymous browsing for a web is implemented. This is done by adding the anonymous account IUSR_<hostname> to the default ACL.

FrontPage and System DLLs

On Windows NT, a DLL that is called from another DLL must run under the same user account as the calling DLL. Therefore, all system DLL code that is run as a consequence of an IIS request must run on the impersonated user's permissions. The FrontPage DLLs admin.dll, author.dll, and shtml.dll contain calls to Windows NT system DLLs. To ensure that the system DLLs will have the correct level of permissions to run under any administrator, author, or end-user's account, FrontPage adds the Interactive and NETWORK accounts to the ACLs of any system DLLs that are used as a result of a FrontPage DLL call. These added users are given "read" and "execute" permissions on the system DLLs. Note that this is necessary when installing any generic CGI scripts that use any Windows NT system services on a Web server. Because FrontPage makes calls to Windows NT system DLLs:

  • Some shared FrontPage DLLs in the \winnt\system directory are made accessible to impersonated users.
  • Some core system DLLs that implement APIs for core system services are made accessible to impersonated users.

    Click here for the full list of system DLLs affected by FrontPage.

Virtual FrontPage Directories

Virtual directories are IIS 2.0 and IIS 3.0 constructs that map the URL space of the Web site onto the file system of the local computer. They control read and execute access to specified directories within the file system and allow seemingly related URLs to refer to noncontiguous content areas in the file system.

FrontPage automatically manages the use of virtual directories for executable and unreadable directories. When installed, FrontPage sets up virtual directories in each FrontPage web to mark the directories that contain the FrontPage Server Extension DLLs as executable and to mark hidden directories as unreadable. FrontPage creates the following virtual directories for each sub-web:

  • _vti_bin
  • _vti_bin\_vti_aut
  • _vti_bin\_vti_adm
  • _vti_pvt
  • _vti_cnf
  • _vti_txt

The root FrontPage web has a seventh virtual directory:

  • _vti_log.

In the FrontPage Explorer, authors can mark directories executable to allow the directories to store executable objects such as Active Server Pages (ASP), Database Connector files (IDC), CGI Scripts, ISAPI Extensions, and Perl scripts. Each directory that is marked executable causes FrontPage to create a virtual directory.

Restricting Windows NT Account Lists

In FrontPage 98, you can set up a single user and group list for each virtual root FrontPage web. This lets you protect the confidentially of your user community by not displaying the full Windows NT account list. To globally enable Windows NT computer account list restrictions, add the following line to your frontpg.ini file, located in the \Winnt directory:

[FrontPage 3.0]
RestrictIISUsersAndGroups = 1

Setting the value to 1 enables restrictions. This same line can also be added for a specific virtual root FrontPage web, for example:

[Port 157.55.49.66:80]
RestrictIISUsersAndGroups = 1

A setting of RestrictIISUsersAndGroups=0 can be used to explicitly disable restrictions, allowing you to set restrictions by default to enabled for all FrontPage Webs except for those where restrictions are explicitly overridden. The default for the global setting is that restrictions are off if the RestrictIISUsersAndGroups key is missing. The default for individual FrontPage webs is to inherit the global setting.

If users and groups restrictions are enabled for a given FrontPage web, the Server Extensions look for a Windows NT group named in the following convention:

FP_[ServiceName][_Subweb]

On a multihosted IIS2.0/3.0 machine [ServiceName] is the service's IP address and port number combination and [_Subweb] is the name of the sub-web. On a single-hosted machine, the ServiceName portion is simply the port number.

On IIS 4.0, [ServiceName] can be of the form /LM/W3SVC/<N>, where <N> is an instance number. This is the recommended method. On IIS 4.0, [ServiceName] can also be of the form <virtual_server>:<port_number>. If you use this form, you must use specify the virtual server's name; you cannot use the virtual server's IP address on IIS 4.0.

To specify a root web's restriction group, omit the _Subweb portion.

Some examples are:

FP_157.55.49.66:80_MySubweb
FP_80_MySubweb
FP_80

FP_/LM/W3SVC/1_MySubweb

If restrictions are enabled on a sub-web but no local group is defined, the FrontPage Server Extensions look for the group of the root web and use it if found. If no appropriately named groups are found then no restriction is placed on permissions visibility setting or contents.

Making a Directory Unreadable

A standard way of saving form results in FrontPage is to use the default form handler (also called the WebBot Save Results component) to write to a results file in a directory in a FrontPage web. In FrontPage 1.1 and FrontPage 97, writing form results to a directory made the contents of the directory readable to any user who discovered the URL of the results file.

In FrontPage 98, authors can assign a virtual directory mapping for a form results directory that has both the execute and the read bits turned off. This prevents any end-user from reading the contents of the directory, but it requires the FrontPage web author to fetch the contents of the directory using the FrontPage Explorer.

To make a directory unreadable, select it in the FrontPage Explorer's Folders view and select Properties from the Edit menu. In the Folder Properties dialog box, deselect the two settings: Allow scripts or programs to be run and Allow files to be browsed.

Note that if you make the /_private directory unreadable, some FrontPage Wizards will not work properly.


Installing the FrontPage Server Extensions

Upgrading the Server Extensions
Installing the FrontPage Server Extensions on Windows

  • What Gets Installed?
  • Installing the Server Extensions
  • IIS 4.0 Installation Considerations

Installing the FrontPage Server Extensions on UNIX

  • What Gets Installed?
  • UNIX Setup Preview
  • Using the Installation Script
  • About the FrontPage Apache Patch
  • FrontPage Apache Patch Security Considerations
  • To Install the Apache Patch
  • Note for FrontPage 98 Beta and FrontPage 98 Initial Release Apache Patch Users

Installing the HTML Administration Forms

  • Activating the HTML Administration Forms on IIS 2.0 and IIS 3.0
    • To create a separate web site to host the HTML Administration Forms
    • To create a virtual directory to host the HTML Administration Forms on an existing web site
  • Activating the HTML Administration Forms on Other Servers

This topic describes installing the FrontPage Server Extensions on a Web server machine. The FrontPage Server Extensions are installed:

  • To support a local Web server on a client computer.
  • To support hosting FrontPage Web sites on the Internet or on an intranet.

The FrontPage Server Extensions are installed in two steps. First the Server Extensions are copied to the host computer's hard drive by the installer program into a single FrontPage directory. Next, the Server Extensions stub DLLs or stub CGI executables are installed on the root web of each virtual server on the host computer and, if sub-webs exist on the server, on each sub-web. During Server Extension installation, you can specify on which virtual servers to install the Server Extensions.

After the Server Extensions are copied to a host computer's hard drive, they must be added to each new FrontPage web that is created. On some platforms this is initiated automatically by the FrontPage client setup program. On other platforms, it must be done as a separate administrative task.

For a full description of how the FrontPage Server Extensions are stored in a FrontPage web, see The FrontPage Server Extensions on UNIX Web Servers and The FrontPage Server Extensions on IIS.

Upgrading the Server Extensions

Each FrontPage client release is accompanied by a new Server Extensions release that supports the new features of the client. For example, FrontPage 98 is accompanied by a new FrontPage 98 Server Extensions release. It is always most effective to use the most up-to-date versions of the FrontPage client and the Server Extensions.

Each new release of the Server Extensions is backward compatible with previous FrontPage client versions so that it continues to support the client's functionality at each earlier level. For example, a FrontPage 97 client can open and edit a FrontPage web from a Web server that has the FrontPage 98 Server Extensions installed, with no loss of functionality in the FrontPage 97 client. However, the client will not be able to access new Server Extensions functionality added for the FrontPage 98 client, such as applying themes to a FrontPage web or creating and saving a FrontPage web structure.

Installing the FrontPage Server Extensions on Windows

On the Microsoft Windows platform, the following products include, as all or part of their installation, the FrontPage 98 Server Extensions:

  • The FrontPage 98 client tool (the FrontPage Explorer and FrontPage Editor) is installed with the Microsoft Personal Web Server (on Windows 95) and the FrontPage Server Extensions. Authors then use the FrontPage Server Extensions to create and test their webs without requiring network access.
  • The FrontPage Server Extensions can be installed without the FrontPage client tools directly on a Web server to support remote FrontPage web authoring.
  • On Internet Information Server 4.0, the FrontPage Server Extensions are installed automatically as part of the Minimum and Typical installations. They can also be installed using the Custom option.

Microsoft Visual InterDev also relies upon the FrontPage Server Extensions and includes them in the Visual InterDev server-side setup program.

What Gets Installed?

When you install the FrontPage Server Extensions, the following components are installed:

  • The FrontPage Server Extensions DLLs and executables, in C:\Program Files\Microsoft FrontPage\version3.0\bin and in \windows\system by default.
  • The three ISAPI or CGI components used by FrontPage to implement the Server Extensions functionality in the user's webs get copied to the hard drive at C:\Program Files\Microsoft FrontPage\version3.0\isapi and C:\Program Files\Microsoft FrontPage\version3.0\_vti_bin. These DLLs or EXEs are subsequently copied into the content area of each virtual server on which the FrontPage extensions are installed.
  • The FrontPage Server Administrator, a tool for installing, updating, verifying, or removing the FrontPage Server Extensions from FrontPage webs. The Server Administrator is installed by default as C:\Program Files\Microsoft FrontPage\version3.0\bin\fpsrvwin.exe. A command line version is located at C:\Program Files\Microsoft FrontPage\version3.0\bin\fpsrvadm.exe.
  • The Server Extensions Resource Kit (this document).
  • HTML Administration forms, a set of HTML forms for remotely administering the FrontPage Server Extensions via web browsers. Also, a command line utility for remote administration of the FrontPage Server Extensions is installed at C:\Program Files\Microsoft FrontPage\version3.0\bin\fpremadm.exe.

Installing the Server Extensions

These installation instructions are for the stand-alone FrontPage Server Extensions that are downloadable from the FrontPage Web site. The FrontPage client is a separate CD-ROM based setup that includes both the FrontPage Server Extensions and the FrontPage client. To install from the CD-ROM simply insert the disk into your CD-ROM drive and click on the FrontPage 98 option.

Note: You must be an NT system administrator to install the FrontPage Server Extensions.

The stand-alone Server Extensions are installed by running a self extracting executable. You can download this program for your language at http://www.microsoft.com/frontpage/ . You can also find the Server Extensions setup programs on the FrontPage 98 CD-ROM, in the folder \ServExt. This folder contains self extracting setup programs named in the form fp98ext_processor_lang, where processor is the machine's processor type and lang is a three-letter code for the language of the server extensions. For example, the German FrontPage Server Extensions setup program for an Intel x86 series processor is on the FrontPage CD-ROM in \ServExt\fp98ext_x86_deu.exe.

  1. To start installing the FrontPage Server Extensions, run the Server Extensions setup program for your language and processor type.

    The Server Extensions are copied to the folder C:\Program Files\Microsoft FrontPage\version3.0. While the Server Extensions are being copied to C:\Program Files\Microsoft FrontPage\version3.0, your Web server is stopped to make sure that files are not locked by the running Web server. As soon as the copy is complete, the Web server is started and remains running for the remainder of the installation process.
  2. On a multi-hosted machine, the Multi-hosted Server dialog box is displayed. Select the virtual servers on which the FrontPage Server Extensions should be installed and click OK. On a single-hosted server the FrontPage Server Extensions are automatically installed on the single content root of the server and no dialog box appears.
  3. You are prompted for the name of a new FrontPage administrator account.

    If you are installing on an IIS server, this account must already exist, and you are not prompted for a password. If you are installing on a Netscape or WebSite server, you are prompted for a name and password and the account is created.

    You can add other administrator accounts after installing the Server Extensions using the Permissions command in the FrontPage Explorer.
  4. The stub Server Extensions are installed on each root web and sub-web.

Installing the Server Extensions on each FrontPage web may take several minutes and may increase the CPU load on your computer. If this is a new installation of the FrontPage Server Extensions, each page's contents are parsed to:

  • Expand FrontPage components, such as Include components and Substitution components
  • Create a hyperlink map of the FrontPage web
  • Extract page titles
  • Extract base URLs

FrontPage implements web security on IIS by changing the access-control lists (ACLs) for all files and directories in each FrontPage web. Installing FrontPage always modifies the ACLs of the Server Extensions stub executables contained in the _vti_bin directory in each web. A new installation of FrontPage will additionally modify the ACLs of the web content files, but an upgrade of an existing installation of the Server Extensions will not modify the content file ACLs and consequently will leave the security settings at a less secure level than the default settings of FrontPage 98. The ACLs of the web content can be upgraded to the level of FrontPage 98 by using the Check and Fix option of the FrontPage Server Administrator utility.

In addition to modifying the security ACLs of the web content files, FrontPage modifies the ACLs of any system DLLs that are used as a result of a FrontPage DLL call, to ensure that the system DLLs will have the correct level of permissions to run under any administrator, author, or end-user's account. For the complete set of ACLs set on FrontPage files, along with a list of the entire contents of a FrontPage installation, see FrontPage Windows NT File Permissions. For a discussion of security considerations when installing the Server Extensions and the reasons why the ACLs of the system DLLs must be modified, see FrontPage Server Extensions: Security Considerations.

IIS 4.0 Installation Considerations

If you are using IIS 4.0, you must use the FrontPage 98 Server Extensions. Previous versions of the FrontPage Server Extensions are not compatible with IIS 4.0. The IIS 4.0 installer program will ensure that any previous versions of the FrontPage Server Extensions are upgraded to the FrontPage 98 Server Extensions when IIS 4.0 is installed.

The FrontPage Server Extensions are installed automatically as a part of the Minimum and Typical IIS 4.0 setup. However the Server Extensions are added to virtual servers based on the following rules:

  • If the machine already has a previous version of the FrontPage Server Extensions active on one or more virtual servers, then those virtual servers are automatically upgraded to the FrontPage 98 Server Extensions.
  • If any virtual servers did not already have a previous version of the FrontPage Server Extensions installed, then the FrontPage 98 Server Extensions are not automatically installed to those virtual servers.

There are two ways to add the FrontPage Extensions to a virtual server with IIS 4.0:

  • Use the FrontPage Server Administrator utility or the HTML Administration Forms, as you would with any other type of Web server. These programs are described in Administering the FrontPage Server Extensions.
  • Use the IIS 4.0 Administration Tool and open the properties of the virtual server. In the Home Directory tab, the FrontPage web option controls whether FrontPage Server Extensions are installed and active for the virtual server. When using this checkbox to install the Server Extensions onto a new virtual server, the initial FrontPage Administrator for the virtual server will be the machine's Administrator account. Use the FrontPage Explorer, the FrontPage Server Administrator, or HTML Administration Forms to add additional FrontPage administrators, authors, and users to the virtual server.

Installing the FrontPage Server Extensions on UNIX

The FrontPage 98 Server Extensions for UNIX platforms are available for downloading at http://www.microsoft.com/frontpage . The installation package for a UNIX platform consists of three files: the installation script fp_install.sh, the Apache server upgrade script change_server.sh, and the Server Extensions in a tar file. The tar file is named fp30.platform.tar.Z, where platform is the UNIX platform to which the Server Extensions are being installed, as in fp30.linux.tar.Z.

The files fp30.platform.tar.z (or fp30.platform.tar.gz), fp_install.sh, and change_server.sh are the complete Server Extensions package. Unlike previous releases of the Server Extensions that offered the Web Presence Provider's Kit, there are no additional utility or configuration script downloads required for the FrontPage 98 Server Extensions. The contents of the former Web Presence Provider's Kit are included.

You can install the FrontPage Server Extensions to the following types of Web servers:

  • Apache
  • Netscape
  • NCSA
  • CERN

What Gets Installed?

When you install the FrontPage Server Extensions, the following components are installed:

  • The FrontPage Server Extensions. These are installed in /usr/local/frontpage by default. If they are installed somewhere else, there must be a link from /usr/local/frontpage to the installation area (which the install script will create). Even if you do not install the Server Extensions in /usr/local you must create it. If you do not have this directory, the installation script will create it.

    Note: The install directory must be on a local partition. The partition must not be mounted NOSUID.
  • Stub executables that link to the FrontPage Server Extensions are installed in directories below the top-level folder of each FrontPage web.
  • The FrontPage Server Administrator, a tool for installing, updating, verifying, or removing the FrontPage Server Extensions from FrontPage webs. The Server Administrator is in /usr/local/frontpage/version3.0/bin/fpsrvadm.exe.
  • HTML Administration forms, a set of HTML forms for remotely administering the FrontPage Server Extensions via a web browser.
  • The Server Extensions Resource Kit (this document).
  • The Apache server patch. FrontPage 98 offers a new patched Apache server that makes it possible to install a single copy of the FrontPage Server Extensions, without stub versions of the Server Extensions in each FrontPage web.

UNIX Setup Preview

Depending on how the content on your server is organized you may want to install the FrontPage Server Extensions in one of the following ways:

  • Each content area is stored starting in a directory immediately below the top-level directory on your server (as in http://sample.microsoft.com/myweb) or in per-user webs of the form http://sample.microsoft.com/~myweb.

    If your content is organized this way, type 'y' at the prompt "Install new sub/per-user webs now?" and follow the instructions for installing the Server Extensions in sub-webs.
  • Each content area is stored in a virtual web, as defined in the Web server's configuration file.

    If your content is organized this way, type 'y' at the prompt "Do you want to install Virtual Webs?" and follow the instructions for installing the Server Extensions in virtual webs. You will also have the options to install sub-webs on each virtual server.
  • Each content area is stored on a separate Web server.

    If your content is organized this way, run the fp_install.sh script once for each Web server. Type 'y' at the prompt "Do you want to install a root web? " and follow the instructions for installing the Server Extensions in root webs and sub-webs.

Using the Installation Script

The FrontPage 98 Server Extensions installation script is fp_install.sh. You must be logged on as root to run this script.

  1. You are prompted to back up the FrontPage installation directory, the server configuration file directory, and any content before installing the FrontPage 98 Server Extensions, and you are prompted for a Server Extensions directory.

    By default, the FrontPage Server Extensions are installed in the directory /usr/local/frontpage/. You can accept the default or specify another location. If you select another location, a symbolic link will be created from /usr/local/frontpage/ to the directory you specified.
  2. You are prompted to untar the FrontPage Server Extensions tar file, fp30.xxx.tar.Z. If the tar file is not in the default directory, you are prompted for its location.
  3. If the Web server currently has the FrontPage Server Extensions, it is upgraded to the FrontPage 98 Server Extensions. The stub Server Extensions are installed on the root web and each sub-web.
  4. FrontPage 98 has a new security model on UNIX in which each FrontPage web can be owned by single UNIX user ID and group ID. In order for this to work correctly, the ID of the Server Extensions on each FrontPage web must be set to the ID of the user who owns the web, and the content needs to have write-permissions by that user. To make this model secure, the content must only be owned and writeable by that user. The fpsrvadm.exe program can do both of these operations for you.

    After upgrading all servers to the FrontPage 98 server extensions, you can specify to set up the security of your FrontPage webs interactively or you can have fp_install generate a script to perform the operation.
    • If you choose the interactive operation, fp_install will prompt you for the UNIX user ID and group ID of each root web and sub-web that you have upgraded. For each FrontPage web, fp_install will then chown the content in each web to be owned by the specified user and group and it will chmod the content. If the FrontPage web is not the FrontPage Apache patch server, fp_install will also chown and suid the Server Extensions CGI executables in each web to be owned by the specified user and group. If you are running the FrontPage Apache patch server this step is not necessary because there is only one centralized copy of the Server Extensions CGI executables instead of copies in each web.
    • If you choose the script option, a script will be generated that does all the necessary chown and chmod operations using fpsrvadm.exe. Before running the script, however, you must fill in the UNIX user IDs and group IDs to associate with each web.
  5. If the Web server does not have the FrontPage Server Extensions, you are prompted to install them on the server's root web.

    Before installing the root web you are prompted for a FrontPage web administrator name and password. You will not need this name and password again during this installation, but will need to use it when creating new FrontPage webs or adding other FrontPage web administrators from the FrontPage Explorer. After installing the root web, you are prompted for your system's local character encoding and default language. See Administering the FrontPage Server Extensions for details.

  6. After installing the stub Server Extensions on the root web of a server that does not have the Server Extensions, you are prompted to install the stub Server Extensions in each sub-web.

    During installation of the stub Server Extensions on each sub-web, you are prompted for the name of each sub-web. If the name is of the form ~webname, then webname is used as the name of the sub-web's owner. If not, you are prompted for the name of the owner.

    For each sub-web that you choose, you are also prompted for any missing information (such as port number) and then the stub Server Extensions are installed on the sub-web.

    While installing a new root web and new sub-webs, fp_install will prompt you for each web's user ID and group ID. (If installing a per-user sub-web, then the install script infers the user ID from the web name.) For each FrontPage web, fp_install will then chown the content in each web to be owned by the specified user and group and it will chmod the content. If the FrontPage web is not the FrontPage Apache patch server, fp_install will also chown the Server Extensions.
  7. After installing on the root web and on all sub-webs, you are prompted to install the FrontPage 98 Server Extensions on any virtual webs. If you indicate that you want to install on virtual webs, the script displays a list of the virtual webs on your server (as indicated in the server configuration file).

    For each virtual server that you choose, you are prompted for any missing information (such as port number) and the stub Server Extensions are installed on the root web and any sub-webs of each virtual server.

    While installing a new virtual root web and sub-webs, fp_install will prompt you for each web's user ID and group ID. (If installing a per-user sub-web, then the install script assumes the user ID from the web name.) For each FrontPage web, fp_install will then chown the content in each web to be owned by the specified user and group and it will chmod the content. If the FrontPage web is not the FrontPage Apache patch server, fp_install will also chown the Server Extensions.

When the installation is finished, if it is a new installation of the FrontPage Server Extensions, each page's contents are parsed to:

  • Expand FrontPage components, such as Include components and Substitution components
  • Create a hyperlink map of the FrontPage web
  • Extract page titles
  • Extract base URLs

FrontPage implements web security on UNIX by making entries in access files throughout the web's content, and by maintaining files that contain lists of users and passwords for the FrontPage web. FrontPage also modifies the Web server's configuration file, unless you are running the FrontPage patched Apache server.

For a complete list of the entire contents of a FrontPage installation, see Files and Permissions for UNIX Servers. For a discussion of security considerations when installing the Server Extensions, see FrontPage Server Extensions: Security Considerations.

About the FrontPage Apache Patch

On Apache Web servers, versions of the FrontPage Server Extensions earlier than version 3.0 modified the Web server's configuration file to mark directories containing the Server Extensions CGI programs as "executable." This was required whenever a FrontPage user remotely created a new FrontPage sub-web, because in addition to creating a new content area, creating a new sub-web also made new copies of the Server Extensions CGI executables in the new web.

Since the FrontPage Server Extensions run as "www" and the Web-server configuration file is owned and modifiable only by "root," and because the Server Extensions executables typically run as the user account of the owner of the website (or the "www" user if not using the SUID/SGID configuration), the Server Extensions cannot modify the server configuration file and thus have been unable to remote create new sub-webs. Instead the FrontPage Server Administrator had to be manually run as "root" on the host computer to modify the Web server's configuration file, increasing the server administrator's workload.

FrontPage 98 offers a new patched Apache server that requires only a single version of the FrontPage Server Extensions, without stub versions of the Server Extensions in each FrontPage web. This makes it unnecessary to write to the Web server's configuration file when creating new FrontPage webs, allowing creation of FrontPage webs remotely, using the FrontPage Explorer.

Note that use of the FrontPage Apache patch is optional, and the FrontPage Server Extensions will function in the Apache environment without the patch. Without the patch, however, users of the FrontPage Explorer will not be able to create new sub-webs, as is the case with other UNIX server types. With the patch, the Server Extensions will automatically use the security SUID/SGID model and users will be able to remotely create new subwebs. Without the patch, the FrontPage Server Extensions should be configured for SUID/SGID operation for maximum security.

The FrontPage 98 Apache patch supercedes the FrontPage 97 Apache script alias patch that was distributed with the FrontPage 97 WPP Kit. While the FrontPage 98 Server Extensions continue to support the FrontPage 97 Apache patch with a server type of "apache-wpp", the recommended configuration for the FrontPage 98 Server Extensions on Apache is to use the FrontPage 98 Apache patch for increased security.

FrontPage Apache Patch Security Considerations

The FrontPage Apache patch consists of two parts:

  • The FrontPage Apache module which intercepts requests from the FrontPage client programs to the FrontPage Server Extensions CGI executables, performs security checks, and redirects the request to the fpexe suid-root stub program. By intercepting each request within the server itself no script alias is required.
  • The fpexe program, which accepts authoring requests from the FrontPage Apache module, performs additional security validation, changes the user ID to the owner of the FrontPage web being authored, and then invokes the central copy of FrontPage Server Extensions CGI executables.

Because the fpexe stub program must be suid root to be able to change user IDs to the owner of the web, numerous security checks are performed in order to prevent this stub program from being used as a security hole. Checks are performed to validate:

  • Proper ownership and permissions of the fpexe program and its directory
  • Proper ownership and permissions of the Server Extensions CGI executables and their directories
  • The user ID of the web content area being authored
  • The group ID of the web content area being authored
  • That only the FrontPage Server Extensions CGI executables are being executed and not other CGI programs on the system
  • That the environment variables are cleaned (including the PATH) and passed only if the variable is on a pre-selected approved list
  • That a 128 byte key value that is dynamically generated when the web server process is initialized is passed to the fpexe program and validated, ensuring that only the web server is able to run fpexe.

The 128 byte key value is generated dynamically when the web server is initialized and stored for validation purposes in a suidkey.* file that is readable and writeable only by root and is stored in a directory that is readable only by root. The suidkey.* file can be written with root-only permissions because the web server process runs as root during initialization, and only switches to another user ID (such as "www") after initialization is completed. The suidkey.* filename suffix is the process group ID of the web server.

The contents of the dynamic key value are generated during web server initialization based on a permutation of the output of the process status (ps) command, and are then XOR'ed with the contents of an administrator-controlled custom key file stored in /usr/local/frontpage/currentversion/apache-fp/suidkey. This custom key file must exist, be owned and readable only by root, and contain at least 8 bytes of data. The contents of the custom key file should be changed regularly by the server administrator and the server restarted to protect the key value.

When a request is processed by the FrontPage Apache module to invoke the FrontPage Server Extensions CGI executables, the module performs preliminary validation of the request and redirects the request to the fpexe stub program. The 128-byte key value generated when the server was initialized is passed to fpexe through a pipe and thus is not visible in the program environment. The 128-byte key value is read by fpexe from the pipe, and then compared to the contents of the dynamically generated suidkey.* file that was created when the web server was initialized. Since fpexe is suid root it is capable of accessing the contents of the suidkey.* file. Assuming that the suidkey.* file still has correct permissions (readable only by root in a directory readable only by root), and assuming that the 128 byte key value matches, then fpexe performs additional checks to validate the user ID, the group ID, and ownership of the target FrontPage Server Extensions CGI executables. If all checks pass then fpexe switches the user and group IDs to that of the web content owner and then runs the FrontPage Server Extensions CGI executables. If any of these checks fail, an error is written to the web server log and the Server Extensions are not run.

Note that the FrontPage Apache module's security checks do not replace the web server's .htaccess file security system. Both systems work together to ensure security for the FrontPage web. The web server's .htaccess security protects remote access to the web content by validating that the user of the FrontPage Server Extensions is a registered browser, author or administrator of the web (this process is as described in FrontPage Security on UNIX-based System). In addition to this normal level of security checking, the FrontPage Apache module's security checks ensure that the fpexe program is not used to gain unauthorized root access to the web server machine.

Because suid root programs are of concern to server administrators, Microsoft makes the source code to the FrontPage Apache module and the fpexe stub program available for review. The latest source code is contained in the FrontPage 98 Server Extensions download kit, and is also available for convenient browsing in an appendix of this document. The source code contains many comments to explain the checks that are performed and recovery actions that should be taken if an error denoting an insecure configuration is logged by the FrontPage Apache module or fpexe.

To Install the Apache Patch

There are two ways to convert your current Apache web server to the FrontPage patched Apache web server.

The first method is to manually compile-in the provided patches and module into your current Apache server. To do this, follow the instructions distributed with the Apache server. Even if you do manually compile in the provided patches and module, you should run the script described below to correctly set up FrontPage to work the with the new server.

The second method for converting your current Apache web server to the FrontPage patched Apache web server is to use the script described below, which will install a pre-compiled version of the Apache server onto your system.

This script will step the user through upgrading existing servers and installing new servers and webs. To run the script, you must be running as root. The script will run with a umask of 002. For FrontPage to work once the new server is installed, the FrontPage Apache stub, in /usr/local/frontpage/version3.0/apache-fp/_vti_bin/fpexe, must be owned by and SUID'd to root. The script does this for you.

  1. Back up your current Apache server directory.
  2. Back up the FrontPage installation directory, server configuration file directory, and all web content.
  3. Start the script change_server.sh.
  4. When prompted, indicate the location of your current Apache server.
  5. The script checks to make to sure the server has not already been upgraded. It then moves the old Apache daemon to the file httpd.orig and copies the new FrontPage patched Apache server to the correct place.

    Next, the FrontPage configuration files in /usr/local/frontpage are modified to refer to the new server. For each Apache server that has the FrontPage Server Extensions and that has not already had the Apache patch installed, you will be prompted to install the patch.

    Installing the Apache patch changes the configuration file in /usr/local/frontpage and deletes any fake configuration file (from the FrontPage 97 WPP Kit) if necessary. Finally, it calls the FrontPage Server Administrator to upgrade the web content area. This removes the Server Extensions stub executables, which are no longer needed.

    A default custom key file is created as /usr/local/frontpage/currentversion/apache-fp/suidkey and is automatically chown'ed and chmod'ed to the appropriate permissions. The default custom key value is dynamically generated, but for the best protection this key value should be changed on a regular basis and the server restarted.

  6. You can specify to set up the security of your FrontPage webs interactively or you can have change_server.sh generate a script to perform the operation.
    • If you choose the interactive operation, change_server.sh will prompt you for the UNIX user ID and group ID of each root web and sub-web that you have upgraded. For each FrontPage web, change_server.sh will chown all the FrontPage-created directories and content in each web to be owned by the specified user and group and it will chmod the content.
    • If you choose the script option, a script will be generated that does all the necessary chown and chmod operations using fpsrvadm.exe. Before running the script, however, you must fill in the UNIX user IDs and group IDs to associate with each web.

Note for FrontPage 98 Beta and FrontPage 98 Initial Release Apache Patch Users

The FrontPage 98 Beta and the initial release of the FrontPage 98 client CD contained a version of the FrontPage Apache patch that had a security bug. The bug was that fpexe did not perform enough checks to ensure that fpexe could only be invoked through the web server and that only the FrontPage Server Extensions CGI executables could be run as a result of accessing fpexe.

This bug was fixed in the FrontPage 98 UNIX Server Extension download kits posted as of 10/21/97 on the Microsoft FrontPage website. The FrontPage 98 Beta UNIX server extensions, and any download kits dated before 10/21/97 should not be used, rather new kits should be downloaded from the website. An additional check is that the version string reported by the server should be FrontPage 3.0.3 or higher. Any version prior to 3.0.3 should be replaced with a more recent download.

To upgrade a server that is running an older version of the FrontPage 98 Server Extensions, download the new kit and re-run change_server.sh. The change_server.sh script will replace the files affected by the bug (fpexe and the Apache daemon itself), generate a default custom key file, and set permissions appropriately.

Installing the HTML Administration Forms

The FrontPage 98 Server Extensions package includes HTML Administration Forms. These are HTML forms that can be used remotely to install and administer the FrontPage Server Extensions from a standard Web browser. These forms are copied to your Web server's hard drive as a part of the FrontPage Server Extensions installation.

Because of the security implications of making remote FrontPage administration available from Web browsers, the FrontPage installer does not make the HTML Administration Forms active and accessible to browsers when the forms are installed. After understanding the security implications, you can make the HTML Administration Forms active on a server following the instructions below.

Note that activating or using the HTML Administration Forms is optional. All FrontPage Server Extensions administration can be done using the FrontPage Server Administrator application or the Server Administrator command line tools running directly on the machine that is running the Web server.

Administering FrontPage remotely from a browser increases the risk that an unauthorized person could gain access to the FrontPage webs on your server, because the FrontPage security settings for the FrontPage webs on the server can be modified or loosened if access to the HTML Administration Forms is gained. Additionally an unauthorized user could, with the HTML Administration Forms, delete FrontPage webs or otherwise deny access to them. To prevent this, the following precautions are recommended:

  • Require a secured connection (such as SSL) to communicate with the HTML Administration Forms. Since configuration information, and in some cases, usernames and passwords, are communicated over the network using the HTML Administration Forms, a secured connection will prevent passwords from being read directly by network traffic spies.
  • Secure access to the HTML Administration Forms using the Web server's security system. A logon with a secure administrator account on the Web server prevents unauthorized access.
  • If possible, require the use of a non-standard HTTP port for accessing the HTML Administration Forms. This will make it much more difficult to guess the URL of the HTML Administration Forms.
  • Use IP Address mask restrictions to prevent unauthorized computers from accessing the HTML Administration Forms. Typically all IP addresses not associated with the owner of the FrontPage server to be administered are denied access.

Activating the HTML Administration Forms on IIS 2.0 and IIS 3.0

You should run the HTML Administration Forms over a secured port. On IIS it is not possible to use a secured port unless the server has a security certificate installed. If you do not already have a security certificate before activating the HTML Administration Forms, use the Key Manager application to make a security certificate request, submit the request to a key authority, and then use the Key Manager application to install the certificate returned by the key authority. The IIS documentation contains more details on this process.

Once you have a security certificate, the following steps will activate the HTML Administration Forms for remote use.

  1. Determine the NT machine account (or group of accounts) that will be granted access to the HTML Administration Forms.

    This account should be a member of the machine's Administrators group. If necessary, create a new account using the Windows NT User Manager. Depending on the machine's account configuration, the Administrators group may be an easy to use alternative to multiple individual machine accounts.
  2. Open the Windows Explorer at the hard drive location of the HTML Administration Forms, which is C:\Program Files\Microsoft FrontPage\version3.0\admin by default. Select the \isapi folder, choose Properties from the File menu, select the Security tab, and click Permissions.
  3. In the Directory Permissions dialog, using the Add and Remove buttons, update the Name list of authorized users and groups.

    Remove all users and groups that are not authorized. In particular make sure that no group that is added to the list contains the IUSR_machinename anonymous access account, and that any wide-access accounts such as EVERYONE are removed.
  4. In the Name list, add the machine's SYSTEM account.

    This account is required to allow IIS to access the file during the security validation process.
  5. For each user or group in the Name list, change Type of Access to Read.
  6. Click Replace Permissions on Subdirectories and Replace Permissions on Existing Files, and click OK to accept the changes. Click OK again to dismiss the folder properties dialog.

Next you will create a virtual root for the HTML Administration Forms

  7. Start the IIS Internet Service Manager application.
  8. Double-click on the WWW service to edit the service properties.
  9. Select the Directories tab, and click Add.
  10. In the Directory field, enter the location of the isapi folder, usually C:\Program Files\Microsoft FrontPage\version3.0\admin\isapi.
  11. In the Alias field, type "/fpadmin"
  12. For Access, click Read and Execute.
  13. Click Require secure SSL channel
  14. Click OK twice to accept the changes.

The forms are now usable for remote administration using a URL such as https://mymachine/fpadmin/fpadmin.htm.

Activating the HTML Administration Forms on IIS 4.0

You should run the HTML Administration Forms over a secured port. On IIS it is not possible to use a secured port unless the server has a security certificate installed. If you do not already have a security certificate before activating the HTML Administration Forms, use the Key Manager application to make a security certificate request, submit the request to a key authority, and then use the Key Manager application to install the certificate returned by the key authority. The IIS documentation contains more details on this process.

Once you have a security certificate, you can enable the HTML Administration Forms either as a separate IIS web site or as a virtual directory on an existing web site. The advantages of using a separate site is that a separate IP address can make the forms harder to discover, and a separate site allows additional security settings to be enabled such as distinct non-standard port numbers. The disadvantage of using a separate web site is that an additional IP address is required for the machine. See To create a separate web site to host the HTML Administration Forms or To create a virtual directory to host the HTML Administration Forms on an existing web site.

To create a separate web site to host the HTML Administration Forms:

  1. Prepare the access permissions on the Administration Form files by following steps 1 through 6 of the Activating the HTML Administration Forms on IIS 2.0 and IIS 3.0 procedure.
  2. Start the IIS Internet Service Manager application and open the IIS and machine's folders.
  3. Right click on the icon labeled with the machine name and click Create New Web Site.
  4. In the New Web Site Wizard, fill in the Description field with the name of the site, for example "FrontPage 98 Administration Forms", and click Next.
  5. Select the IP Address to use for this site. The IP Address must have been pre-configured before running the New Web Site Wizard. Do not use the TCP Port field because the Administration Forms will only be accessed through a secure port. Click Next to continue.
  6. Enter the path to the HTML Administration Form files, usually C:\Program Files\Microsoft FrontPage\version3.0\admin\isapi, and make sure that the Allow anonymous access to this web site checkbox is turned off. Click Next.
  7. Click both Allow Read Access and Allow Execute Access (includes Script Access) and click Finish.
  8. Right click on the new web site icon created in the left pane, which will be labeled with the name typed in for step 4. Click Properties.
  9. Select the Web Site tab, and type in a non-standard port number in the SSL port field, for example 8234.
  10. Select the Directory Security tab, and click the Secure Communications Edit button. Click the Require Secure Channel checkbox and Click OK.
  11. Add any TCP/IP Access Restrictions that are desired.
  12. Click OK to accept the changes.

The forms are now usable for remote administration using a URL such as https://machinename:8234/fpadmin.htm, where machinename corresponds to the IP address entered in step 5 and 8234 corresponds to the port number entered in step 9.

To create a virtual directory to host the HTML Administration Forms on an existing web site:

  1. Prepare the access permissions on the Administration Form files by following steps 1 through 6 of the Activating the HTML Administration Forms on IIS 2.0 and IIS 3.0 procedure.
  2. Start the IIS Internet Service Manager application and open the IIS and machine's folders.
  3. Right click on the web site icon that will be used to host the HTML Administration Forms, such as Default Web Site. Click Create New Virtual Directory.
  4. In the New Virtual Directory Wizard, fill in the Alias field with the alias name of the HTML Administration Forms, such as "fpadmin", and click Next.
  5. Enter the path to the HTML Administration Form files, usually C:\Program Files\Microsoft FrontPage\version3.0\admin\isapi, and click Next.
  6. Click both Allow Read Access and Allow Execute Access (includes Script Access) and click Finish.
  7. Right click on the new fpadmin virtual directory icon, and click Properties.
  8. Select the Directory Security tab, and click the Password Authentication Method box's Edit button.
  9. Make sure that the Allow Anonymous checkbox is not checked, and that one or both of Basic Authentication or Windows NT Challenge/Response is checked, and click OK.
  10. Click the Secure Communications box's Edit button.
  11. Click Require Secure Channel, and click OK.
  12. Add any TCP/IP Access Restrictions that are desired.
  13. Click OK to accept the changes.

The forms are now usable for remote administration using a URL such as https://machinename/fpadmin/fpadmin.htm.

Activating the HTML Administration Forms on Other Servers

When using servers other than IIS, use the server's administration tool or configuration files to configure a new virtual directory for the HTML Administration forms, and configure the appropriate security settings.

  • When using a non-IIS Windows server, the HTML Administration forms are installed to the C:\Program Files\Microsoft FrontPage\version3.0\admin\cgi. Note that the cgi directory is different than the directory used for IIS servers, since non-IIS servers use CGI and not the ISAPI interface.
  • When using a UNIX server, the HTML Administration forms are installed to the /usr/local/frontpage/version3.0/admin directory.

In addition to configuring a virtual root and the appropriate access controls, execute permissions must be granted to the scripts subdirectory of the forms directory in order to run the CGI application that actually performs the administration command on the server.


Administration of the Microsoft FrontPage Server Extensions

General FrontPage Server Extensions Administration

  • The fpsrvadm Utility
  • HTML Administration Forms
  • The fpremadm Utility
  • Using FTP To Copy a FrontPage Web
  • Using the FrontPage Configuration File
  • Language Settings in FrontPage Webs
  • Recalculating FrontPage Webs
  • Setting Up Your E-mail Transport

Windows FrontPage Server Extensions Administration

  • The FrontPage Server Administrator Utility
  • The iisadmin Utility
  • The admin.pl Utility
  • Using FrontPage with Microsoft Index Server
  • Creating a New Virtual Server on Windows NT
  • IIS Security and Permissions Management Strategies
  • IIS 4.0 and the Server Extensions
  • Microsoft Visual SourceSafe 5.0 Integration

UNIX FrontPage Server Extensions Administration

  • Creating a New Virtual Server on UNIX

The fpsrvadm Utility

The fpsrvadm utility installs, updates, removes, and checks the FrontPage Server Extensions on FrontPage root webs and sub-webs, and performs other administrative FrontPage web operations. fpsrvadm can be run even when the Web server is not currently running (although the administration service for servers that use one may need to be running).

The fpsrvadm utility is a command line application used on both UNIX and Windows NT.

When you invoke fpsrvadm, you supply an operation, of the form -operation <value> and a set of command line options in the form -option <value>. For example, the following fpsrvadm command upgrades the FrontPage Server Extensions on port 80 of the virtual server sample.microsoft.com:

fpsrvadm -operation upgrade -port 80 -multihost sample.microsoft.com

Each option has a short form, shown below. The sample command above in short form is:

fpsrvadm -o upgrade -p 80 -m sample.microsoft.com

fpsrvadm includes the following operations:

Operation | Definition
install | Installs the Server Extensions on the root web or a sub-web.
upgrade | Upgrades the Server Extensions on the root web or a sub-web.
uninstall | Uninstalls the Server Extensions on the specified port and virtual server.
check | Checks and fixes the FrontPage Server Extensions installation on the specified port and virtual server.
security | Adds or remove administrators, authors, or end users from a FrontPage web, and sets IP address restrictions.
chown | (UNIX only) Sets up file system security settings so that they work correctly with the FrontPage Server Extensions.
enable | Enables FrontPage web authoring and administering on the specified port and virtual server.
disable | Disables FrontPage web authoring and administering on the specified port and virtual server.
recalc | Recalculates all hyperlinks in the FrontPage web on the specified port and virtual server.
putfile | Imports a file into the FrontPage web on the specified port and virtual server.
recalcfile | Recalculates all hyperlinks in the specified file in a FrontPage web on the specified port and virtual server
delete | Deletes a FrontPage sub-web.
rename | Renames a FrontPage sub-web.
setdirexec | Specifies that a directory can contain executable scripts or programs.
setdirnoexec | Specifies that a directory cannot contain executable scripts or programs.

The fpsrvadm options are:

Option

Short Form

Specifies …

Values

-port -p A port number An integer, such as 80 or a virtual server name followed by an integer, as in sample.microsoft.com:80.

For IIS 4.0 Web servers, you can use
-m <instance_number> instead of
-m <hostname> -p <port>
-web | -w | A FrontPage web name | The URL of a directory, relative to the root of the content area, such as /mydirectory
-type -t A Web server type On UNIX:
ncsa
apache
apache-wpp
apache-fp (Apache with FrontPage patch)
cern
netscape-communication
netscape-commerce
netscape-enterprise
netscape-fastrack
On Windows:
msiis (Microsoft Internet Information Server)
mspws (Microsoft Personal Web Server)
frontpage
netscape-communication
netscape-commerce
netscape-enterprise
netscape-fastrack
website
-servconfig -s A Web server configuration file A full pathname, such as
/usr/local/apache/conf/
httpd.conf
-multihost -m A virtual server's name or IP address.

On IIS 4.0 Web servers, this option is used to specify an instance number. 		An IP address or full WWW host name, as in
157.50.65.43, or sample.microsoft.com.

On IIS 4.0, an instance number, such as
/LM/W3SVC/10
-username | -u | A user name | A name, such as username. With IIS the username can be qualified with a domain name, for example domain\username. With IIS this value can be either a Windows NT user account name or a Windows NT group name.
-password | -pw | A password. | A password string, such as 124Xyz
-ipaddress -i An IP address. An IP address, such as
123.12.12.12
-access -a The type of FrontPage web access being granted One of the following values:
administrators,
authors, users,
remove (removes all access for the specified account)
-destination -d A URL in a FrontPage web A URL relative to the top-level directory of the FrontPage web, such as
/mydirectory/myfile.htm
-filename -f A file name A full path and file name, such as
C:\myfiles\filename.htm
-xUser -xu A UNIX user account name An account name, such as
www
-xGroup -xg A UNIX group account name A group account name, such as
www
-noChownContent -n Specifies to only chown the contents of FrontPage _vti*
directories and not users' content 		None

Install

fpsrvadm -o install -p <nnnn> -m <hostname>
    -u <username> -pw <password>
    -t <servertype> [-s <server config file> [ -w <webname> ]
    [ -xu <UNIX username>] [ -xg <UNIX groupname>] [ -n]

Installs the FrontPage Server Extensions on port <nnnn> of virtual server <hostname>, using the specified administrator name and password. If <webname> is specified, the Server Extensions are installed on the named FrontPage sub-web. Otherwise, the Server Extensions are installed on the root web of the specified virtual server. For any <servertype> except website and msiis, you must specify a server configuration file, using the -s switch.

On UNIX, if -xu and -xg are specified, the FrontPage directories and Server Extensions files along with the web's content are chowned and chmoded to <UNIX username> and <UNIX groupname>. The -n switch specifies to only chown and chmod the FrontPage directories and Server Extensions files, not the web content files. For a discussion of UNIX server security with FrontPage see the FrontPage Security on UNIX-based Systems.

To install the server extensions on Windows NT with an IIS web server, use the following options. The password option is not necessary because with IIS the passwords for accounts are specified in the NT account list administration tools, not in the web server or FrontPage administration tools.

fpsrvadm -o install -t msiis -p 80 -m sample.microsoft.com -u adminaccount

To install the server extensions on an Apache Web server that is running the FrontPage apache patch, use the following command line:

fpsrvadm -o install -t apache-fp -s /usr/local/apache/conf/httpd.conf -p 80 -m sample.microsoft.com -u adminaccount -p adminpassword -xu www -xg www

Upgrade

fpsrvadm -o upgrade -p <nnnn> -m <hostname> [ -w <webname> ]
    [ -xu <UNIX username>] [ -xg <UNIX groupname>] [ -n]

Upgrades the FrontPage Server Extensions on port <nnnn> of virtual server <hostname>. If <webname> is specified, the Server Extensions are upgraded on the named FrontPage sub-web. Otherwise, the Server Extensions are upgraded on the root web of the specified virtual server, and any sub-webs present beneath that root web are also upgraded.

On UNIX, if -xu and -xg are specified, the FrontPage directories and Server Extensions files, along with the web's content, are chowned and chmoded to <UNIX username> and <UNIX groupname>. The -n switch specifies to only chown and chmod the FrontPage directories and Server Extensions files.

Uninstall

fpsrvadm -o uninstall -p <nnnn> -m <hostname>

Uninstalls the FrontPage Server Extensions on port <nnnn> of virtual server <hostname>. Uninstalling the server extensions from the virtual server's root web also uninstalls the server extensions from any sub-webs that are present beneath the root web.

Note that uninstalling the FrontPage Server Extensions does not remove content. It only removes the Server Extensions executables and accessory Server Extensions files.

Check

fpsrvadm -o check -p <nnnn> -m <hostname> [ -w <webname> ]

Checks and fixes the FrontPage Server Extensions installation on port <nnnn> of virtual server <hostname>. If <webname> is specified, the Server Extensions are checked on the named FrontPage sub-web. Otherwise, the Server Extensions are checked on the root web of the specified virtual server.

Checking the Server Extensions includes replacing missing FrontPage directories and files, and making sure all FrontPage executables are present and with the correct permissions.

Security

fpsrvadm -o security -p <nnnn> -m <hostname> -w <webname>
    -a <accesstype> -u <username> -pw <password> [-i <ipaddress>]

Sets up FrontPage web security on the FrontPage web <webname> on the specified virtual server and port, for the specified username and password. On Microsoft IIS servers, the username must be an NT account and the password is ignored if it is provided.

To add an administrator, specify the access type "administrators." To add an author, specify the access type "authors," and to add a user, specify the access type "users." To remove a user's, administrator's, or author's FrontPage web permissions, specify the access-type "remove." To downgrade the permissions granted to a particular account, the account must first be removed and then re-added with the new permissions level.

Use the optional -i switch to restrict authoring, administering, or end user access to client computers based on IP address. You can use the asterisk character "*" as a wild card in any of the four IP address sections. For example, the IP address mask 157.*.*.* specifies any IP address beginning with 157. Note that IP address restrictions are not supported by some of the server types supported by the FrontPage Server Extensions.

Chown

fpsrvadm -o chown -p <nnnn> -m <hostname> [ -w <webname> ]
    [ -xu <UNIX username>] [ -xg <UNIX groupname>] [ -n]

On UNIX only, chowns and chmods the FrontPage directories and Server Extensions files, along with the web's content to <UNIX username> and <UNIX groupname>. This guarantees the optimum FrontPage Server Extensions security on UNIX. See FrontPage Security on UNIX-based Systems for details.

The -n switch specifies to only chown and chmod the FrontPage directories and Server Extensions files, and not the web contents directories and files.

Enable

fpsrvadm -o enable -p <nnnn> -m <hostname>

Enables authoring and administering FrontPage webs on port <nnnn> of virtual server <hostname>.

Disable

fpsrvadm -o disable -p <nnnn> -m <hostname>

Disables authoring and administering FrontPage webs on port <nnnn> of virtual server <hostname>.

Recalc

fpsrvadm -o recalc -p <nnnn> -m <hostname> -w <webname>

Recalculates and repairs all internal hyperlinks in the specified FrontPage web on the specified virtual server and port. This command also re-includes pages in Include Page components, recalculates other FrontPage components (such as Search Forms and Navigation Bars), reapplies borders to any pages using borders, resets permissions on FrontPage form handler result pages, and recalculates text indices.

Putfile

fpsrvadm -o putfile -p <nnnn> -m <hostname> -w <webname>
    -f <filename> -d <destination>

Imports the file <filename> to the URL <destination> in the FrontPage web <webname> on the specified virtual server and port.

Recalcfile

fpsrvadm -o recalcfile -p <nnnn> -m <hostname> -w <webname>
    -d <destination>

Recalculates and repairs all internal hyperlinks at the specified URL <destination> in the FrontPage web <webname> on the specified virtual server and port. This command also re-includes pages in Include Page components and recalculates text indices.

Delete

fpsrvadm -o delete -p <nnnn> -w <webname> [-m <hostname>]

Deletes the FrontPage sub-web <webname> on the specified virtual server and port. This is the only way to delete sub-webs on servers of the following types: ncsa, apache, cern. You cannot delete the root web using this command. Instead, use the Uninstall option.

Rename

fpsrvadm -o rename -p <nnnn> -w <webname> -d <destination> [-m <hostname>]

Renames the FrontPage sub-web <webname> on the specified virtual server and port to <destination>. This is the only way to rename sub-webs on servers of the following types: ncsa, apache, cern.

SetDirExec

fpsrvadm -o setdirexec -p <nnnn> -w <webname> -d <destination>
        [-m <hostname>]

Specifies that the directory <destination> can contain executable scripts or programs in the FrontPage sub-web <webname> on the specified virtual server and port. This is the only way to make a directory executable on servers of the following types: ncsa, apache, cern.

SetDirNoExec

fpsrvadm -o setdirnoexec -p <nnnn> -w <webname> -d <destination>
        [-m <hostname>]

Specifies that the directory <destination> cannot contain executable scripts or programs in the FrontPage sub-web <webname> on the specified virtual server and port. This is the only way to specify that a directory cannot contain executable scripts or programs on servers of the following types: ncsa, apache, cern.

HTML Administration Forms

The FrontPage 98 Server Extensions package includes HTML Administration Forms. These are HTML forms that can be used remotely to install and administer the FrontPage Server Extensions from a standard Web browser. These forms are copied to your Web server's hard drive as a part of the FrontPage Server Extensions installation. The home page of the HTML Administration Forms is fpadmin.htm.

Because of the security implications of making remote FrontPage administration available from Web browsers, the FrontPage installer does not make the HTML Administration Forms active and accessible to browsers when the forms are first installed. After understanding the security implications, you can decide whether or not to make the HTML Administration Forms active on a server. For a discussion of these security implications, along with descriptions of how to install the HTML Administration Forms on IIS 2.0, 3.0, and 4.0, see Installing the HTML Administration Forms.

Installing the FrontPage Server Extensions on a New Virtual Server

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose New Virtual Server.
  3. In the Virtual Host Name field, enter the name of the virtual host that will have the FrontPage Server Extensions installed.
  4. In the Port Number field, enter the name of the port.
  5. In the Administrator Account Username field, enter a user name. With IIS the user name can be qualified with a domain name, for example domain\username, and this value can be either a Windows NT user account name or a Windows NT group name.
  6. Click Create Server.

The FrontPage Server Extensions are installed and a root web is created.

Installing the FrontPage Server Extensions on a New Sub-web

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose New Subweb.
  3. In the Virtual Host Name field, enter the name of the virtual host that the sub-web will be created beneath
  4. In the Port Number field, enter the name of the port.
  5. In the Subweb Name field, enter the name of the new sub-web.
  6. Click Create Subweb.

The sub-web is created and the FrontPage Server Extensions are installed. Security settings for new sub-webs are inherited from the root web. To change sub-web security use the User Permissions and IP Address Permissions forms.

Removing the FrontPage Server Extensions from a Virtual Server

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose Uninstall.
  3. In the Virtual Host Name field, enter the name of the virtual host.
  4. In the Port Number field, enter the name of the port.
  5. Click Uninstall.

Note that uninstalling the FrontPage Server Extensions does not remove content. It only removes the Server Extension executables and accessory Server Extension files. Uninstalling the server extensions from a virtual server's root web will uninstall the Server Extensions from not only the root web but also from any sub-webs that were present beneath the root web.

Checking and Fixing the FrontPage Server Extensions on a Virtual Server

Checking the Server Extensions includes replacing missing FrontPage directories and files, making sure all FrontPage executables are present and with the correct permissions, and removing lock files.

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose Check and Fix Extensions.
  3. In the Virtual Host Name field, enter the name of the virtual host.
  4. In the Port Number field, enter the name of the port.
  5. Click Check.

Recalculating Hyperlinks on the Root Web or a Sub-web

This form recalculates and repairs all internal hyperlinks in the specified FrontPage web on the specified virtual server and port. This also re-includes pages in Include Page components, recalculates other FrontPage components (such as Search Forms and Navigation Bars), reapplies borders to any pages using borders, resets permissions on FrontPage form handler results pages, and recalculates text indices.

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose Recalculate Links.
  3. In the Virtual Host Name field, enter the name of the virtual host.
  4. In the Port Number field, enter the name of the port.
  5. To recalculate hyperlinks for a sub-web, in the Subweb Name field, enter the name of the sub-web.
  6. Click Recalculate.

Enabling Authoring on a Virtual Server

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose Enable Authoring.
  3. In the Virtual Host Name field, enter the name of the virtual host.
  4. In the Port Number field, enter the name of the port.
  5. Click Enable Authoring.

Disabling Authoring on a Virtual Server

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose Disable Authoring.
  3. In the Virtual Host Name field, enter the name of the virtual host.
  4. In the Port Number field, enter the name of the port.
  5. Click Disable Authoring.

Changing Permissions for a User

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose User Permissions.
  3. In the Virtual Host Name field, enter the name of the virtual host.
  4. In the Port Number field, enter the name of the port.
  5. In the Subweb Name field enter the sub-web name.
  6. In the Username field, enter the name of the user whose permissions you are adding, removing, or changing.
  7. In the Password field, enter the user's password.
  8. Select the level of access for the user or, to give the user no access, click Remove this User.
  9. Click Change Permissions.

Changing Permissions for a Computer

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose IP Address Permissions.
  3. In the Virtual Host Name field, enter the name of the virtual host.
  4. In the Port Number field, enter the name of the port.
  5. In the Subweb Name field enter the sub-web name.
  6. In the IP Address field, enter the IP address of the computer or set of computers whose permissions you are adding, removing, or changing. You can use the asterisk character "*" as a wildcard, as in 128.109.*.*
  7. Select the level of access for the computer or group of computers, or, to remove all restrictions on the IP address or IP address mask, click Remove this mask.
  8. Click Change Permissions.

Deleting a Subweb

This is the only way to delete sub-webs on servers of the following types: ncsa, apache, cern. You cannot delete the root web using this command. Instead, use the Uninstall option.

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose Delete Subweb.
  3. In the Virtual Host Name field, enter the name of the virtual host.
  4. In the Port Number field, enter the name of the port.
  5. In the Subweb Name field, enter the name of the subweb.
  6. Click Delete Subweb.

Renaming a Subweb

This is the only way to rename sub-webs on servers of the following types: ncsa, apache, cern.

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose Rename Subweb.
  3. In the Virtual Host Name field, enter the name of the virtual host.
  4. In the Port Number field, enter the name of the port.
  5. In the Subweb Name field, enter the name of the subweb.
  6. In the New Subweb Name field, enter the new name of the subweb.
  7. Click Rename Subweb.

Setting a Directory Executable

This is the only way to make a directory executable on servers of the following types: ncsa, apache, cern. To make a directory not executable, use the Set Directory Not Executable command.

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose Set Directory Executable.
  3. In the Virtual Host Name field, enter the name of the virtual host.
  4. In the Port Number field, enter the name of the port.
  5. In the Subweb Name field, enter the name of the subweb.
  6. In the Directory URL field, enter a URL relative to the top-level directory of the FrontPage web.
  7. Click Set Directory Executable.

Setting a Directory Not Executable

This is the only way to make a directory not executable on servers of the following types: ncsa, apache, cern. To make a directory executable, use the Set Directory Executable command.

  1. From your browser, start the HTML Administration Forms by opening fpadmin.htm.
  2. In the contents listing, choose Set Directory Not Executable.
  3. In the Virtual Host Name field, enter the name of the virtual host.
  4. In the Port Number field, enter the name of the port.
  5. In the Subweb Name field, enter the name of the subweb.
  6. In the Directory URL field, enter a URL relative to the top-level directory of the FrontPage web.
  7. Click Set Directory Not Executable.

The fpremadm Utility

The fpremadm utility is based on the fpsrvadm utility. It supports remote administration of the FrontPage Server Extensions using a client computer via WinInet. It installs, updates, removes, and checks the FrontPage Server Extensions on FrontPage root webs and sub-webs, and performs other administrative FrontPage web operations similarly to fpsrvadm.

The fpremadm.exe utility is only provided for Windows machines. There is no UNIX version of this utility.

In order to use fpremadm you must first enable the HTML Administration Forms, since fpremadm.exe uses the same server-side CGI or ISAPI script as the HTML Administration Forms. The URL used for the HTML Administration Forms will be used in a slightly modified form as the -targetserver argument value to fpremadm.exe.

fpremadm has the same set of operations as fpsrvadm. It includes the following additional options that support remote administration:

Additional Option | Specifies … | Values
-targetserver | The full URL of the server-side administration script. This is not the same as the -multihost option, which controls what virtual server to administer. The -targetserver option must be the full URL to the actual administration script executable. | A URL string, such as: http://sample.microsoft.com/fpadmin/scripts/fpadmcgi.exe, or for IIS and Microsoft Personal Web Server Web servers, the URL will be of the form: http://sample.microsoft.com/fpadmin/scripts/fpadmdll.dll
-adminusername | The username to use to authenticate access to the administration script. This is not the same as the -username argument. It is the user name that is used to logon in order to gain access to the remote administration capability. | A user name, such as: useraccount This can be left blank if you are using Windows NT Challenge/Response Authentication.
-adminpassword | The password to use to authenticate access to the administration script. This is not the same as the -password argument. It is the password that is used to logon in order to gain access to the remote administration capability. | A password, such as: 787abC This can be left blank if you are using Windows NT Challenge/Response Authentication.

The FrontPage Server Administrator Utility

The FrontPage Server Administrator, fpsrvwin.exe, installs, updates, removes, and checks the FrontPage Server Extensions on FrontPage root webs and sub-webs, and performs other administrative FrontPage web operations. It is a Windows-only graphical user interface to the frpsrvadm utility. It can be run even when the Web server is not currently running (although with some server types you may need to have the administration service for the server running in order to use fpsrvwin).

Note: Some FrontPage Server Administrator operations require that you supply the location of the server configuration file. For Netscape servers, the server configuration information is kept in the Windows NT or Windows 95 Registry, in a different area for each port. You must enter the port number in the space provided. For WebSite servers, the server configuration information is kept in the Windows NT or Windows 95 Registry. You only need to enter server-specific information if you are using the multi-homing feature of WebSite, and in this case you must enter the fully qualified domain name for the server host that you are installing.

The FrontPage Server Administrator is implemented as a single dialog box in which you select the operation and set the port number. The dialog box has the following fields:

Select server or port

This field lists the virtual servers and ports on which the FrontPage Server Extensions are installed. Select a virtual server/port number before you perform any operation except Install

Install

Installs the FrontPage Server Extensions on a Web server. You can install on the following Web server types:

  • Microsoft Internet Information Server
  • Microsoft Personal Web Server
  • FrontPage Web Server
  • Netscape Communicator
  • Netscape Commerce
  • Netscape Enterprise
  • Netscape Fastrack
  • O'Reilly WebSite

Upgrade

Upgrades the FrontPage Server Extensions on the selected virtual server/port. The root web and any sub-webs will be upgraded to the latest version of the Server Extensions on the server machine.

Uninstall

Removes the FrontPage Server Extensions on the selected virtual server/port.

Check and Fix

Checks and fixes the FrontPage Server Extensions installation on the selected virtual server/port.

Checking the server extensions includes replacing missing FrontPage directories and files and making sure all FrontPage executables are present and with the correct permissions. On IIS Web servers and Microsoft Personal Web Servers, you are prompted to tighten security. If you click Yes, FrontPage will optimize security settings on folders and files in your webs. This may change current security settings.

Authoring

Enables or disables authoring on the selected virtual server/port. Click Enabled to enable authoring and Disabled to disable it.

Security

Adds an administrator for the selected virtual server/port. For some server-types you are prompted for a name and password. On other servers, you are just prompted for a name and the system password for the provided name is used.

Creating a New Virtual Server on Windows NT

On IIS2.0 and 3.0 ...

Use the following procedure for creating a new virtual server.

  1. You must define the IP Address of the new virtual server using the NT Network control panel. You must reboot after adding an IP address to have it take affect. To avoid rebooting when adding a new virtual server (and thus taking the machine offline for a few minutes), prepare 50 IP addresses in reserve in the registry.
  2. IIS security is based on NT machine accounts, so in most cases you will create an NT machine account before you install the FrontPage extensions. You create NT machine accounts with the net.exe utility or the NT User Manager. For help with the net.exe utility, type "net help user" at the MS-DOS command line.
  3. Create a content root on the hard drive. Typically this is "C:\InetPub\www.virtualmachinename.com".
  4. The content root directory will have an ACL inherited from its parent directory in the file system. Often, the file system has loose permissions, such as granting full control to the EVERYONE account. If this set of permissions is not modified, the EVERYONE account permissions will be preserved during the installation of the FrontPage extensions into this content root, and any user will be able to browse the content area and any user will have the ability to write to the content area (but not via FrontPage). To prevent this, remove these ACLs and set the initial ACL on the content root to a clean baseline which includes any authorized users, the SYSTEM account, and possibly the IUSR_machinename account if the web is to be browsable without authentication.
  5. Create a virtual server root with the new IP Address created or allocated in step 1. You can do this using the iisadmin.exe utility or the Windows NT Internet Service Manager application.
  6. Install the FrontPage Server Extensions to the root web of the virtual server using the FrontPage Server Administrator, the fpsrvadm utility, or HTML Administration Forms.
  7. Optionally add an FTP service to the virtual server using the iisadmin.exe utility or the Windows NT Internet Service Manager.

On IIS4.0 ...

On IIS 4.0, virtual server creation and installation of the FrontPage Server Extensions onto the new virtual root is integrated with the IIS 4.0 administration tools. After creating a new Web site with the New Web Site Wizard, the Server Extensions can be added either with the FrontPage Server Administrator or by using the properties page of the virtual server. Go to the Home Directory Tab, then click on the FrontPage web option, which will automatically install the FrontPage Server Extensions.

On Netscape ...

On Netscape Web servers, use the appropriate administration tool for creating a virtual server, then add the server extensions using the FrontPage Server Administrator tool.

Creating a New Virtual Server on UNIX

  1. Create a new UNIX account for the user.
  2. Create a content root and configuration file area. For example, /usr/local/www/newuser/content and /usr/local/www/newuser/conf.
  3. Create a new virtual server for the new account. Consult your Web server documentation for details.
  4. Run the fpsrvadm utility (or use HTML Administration forms) to install the FrontPage Server Extensions on the new virtual server. For example:

    5. fpsrvadm -o install -t servertype -h hostname -u username -pw password -p port -xUser unixuseraccount -xGroup unixgroupaccount

  5. Chown the web appropriately. Using the sample command line above, you can do this at the same time you install the FrontPage Server Extensions, using the -xUser and -xGroup options. Otherwise, use the chown option of fpsrvadm. For example:

fpsrvadm -o chown -h hostname-p port -xUser unixuseraccount -xGroup unixgroupaccount

IIS Security and Permissions Management Strategies

The FrontPage security system uses a combination of the Web server's security system and the web server machine's file system security system. As explained in Security Considerations, in the FrontPage security model, all content within a particular FrontPage web has the same set of permissions for browsing, authoring, and administrative functions.

In some applications easier administration or a finer level of security than the FrontPage web level is required. In some cases, you may want to have permissions settings for authoring or browsing access on a per-directory basis or a per-file basis. Permissions of this type are not directly supported through FrontPage, but by using a combination of FrontPage security management and manual security management it is possible to achieve a finer security granularity. This section contains a range of suggested strategies for fine-grained security and for administering permissions easily.

FrontPage does all security management, but administration of permissions is through the NT User Manager

In this scenario, the FrontPage per-web level of granularity is used, but the FrontPage permissions user-interface in the FrontPage Explorer is not used for security management. The FrontPage permissions user-interface uses the contents of the NT account list to control which users have browse, author, and administrative privileges. However, the FrontPage interface is different from the NT User Manager tools which are used for other Windows NT user administration tasks. To enable administration of FrontPage web permissions via the Windows NT User Manager, use Windows NT groups.

When each FrontPage web is created, create and add a separate Windows NT group to the web for web browsers, authors, and administrators using FrontPage's Permissions command. Once these groups are added using the FrontPage Permissions command, all subsequent control over which users are allowed permissions to the FrontPage web is handled by controlling the membership of the groups using the NT User Manager. IIS and the FrontPage extensions will automatically grant browsing and authoring privileges based on the group membership.

To prevent FrontPage Administrators from altering the FrontPage web's permissions using the FrontPage Permissions command (and thus bypassing the NT groups) reserve FrontPage administrative privileges for Web server machine administrators, and do not grant FrontPage Administrative privileges to content authors. Not granting FrontPage administrative privileges to authors will prevent them from creating new sub-webs. Sub-web creation will have to be done by the Web server machine administrators.

Mix of FrontPage security management and manual management for a few per-directory security settings

If most the web content has uniform security requirements, and only a few of the directories in the web need to have unique security settings, use FrontPage's security management with a few manual changes to the file system to modify security on the exceptional directories. Examples of when this strategy of security management is appropriate are:

  • Removing anonymous browse-access from a particular directory, but keeping the rest of the web's content anonymously browsable. In the directory that should not be anonymously browsable, use the Windows Explorer to remove the IUSR_machinename account from the directory and from the directory's content ACLs. As long as the "Everyone has browse access" setting in the FrontPage Permissions dialog box is not changed, you can use the FrontPage Permissions dialog box to add and remove users and groups, and FrontPage will preserve the lack of anonymous access for the directory that was altered.
  • If anonymous browsing is off for the entire web, you can modify the ACLS for a particular directory to which you manually gave extra users browse-access. These ACLs will be preserved by FrontPage even if the FrontPage Permissions command is subsequently used.
  • You can disallow authoring for a selected directory for a small set of users. In the directory where authoring should not be allowed, remove the users from the directory and directory-content ACLs using the Windows Explorer. The removal of these users will be preserved by FrontPage. This technique is most applicable when anonymous browsing is enabled for the entire web, so that users can always browse the entire web's content but may not be able to author content in a particular directory.

Use of separate sub-webs for finer security granularity

Instead of storing all web content in a single large, hierarchically-organized web, break up the content into a number of sub-webs. Leaf directories in the hierarchical structure become individual sub-webs. By using sub-webs, finer security granularity is automatic since each sub-web maintains separate security settings. An additional benefit of using sub-webs is potentially better performance, because the time required to recalculate hyperlinks is directly proportional to the number and size of the documents stored in a single web. Since each sub-web will store a subset of the documents, the time required for a user to recalculate hyperlinks in that user's content area is less. A disadvantage of this approach is that URLs to access the content no longer reflect an organizational hierarchy, and linking between leaves of the hierarchy is more difficult.

Use a staging server for authoring, and then copy to a production server with manually managed permissions

In this model, all authoring takes place on a staging server that is not used for "production" publishing of the web content, and all permissions are managed using the normal FrontPage Permissions command. When the content is ready to be published it is copied to a production server (either using the FrontPage Publish command or via some other means such as file copying or the Microsoft Content Replication System) and permissions on the production server are set up appropriately outside of the FrontPage Permissions command.

Some advantages of this model are that authoring and works-in-progress are never exposed to users browsing the web, but the disadvantages are that use of some FrontPage Components, such as the default FrontPage form handler, is more difficult because the results files will be on the production server and not on the authoring server. Additionally publishing and fixing up permissions are separate steps that may require special configuration.

Perform all permissions management manually

Permissions can be managed completely outside of the FrontPage Permissions command by directly manipulating file system ACLs for all of the web content. If this approach is used, the following guidelines will help prevent conflicts with FrontPage, however manual management of permissions is not recommended because of the risk of a misconfiguration causing FrontPage to become non-functional or possibly loosening permissions in such a way that leaves the web exposed to unauthorized browsers, authors, or administrators.

  • Initially, add a single NT group containing all authors using the FrontPage Permissions command. This correctly sets the authoring permissions on the FrontPage Server Extensions DLLs stored in the web. It is important that the membership of this NT group always contain the set of all authors for the web's content, so that access to the FrontPage DLLs is granted.
  • After adding the initial authors group, do not use the FrontPage Permissions command for further permissions management on the web's content. Instead, manage content permissions on a per-file or per-directory basis, using the Windows Explorer or the cacls.exe command to directly modify file system ACLs.
  • Do not grant FrontPage administrative privileges to any user. This will prevent a FrontPage user from accessing the FrontPage Permissions command and potentially overwriting the web's customized permissions.
  • Selective use of NT groups when modifying file system ACLs will reduce the overhead of adding and removing individual users to all files and directories in a web.
  • Do not overwrite the ACLs of the FrontPage _vti_* directories in the root directory of the web. These directories contain configuration data for the entire web and additionally must be accessible to all authors on a given web, and they have permissions settings that are different from the permissions settings on the content stored within the web's root directory. Be particularly careful of the "Replace Permissions on subdirectories" option in the Windows Explorer Permissions dialog box, since use of this option when changing permissions on the root directory of a web will cause the _vti_* directory permissions to be overwritten with the permissions you designate. Doing so may cause some authors of the web to be denied access or possibly may leave the web open for authoring by any user. Use of the cacls.exe command is recommended when manually managing web permissions, since cacls.exe is capable of removing or adding individual users to a given file's ACL, as opposed to overwriting the entire ACL.

IIS 4.0 and the Server Extensions

Administration of the FrontPage Server Extensions with IIS version 4.0 is generally the same as administration with earlier versions of IIS. When using the FrontPage Server Extensions with IIS 4.0, make sure that the FrontPage Server Extensions are not run in a separate memory space, as is optional for IIS 4.0 web sites. Running the FrontPage Server Extensions in a separate memory space will cause the following problems:

  • The FrontPage Permissions command will not function correctly.
  • Integration of the FrontPage Search Form Component with Microsoft Index Server will not function.
  • Authoring performance will be slower.

The iisadmin Utility

The iisadmin utility adds, removes, or modifies virtual servers on Microsoft IIS 2.0 and 3.0 Web servers. This utility is designed to be run from scripts or the command line to automate the maintenance of IIS 2.0 and IIS 3.0 Web servers, which otherwise must be maintained using the graphical Internet Service Manager application.

iisadmin includes the following operations:

Operation | Definition
add | Adds a virtual server or root web.
delete | Deletes a virtual server or root web.
edit | Modifies the configuration of a virtual server or a root web.

The iisadmin options are (see below for a detailed description of which options are valid for each operation):

Option | Short Form | Specifies ... | Values
-targetserver | -t | The server machine to run on | A machine name, such as \\myserver If this switch is omitted, the local server is used.
-service | -s | The service to offer on the virtual server | www or ftp
-url | -u | The new virtual root's URL | A relative URL, such as /vroot Note that FrontPage does not recognize UNC directories of the form \\mymachine\directory.
-directory | -d | The directory to map to the virtual root | A directory, such as C:\content Note that FrontPage does not recognize UNC directories of the form \\mymachine\directory.
-virtual | -v | An IP address to map to the virtual server. | An IP address, such as 123.12.12.12, if the value is not specified and the service is www all IP addresses registered on the server machine are mapped to the virtual server
-account | -a | The user account | An account name such as myaccount
-password | -p | The password for the user account | A password, such as 123aBc
-read | -r | Gives users browse-access to the virtual root | true or false
-write | -w | Gives users write-access to the virtual root | true or false (for FTP only)
-execute | -e | Lets users execute scripts at the virtual root | true or false (for WWW only)

Add

iisadmin -o add -s <service> -u <url> -d <directory>
    -v [<ipaddress>] -r <true|false> -w <true|false>
    -e <true|false> [-t <targetserver>]

Adds the virtual root <url> to the machine <targetserver>. If <targetserver> is omitted, it adds the virtual root to the current machine. The content mapped to the server is at <directory>. If <ipaddress> is specified, it is mapped to the virtual root. If <ipaddress> is not specified, all IP addresses registered on <targetserver> are mapped to the virtual root. The <service> can be "www" or "ftp".

The -r, -w, and -e switches set read, write, and execute restrictions on the virtual root.

Delete

iisadmin -o delete -u <url> -d <directory> -v <ipaddress>
    [-t <targetserver>]

Deletes the virtual root <url> mapped to the IP address <ipaddress> from the machine <targetserver>. If <targetserver> is omitted, it deletes the virtual root on the current machine. The <directory> switch is required to ensure that the correct virtual root is deleted.

Edit

iisadmin -o edit -s <service> -u <url> -d <directory>
    [-t <targetserver>] -r <true|false> -w <true|false> -e <true|false>

Changes the read, write, or execute restrictions on the virtual root <url> on the machine <targetserver>. If <targetserver> is omitted, the change is applied on the current machine. The content mapped to the server is at <directory>. The -r, -w, and -e switches set read, write, and execute restrictions on the virtual root.

Using the FrontPage Configuration File

Some features of the FrontPage 97 Server Extensions can be controlled by setting parameters in the appropriate sections of the FrontPage configuration file.

On Windows, the FrontPage configuration file is frontpg.ini. This file is in the Windows NT folder. The appropriate sections for each virtual server are labeled in the form [Port <IPAddress>:<port>], and global settings are stored in the [FrontPage 3.0] section. The default setting in the software for each of these parameters is 0, unless otherwise noted.

Placing a parameter in the [FrontPage 3.0] section of frontpg.ini will affect all ports and all web servers installed on that server. Placing the parameter in the [Port <IPAddress>:<port>] section will affect only the specified port.

The parameter syntax in frontpg.ini is:

Parameter=value

See frontpg.ini Settings for a full description of this file, with default FrontPage settings.

On UNIX, the general FrontPage configuration file (for all servers) is /usr/local/frontpage/version 3.0/frontpg.cnf. The FrontPage configuration files for each virtual server are also in the /usr/local/frontpage/ directory. They are named we<port>.cnf or <hostname:port>.cnf.

The parameter syntax on UNIX is:

Parameter:value

See UNIX FrontPage Configuration File Settings for a full description of this file, with default FrontPage settings.

The following are some key variables in the FrontPage configuration file:

NoSaveResultsToAbsoluteFile

When set to a non-zero value, prevents the FrontPage default, Registration, and Discussion form handlers from writing to an absolute file path even if the browsing account has the NTFS rights to write to that path. When this is set, the default form handler can only write a file within the web's content area.

NoExecutableCgiUpload

When set to a non-zero value, authors cannot upload files to a directory marked executable, and cannot mark a directory executable. Setting this parameter to a non-zero value completely prevents authors from uploading and executing Active Server Pages (ASP), Internet Database Connector Pages (IDC), PERL Scripts (PL), CGI scripts and ISAPI extensions. To only restrict authors ability to upload and execute CGI scripts and ISAPI extensions use the AllowExecutableScripts configuration parameter, below.

AllowExecutableScripts (IIS Only)

When set to a non-zero value, FrontPage will set the executable bit on files within executable directories. When directories are marked executable all files within the directory will be also marked executable. If authors are permitted to upload into executable directories (because the NoExecutableCgiUpload parameter, above, is zero), then by setting this parameter to a non-zero value, authors will be able to execute newly uploaded CGI scripts and ISAPI extensions because they will be marked executable.

RestrictIISUsersAndGroups (IIS Only)

When set to non-zero, only displays users and groups from a single NT group. If RestrictIISUsersAndGroups is enabled for a given service, the FrontPage Server Extensions look for an NT group named in the following format:

FP_ServiceName[_Subweb]

Where ServiceName is the service's IP address and Port number combination (on a multihosted server) and Subweb is the name of the sub-web. On a single-hosted IIS 2.0 or 3.0 server, the ServiceName portion of the name is the port number, for example "80". To specify a root web's restriction group, omit the _Subweb portion. Some examples are:

FP_157.55.49.66:80_MySubweb
FP_80_MySubweb

If restrictions are enabled on a sub-web but no local group is defined, the FrontPage Server Extensions look for the group of the root web and use it if found. If no appropriately named groups are found, no restriction is placed on permissions.

Logging

When set to a non-zero value, authoring operations are logged to the file _vti_log/author.log in the root web. Each operation is logged with the current time, the remote host, the author's user name, the name of the web, the operation performed, and per-operation data.

Using FTP To Copy a FrontPage Web

FrontPage's Publish command uses HTTP to communicate with the Web server. This command will not transfer the local FrontPage Server Extension files to the target server. When using an FTP application, it is important to transfer only the content files from the originating web server. Do not FTP any _vti _* directories. If these directories or files are transferred, they will overwrite the existing files on the target server. FrontPage Server Extensions should only be installed using the FrontPage Server Administrator utility on the host server or remotely using the HTML Administration Forms.

If you FTP the contents of a FrontPage web to a Web server that does not have the FrontPage Server Extensions, some runtime FrontPage functionality such as form handling and searching will be lost.

Language Settings in FrontPage Webs

Each FrontPage web has two language settings:

  • Default Web Language

This is the language setting for the FrontPage web. It is used by the FrontPage Server Extensions to determine the language that should be used to pass error messages from the Web server to the Web browser. It also affects generated content such as the results returned by FrontPage Search Forms.

The default web language is set in the FrontPage Explorer in the Language tab of the FrontPage Web Settings dialog box. You can set the default language for a FrontPage web using the vti_defaultlanguage parameter in the _vti_pvt/service.cnf file. You can set the default language for a Web server using the defaultLanguage parameter in /usr/local/frontpage/XXXX.cnf, and you can set the default language for all Web servers using the defaultLanguage parameter in /usr/local/frontpage/frontpage.cnf.

To set this parameter, using one of the following:

vti_defaultlanguage = <language_code>
DefaultLanguage = <language_code>

where <language_code> is "de" (German), "en" (English), "es" (Spanish), "fr" (French), "it" (Italian), or "ja" (Japanese).
  • Default HTML Encoding

This parameter controls the mapping between URLs and file names.

The default HTML encoding is set in the FrontPage Explorer in the Language tab of the FrontPage Web Settings dialog box. You can set the default language for a FrontPage web using the
vti_ localCharEncoding parameter in the _vti_pvt/service.cnf file. You can set the default language for a Web server using the localCharEncoding parameter in /usr/local/frontpage/XXXX.cnf, and you can set the default language for all Web servers using the localCharEncoding parameter in /usr/local/frontpage/frontpage.cnf.

To set this parameter, using one of the following syntaxes:

vti_localCharEncoding = <language_code>
localCharEncoding = <language_code>

Note: If the character encoding of your client (such as FrontPage, Internet Explorer, or Netscape) and your server do not match, you must restrict URL (web, folder and page names) to 7-bit ASCII. Also, if the character encoding of your server does not match the character encoding of your content (HTML pages) you should restrict your URLs (folder and page names) to 7-bit ASCII.

Using FrontPage with Microsoft Index Server

Microsoft Index Server version 1.1 is a content-indexing and search component included with Microsoft Internet Information Server (IIS) 3.0. When the FrontPage 98 Server Extensions are installed with IIS 3.0 and higher, the FrontPage Search Form uses the document index and search component of Index Server. When Index Server is used with IIS virtual servers and FrontPage, there are special considerations described here.

Installing Index Server for Virtual Servers

For information about installing the Index Server, go to http://www.microsoft.com/ntserver/search/docs. (Because the Microsoft Web site is constantly updated, the site address may change without notice. If this occurs, go to the Microsoft home page http://www.microsoft.com .)

For information about setting up the catalog, associating it with a specific virtual server, and configuring Index Server Administration, read "Multiple Catalogs for Multiple Virtual Servers" at http://www.microsoft.com/ntserver/search/docs/cathlp.htm#multiple.

Using the Index Server Administration HTML pages, check the list of virtual roots to be indexed in the catalog and remove any virtual roots you do not want to include in the catalog. Common Roots (virtual roots without specific IP addresses) are indexed in all catalogs by default.

Force the creation of the catalog by browsing to the virtual server and attempting a search.

Index Server Issues

FrontPage can use either of two search engines. The default search engine is the built-in WAIS search engine that is included with the FrontPage Server Extensions. On IIS, if Index Server is installed then FrontPage will use Index Server instead of the WAIS search engine. Web servers other than IIS will always use the built-in WAIS search engine. The pros and cons of each engine are:

WAIS Index Server
Pro
  • Built-in to the FrontPage Server Extensions, so no additional configuration is required.
  • The text index is immediately updated whenever a page is saved, resulting in instant feedback in search forms when authoring and testing webs.
  • Improved performance because the background indexing system does not require that the text index be updated when each page is saved.
  • A rich set of page attributes are indexed and displayable in the search result pages.
  • A large degree of flexibility when configuring what content is to be included into a text index.
  • Indexing of Microsoft Office documents.
Con
  • The text index is immediately updated whenever a page is saved, which can cause a noticeable delay when saving pages.
  • The web must be recalculated whenever documents in the web are deleted in order to flush those documents from the text index.
  • No indexing of Microsoft Office documents.
  • Separate installation is required, and Index Server only works with Microsoft Internet Information Server.
  • A separate configuration step is required for each virtual server.
  • There is no immediate update of the text index, because Index Server uses a background indexing system. The lag between saving a page and when changes to the page's contents become searchable can be confusing to web authors.

If you want to avoid using the FrontPage Search Form, you may design a custom form linked to an .idq file in a directory other than _vti_bin to customize the query.

The catalog can be updated from the Index Server Administration page by performing an incremental directory scan and merging the index. The scan and merge operations are performed automatically as defined by the registry entries ForcedNetPathScanInterval and MasterMergeTime. The default interval for ForcedNetPathScanInterval is 120 minutes and the default for MasterMergeTime is 0:00.

Recalculating FrontPage Webs

The FrontPage Explorer's Tools menu includes a Recalculate Hyperlinks command that FrontPage authors can use to rebuild the internal map of hyperlinks between pages maintained by FrontPage. Recalculate Hyperlinks is a CPU-intensive command because it must reparse every page in the FrontPage web. This command is not normally necessary during FrontPage Web authoring, because the hyperlink map maintained by FrontPage is kept up-to-date in the background as authors create and save pages through the FrontPage client applications. However, if authors move or rename pages in a FrontPage web using a mechanism outside of FrontPage, such as FTP, the Windows Explorer, or UNIX file system commands, you can instruct them to use the Recalculate Hyperlinks command to repair the hyperlink map.

If an author is using a WAIS index, Recalculate Hyperlinks is useful to force the WAIS index to be rebuilt. This may be necessary when words are deleted from pages or when pages are deleted from a FrontPage web.

Recalculate Hyperlinks does the following:

  • Reparses all pages in the FrontPage web to rebuild the hyperlink map of the web.
  • Forces updating of the WAIS text index and flushes deleted documents from the index.
  • Expands FrontPage components such as the Include Page component and the Table of Contents.
  • Reapplies FrontPage themes to pages.
  • Re-applies shared borders to pages.
  • Updates the FrontPage web's meta-information.
  • Re-synchronizes Microsoft Visual SourceSafe status.

Setting Up Your E-mail Transport

In Frontpage 98, authors can configure a form to send the form's contents as an e-mail message. In order to send e-mail from the Web server on which the form is stored, you must configure the FrontPage Server Extensions to deliver the e-mail to an e-mail transport.

You configure the FrontPage Server Extensions in the FrontPage Server Extensions configuration file. See UNIX Configuration File Settings or frontpg.ini File Settings.

FrontPage supplies five configuration variables for setting up your e-mail transport: SMTPHost, SendMailCommand, MailSender, MailCharSet, and MailEncoding. You set either SMTPHost or SendmailCommand but not both.

  • SMTPHost

This parameter should be set to the name or IP address of a host running an SMTP server or daemon, such as sendmail on UNIX. When a user submits a form whose results are to be sent via e-mail, the FrontPage Server Extensions connect to the SMTP server to deliver the mail. By default FrontPage assumes the server is listening on port 25 (the standard for SMTP) but you can override this by appending ":xx" to the name, where the xx is the port to use. Examples:

SMTPHost=mail.example.microsoft.com
SMTPHost=test:10000
SMTPHost=127.0.0.1

  • SendMailCommand

This parameter should be set to the name of a program on the server machine to which e-mail should be piped. Typically this will be sendmail on UNIX, but it could be any program. When the FrontPage Server Extensions receive a form processed as an e-mail message, the Server Extensions invoke the command, replacing all occurrences of "%r" with the recipient of the mail. The per cent sign character followed by any other character is replaced by that character. The mail message is passed to the command as standard input. If both SendMailCommand and SMTPHost are set, SendmailCommand takes priority. Example:

SendmailCommand:/usr/lib/sendmail %r
  • MailSender

This parameter should be set to the user name to use as the "from" account when sending e-mail. Specifically, it is used as the argument to the "SEND FROM:" command in SMTP. The default for SMTP is "user@host", where "user" is the current user account and "host" is the current host name.

  • MailCharSet

This parameter can be used to override the character set attribute of the content-type header.

  • MailEncoding

This parameter can be used to override the content transfer encoding attribute of the content-type header.

Microsoft Visual SourceSafe 5.0 Integration

Microsoft Visual SourceSafe is a version control system for team development of software applications, Web sites, publications, and any other projects that benefit from version control. Version control systems track and store changes to each file so that users can view the file's history. A Visual SourceSafe project is a collection of files you store in Visual SourceSafe. Organizing your files in a Visual SourceSafe project is similar to organizing files in directories.

FrontPage 97 and FrontPage 98 webs can be integrated with Microsoft Visual SourceSafe version 5.0. This allows the FrontPage web administrator to synchronize a FrontPage web with a Visual SourceSafe project.

FrontPage/Visual SourceSafe integration is available on all FrontPage-supported Web servers on Microsoft Windows NT Server 4.0 or higher, Microsoft Windows NT Workstation 4.0 or higher, and Microsoft Windows 95. The Microsoft Personal Web Server requires the Windows 95 Distributed Component Object Model (DCOM) update to work with Visual SourceSafe.

To configure Visual SourceSafe and FrontPage for integration, use the following procedures:

  • Installing Microsoft Visual SourceSafe for Use with FrontPage
  • Configuring Microsoft Visual SourceSafe for Use with FrontPage
  • Synchronizing a FrontPage Web with a Visual SourceSafe Project

Once a FrontPage web is synchronized with a Visual SourceSafe project, a FrontPage author or administrator can use the Visual SourceSafe Check Out, Check In, and Undo Check Out commands from the FrontPage Explorer's Edit menu or shortcut menu. All files in the FrontPage web will be stored and tracked in the Visual SourceSafe database.

Many FrontPage web operations cause the FrontPage Server Extensions to move, delete, or check pages in and out of the Visual SourceSafe project that is synchronized with the web. The following table describes FrontPage Server Extensions actions for common FrontPage web operations:

If you ... | The FrontPage Server Extensions ... | Notes
Edit and save a page that has not been checked out | Check the page out, update it, and check it back into the Visual SourceSafe database. |
Move a file | Move the file in the Visual SourceSafe database, then check out every page in the web that contains a hyperlink to the moved file, update all hyperlinks to it, and check every page back in. | If a page containing a hyperlink to the moved file is already checked out, FrontPage will not let you move the file.
Rename a file | Rename the file in the Visual SourceSafe database, then prompt you to check out every page in the web that contains a hyperlink to the moved file, update all hyperlinks to it, and check every page back in. | If a page containing a hyperlink to the renamed file is already checked out, FrontPage will not let you rename the file.
Delete a file | Delete the file in the Visual SourceSafe database. | You cannot delete a file that is checked out.
Import a file | If the file is new, check the file into the Visual SourceSafe database. If the file already exists in the FrontPage web, check the file out, update it, and check it back into the Visual SourceSafe database. |
Create a new page | Check the page into the Visual SourceSafe database. |
Edit and save a page or image that is included in other pages | Try to check out every page in the web that includes the page or image, update all pages, and check every page back in. | If a page that includes the page or image is checked out it will be skipped. To update all pages, have all authors check in all pages, then use the Recalculate Hyperlinks command.
Apply a theme to a FrontPage web. | Try to check out every page in the web that uses the default web theme, update all pages, and check every page back in. | If a page that uses the default theme is checked out it will be skipped. To update all pages, have all authors check in all pages, then reapply the theme to the FrontPage web.
Edit and save a shared border | Try to check out every page in the web that contains the shared border, update all pages, and check every page back in. | If a page that uses the shared border is checked out it will be skipped. To update all pages, have all authors check in all pages, then remove and reapply the shared borders to the FrontPage web using the FrontPage Explorer's Shared Borders command.

Installing Microsoft Visual SourceSafe for Use with FrontPage

To use Visual SourceSafe Integration with FrontPage you must choose the Enable SourceSafe Integration feature of the Visual SourceSafe setup:

  1. Run the Visual SourceSafe installation program setup.exe from the Microsoft Visual SourceSafe 5.0 CD-Rom.
  2. Select the Custom installation option.
  3. In the Microsoft Visual SourceSafe 5.0 - Custom dialog box, select the Enable SourceSafe Integration option.
  4. Select Continue.

    Visual SourceSafe will be installed.

Configuring Microsoft Visual SourceSafe for Use with FrontPage

Visual SourceSafe 5.0 includes an Administrator application that you use to set up and configure user accounts for use in Visual SourceSafe 5.0 projects. The Visual SourceSafe Administrator is available on the Start menu as Visual SourceSafe 5.0 Admin.

To enable Visual SourceSafe Integration with FrontPage, you must add the following user accounts using the Visual SourceSafe Administrator:

Groups/Users | Permissions
All FrontPage Administrator groups or users | read-write
All FrontPage Author groups or users | read-write
The Internet guest account (Internet Information Server or Peer Web Server only) | read
The account under which the Web server is running (other Windows Web servers)

To add a user account in the Visual SourceSafe Administrator:

  1. Run the Visual SourceSafe Administrator.
  2. From the Users menu, choose Add User.
  3. In the Add User dialog box, type the user name in the User Name field, and leave the Password field blank.
  4. Click OK.

Synchronizing a FrontPage Web with a Visual SourceSafe Project

Once you have installed Visual SourceSafe 5.0 and established the user and group accounts that will have permissions to use the Visual SourceSafe project, you must synchronize the Visual SourceSafe project with your FrontPage web.:

  1. In the FrontPage Explorer, open the FrontPage web for which you want to create a Visual SourceSafe project.
  2. In the Tools menu, select Web Settings.
  3. In the Source Control Project field of the Configuration tab, type "$/" followed by a project name, as in "$/rootweb".
  4. Click Apply.

    If the project does not already exist in Visual SourceSafe, it is created and all files in the FrontPage web are checked in. If the project already exists, the FrontPage web and the project are merged. Any file in the FrontPage web that is in an ambiguous state (such as a file that has the same name as a file in the Visual SourceSafe project but that was never in the SourceSafe repository) remains checked out.

  5. You are prompted to recalculate the hyperlinks for the FrontPage web. Click Yes.

    After the recalculation, the FrontPage Explorer will reload the web. All items under Visual SourceSafe control will be displayed with a green dot (checked in) or a red checkmark (checked out).

The admin.pl Utility

admin.pl -operation <install> [-port <nnnn>] [-type <servertype>]
    [-web <webname>] [-servconf <server config file>]
    [-multihost <hostname> -username <username> [-password <password>]
    [ -createuser <true|false>] [-groups <grouplist>]
    [-localgroups <localgrouplist>] [-wwwroot <wwwfolder>]
    [-ftproot <ftpfolder>] [-ftprw <rw>]

The admin.pl utility has been created to make it easy for Internet Service Providers to add new FrontPage user accounts quickly. It is a PERL process automation script that creates a new user account on a host Windows NT machine running IIS 2,0 or 3.0, creates a new document root and virtual Web server or FTP server on the host machine, and then installs the FrontPage Server Extensions on the virtual server. You must have the PERL interpreter perl.exe installed on your PC to use admin.pl. admin.pl is installed by default in C:\Program Files\Microsoft FrontPage\version3.0\bin.The admin.pl utility is only provided for Windows machines. There is no UNIX version of this utility.

Admin.pl calls the following NT system and FrontPage utilities:

  • The Windows NT net utility, to create new system user accounts and add them to groups
  • The FrontPage iisadmin utility, to create virtual World Wide Web or FTP servers
  • The FrontPage fpsrvadm utility, to install the FrontPage Server Extensions on the virtual World Wide Web server

You may be prompted by one or more of these utilities for missing arguments.

Admin.pl supports a single operation: Install. When you invoke admin.pl, you supply the Install operation and a set of command line options in the form -option <value>:

Option

Specifies …

Values

-port | A port number | An integer. The default value is 80.
-type The Web server type msiis (Microsoft Internet Information Server)
mspws (Microsoft Personal Web Server)
frontpage
netscape-communicator
netscape-commerce
netscape-enterprise
netscape-fastrack
website

The default value is msiis.

-web A FrontPage web name The URL of a directory, relative to the root of the content area, such as
/mydirectory
-servconf A Web server configuration file The full pathname of the server configuration file.
-multihost A domain name or IP address to map to the virtual server. An IP address, such as
123.12.12.12, or a domain name, such as sample.microsoft.com.
If the value is not specified and the service is www all IP addresses registered on the server machine are mapped to the virtual server
-username | The user name to create. | A legal user account name.
-password | The password for the new user account. | A legal password
-createuser Specifies to create a new system user account using the username and password options. true or false

Default value is false.

-groups | Global groups to add the new user account to. | A comma-separated list of global groups.
-localgroups | Local groups to add the new user account to. | A comma-separated list of local groups.
-wwwroot The directory to map as a World Wide Web virtual server. If this option is specified, a World Wide Web service is created. A directory, such as

C:\www_content

Note that FrontPage does not recognize UNC directories of the form

\\mymachine\directory.

-ftproot A directory to map as an FTP virtual server. If this option is specified, an FTP service is created. A directory, such as

C:\ftp_content

-ftprw Specifies whether the FTP service will allow read-access, write-access, or both. w for write-access
r for read-access
rw for read-write-access

Default value is r.

Examples:

  • To create a World Wide Web virtual server

    This example creates the NT user "adminaccount," creates an IIS virtual World Wide Web server with an IP address 157.54.64.98, and installs a FrontPage 98 root web on this virtual server:

    <Perl Root>\perl.exe admin.pl -operation install -port 80 -username adminaccount -password adminpassword -multihost sample.microsoft.com -createuser true -wwwroot c:\InetPub\wwwroot98

  • To create an FTP virtual server

    This example creates the NT user "adminaccount," creates an IIS virtual World Wide Web and a read-only FTP server with an IP address 157.54.64.98, and installs a FrontPage 98 root web on this virtual server:

    <Perl Root>\perl.exe admin.pl -operation install -port 80 -username adminaccount -password adminpassword -multihost sample.microsoft.com -createuser true -wwwroot c:\InetPub\wwwroot98 -ftproot c:\InetPub\wwwroot98\ftp -ftprw r


Server Extensions Resource Kit Troubleshooting Guide

Overview

This chapter of the Server Extensions Resource Kit helps you understand common error messages associated with the FrontPage Server Extensions. It is divided into two sections, NT issues and UNIX issues.

Many of the error messages that are listed in this chapter can occur in many ways. This chapter attempts to identify the most common causes of each error message. In many cases, when FrontPage returns a standard HTML error, the recommended action is to check the error log files of your server. These log files will often have enough detailed information to identify the problem.

Common FrontPage Server Extensions Error Messages and Questions on Windows NT

Installing

IIS – Unknown Server "MSIIS"

Opening a web

NTLM authentication failed
NTLM authentication failed, because you are connecting to the server via a proxy server...
IIS - Can open web without Username/Password prompt
IIS – Cannot open web, Username/Password prompt continually displayed.
Server error: Web Server busy. Please try again.
There is no server on Port 80 at ‘server_name’.
Netscape – Can open web without Username/Password prompt

Publishing a web

Using FTP instead of Publish FrontPage Web

Http Errors

HTTP 500 error
HTTP 501 error

FAQ’s – NT

Are there any considerations when FTPing to my FrontPage web?

Common FrontPage Server Extensions Error Messages and Questions on UNIX

Installing

Server error: Cannot open file "usr/local/directory_name/service.lck" for writing.
Server error: Cannot open file "usr/local/directory_name/config/magnus.lck" for writing.

Opening a web

Netscape – Web opens without username/password prompt
Apache - Can open web without username/password
The server could not complete your request. For more information on the message from the server, click Details.
Cannot open file "/usr/local/frontpage/we80.cnf" for reading.
Server Error The server encountered an internal error or misconfiguration

Publishing a web

The server "server_name" timed out.
Cannot add task named task_name to the task list on the server.

Administrating a web

Server error: Cannot open file "document_root_path/_vti_pvt/service.pwd"

Browsing a web

Netscape – Cannot restrict browse access

Http Errors

HTTP 403 Error
HTTP 404 Error
HTTP 500 Error
HTTP 501 Error
HTTP 502 Error

FAQ’s – UNIX

Using FTP instead of Publish FrontPage Web
I am running FreeBSD on my server and am running into problems.

Common FrontPage Server Extensions Error Messages and Questions on Windows NT

Installing

IIS – Unknown Server "MSIIS", or IIS is not listed in Server type dropdown box

This error message may be caused by a missing or out of date file:

c:\Program Files\Microsoft FrontPage\version3.0\servsupp\fp30msft.dll

Check for the presence and date of this file. Reinstall the FrontPage Server Extensions from the FrontPage 98 CD-ROM if the date is older than the other DLLs in the ../version3.0/servsupp directory.

Opening a Web

NTLM authentication failed

Outside of your LAN, your users will need to specify the name of the domain along with their user names, as in mydomain\myuserame. This will indicate that the Web server should use the account on the Primary Domain Controller (PDC) instead of looking for a local account.

NTLM authentication failed, because you are connecting to the server via a proxy server, and NTLM authentication does not work in this case. You should either disable NTLM authentication for this server, or if the proxy server is unnecessary, add the server to the List of Hosts without proxies in the Tools/Options dialog.

If NTLM is enabled and you are attempting to access a FrontPage web through a proxy server or firewall, you will be unable to access the web. To gain access, the Password Authentication setting should be set to Basic (Clear Text) in the Internet Service Manager. If some users who are accessing the web require NTLM and are not using a proxy server, select NTLM in addition to Basic authentication. FrontPage will attempt to connect using NTLM authentication and then degrade to using Basic authentication when necessary.

IIS - Can open web without Username/Password prompt

If a FrontPage Web can be accessed without being prompted for a username and password, consider the following:

  • If you are using NT Challenge/Response and are already logged into your machine as an administrator, FrontPage will automatically use your same password. To troubleshoot if this is the case, try to open a FrontPage Web from a client PC. You should now be prompted with the username/password dialog box.
  • The IUSR_Machine_Name or INTERACTIVE account may have been given rx permission to the _vti_bin/_vti_aut directory. If you have applied this high a level of permissions to the subdirectories of _vti_bin, FrontPage Explorer will never prompt you to identify yourself when you log on, and the logon account will be regarded as the Internet guest. If this is the case, remove permissions for all but the author and administrator groups.
  • If you are running on a FAT file system, you will not be able to limit access to your FrontPage web. Anyone using the FrontPage client will be able to access your web. You need to re-install IIS on an NTLM partition.

IIS – Cannot open web, Username/Password prompt continually displayed.

This error message can be caused by one of the following:

  • You are using an incorrect username/password combination
  • There is a file/directory permissions problem. If this is a file/directory permissions problem, perhaps the account doesn't have rx permission to the _vti_aut or _vti_adm directory (depending on whether you are prompted for authoring permissions or administrator permissions).
  • If this is a new NT user account, make sure that in the User Properties of the NT User Manager, the "User Must Change Password at Next Logon" option is not checked.

Server error: Web Server busy. Please try again.

The user account does not have rwxd permission to the _vti_pvt directory of the corresponding web; specifically, the user doesn't have access to the Service.lck file

There is no server on Port 80 at ‘server_name’.

This error message indicates that the Web server at this site is not running.

Netscape – Can open web without Username/Password prompt

For the Netscape server, this error message is usually caused by access control not being set correctly. In the Netscape Server Administrator, configure per-directory configuration files (for access control) according to the parameters listed below:

  1. Infer base directory from URL
  2. File name = ".nsconfig"
  3. Search subdirectories for configuration files

Publishing a web

Using FTP instead of Publish FrontPage Web

Http Errors

If you receive an http error message with a status code, it is important to note that the codes are industry standards and are specified in the HTML 3.2 specification. 400 series messages indicate that the problem originates on the client while 500 series messages indicate that the problem originates on the server.

500 - Server Error This server has encountered an internal error which prevents it from fulfilling your request. The most likely cause is a misconfiguration. Please ask the administrator to look for messages in the server's error log.

Possible corrections:

  • Convert the default server to a virtual server in the Internet Service Manager. You can determine if the server is virtual in the FrontPage Server Administrator. If the default server shows just the port numbers (80 and 443) and not the TCP/IP address, it is not virtual.

    To correct this problem, uninstall the Server Extensions from the default server only. Next run IIS Internet Service Manager and, under the Directories tab, select the directory for the default service. Select Edit Properties, mark the Virtual Server box, supply the proper TCP/IP address and click Apply. Next, stop and restart your server and reinstall the FrontPage Server Extensions on the new virtual server.

  • Also see: http://www.microsoft.com/kb/articles/q143/0/97.htm

501 - HTTP/1.0 501 Not Supported

This error message indicates that the target server does not have the FrontPage Server Extensions installed. On the server, use the FrontPage Server Administrator to install the Server Extensions.

This error can also occur when attempting to run a CGI script. If this is the case, the 501 error will be Unsupported. Make sure that the CGI-bin directory is marked as Executable in the FrontPage Explorer’s Directory Properties dialog box.

Common FrontPage Server Extensions Error Messages and Questions on UNIX

Installing

Server error: Cannot open file "usr/local/directory_name/service.lck" for writing.
Server error: Cannot open file "usr/local/directory_name/config/magnus.lck" for writing.

During installation of the Server Extensions, FrontPage attempts to create a zero byte lock file (.lck) in the named directory so that no changes can be made by other users or programs on the system. When the installation program cannot open this file, it is usually because the lock file has not been successfully created. This can happen because the permissions for the directory prevent the installation program from writing to that directory. For a listing of the correct permissions for this directory, see Files and Permissions for UNIX Web Servers.

Opening a web

Netscape – Web opens without username/password prompt

On a Netscape server, this error message usually indicates that access control is not set correctly. In the Netscape Server Administrator, configure per-directory configuration files (for access control) according to the parameters listed below:

  1. Infer base directory from URL
  2. File name = ".nsconfig"
  3. Search subdirectories for configuration files

Apache – Web opens without username/password prompt

This error message is usually caused by setting the AllowOverride directive to None in the access.conf file. Setting this parameter to All will alleviate this problem.

The server could not complete your request. For more information on the message from the server, click Details

The following messages may accompany the above error message in the Detail section.

msg=Cannot open file "/usr/local/frontpage/we80.cnf" for reading.
osmsg=Permission denied

The we80.cnf file (or domain_name:port_number.cnf) is a configuration file that is created by FrontPage during the installation of the FrontPage Server Extensions. Check the permissions assigned to this file and make sure they match those listed in Files and Permissions for UNIX Web Servers.

msg=Cannot open file "/usr/local/frontpage/we80.cnf" for reading.
osmsg=No such file or directory.

If the file we80.cnf, (or domain_name:port_number.cnf) does not exist in the "/usr/local/frontpage" directory, re-install the FrontPage Server Extensions for the domain in question.

Server Error The server encountered an internal error or misconfiguration and was unable to complete your request. Please contact the server administrator, admin@my_isp.com and inform them of the time the error occurred, and anything you might have done that may have caused the error.

For the error messages listed above, check the error log file of the Web server. The following error message may be found there:

Access to /content_directory/_vti_bin/shtml.exe failed for hostname, reason: Premature end of script headers

This error message indicates that although the FrontPage Server Extension file, shtml.exe was found on the server, it did not contain the expected code. This can be caused by having the stub executable file incorrectly installed in the /usr/local/frontpage/version3.0/exes directory instead of the actual CGI file. Since the size of the actual CGI files are approximately 2M, make sure that:

  • The CGI files are of the correct size in the ../version3.0/exes directory.
  • The stub executable in the content directory points to the correct location of the CGI files. Running the "strings" function will display the text code in the stub executable.

Publishing a web

The server "server_name" timed out. The current request did not complete successfully.

This error message usually indicates that you should increase the timeout parameter in the server’s configuration file.

Cannot add task named task_name to the task list on the server.

This error message usually indicates that FrontPage does not have sufficient privileges to write to document_root /_vti_pvt directory.

You may use the Check option in the fpsrvadm.exe file for a fuller diagnosis of the problem. Also, for a complete file permissions listing, see Files and Permissions for UNIX Web Servers.

Administrating a web

Server error: Cannot open file "document_root_path/_vti_pvt/service.pwd"

This error may be encountered when attempting to add/modify permissions for an open web. Check the file permissions for this file and make sure that the owner has RW access, and that the FrontPage CGI programs (shtml.exe, admin.exe, author.exe) are SUID’ed and owned by the same UNIX owner. The default permissions for this file are 644. See Files and Permissions for UNIX Web Servers for a complete listing of file permissions.

Browsing a web

Netscape – Cannot restrict browse access

Netscape maintains end-user databases as an optional feature. Even if you create a database of registered end users as per instructions from Netscape, using a FrontPage Registration form handler is not supported on these servers, because Netscape servers will incorrectly give registered end users authoring access to the web.

Http Errors

If you receive an http error message with a status code, it is important to note that the codes are industry standards and are specified in the HTML 3.2 specification. 400 series messages indicate that the problem originates on the client while 500 series messages indicate that the problem originates on the server.

403 – Forbidden

This error message indicates that you do not have permissions to access this directory. This message can also occur when browsing to a site that does not contain a home page.

404 – The proxy server has encountered an error (Host was not found).

This error message indicates that the requested URL cannot be located by your Domain Name Service (DNS). Try to access the URL from your browser to confirm that the site is up and running. If you connect successfully, try connecting from the FrontPage Explorer again. If you still receive a 404 error, this probably indicates that the server does not have the FrontPage Server Extensions installed.

500 - Server Error This server has encountered an internal error which prevents it from fulfilling your request. The most likely cause is a misconfiguration. Please ask the administrator to look for messages in the server's error log.

This error message may be caused in many ways. The FrontPage client cannot diagnose the problem beyond the information that the server has sent. To investigate further, check the Web server’s error logs. Frequently this error message indicates permissions issues, timeout problems or that the server is running out of disk space.

501 - HTTP/1.0 501 Not Supported

This error message indicates that the target server does not have the FrontPage Server Extensions installed. On the server, use the FrontPage Server Administrator to install the Server Extensions.

502 - An error occurred in the web server that made it impossible for the FrontPage Server Extensions to process this request. (HTTP Error 502)

This error message indicates that the Web Server, while acting as a gateway or proxy, received an invalid response from the upstream server it accessed in attempting to fulfill the request. This is usually caused by permissions problems. Check the server’s error logs for detailed information.

FAQ’s – UNIX

When using FTP to transfer FrontPage Web files to the server, which files should not be transferred?

FrontPage’s Publish command utilizes HTTP to communicate with the web server. The command will not transfer the local FrontPage Server Extension files to the target server. When using an FTP application, it is important to transfer only the content files from the originating web server. Do not FTP any _vti _* directories. If these directories or files are transferred, they will overwrite the existing files on the target server. FrontPage Server Extensions should only be installed using the FrontPage Server Administrator utility on the host server or remotely using the HTML Administration Forms.

I am running FreeBSD on my server and am running into problems.

FrontPage has Server Extensions support for the BSDi operating system, however we do not officially support FreeBSD. The server extensions on FreeBSD have not undergone extensive testing at Microsoft therefore we cannot provide assistance regarding these issues.


Appendices

UNIX Server Information

  • Files and Permissions for UNIX Web Servers
  • List of UNIX Configuration File Settings
  • Source code for FrontPage Apache module and fpexe program

Windows NT and Internet Information Server (IIS) Information

  • Files and Permissions for Windows NT and Internet Information Server (IIS)
  • List of FRONTPG.INI Settings

Miscellaneous

  • List of FrontPage Components (formerly known as FrontPage WebBot Components)
  • List of special directories and storage locations in FrontPage webs


List of FrontPage WebBot Components

FrontPage components are built-in FrontPage objects that are evaluated and executed when an author saves a page or, in some cases, when a user browses to the page. FrontPage components generate HTML, or, in some cases, client-side or server-side script code. Using the FrontPage SDK (available on the FrontPage 98 CD-ROM) users can add their own FrontPage components.

Run-time components expand dynamically when the page containing the component is fetched by a browser, or for Form handler components when a form is submitted. This is similar to a CGI script running on the server. Authoring-time components expand only when the page is saved, and not when the page is fetched by a browser.

Component | Type | Purpose
Banner Ad Manager | Authoring-time | Allows images to be automatically displayed and rotated in sequence. Users can click the images to follow a hyperlink.
Comment | Authoring-time | Text that authors can view in the FrontPage Editor but that will not be displayed by a Web browser, similarly to "hidden text" in a word processor. Comment text appears purple in the FrontPage Editor and retains the character-size and other attributes of the current paragraph style. Comments are particularly useful for instructions embedded in templates.
Confirmation Field | Run-time | Includes the values of fields in a form on the form’s confirmation page.
Default Form Handler (also called Save Results component) | Run-time | Appends the contents of a form to a file on the server in any of eight formats (suitable for importing into databases, feeding into a mail merge with Microsoft Word, viewing in a text editor, viewing in a web browser, etc.). This form handler can also be configured to e-mail the form’s contents.
Discussion | Run-time | Creates a threaded discussion group.
Hit Counter | Run-time | Monitors and displays the number of visits a page has received.
Hover Button | Authoring-time | A button on a Web page that contains an animation that is activated when the mouse moves over the button or is clicked on the button.
Include Page | Authoring-time | Replaced with the contents of a page in the FrontPage web. If the included page changes, it is re-included. Note that the Include Page component is not the same as a server-side include. Server-side includes dynamically include pages when the page is fetched. The Include Page Component only updates the included data when the page is saved.
Insert HTML | Authoring-time | Allows the author to enter (and preserve) HTML tags. Useful for inserting tags that are not recognized by the FrontPage Editor.
Marquee | Authoring-time | Creates a horizontal scrolling text window.
Page Banner | Authoring-time | Creates a banner across the page with the page’s title. Text or images are used, based on the FrontPage theme selected for the web.
Registration | Run-time | Allows end-users to add themselves to the list of users permitted to browse a protected web by registering a username and password.
Scheduled Image | Authoring-time | Similar to the Scheduled Include FrontPage component, except that only an image is included.
Scheduled Include | Authoring-time | Similar to an Include Page component, but the inclusion is only effective during a specified time period, before and after which the inclusion is automatically disabled (or, optionally, a different page is included).
Search | Run-time | Performs a full-text search over all pages in a web, or over all messages in a discussion group.
Substitution | Authoring-time | Performs macro substitutions, allowing the values of data items (such as a company’s address) to be centralized for easy updating.
Table of Contents | Authoring-time | Displays a complete outline of all pages in a web, and optionally updates that outline whenever any page is added, deleted, or renamed within the web.
Timestamp | Authoring-time | Indicates when a page was last edited by an author or (optionally) when it was last automatically updated, in various date and time formats.


Source Code for fpexe Program

fpexe.c

/* ====================================================================
 *
 * FrontPage SUID Stub Executable
 *
 * Copyright (c) 1995-1997 Microsoft Corporation -- All Rights Reserved.
 *
 * NO WARRANTIES. Microsoft expressly disclaims any warranty for this code and
 * information. This code and information and any related documentation is
 * provided "as is" without warranty of any kind, either express or implied,
 * including, without limitation, the implied warranties or merchantability,
 * fitness for a particular purpose, or noninfringement. The entire risk
 * arising out of use or performance of this code and information remains with
 * you.
 *
 * NO LIABILITY FOR DAMAGES. In no event shall Microsoft or its suppliers be
 * liable for any damages whatsoever (including, without limitation, damages
 * for loss of business profits, business interruption, loss of business
 * information, or any other pecuniary loss) arising out of the use of or
 * inability to use this Microsoft product, even if Microsoft has been advised
 * of the possibility of such damages. Because some states/jurisdictions do not
 * allow the exclusion or limitation of liability for consequential or
 * incidental damages, the above limitation may not apply to you.
 *
 * Version 1.2
 */

/*
 * User configurable items.  We will not run the server extensions with any
 * UID/GID less than LOWEST_VALID_UID/LOWEST_VALID_GID.
 */

#if defined(LINUX)
#define LOWEST_VALID_UID 15
#else
#define LOWEST_VALID_UID 11
#endif

#if defined(HPUX) || defined(IRIX) || defined(SUNOS4)
#define LOWEST_VALID_GID 20
#else
#if defined(SCO)
#define LOWEST_VALID_GID 24
#else
#define LOWEST_VALID_GID 21   /* Solaris, AIX, Alpha, Bsdi, etc. */
#endif
#endif

#define CLEAN_PATH "PATH=/usr/bin:/bin"

static struct SaveEnvVars
{
    const char* szVar;
    int         iLen;
} gSafeEnvVars[] =
{
    { "AUTH_TYPE=", 0 },
    { "CONTENT_LENGTH=", 0 },
    { "CONTENT_TYPE=", 0 },
    { "DATE_GMT=", 0 },
    { "DATE_LOCAL=", 0 },
    { "DOCUMENT_NAME=", 0 },
    { "DOCUMENT_PATH_INFO=", 0 },
    { "DOCUMENT_ROOT=", 0 },
    { "DOCUMENT_URI=", 0 },
    { "FILEPATH_INFO=", 0 },
    { "GATEWAY_INTERFACE=", 0 },
    { "HTTP_", 0 },
    { "LAST_MODIFIED=", 0 },
    { "PATH_INFO=", 0 },
    { "PATH_TRANSLATED=", 0 },
    { "QUERY_STRING=", 0 },
    { "QUERY_STRING_UNESCAPED=", 0 },
    { "REDIRECT_QUERY_STRING=", 0 },
    { "REDIRECT_STATUS=", 0 },
    { "REDIRECT_URL=", 0 },
    { "REMOTE_ADDR=", 0 },
    { "REMOTE_HOST=", 0 },
    { "REMOTE_IDENT=", 0 },
    { "REMOTE_PORT=", 0 },
    { "REMOTE_USER=", 0 },
    { "REQUEST_METHOD=", 0 },
    { "SCRIPT_FILENAME=", 0 },
    { "SCRIPT_NAME=", 0 },
    { "SCRIPT_URI=", 0 },
    { "SCRIPT_URL=", 0 },
    { "SERVER_ADMIN=", 0 },
    { "SERVER_NAME=", 0 },
    { "SERVER_PORT=", 0 },
    { "SERVER_PROTOCOL=", 0 },
    { "SERVER_SOFTWARE=", 0 },
    { "TZ=", 0 },
    { "USER_NAME=", 0 },
    { 0, 0 }
};

/*
 * End of user configurable items
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <ctype.h>
#include <time.h>
#include <pwd.h>
#include <grp.h>
#if !defined(bsdi) && !defined(hpux) && !defined(sun) && !defined(linux) && !defined(SCO5)
#include <sys/mode.h>
#endif

extern char **environ;
extern int errno;

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef MAXPATHLEN
#define MAXPATHLEN 1024
#endif
#if (MAXPATHLEN < 1024)
#undef MAXPATHLEN
#define MAXPATHLEN 1024
#endif

#define KEYLEN 128                  /* Should be a multiple of sizeof(int) */

#define FPKEYDIR "/usr/local/frontpage/currentversion/apache-fp"
#define KEYFILE  "/usr/local/frontpage/currentversion/apache-fp/suidkey.%d"
#define FPDIR    "/usr/local/frontpage/currentversion/exes"

/* Legal modules */
#define SHTML    "/_vti_bin/shtml.exe"
#define FPCOUNT  "/_vti_bin/fpcount.exe"
#define AUTHOR   "/_vti_bin/_vti_aut/author.exe"
#define ADMIN    "/_vti_bin/_vti_adm/admin.exe"

/*
 * Something is not quite right - give up
 */
void die(const char *msg)
{
    char timebuf[26];
    time_t t = time(0);
    strcpy(timebuf, ctime(&t));
    timebuf[24] = '\0';
    fprintf(stderr, "[%s] %s\n", timebuf, msg);
    printf("Content-Type: text/html\n\n<HTML>*-*-* :-| :^| :-/ :-( 8-( *-*-*\n<ul>\n<li>status=1\n<li>osstatus=0\n<li>msg=FrontPage security violation.\n<li>osmsg=\n</ul>\n", msg);
    exit(0);
}

/*
 * Remove any variable that is not known to be a standard CGI or OS
 * environment variable.  Also, sanitizes the PATH.
 */
static void CleanEnvironment()
{
    char** pp;
    char** ppi;
    struct SaveEnvVars* pOkEnv;

    for (ppi = pp = environ;  *pp;  pp++)
    {
        /*
         * Inefficient linear lookup; could be improved with binary search.
         */
        for (pOkEnv = gSafeEnvVars;  pOkEnv->szVar;  pOkEnv++)
        {
            int iLen = pOkEnv->iLen;
            if (!iLen)
                pOkEnv->iLen = iLen = strlen(pOkEnv->szVar);

            if (strncmp(pOkEnv->szVar, *pp, iLen) == 0)
                break;
        }

        if (!strncmp(*pp, "PATH=", 5))
            *ppi++ = CLEAN_PATH;
        else if (pOkEnv->szVar)
            *ppi++ = *pp;
    }

    *ppi = 0;
}

void main(int argc, char **argv)
{
    struct passwd* pw;
    const char* szFpUserName;
    const char* szFpExe = getenv("FPEXE");
    const char* szFpUid = getenv("FPUID");
    const char* szFpGid = getenv("FPGID");
    const char* szFpFd  = getenv("FPFD");
    char* pEnd;
    char* pDir;
    uid_t iFpUid;
    uid_t iFpGid;
    uid_t iBinUid;
    int iFpFd;
    int iKeyFd;
    int iCount;
    char szKeyFile[MAXPATHLEN];
    char szWork[MAXPATHLEN];
    char inpKey[KEYLEN];
    char refKey[KEYLEN];
    struct stat fs;

    /*
     * Assure that this program was actually SUID'd to root
     */
    if (geteuid())
        /*
         * User recovery:  Make sure fpexe is setuid to root
         */
        die("FrontPage SUID Error: not running as root");

    /*
     * Assure that the user the web server runs as is a valid user
     */
    if (!getpwuid(getuid()))
        /*
         * User recovery:  Make sure that the web server user is in /etc/passwd
         */
        die("FrontPage SUID Error: invalid uid");

    /*
     * Assure that we have the proper arguments (passed in the environment)
     */
    if (!szFpExe || !szFpUid || !szFpGid || !szFpFd)
        /*
         * User recovery:  Make sure fpexe is run from patched Apache server
         */
        die("Frontpage SUID Error: invalid environment arguments");

    /*
     * Validate the arguments
     */
    if (strcmp(szFpExe, SHTML) != 0   &&
        strcmp(szFpExe, FPCOUNT) != 0 &&
        strcmp(szFpExe, AUTHOR) != 0  &&
        strcmp(szFpExe, ADMIN) != 0)
        /*
         * User recovery:  Make sure fpexe is only invoked to run FrontPage
         * server extension programs.
         */
        die("FrontPage SUID Error: target program violation");

    if (strlen(szFpExe) + strlen(FPDIR) + 1 > MAXPATHLEN)
        die("FrontPage SUID Error: path too long");
    strcpy(szWork, FPDIR);
    strcat(szWork, szFpExe);

    iFpUid = strtol(szFpUid, &pEnd, 10);
    if (!pEnd || *pEnd)
        iFpUid = 0;
    if (iFpUid < LOWEST_VALID_UID || !(pw = getpwuid(iFpUid)))
        /*
         * User recovery:  Make sure FrontPage user ids are above minimum
         */
        die("FrontPage SUID Error: invalid target uid");
    szFpUserName = strdup(pw->pw_name);

    iFpGid = strtol(szFpGid, &pEnd, 10);
    if (!pEnd || *pEnd)
        iFpGid = 0;
    if (iFpGid < LOWEST_VALID_GID || !getgrgid(iFpGid))
        /*
         * User recovery:  Make sure FrontPage group ids are above minimum
         */
        die("FrontPage SUID Error: invalid target gid");

    iFpFd = strtol(szFpFd, &pEnd, 10);
    if (!pEnd || *pEnd)
        iFpFd = -1;
    if (iFpFd < 0)
        /*
         * User recovery:  Make sure fpexe is run from patched Apache server
         */
        die("FrontPage SUID Error: invalid key file descriptor");

    /*
     * Read the key from our server.  And, while we're still root and have
     * access, read the key from the master key file.  Verify the key matches.
     */
    if (lstat(FPKEYDIR, &fs) == -1 ||
        (fs.st_mode & (S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH)) || fs.st_uid ||
        !(S_ISDIR(fs.st_mode)))
        /*
         * User recovery is: set directory to be owned by by root with
         * permissions rwx--x--x.
         */
        die("FrontPage SUID Error: key file directory is insecure");

    sprintf(szKeyFile, KEYFILE, (int)getpgrp());
    if (stat(szKeyFile, &fs) == -1 ||
        (fs.st_mode & (S_IRWXG | S_IRWXO)) || fs.st_uid)
        /*
         * User recovery is:  Make sure the key file is properly protected
         * (owned by root, permissions r**------), restart patched Apache
         * server.
         */
        die("FrontPage SUID Error: key file security violation");

    iKeyFd = open(szKeyFile, O_RDONLY);
    if (iKeyFd < 0)
        /*
         * User recovery is:  Make sure fpexe is run from patched Apache
         * server, restart the patched Apache server.
         */
        die("FrontPage SUID Error: could not open key file" );
    iCount = read(iKeyFd, refKey, sizeof(refKey));
    close(iKeyFd);
    if (iCount != sizeof(refKey))
        /*
         * User recovery is:  Make sure fpexe is run from patched Apache
         * server, restart the patched Apache server.
         */
        die("FrontPage SUID Error: could not read valid key from key file");

    iCount = read(iFpFd, inpKey, sizeof(inpKey));
    close(iFpFd);
    if (iCount != sizeof(inpKey))
        /*
         * User recovery is:  Make sure fpexe is run from patched Apache server
         */
        die("FrontPage SUID Error: could not read valid input key");

    if (memcmp(inpKey, refKey, sizeof(refKey)) != 0)
        /*
         * User recovery is:  Make sure fpexe is run from patched Apache server
         */
        die("FrontPage SUID Error: key security violation");

    /*
     * Change user and group IDs to be the indicated user
     */
    if (setgid(iFpGid) == -1 || initgroups(szFpUserName, iFpGid) == -1)
        /*
         * User recovery:  Make sure user is properly registered in
         * /etc/passwd and /etc/group.
         */
        die("FrontPage SUID Error: setgid() failed");

    if (setuid(iFpUid) == -1)
        /*
         * User recovery:  Make sure user is properly registered in
         * /etc/passwd.
         */
        die("FrontPage SUID Error: setuid() failed");

    /*
     * Validate the target directory.
     */
    iBinUid = 0;
    if (pw = getpwnam("bin"))
        iBinUid = pw->pw_uid;

    pDir = strrchr(szWork, '/');
    *pDir = 0;
    if (lstat(szWork, &fs) == -1 || (fs.st_mode & (S_IWGRP | S_IWOTH)) ||
                                    (fs.st_uid != iBinUid && fs.st_uid != 0) ||
                                    !(S_ISDIR(fs.st_mode)))
        /*
         * User recovery is: make sure FrontPage exe programs are available,
         * set directory to be owned by bin or root and have permissions
         * rwx*-x*-x.
         */
        die("FrontPage SUID Error: target directory not found or insecure");

    *pDir = '/';

    /*
     * Validate the target program
     */
    if (stat(szWork, &fs) == -1 || ((fs.st_mode & (S_IWGRP | S_IWOTH)) ||
                                    (fs.st_mode & (S_ISUID | S_ISGID)) ||
                                    (fs.st_uid != iBinUid && fs.st_uid != 0)))
        /*
         * User recovery is: make sure FrontPage exe programs are available,
         * set programs to be owned by bin or root and have permissions
         * rwx*-x*-x.
         */
        die("FrontPage SUID Error: target program not found or insecure");

    *pDir = '/';

    /*
     * Make sure the environment contains no unsafe values.
     */
    CleanEnvironment();

    /*
     * Run the specified program.
     */
    argv[0] = szWork;
    umask(022);
    execv(argv[0], argv);

    /*
     * We should never get here.  Exit with error.
     */
    exit(1);
}


List of FRONTPG.INI Settings

Configuring Server Extensions Parameters

Default Server Extensions Parameters

  • NoAbsoluteFileResults
  • NoServerFileResults

Other Security-related Server Extensions Parameters

  • NoExecutableCgiUpload
  • Logging
  • AllowExecutableScripts
  • AccessControl
  • RestrictIISUsersAndGroups

Additional Server Extension Configuration Parameters

  • ReformatHtml
  • UpperCaseTags
  • PreserveTagCase
  • TextMemory
  • NoIndexServer
  • SMTPHost
  • MailSender
  • SendMailCommand
  • MailCharSet
  • MailEncoding
  • CacheMaxDocMeta
  • CacheMaxInclude
  • CacheMaxImage

Parameters That Can Also Be Set in the FrontPage Explorer

  • NoClientImageMaps
  • ImageMapFormat
  • ImageMapURLPrefix
  • ScriptLanguage

Configuring Server Extensions Parameters

Some features of the FrontPage 98 Server Extensions can be controlled by setting parameters in the appropriate sections of the frontpg.ini file. The frontpg.ini is in the Windows NT directory. The appropriate sections for each virtual server are titled [Port <IPAddress>:<port>] for multihosted servers or just [Port <port>] for single-hosted servers, global settings are stored in the [FrontPage 3.0] section. The default setting in the software for each of these parameters is 0, unless otherwise noted. The parameter syntax is as follows: Parameter=value

For Example: Logging=1

Placing the parameter in the [FrontPage 3.0] section of the frontpg.ini will affect all ports and all web servers installed on that server. Placing the parameter in the [Port <IPAddress>:<port>] section will affect only that port.

Default Server Extensions Parameters

The FrontPage 98 Server Extensions install with the following parameters set as indicated. This default configuration minimizes the host server's vulnerability.

NoAbsoluteFileResults

Initial value after installation: 1. A value of 1 for this parameter forces the default (Save Results), Registration, and Discussion FrontPage form handling components write only to a file within the customer's web content area. It prevents these FrontPage Components from writing to an absolute file path.

NoServerFileResults

Initial value after installation: 1. A value of 1 for this parameter prevents the default (Save Results), Registration, and Discussion FrontPage form handling components from writing to the _vti_log directory in the customer's document root (Setting the NoServerFileResults parameter to zero can be useful to allow customers to save the output generated from the Save Results, Registration, and Discussion FrontPage Components to the _vti_log directory in the server's root web). As a security measure, the author.log file in the _vti_log directory records all authoring actions on the web when the Logging parameter is set (see below). The non-zero value for NoServerFileResults prevents an author from "covering his tracks" by overwriting or modifying the author.log file.

Other Security-related Server Extensions Parameters

The following web configuration parameters are not included in the default installation of the FrontPage 98 Server Extensions, but can be added by editing the Server Extensions configuration file. When set as indicated below, these options can increase the overall security of FrontPage.

NoExecutableCgiUpload

Initial value after installation: 0. When set to 1, authors cannot upload files to a directory marked executable, and cannot mark a directory executable. Setting this parameter to 1 completely prevents authors from uploading and executing Active Server Pages (ASP), Internet Database Connector Pages (IDC), PERL Scripts (PL), CGI scripts and ISAPI extensions. To only restrict authors ability to upload and execute CGI scripts and ISAPI extensions use the AllowExecutableScripts configuration parameter, below.

Logging

When set to a non-zero value, authoring operations are logged to _vti_log/author.log in the root web. Each operation is logged with the current time, the remote host, the author's user name, the name of the web, the operation performed, and per-operation data. In the event of a security breach, this log file can be analyzed for authoring activity on the customer's web. Default value = 0.

AllowExecutableScripts

When set to a non-zero value, FrontPage will set the executable bit on files within executable directories. So, when directories are marked as executable, all files within the directory will also be marked as executable. If authors are permitted to upload into executable directories (because the NoExecutableCgiUpload parameter, above, is zero), then by setting this parameter to a non-zero value, authors will be able to execute newly uploaded CGI scripts and ISAPI extensions because they will be marked as executable. If this parameter is zero and NoExecutableCgiUpload is also zero, authors will be able to upload and use ASP and IDC files but not CGI or ISAPI files.

AccessControl

When this parameter is set to zero, FrontPage AccessControl is completely disabled. In general this is not recommended. Turning off AccessControl requires that the access control on the _vti_bin directories be set manually whenever a sub-web is created. Until this is done, anyone can author against the web. The advantage to AccessControl is that a knowledgeable webmaster who has set custom access control permissions will not have work re-written by FrontPage. This also causes the FrontPage Explorer to disable the Permissions command on the FrontPage Explorer's Tools menu. Default = 1.

RestrictIISUsersAndGroups

This parameter enables user and group list restrictions, thereby preventing a FrontPage end user from seeing all NT accounts on the server. This parameter can be enabled globally or on a per-service basis, and restrictions can be overridden on a per-server basis. Setting the key to 1 enables restrictions. If the users and groups restrictions are enabled for a given service, the extenders look for an NT group named in the following format:

FP_ServiceName[_Subweb]

On a multihosted IIS2.0/3.0 machine ServiceName is the service's IP address and port number combination and _Subweb is the name of the sub-web. On a single-hosted machine, the ServiceName portion is simply the port number.

On IIS 4.0, ServiceName can be of the form /LM/W3SVC/<N>, where <N> is an instance number. This is the recommended method. On IIS 4.0, ServiceName can also be of the form <virtual_server>:<port_number>. If you use this form, you must use specify the virtual server's name; you cannot use the virtual server's IP address on IIS 4.0.

To specify a root web's restriction group, omit the _Subweb portion.

Examples:

FP_157.55.49.66:80_MySubweb

FP_80_MySubweb

FP_/LM/W3SVC/1_MySubweb

Restriction groups are global groups and are not restricted to be groups on the local machine.

Additional Server Extension Configuration Parameters

These Server Extension configuration parameters do not have an effect on the security of FrontPage, but are relevant to concerns that a Web presence provider may have.

ReformatHtml

Setting this parameter to "Y" or a non-zero value will cause the FrontPage 98 Server Extensions to reformat all HTML pages when they are uploaded to the web server. Setting a zero value for this parameter causes only pages with FrontPage Components to be reformatted. Default = "N"

UpperCaseTags

When set to "Y" or a non-zero value, converts all HTML tags to upper-case when the FrontPage 98 Server Extensions reformats HTML pages. Defaults to 0.

PreserveTagCase

When set to "Y" or a non-zero value, attempts to preserve the case of HTML tag attributes when the FrontPage 98 Server Extensions reformats HTML pages. Note that the tag itself will always be upper- or lower-case according to the UpperCaseTags attribute. Defaults to 0.

TextMemory

When set to zero, turns off full-text indexing of your webs. When set to a non-zero value, sets how many megabytes the text-indexing allocates for its hash-tables and other data structures. Defaults to 1.

NoIndexServer

Setting this parameter to 1 communicates to FrontPage that it should not use the IIS Index Server and that it should use the FreeWAIS search engine that is included in FrontPage 98. Default value = 0, indicating that if FrontPage detects the presence of the Index Server, it will use it as the search engine for this server.

SMTPHost

This parameter is set to the name or IP address of a host running an SMTP daemon, such as Exchange on NT. When a user submits a form whose results are to be sent via Email, the FrontPage Server Extensions connect to the SMTP daemon to deliver the mail. By default FrontPage assumes the daemon is listening on port 25 (the standard for SMTP) but you can override this by appending ":xx" to the name, where the xx is the port to use. Normally you will set either SMTPHost or SendmailCommand, but not both, because SendmailCommand takes priority over SMTPHost. Examples:

SMTPHost=mail.example.microsoft.com

SMTPHost=test:10000

SMTPHost=127.0.0.1

MailSender

This parameter sets the user name to use as the "from" account when sending Email. Specifically, it is used as the argument to the "SEND FROM:" command in SMTP. The default for SMTP is user@host, where "user" is the current user account and "host" is the current host name.

SendMailCommand

This parameter sets the name of a program to which Email should be piped. Typically this will be sendmail, but it could be any program. Before invoking the command, all occurrences of "%r" are replaced with the recipient of the mail. The per cent sign character followed by any other character is replaced by that character. Example:

SendmailCommand=/usr/lib/sendmail %r

MailCharSet

This parameter can be used to override the character set attribute of the content-type header.

MailEncoding

This parameter can be used to override the content transfer encoding attribute of the content-type header.

CacheMaxDocMeta

This integer parameter sets the maximum number of documents in the cache. The default value is 512 (files)

CacheMaxInclude

This integer parameter sets the size in MB of the include file cache. The default value is 16.

CacheMaxImage

This integer parameter sets the size in MB of the image file cache. The default value is 16.

Parameters That Can Also Be Set in the FrontPage Explorer

The following parameters can be set in the FrontPage Explorer under the Tools menu's Web Settings command in the Advanced tab. Using these parameters will set the defaults for the web, however these settings will not be updated in the FrontPage Explorer's user interface.

NoClientImageMaps

When this parameter is set to 1, it prevents FrontPage from generating HTML that supports client-side image map processing. By default, FrontPage can generate both client-side and server-side HTML by not setting this parameter and by selecting a server-side ImageMapFormat.

ImageMapFormat

This parameter sets the server image-map style. Valid parameters include: FrontPage, NCSA, CERN, Netscape, or <None>. If you select <None>, FrontPage will not generate HTML to support server-side image map processing.

ImageMapURLPrefix

This parameter sets the server-relative URL of the server-side handler for the selected image-map style. If style (ImageMapFormat) is FrontPage, server-side image maps are handled automatically. For other styles, provide the name and location of a handler.

ScriptLanguage

This parameter sets the scripting language for the scripts that are automatically generated to enforce any data validation settings you apply to form fields. Valid parameters include VBScript, JavaScript, or None.


Files and Permissions for Internet Information Server (IIS)

This appendix lists the detailed, minimum file permission settings that must be in place for FrontPage to perform as designed. Any reference to shtml.dll, author.dll, or admin.dll applies equally to their CGI counterparts: shtml.exe, author.exe, and admin.exe on IIS 1.x servers. FrontPage only edits ACLs, it never affects the permissions of any accounts not listed below on any files.

File Permissions Assigned by "Check Installation"

The FrontPage 98 Server Administrator (fpsrvwin.exe) has a "Check and Fix" button that can correct problems in NTFS permissions. The following is list of files shows the minimum permissions required for FrontPage. This feature will set the file permissions to those listed below but will not correct:

  • Incorrect permission on data (e.g. HTML files)
  • Permissions on the root of the content drive
  • Permissions that are too lenient
  • Permissions on sub-webs

Windows NT directory

\WINNT\frontpg.ini

INTERACTIVE | Read (R)
NETWORK | Read (R)

\WINNT\system\fp30utl.dll

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\WINNT\system\fp30txt.dll

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\WINNT\system\fp30wel.dll

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\WINNT\system32\infoadmn.dll

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\WINNT\system32\mfc42.dll

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\WINNT\system32\msvcirt.dll

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\WINNT\system32\msvcrt.dll

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\WINNT\system32\netapi32.dll

INTERACTIVE | Read (RX)(RX)
NETWORK |  | Read (RX)(RX)

\WINNT\system32\netrap.dll

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\WINNT\system32\rpcltc1.dll

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\WINNT\system32\samlib.dll

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\WINNT\system32\wsock32.dll

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

Microsoft FrontPage Installation Directory

The FrontPage installation directory defaults to C:\Program Files\Microsoft FrontPage, but the directory can be changed by the user during the installation process.

\Microsoft FrontPage\version3.0\servsupp\

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\Microsoft FrontPage\version3.0\servsupp\fp30msft.dll

INTERACTIVE | Read (RX)
NETWORK | Read (RX)

\Microsoft FrontPage\version3.0\servsupp\servers.cnf

INTERACTIVE | Special Access (R)
NETWORK | Special Access (R)

\Microsoft FrontPage\version3.0\bin\

INTERACTIVE | List (RX)(Not Specified)
NETWORK | List (RX)(Not Specified)

\Microsoft FrontPage\version3.0\bin\fp30vss.dll

INTERACTIVE | Read (RX)
NETWORK | Read (RX)

\Microsoft FrontPage\version3.0\bin\fpext*.msg

These files are only present for multi-language support, and are not normally present in an English installation of the FrontPage Server Extensions.

INTERACTIVE | Read (RX)
NETWORK | Read (RX)

\Microsoft FrontPage\version3.0\isapi\

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\Microsoft FrontPage\version3.0\isapi\_vti_bin

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\Microsoft FrontPage\version3.0\isapi\_vti_bin\shtml.dll

INTERACTIVE | Read (RX)
NETWORK | Read (RX)

\Microsoft FrontPage\version3.0\isapi\_vti_bin\_vti_adm\

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\Microsoft FrontPage\version3.0\isapi\_vti_bin\_vti_adm\admin.dll

INTERACTIVE | Read (RX)
NETWORK | Read (RX)

\Microsoft FrontPage\version3.0\isapi\_vti_bin\_vti_aut\

INTERACTIVE | Read (RX)(RX)
NETWORK | Read (RX)(RX)

\Microsoft FrontPage\version3.0\isapi\_vti_bin\_vti_aut\author.dll

INTERACTIVE | Read (RX)
NETWORK | Read (RX)

\Microsoft FrontPage\version3.0\temp\

INTERACTIVE | Special Access (RWX)(RWX)
NETWORK | Special Access (RWX)(RWX)

\Microsoft FrontPage\version3.0\temp\frontpg.lck

INTERACTIVE | Special Access (RW)
NETWORK | Special Access (RW)

Web Content Area

"Check Installation" on an existing FrontPage web will only affect the following files and directories in the web content root area - it will not make any adjustment to NTFS permissions in FrontPage sub webs unless the "tighten permissions" option is chosen. The minimum level of permissions required in FrontPage sub-webs will be set during the "tighten permissions" option. In addition to the permissions listed below, browsers will need READ permissions to shtml.dll, authors will need READ permissions to author.dll, and administrators will need READ permissions to admin.dll. This listing assumes a web content area of \inetpub\wwwroot.

\inetpub

All directories enclosing the content root will grant LIST permissions to these accounts.

INTERACTIVE | List (RX)(Not Specified)
NETWORK | List (RX)(Not Specified)

\inetpub\wwwroot

INTERACTIVE | List (RX)(Not Specified)
NETWORK | List (RX)(Not Specified)

\inetpub\wwwroot\_vti_pvt

INTERACTIVE | Special Access (RWXD)(RWD)
NETWORK | Special Access (RWXD)(RWD)

\inetpub\wwwroot\_vti_pvt\botinfs.cnf

INTERACTIVE | Special Access (R)
NETWORK | Special Access (R)

\inetpub\wwwroot\_vti_pvt\bots.cnf

INTERACTIVE | Special Access (R)
NETWORK | Special Access (R)

\inetpub\wwwroot\_vti_pvt\services.cnf

INTERACTIVE | Special Access (R)
NETWORK | Special Access (R)

\VSS\win32\ssapi.dll

This file's security settings are modified only if Visual SourceSafe 5 is installed.

INTERACTIVE | (RX)
NETWORK | (RX)

\VSS\win32\ssxx.dll

This file's security settings are modified only if Visual SourceSafe 5 is installed. The xx value is the country code, and ssus.dll is the default if no other country code is present.

INTERACTIVE | (RX)
NETWORK | (RX)

Additional File Permissions Assigned by Installation

The following list is of additional file permissions assigned when FrontPage is installed. Add the following list to the list above for the complete picture of the effect of FrontPage installation on the server. This list assumes that the built in Windows NT groups "Administrators" and "SYSTEM" already have full control over the entire drive, and that the IUSR_<hostname> account is granted READ access to the web content before FrontPage is installed.

FrontPage will assume any account with READ access to the web content will need continued access after installation. Such accounts will become end users of the web content. IUSR_<hostname> is only granted access in the list below if it had access to the files at installation time. You can substitute "all user accounts with read access to the web content" in place of IUSR_<hostname>. Regardless of what level access these accounts were assigned prior to installation, they will be normalized to the access levels described below by the installation process.

FrontPage will assign "Administrators" and "SYSTEM" full control everywhere.

The installing account is explicitly given Admin rights throughout the content area even though they are already an admin. You must be a Windows NT Administrator to successfully run the FrontPage Server Administrator.

Microsoft FrontPage Installation Directory

The FrontPage installation directory defaults to C:\Program Files\Microsoft FrontPage, but the directory can be changed by the user during the installation process.

\Microsoft FrontPage\temp\_x_todo.htm

INTERACTIVE | Special Access (RWX)
NETWORK | Special Access (RWX)

Web Content Area

\inetpub\wwwroot\

IUSR_<host_name> | Special Access (RWXD) (RWD)
The Installing Account | Special Access (RWXD) (RWD)

All Browseable Content

IUSR_<host_name> | Special Access (RX)(R)
The Installing Account | Special Access (RWXD) (RWD)

\inetpub\wwwroot\_vti_log\

IUSR_<host_name> | Special Access (RWXD) (RWD)
The Installing Account | Special Access (RWXD) (RWD)

\inetpub\wwwroot\_vti_pvt\

IUSR_<host_name> | Special Access (RWXD) (RWD)
The Installing Account | Special Access (RWXD) (RWD)

\inetpub\wwwroot\_vti_pvt\access.cnf

IUSR_<host_name> | Special Access (RWD)
The Installing Account | Special Access (RWD)

\inetpub\wwwroot\_vti_pvt\doctodep.btr

IUSR_<host_name> | Special Access (RWD)
The Installing Account | Special Access (RWD)

\inetpub\wwwroot\_vti_pvt\deptodoc.btr

IUSR_<host_name> | Special Access (RWD)
The Installing Account | Special Access (RWD)

\inetpub\wwwroot\_vti_pvt\linkinfo.cnf

IUSR_<host_name> | Special Access (RWD)
The Installing Account | Special Access (RWD)
INTERACTIVE | Special Access (RWD)
NETWORK | Special Access (RWD)

\inetpub\wwwroot\_vti_pvt\service.cnf

IUSR_<host_name> | Special Access (RWD)
The Installing Account | Special Access (RWD)
INTERACTIVE | Special Access (RWD)
NETWORK | Special Access (RWD)

\inetpub\wwwroot\_vti_pvt\services.org

IUSR_<host_name> | Special Access (RWD)
The Installing Account | Special Access (RWD)
INTERACTIVE | Special Access (RWD)
NETWORK | Special Access (RWD)

\inetpub\wwwroot\_vti_pvt\structure.cnf

IUSR_<host_name> | Special Access (RWD)
The Installing Account | Special Access (RWD)
INTERACTIVE | Special Access (R)
NETWORK | Special Access (R)

\inetpub\wwwroot\_vti_pvt\svcacl.cnf

IUSR_<host_name> | Special Access (RWD)
The Installing Account | Special Access (RWD)
INTERACTIVE | Special Access (RWD)
NETWORK | Special Access (RWD)

\inetpub\wwwroot\_vti_pvt\uniqperm.cnf

IUSR_<host_name> | Special Access (RWD)
The Installing Account | Special Access (RWD)
INTERACTIVE | Special Access (RWD)
NETWORK | Special Access (RWD)

\inetpub\wwwroot\_vti_txt\

IUSR_<host_name> | Special Access (RWXD) (RWD)
The Installing Account |  | Special Access (RWXD) (RWD)
INTERACTIVE |  | Special Access (RWXD) (Not Specified)
NETWORK |  | Special Access (RWXD) (Not Specified)

\inetpub\wwwroot\_vti_bin\

IUSR_<host_name> | Read (RX)(RX)
The Installing Account | Read (RX)(RX)
INTERACTIVE | List (RX) (Not Specified)
NETWORK | List (RX) (Not Specified)

\inetpub\wwwroot\_vti_bin\shtml.dll

IUSR_<host_name> | Read (RX)
The Installing Account | Read (RX)

\inetpub\wwwroot\_vti_bin\_vti_aut\

The Installing Account Read (RX)(RX)

\inetpub\wwwroot\_vti_bin\_vti_aut\author.dll

The Installing Account Read (RX)

\inetpub\wwwroot\_vti_bin\_vti_adm\

The Installing Account Read (RX)(RX)

\inetpub\wwwroot\_vti_bin\_vti_adm\admin.dll

The Installing Account Read (RX)

\inetpub\wwwroot\_vti_bot\

The Installing Account | Read (RX)
NETWORK | Special Access (RX) (RX)
INTERACTIVE | Special Access (RX) (RX)

\inetpub\wwwroot\_vti_cnf\

IUSR_<host_name> | Special Access (RX) (R)
The Installing Account | Special Access (RWXD) (RWD)

\inetpub\wwwroot\_private\

IUSR_<host_name> | Special Access (RX) (R)
The Installing Account | Special Access (RWXD) (RWD)


Source Code for FrontPage Apache Module

mod_frontpage.c

/* ====================================================================
 *
 * Apache FrontPage module.
 *
 * Copyright (c) 1996-1997 Microsoft Corporation -- All Rights Reserved.
 *
 * NO WARRANTIES. Microsoft expressly disclaims any warranty for this code and
 * information. This code and information and any related documentation is
 * provided "as is" without warranty of any kind, either express or implied,
 * including, without limitation, the implied warranties or merchantability,
 * fitness for a particular purpose, or noninfringement. The entire risk
 * arising out of use or performance of this code and information remains with
 * you.
 *
 * NO LIABILITY FOR DAMAGES. In no event shall Microsoft or its suppliers be
 * liable for any damages whatsoever (including, without limitation, damages
 * for loss of business profits, business interruption, loss of business
 * information, or any other pecuniary loss) arising out of the use of or
 * inability to use this Microsoft product, even if Microsoft has been advised
 * of the possibility of such damages. Because some states/jurisdictions do not
 * allow the exclusion or limitation of liability for consequential or
 * incidental damages, the above limitation may not apply to you.
 *
 * $Revision: 1.3 $
 * $Date: 1997/10/15 17:23:46 $
 *
 */

/*
 * User configurable items.  We will not run the server extensions with any
 * UID/GID less than LOWEST_VALID_UID/LOWEST_VALID_GID.
 */

#if defined(LINUX)
#define LOWEST_VALID_UID 15
#else
#define LOWEST_VALID_UID 11
#endif

#if defined(HPUX) || defined(IRIX) || defined(SUNOS4)
#define LOWEST_VALID_GID 20
#else
#if defined(SCO)
#define LOWEST_VALID_GID 24
#else
#define LOWEST_VALID_GID 21   /* Solaris, AIX, Alpha, Bsdi, etc. */
#endif
#endif

/*
 * End of user configurable items
 */

#include "httpd.h"
#include "http_config.h"
#include "http_conf_globals.h"

#include <stdio.h>
#include <sys/time.h>

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef MAXPATHLEN
#define MAXPATHLEN 1024
#endif
#if (MAXPATHLEN < 1024)
#undef MAXPATHLEN
#define MAXPATHLEN 1024
#endif

#define KEYLEN 128                  /* Should be a multiple of sizeof(int) */

static char gszKeyVal[KEYLEN+1];    /* SUID key value used by this module */
static int  gfdKeyPipe[2];          /* Pipe to fpexe stub CGI */
static int  gbKeyPipeActive;        /* Pipe to fpexe stub CGI is active */
static int  gbEnabled;              /* TRUE when SUID scheme is enabled */
static int  giInitializeCount;      /* FrontPageInit called previously */

static const char* FP         =
          "/usr/local/frontpage/currentversion";
static const char* FPKEYDIR   =
          "/usr/local/frontpage/currentversion/apache-fp";
static const char* KEYFILEXOR =
          "/usr/local/frontpage/currentversion/apache-fp/suidkey";
static const char* KEYFILE    =
          "/usr/local/frontpage/currentversion/apache-fp/suidkey.%d";
static const char* FPSTUBDIR  =
          "/usr/local/frontpage/currentversion/apache-fp/_vti_bin";
static const char* FPSTUB     =
          "/usr/local/frontpage/currentversion/apache-fp/_vti_bin/fpexe";
static const char* VTI_BIN    =
          "/_vti_bin";
static const char* SHTML      =
          "/_vti_bin/shtml.exe";
static const char* FPCOUNT    =
          "/_vti_bin/fpcount.exe";
static const char* AUTHOR     =
          "/_vti_bin/_vti_aut/author.exe" ;
static const char* ADMIN      =
          "/_vti_bin/_vti_adm/admin.exe" ;

/*
 * Print a descriptive error in the httpd's error_log.  The format string
 * should be length limited so that it is no longer than 1800 bytes.
 */
static void LogFrontPageError(
    server_rec* s,
    const char* szFormat,
    const char* szFile,
    const char* szRoutine,
    int bIsDisabled)
{
    char szBuf[MAXPATHLEN * 2];
    sprintf(szBuf, szFormat, szFile);
    strcat(szBuf, " in ");
    strcat(szBuf, szRoutine);
    strcat(szBuf, ".");
    if (bIsDisabled)
    {
        strcat(szBuf, "  Until this problem is fixed, the FrontPage security patch is disabled and the FrontPage extensions may not work correctly.");
        gbEnabled = FALSE;            /* Make double sure we're not enabled */
    }
    log_error(szBuf, s);
}

/*
 * Clean up stale keyfiles.  Failure to clean up stale keyfiles does not
 * stop the FrontPage SUID scheme.
 */
static void FrontPageCleanup(server_rec *s)
{
    DIR *d;
    struct DIR_TYPE *dstruct;
    int myPid = getpid();

    if (!(d = opendir(FPKEYDIR)))
    {
        /*
         * This should be a rare occurrence, because we're running as root and
         * should have access to the directory.  Stale key files can be
         * exploited.  User recovery: Check that the directory exists and is
         * properly protected (owned by root, permissions rwx--x--x), and that
         * there are no stale key files in it (suidkey.*, where * is a
         * non-existant PID).
         */
        LogFrontPageError(s, "Can't clean stale key files from directory \"%-.1024s\"",
                          FPKEYDIR, "FrontPageCleanup()", FALSE);
        return;
    }

    while ((dstruct = readdir(d)))
    {
        if (strncmp("suidkey.", dstruct->d_name, 8) == 0)
        {
            /*
             * Make sure the key file contains a pid number - otherwise
             * it is harmless and you can ignore it.
             */
            char* pEnd = 0;
            int pid = strtol(dstruct->d_name + 8, &pEnd, 10);
            if (!pEnd || *pEnd)
                continue;

            /*
             * Make sure there isn't some other server using this key file.
             * If the process group isn't alive, then the file is stale
             * and we want to remove it.
             */
            if (pid == myPid || kill(pid, 0) == -1)
            {
                char szBuf[MAXPATHLEN];
                sprintf(szBuf, "%-.500s/%-.500s", FPKEYDIR, dstruct->d_name);
                if (unlink(szBuf) == -1)
                {
                    /*
                     * This should be a rare occurrence, because we're running
                     * as root and should always have permission to delete the
                     * file.  Stale key files can be exploited.  User recovery:
                     * delete the offending file.
                     */
                    LogFrontPageError(s, "Can't unlink stale key file \"%-.1024s\"",
                                      szBuf, "FrontPageCleanup()", FALSE);
                }
            }
        }
    }

    closedir(d);
}

/*
 * Checks that all the permissions are currently correct for the FrontPage
 * fpexe SUID stub to run correctly.  If not, it logs an error and aborts
 * initialization, effectively disabling the FrontPage SUID scheme.
 * It checks both the file permissions (owned by root and not writable to
 * group, other) and that the directory is not writable.
 */
static int FrontPageCheckup(server_rec *s)
{
    struct stat fs;

    if (geteuid() != 0)
    {
        /*
         * We need to be root to have the security scheme work correctly.
         * User recovery: run the server as root.
         */
        LogFrontPageError(s, "Not running as root",
                          0, "FrontPageCheckup()", TRUE);
        return (FALSE);
    }

    if (lstat(FPKEYDIR, &fs) == -1          || /* We can't stat the key dir */
        fs.st_uid                           || /* key dir not owned by root */
        (fs.st_mode & (S_IRGRP | S_IROTH))  || /* key dir is readable */
        (fs.st_mode & (S_IWGRP | S_IWOTH))  || /* key dir is writable */
        !(fs.st_mode & (S_IXGRP | S_IXOTH)) || /* key dir is not executable */
        !(S_ISDIR(fs.st_mode)))
    {
        /*
         * User recovery: set directory to be owned by by root with permissions
         * rwx--x--x.  Note you need the execute bit for group and other so
         * that non-root programs can run apache-fp/_vti_bin/fpexe (even though
         * non-root cannot list the directory).
         */
        LogFrontPageError(s, "Incorrect permissions on key directory \"%-.1024s\"",
                          FPKEYDIR, "FrontPageCheckup()", TRUE);
        return (FALSE);
    }

    if (lstat(FPSTUBDIR, &fs) == -1         || /* We can't stat the stub dir */
        fs.st_uid                           || /* stub dir not owned by root */
        (fs.st_mode & (S_IWGRP | S_IWOTH))  || /* stub dir is writable */
        (!S_ISDIR(fs.st_mode)))
    {
        /*
         * User recovery: set directory to be owned by by root with permissions
         * r*x*-x*-x.
         */
        LogFrontPageError(s, "Incorrect permissions on stub directory \"%-.1024s\"",
                          FPSTUBDIR, "FrontPageCheckup()", TRUE);
        return (FALSE);
    }

    if (stat(FPSTUB, &fs) == -1             || /* We can't stat the stub */
        fs.st_uid                           || /* stub not owned by root */
        !(fs.st_mode & S_ISUID)             || /* stub is not set-uid */
        (fs.st_mode & S_ISGID)              || /* stub is set-gid */
        (fs.st_mode & (S_IWGRP | S_IWOTH))  || /* stub is writable */
        !(fs.st_mode & (S_IXGRP | S_IXOTH)))   /* stub is not executable */
    {
        /*
         * User recovery: set stub to be owned by by root with permissions
         * r*s*-x*-x.
         */
        LogFrontPageError(s, "Incorrect permissions on stub \"%-.1024s\"",
                          FPSTUB, "FrontPageCheckup()", TRUE);
        return (FALSE);
    }

    return (TRUE);
}

/*
 * Module-initializer: Create the suidkey file and local value.
 * Everything needs to be just right, or we don't create the key file, and
 * therefore, the fpexe SUID stub refuses to run.
 */
static void FrontPageInit(server_rec *s, pool *p)
{
    int fdPipe[2];
    pid_t pid;
    FILE *f;
    struct stat fs;
    int fd;
    char szKeyFile[MAXPATHLEN];
    int iRandom[5];
    char* szRandom = (char*)iRandom;
    struct timeval tp;
    struct timezone tz;

    (void)p;   /* p is unused */

    /*
     * Standalone servers call initialization twice: once in main() and again
     * in standalone_main().  The fully initializing on the the first call is a
     * waste of time, and a race condition can leave a stale suidkey.pgrpid
     * file around.
     */
    if (standalone && !giInitializeCount++)
        return;

    /*
     * Disable the suid scheme until everything falls perfectly into place.
     */
    gbEnabled = FALSE;
    gbKeyPipeActive = FALSE;

    /*
     * Clean up old key files before we start
     */
    FrontPageCleanup(s);
    if (!FrontPageCheckup(s))
        return;

    if (pipe(fdPipe) == -1)
    {
        /*
         * This should be a rare occurrence.  User recovery: check to see why
         * the system cannot allocate a pipe (is the file table full from
         * run-away processes?), and fix the problem or reboot, then try again.
         */
        LogFrontPageError(s, "pipe() failed", 0, "FrontPageInit()", TRUE);
        return;
    }

    gettimeofday(&tp, &tz);
    iRandom[0] = tp.tv_sec;
    iRandom[1] = tp.tv_usec | tp.tv_usec << 20;

    pid = fork();
    if (pid == -1)
    {
        /*
         * This should be a rare occurrence.  User recovery: check to see why
         * the system cannot allocate a process (is the process table full from
         * run-away processes?), and fix the problem or reboot, then try again.
         */
        LogFrontPageError(s, "fork() failed", 0, "FrontPageInit()", TRUE);
        return;
    }

    if (pid)
    {
        /*
         * I am the parent process.  Try to read a random number from the
         * child process.
         */

        unsigned int npos = (unsigned int)-1;
        unsigned int v1 = npos, v2 = npos, v3 = npos, v4 = npos;
        int stat;
        int iCount;

        close(fdPipe[1]);
        if (waitpid(pid, &stat, 0) == -1 ||
            (!WIFEXITED(stat) || WIFEXITED(stat) && WEXITSTATUS(stat)))
        {
            /*
             * This should be a rare occurrence.  User recovery: Make sure you
             * have a /bin/sh, or change the shell location in the execl
             * command below.  Try the commands defined in RAND_CMD in a
             * /bin/sh session to make sure they work properly.  Rebuild this
             * module and your httpd with the proper commands.
             */
            LogFrontPageError(s, "Random number generator exited abnormally", 0,
                              "FrontPageInit()", TRUE);
            return;
        }

        iCount = read(fdPipe[0], gszKeyVal, KEYLEN);
        close(fdPipe[0]);
        if (iCount < 0)
        {
            /*
             * This should be a rare occurrence.  See the above comment under
             * the waitpid failure condition for user recovery steps.
             */
            LogFrontPageError(s, "Could not read random numbers", 0,
                              "FrontPageInit()", TRUE);
            return;
        }
        gszKeyVal[iCount] = 0;

        sscanf(gszKeyVal, "%u %u %u %u", &v2, &v1, &v4, &v3);
        if (v1 == npos || v2 == npos || v3 == npos || v4 == npos)
        {
            /*
             * This should be a rare occurrence.  See the above comment under
             * the waitpid failure condition for user recovery steps.
             */
            LogFrontPageError(s, "Could not scan random numbers", 0,
                              "FrontPageInit()", TRUE);
            return;
        }

        iRandom[2] = (v1 << 16) + v2 + (v4 << 12) + v3;
    }
    else
    {
        /*
         * I am the child process.  Create a random number which shouldn't
         * be easily duplicated.
         */

        if (dup2(fdPipe[1], 1) == -1)
            exit(1);                    /* Parent picks up the error */

        close(fdPipe[0]);

#ifdef LINUX
#define RAND_CMD "/bin/ps laxww | /usr/bin/sum ; /bin/ps laxww | /usr/bin/sum"
#else
#ifdef bsdi
#define RAND_CMD "/bin/ps laxww | /usr/bin/cksum -o 1 ; /bin/ps laxww | /usr/bin/cksum -o 1"
#else
#define RAND_CMD "/bin/ps -ea | /bin/sum ; /bin/ps -ea | /bin/sum"
#endif
#endif
        execl("/bin/sh", "/bin/sh", "-c", RAND_CMD, NULL);
        exit(1);
    }

    gettimeofday(&tp, &tz);
    iRandom[3] = tp.tv_sec;
    iRandom[4] = tp.tv_usec | tp.tv_usec << 20;

    /*
     * See if there is an 'suidkey' file to merge into our key.
     */
    if (stat(KEYFILEXOR, &fs) == -1)
    {
        /*
         * It's a security violation if the key file is not present.  User
         * recovery: Make sure the key file is present and properly protected
         * (owned by root, permissions r**------).
         */
        LogFrontPageError(s, "The key file \"%-.1024s\" does not exist",
                          KEYFILEXOR, "FrontPageInit()", TRUE);
        return;
    }
    else
    {
        int i, iCount;
        char szBuf[KEYLEN];

        if ((fs.st_mode & (S_IRWXG | S_IRWXO)) || fs.st_uid)
        {
            /*
             * It's a security violation if the key file is not owned by root,
             * and is not protected from all other group. User recovery: Make
             * sure the key file is properly protected (owned by root,
             * permissions r**------).
             */
            LogFrontPageError(s, "The key file \"%-.1024s\" must not be accessible except by root",
                              KEYFILEXOR, "FrontPageInit()", TRUE);
            return;
        }

        if ((fd = open(KEYFILEXOR, O_RDONLY)) == -1)
        {
            /*
             * This should be a rare occurrence.  User recovery: Make sure
             * the key file exists, is properly owned and protected, and is
             * readable.
             */
            LogFrontPageError(s, "Cannot open key file \"%-.1024s\"",
                              KEYFILEXOR, "FrontPageInit()", TRUE);
            return;
        }

        iCount = read(fd, szBuf, KEYLEN);
        if (iCount < 8)
        {
            /*
             * The keyfile must be at least 8 bytes.  If it longer than 128
             * bytes, only the first 128 bytes will be used.  Any character
             * value from 0-255 is fine.  User recovery: Make sure the key file
             * is at least 8 bytes long.
             */
            LogFrontPageError(s, "Key file \"%-.1024s\" is unreadable or is too short",
                              KEYFILEXOR, "FrontPageInit()", TRUE);
            return;
        }

        /*
         * Now generate the effective key we'll be using by XORing your key
         * with 5 "random" 32-bit integers.  The primary security of this
         * scheme is your key; properly setting it and changing it often keeps
         * the FrontPage SUID scheme secure.  All this work above to generate 5
         * random 32-bit integers is soley to make your key somewhat harder to
         * crack (assuming the key files are properly protected).  If you don't
         * like the algorithm used to generate the 5 random integers, feel free
         * to substitute as appropriate (check out SGI's Lavarand (TM) at
         * lavarand.sgi.com).
         */
        for (i = 0;  i < KEYLEN;  i++)
            gszKeyVal[i] = szBuf[i % iCount] ^ szRandom[i % sizeof(iRandom)];
    }

#if defined(SUNOS4)
    pid = getpgrp(0);
#else
    pid = getpgrp();
#endif
    sprintf(szKeyFile, KEYFILE, (int)pid);

    fd = creat(szKeyFile, 0600);
    if (fd < 0)
    {
        /*
         * This should be a rare occurrence, because we're running as root and
         * should always have permission to create the file.  User recovery:
         * check that you are not out of disk space, or that the file is not
         * NFS-mounted on a share where you do not have permissions.
         */
        LogFrontPageError(s, "Could not create key file \"%-.1024s\"",
                          szKeyFile, "FrontPageInit()", TRUE);
        return;
    }

    if (write(fd, gszKeyVal, 128) != 128)
    {
        /*
         * This should be a rare occurrence.  User recovery: check that you are
         * not out of disk space.
         */
        close(fd);
        unlink(szKeyFile);
        LogFrontPageError(s, "Could not write to key file \"%-.1024s\"",
                          szKeyFile, "FrontPageInit()", TRUE);
        return;
    }

    close(fd);

    /*
     * Everything looks OK enough to start the suid scheme.
     */
    gbEnabled = TRUE;
}

/*
 * Look for a valid FrontPage extensions scenario and fake a scriptalias if
 * appropriate.  If there are any problems, we silently decline.
 */
static int FrontPageAlias(
    request_rec* r,
    char* szCgi,
    const char* szFpexe)
{
    int iLen;
    struct stat webroot;
    struct stat vti_pvt;
    struct stat stub;
    char szBuf[MAXPATHLEN];
    char chSave;

    /*
     * Decline if we cannot run the stub, or it is writable.
     */
    if (stat(FPSTUB, &stub) == -1 || !(stub.st_mode & S_IXOTH) ||
        stub.st_mode & (S_IWGRP | S_IWOTH))
    {
        /*
         * The stub used to be correctly permissioned; what happened?  User
         * recovery: set stub to be owned by by root with permissions
         * r*s*-x*-x.
         */
        LogFrontPageError(r->server, "Incorrect permissions on stub \"%-.1024s\"",
                          FPSTUB, "FrontPageAlias()", FALSE);
        return DECLINED;
    }

    chSave = szCgi[1];
    szCgi[1] = '\0';
    translate_name(r);
    szCgi[1] = chSave;

    /*
     * Zap trailing slash that confuses some OSes.
     */
    iLen = strlen(r->filename);
    r->filename[--iLen] = 0;

    if (iLen > MAXPATHLEN - 10)
        return DECLINED;
    sprintf(szBuf, "%s/_vti_pvt", r->filename);

    /*
     * Decline if webroot and webroot/_vti_pvt don't have the same
     * user and group or uid < LOWEST_VALID_UID or gid < LOWEST_VALID_GID.
     */
    if (stat(szBuf, &vti_pvt) == -1       ||
        vti_pvt.st_uid < LOWEST_VALID_UID ||
        vti_pvt.st_gid < LOWEST_VALID_GID ||
        stat(r->filename, &webroot) != 0  ||
        webroot.st_uid != vti_pvt.st_uid  ||
        webroot.st_gid != vti_pvt.st_gid)
    {
        /*
         * The webroot and webroot/_vti_pvt don't match.  User recovery: fix
         * the owners and groups of both directories to match, and have both a
         * uid and gid in the allowable range.
         */
        LogFrontPageError(r->server, "Incorrect permissions on webroot \"%-.0124s\" and webroot's _vti_pvt directory",
                          szBuf, "FrontPageAlias()", FALSE);
        return DECLINED;
    }

    /*
     * If the pipe is active, it was because we previously executed a CGI.
     * That CGI must have finished by now (otherwise we wouldn't be processing
     * this next request), so we can and should close the pipe to avoid a
     * resource leak.
     */
    if (gbKeyPipeActive)
    {
        close(gfdKeyPipe[0]);
        gbKeyPipeActive = FALSE;
    }

    /*
     * If we can't get a pipe, that's really bad.  We'll log an error, and
     * decline.  This should be a rare occurrence.  User recovery: check to see
     * why the system cannot allocate a pipe (is the file table full from
     * run-away processes?), and fix the problem or reboot, then try again.
     */
    if (pipe(gfdKeyPipe) == -1)
    {
        LogFrontPageError(r->server, "pipe() failed", 0,
                          "FrontPageAlias()", FALSE);
        return DECLINED;
    }

    /*
     * Note: pstrdup allocates memory, but it checks for out of memory
     * conditions - it will not return if out of memory.
     */
    r->handler = pstrdup(r->pool, "cgi-script");
    table_set(r->notes, "alias-forced-type", r->handler);

    table_set(r->subprocess_env, "FPEXE", pstrdup(r->pool, szFpexe));
    sprintf(szBuf, "%d", webroot.st_uid );
    table_set(r->subprocess_env, "FPUID", pstrdup(r->pool, szBuf));
    sprintf(szBuf, "%d", webroot.st_gid );
    table_set(r->subprocess_env, "FPGID", pstrdup(r->pool, szBuf));
    sprintf(szBuf, "%d", gfdKeyPipe[0]);
    table_set(r->subprocess_env, "FPFD", pstrdup(r->pool, szBuf));

    r->execfilename = pstrcat(r->pool, FPSTUB, szCgi + strlen(szFpexe), NULL);
    r->filename = pstrcat(r->pool, r->filename, szCgi, NULL);

    if (write(gfdKeyPipe[1], gszKeyVal, 128) != 128)
    {
        /*
         * If we can't write to the pipe, that's really bad.  We'll log an
         * error, and decline.  This should be a rare occurrence.  User
         * recovery: check to see why the system cannot write to the pipe (is
         * the system being choked with too much load?), and fix the problem or
         * reboot, then try again.
         */
        LogFrontPageError(r->server, "Write to pipe failed", 0,
                          "FrontPageAlias()", FALSE);
        close (gfdKeyPipe[0]);
        close (gfdKeyPipe[1]);
        return DECLINED;
    }
    close(gfdKeyPipe[1]);

    gbKeyPipeActive = TRUE;
    return OK;
}

/*
 * This routine looks for shtml.exe, fpcount.exe, author.exe and admin.exe
 * in a URI, and if found we call FrontPageAlias() to check for a valid
 * FrontPage scenario.
 *
 * The return value is OK or DECLINED.
 */
static int FrontPageXlate(
    request_rec *r)
{
    char *szVti;
    char *szCgi;

    /*
     * Decline if we're improperly initialized.
     */
    if (!gbEnabled)
        return DECLINED;

    /*
     * Check once for anything with _vti_bin.  This is much faster than
     * checking all four paths, because anything without this is definitely
     * not a FrontPage scenario.
     */
    if (!(szVti = strstr(r->uri, VTI_BIN)))
        return DECLINED;

    /*
     * Test for FrontPage server extenders:
     * .../_vti_bin/shtml.exe...
     * .../_vti_bin/fpcount.exe...
     * .../_vti_bin/_vti_aut/author.exe...
     * .../_vti_bin/_vti_adm/admin.exe...
     */
    if (szCgi = strstr(szVti, AUTHOR ))
        return FrontPageAlias(r, szCgi, AUTHOR);
    if (szCgi = strstr(szVti, SHTML  ))
        return FrontPageAlias(r, szCgi, SHTML);
    if (szCgi = strstr(szVti, ADMIN  ))
        return FrontPageAlias(r, szCgi, ADMIN);
    if (szCgi = strstr(szVti, FPCOUNT))
        return FrontPageAlias(r, szCgi, FPCOUNT);

    return DECLINED;
}

/*
 * Declare ourselves so the configuration routines can find us.
 */
module frontpage_module =
{
    STANDARD_MODULE_STUFF,
    FrontPageInit,             /* initializer */
    NULL,                      /* per-directory config creater */
    NULL,                      /* dir config merger - default is to override */
    NULL,                      /* server config creator */
    NULL,                      /* server config merger */
    NULL,                      /* command table */
    NULL,                      /* [6] list of handlers */
    FrontPageXlate,            /* [1] filename-to-URI translation */
    NULL,                      /* [4] check/validate HTTP user_id */
    NULL,                      /* [5] check HTTP user_id is valid *here* */
    NULL,                      /* [3] check access by host address, etc. */
    NULL,                      /* [6] MIME type checker/setter */
    NULL,                      /* [7] fixups */
    NULL,                      /* [9] logger */
    NULL,                      /* [2] header parser */
};


FrontPage 98 Apache Patch Source Code

When using the FrontPage 98 Server Extensions for UNIX with the Apache web server, the recommended configuration is to patch the Apache web server. The patch to the Apache web server consists of two modifications:

  • The FrontPage Apache module that intercepts remote requests from the FrontPage client programs, validates security, and redirects the request to the fpexe suid root stub program.
  • The fpexe program, which accepts authoring requests from the FrontPage Apache module, performs additional security validation, changes user ID to the owner of the website being authored, and then invokes the appropriate FrontPage Server Extensions CGI executable.

The source code to the FrontPage Apache module and the fpexe program is presented here for review. This source code is also included in the FrontPage 98 Server Extensions for UNIX download kits suitable for compiling with customized builds of the Apache web server.

  • Source Code for FrontPage Apache Module: mod_frontpage.c
  • Source Code for fpexe Program: fpexe.c


List of Special Files and Directories Maintained by FrontPage

This appendix lists all the files and directories that FrontPage adds to each root web or sub-web.

Folders | Files | Purpose
_overlay | *.gif | Overlay files for FrontPage’s text on GIF and navigation button features. These files are transparent GIFs that are overlaid on top of base button or banner images to build a complete text on GIF or navigation button composite image.
_derived | *.htx, *.gif | Files that are dynamically generated by FrontPage that can be regenerated at any time, such as *.htx files created by the FrontPage Search Component (only when using IIS with Microsoft Index Server) and composite text on GIF images (for example, theme buttons and banners).
_borders | top.htm, left.htm, right.htm, bottom.htm | Shared border definition files that are included into pages using shared borders.
_themes | *.gif, *.inf, *.css files for each theme | FrontPage themes storage. Each theme that is applied to the web is uploaded into a uniquely named subfolder of the _themes directory. Each theme consists of GIF, CSS, and INF files that define the theme.
_fpclass | *.class | Compiled Java class files that implement the Banner Ad Manager and Hover Button FrontPage components.
_private |  | This folder is created in each FrontPage web. It is intended to contain user files that are not browsable. This feature does not work on IIS servers.
_vti_bin | shtml.dll shtml.exe | Stub FrontPage Server Extensions executables for runtime functionality.
 | fpcount.exe | Runtime portion of the FrontPage Hit Counter component.
 | *.idq | Query files created by the FrontPage Search component when using IIS with Microsoft Index Server. These files reside in the _vti_bin directory in order to get execute permissions.
_vti_bin/_vti_aut | author.dll author.exe | Stub FrontPage Server Extensions executables for authoring functionality.
_vti_bin/_vti_adm | admin.dll admin.exe | Stub FrontPage Server Extensions executables for security functionality.
_vti_bot |  | Used for custom FrontPage (WebBot) components created using the FrontPage SDK. This folder contains the implementations of custom FrontPage components. FrontPage custom components installed in these directories are optionally downloaded to the user's machine when that Component is inserted by the user.
_vti_cnf | For each HTML page and graphics file in a FrontPage web there is a configuration file of the same name. | Each configuration page contains a set of name value pairs, identifying such things as the last author to edit a page or the program associated with a file.
_vti_log |  | Root web only. Only populated after the web administrator has enabled logging in the frontpg.ini or we<port>.cnf file. When active, an author.log file gets created here logging only FrontPage authoring and administration operations.
_vti_pvt | _x_todo.htm | Contains the current settings of the To Do List
 | _x_todoh.htm | Contains the changes to the To Do List
 | access.cnf | Contains HTTP server-specific access control information
 | administrators.pwd | On Netscape servers only. Encrypted names and passwords of administrators.
 | authors.pwd | On Netscape servers only. Encrypted names and passwords of authors.
 | bots.cnf | Used for custom WebBot components created using the FrontPage SDK.
 | botinfs.cnf | Custom FrontPage (WebBot ) components information listing
 | deptodoc.btr | Dependency database for the web.
 | doctodep.btr | Dependency database for the web.
 | frontpg.lck | Root Web only. Lock file to keep web server resources from being accessed simultaneously. Should be a zero-byte file at idle time. With IIS and WebSite servers, this file is located in C:\Program Files\Microsoft FrontPage\version3.0\temp, not in the web content area's _vti_pvt directory.
 | linkinfo.cnf | Back links for URLs not in the current web.
 | service.cnf | Contains meta-information about the web.
 | service.grp | Lists the members of the Administrator and Author groups. Used only for CERN and NCSA servers.
 | service.pwd | Contains the encrypted password files. Not used on IIS and WebSite servers.
 | Service.stp | Contains the absolute file system path to the FrontPage web's service.pwd and service.grp files. Used only for CERN and NCSA servers.
 | services.cnf | Root web only. Contains the list of sub-webs.
 | services.org | Root web only. File used as the basis for services.cnf when reinstalling the Server Extensions, so that sub-webs are recreated as sub-webs instead of as subdirectories of the root web.
 | service.lck | Lock file to keep web resources from being accessed simultaneously. Should be a zero-byte file at idle time.
 | structure.cnf | Contains FrontPage web navigational information storage.
 | svcacl.cnf | Root web only. File used to store whether sub-webs have unique permissions settings and any IP Address restrictions, so that when reinstalling the Server Extensions the correct permissions settings are reapplied to any sub-webs.
 | users.pwd | On Netscape servers only. Encrypted names and passwords of end-users.
 | uniqueperm.cnf | Used on IIS only. The presence of this file indicates that the sub-web has unique permissions settings, as opposed to inheriting permissions from the root web. Present only in sub-webs.
 | writeto.cnf | Back links for files that can be written to by users of the web, such as Save Results Form handler result files. Files that can be written to by users of the web have a looser security setting than regular web content.
_vti_map |  | Contains image map files.
_vti_txt |  | This folder contains text indices for the WAIS search engine only. It is not used by Index Server on IIS.

FrontPage also includes Server Extensions configuration files. See Using the FrontPage Configuration File for details on Server Extensions configuration files naming convention and file locations.

Subsystem Definition Affected Stores
Document parsing and attribute discovery Document parser plus title, base, link extractor
  • _vti_cnf, link map
  • content (read only)
  • _vti_txt
Document expansion Bot expansion, themes, borders,URL macros, link fix-up, taking page styles from other pages
  • _vti_cnf
  • link map
  • service.cnf (read)
  • deptodoc, doctodep
  • structure store (read)
  • bot meta-info (read)
  • _themes
  • content
  • _vti_map
  • _overlay (read)
  • frontpg.ini (read)
Source control VSS integration
  • VSS database
  • content
  • _vti_cnf
  • service.cnf
  • structure.cnf
  • _overlay
Structure store Web structure store
  • structure store
  • content
  • _vti_cnf
  • trigger dependency recalculation
Access control Setting permissions on web
  • svcacl.cnf, access.cnf
  • content
  • web server config (read)
Todo list Todo list
  • to do list
File system management Generic reading, writing, etc. of files
  • content
  • trigger dependency recalculation
  • _vti_cnf
Meta-info store Combined meta-information stores
  • _vti_cnf
  • service.cnf
  • frontpg.ini (read)
  • trigger dependency recalculation
Dependency management Managing relationships between documents, structure store, time, meta-info, etc.
  • _vti_cnf
  • deptodoc, doctodep
  • service.cnf (autorecalc bit)
Text indexing/searching Internal WAIS text index
  • service.cnf
  • frontpg.ini (read)
  • _vti_txt
Logging Only author and admin ops
  • _vti_log
"Open bot" management Install and execution of open bots
  • bots.cnf (read)
  • botinfs.cnf (read)
  • _vti_bot (read)
Web server management Marking folders as executable, readable, etc. Getting URL to file mappings, etc.
  • frontpg.ini (read)
  • web server configuration
Locking Internal based, not user driven
  • _vti_pvt/service.lck


List of UNIX Configuration File Settings

Configuring Server Extensions Parameters

Default Server Extensions Parameters

  • NoExecutableCgiUpload
  • NoServerFilePipeTo
  • NoAbsoluteFileResults
  • NoServerFileResults

Other Security-related Server Extensions Parameters

  • ComplexPasswords
  • Logging
  • ServerFilePipeToAllows

Additional Server Extension Configuration Parameters

  • TextMemory
  • ReformatHtml
  • UpperCaseTags
  • PreserveTagCase
  • MaxAliases
  • AccessControl
  • SMTPHost
  • MailSender
  • SendMailCommand
  • MailCharSet
  • MailEncoding
  • CacheMaxDocMeta
  • CacheMaxInclude
  • CacheMaxImage
  • Locale

Parameters That Can Also Be Set in the FrontPage Explorer

  • NoClientImageMaps
  • ImageMapFormat
  • ImageMapURLPrefix
  • ScriptLanguage

Configuring Server Extensions Parameters

Some features of the FrontPage 98 Server Extensions can be configured by setting server parameters in the Server Extensions configuration file. On multi-hosted systems, the file is named '<hostname>:port.cnf' where <hostname> is the fully qualified domain name of the server. On a single-host system, the Server Extensions configuration file is named weXXXX.cnf where XXXX refers to the web server's port number. This file is stored in the /usr/local/frontpage directory by default and can be edited by the server administrator if changes are necessary. The syntax for configuration parameters is parameter:value.

Default Server Extensions Parameters

The FrontPage 98 Server Extensions install with the following parameters set as indicated. This default configuration maximizes the host server's security.

NoExecutableCgiUpload

Initial value after installation: Non-zero. A non-zero value for this parameter prevents the FrontPage 98 Server Extensions from setting the execute bit on any CGI scripts that the customer uploads to the web content area using FrontPage. On inspecting the CGI script, the web presence provider can manually set the execute permission, if desired. Changing this parameter value to zero instructs the Server Extensions to automatically set the execute bit on CGI scripts uploaded to the customer's cgi-bin directory.

NoServerFilePipeTo

Initial value after installation: Non-zero. A non-zero value for this parameter prevents the default (Save Results), Registration, and Discussion FrontPage form handling components from piping their output to any program. To let customers pipe output to a specific list of executables, the parameter ServerFilePipeToAllows should be set instead, and NoServerFilePipeTo should be set to zero. The list of executables specified by ServerFilePipeToAllows is ignored if NoServerFilePipeTo is set to a non-zero value.

NoAbsoluteFileResults

Initial value after installation: Non-zero. A non-zero value for this parameter forces the default (Save Results), Registration, and Discussion FrontPage form handling components to write only to a file within the customer's web content area. It prevents these FrontPage Components from writing to an absolute file path.

NoServerFileResults

Initial value after installation: Non-zero. A non-zero value for this parameter prevents the default (Save Results), Registration, and Discussion FrontPage form handling components from writing to the _vti_log directory in the customer's document root (Setting the NoServerFileResults parameter to zero can be useful to allow customers to save the output generated from the Save Results, Registration, and Discussion FrontPage Components to the _vti_log directory in the server's root web). As a security measure, the author.log file in the _vti_log directory records all authoring actions on the web when the Logging parameter is set (see below). The non-zero value for NoServerFileResults prevents an author from "covering his tracks" by overwriting or modifying the author.log file.

Other Security-related Server Extensions Parameters

The following web configuration parameters are not included in the default installation of the FrontPage 98 Server Extensions, but can be added by editing the Server Extensions configuration file. When set as indicated below, these options can increase the overall security of FrontPage.

ComplexPasswords

A non-zero value for this parameter forces FrontPage to require all FrontPage passwords be a minimum of eight characters, including at least one non-alphanumeric character. Also, when this parameter is set, the password cannot be a sub-string of the username.

Logging

A non-zero value for this parameter causes all authoring operations to be logged to the file author.log in the _vti_log directory of the customer's document root. Each operation is recorded with the current time, remote host, author's user name, web name, operation performed, and the per-operation data. In the event of a security breach, this log file can be analyzed for authoring activity on the customer's web. Default value = 0.

ServerFilePipeToAllows

A space-separated list of programs to which the default (Save Results), Registration, and Discussion FrontPage form handling components can pipe their output. At installation time, the FrontPage 98 Server Extensions set the NoServerFilePipeTo parameter (see above) to a non-zero value so that these FrontPage Components cannot pipe their output to any program. Setting NoServerFilePipeTo to zero and then setting ServerFilePipeToAllows to a list of programs provides additional flexibility for piping output from the FrontPage Components.

Additional Server Extension Configuration Parameters

These Server Extension configuration parameters do not have an effect on the security of FrontPage, but are relevant to concerns that a Web presence provider may have.

TextMemory

Setting this parameter to zero turns off full-text indexing of the web. A non-zero value allows you to specify the number of megabytes of RAM to use during text indexing for hash-tables and other data structures.

ReformatHtml

Setting this parameter to Y or a non-zero value will cause the FrontPage 98 Server Extensions to reformat all HTML pages when they are uploaded to the web server. Setting a zero value for this parameter causes only pages with FrontPage Components to be reformatted. Default = N

UpperCaseTags

A non-zero value for this parameter causes all HTML tags to be converted to uppercase when the FrontPage 98 Server Extensions reformat HTML pages. Default = 0

PreserveTagCase

When set to "Y" or a non-zero value, attempts to preserve the case of HTML tag attributes when the FrontPage 98 Server Extensions reformats HTML pages. Note that the tag itself will always be upper- or lower-case according to the UpperCaseTags attribute. Defaults to 0.

MaxAliases

This integer value limits the maximum number of aliases for NCSA server. The default is no maximum for NCSA. (This does not affect Apache servers.) This presumes that the NCSA server has been recompiled with a higher limit on the number of aliases. If this is not set, an error may occur after the fifth sub-web you create.

AccessControl

When this parameter is set to zero, FrontPage AccessControl is completely disabled. In general this is not recommended. Turning off AccessControl requires that the access control on the _vti_bin directories be set manually whenever a sub-web is created. Until this is done, anyone can author against the web. The advantage to AccessControl is that a knowledgeable webmaster who has set custom access control permissions will not have work re-written by FrontPage. This also causes the FrontPage Explorer to disable the Permissions command on the FrontPage Explorer's Tools menu. Default = 1.

SMTPHost

This parameter is set to the name or IP address of a host running an SMTP daemon, such as sendmail on UNIX. When a user submits a form whose results are to be sent via Email, the FrontPage Server Extensions connect to the SMTP daemon to deliver the mail. By default FrontPage assumes the daemon is listening on port 25 (the standard for SMTP) but you can override this by appending ":xx" to the name, where the xx is the port to use. Normally you will set either SMTPHost or SendmailCommand, but not both, because SendmailCommand takes priority over SMTPHost. Examples:

SMTPHost:mail.example.microsoft.com

SMTPHost:test:10000

SMTPHost:127.0.0.1

MailSender

This parameter sets the user name to use as the "from" account when sending Email. Specifically, it is used as the argument to the "SEND FROM:" command in SMTP. The default for SMTP is "user@host", where "user" is the current user account and "host" is the current host name.

SendMailCommand

This parameter sets the name of a program to which Email should be piped. Typically this will be sendmail, but it could be any program. Before invoking the command, all occurrences of "%r" are replaced with the recipient of the mail. The per cent sign character followed by any other character is replaced by that character. Example:

SendmailCommand:/usr/lib/sendmail %r

MailCharSet

This parameter can be used to override the character set attribute of the content-type header.

MailEncoding

This parameter can be used to override the content transfer encoding attribute of the content-type header.

CacheMaxDocMeta

This integer parameter sets the maximum number of documents in the cache. The default value is 512 .

CacheMaxInclude

This integer parameter sets the size (in MB) of the include file cache. The default value is 16.

CacheMaxImage

This integer parameter sets the size (in MB) of the image file cache. The default value is 16.

Locale

The locale of a program determines such things as how dates and times are formatted, and the collating order of strings. The Server Extensions set their locale from their environment but some UNIX http servers strip out the environment in CGI scripts. If locale is set, the Server Extensions call the operating system routine setlocale with that value as the second parameter and LC_ALL as the first parameter. The following example changes the locale to German:

locale:de

Parameters That Can Also Be Set in the FrontPage Explorer

The following parameters can be set in the FrontPage Explorer under the Tools menu's Web Settings command in the Advanced tab. Using these parameters will set the defaults for the web, however these settings will not be updated in the FrontPage Explorer's user interface.

NoClientImageMaps

When this parameter is set to 1, it prevents FrontPage from generating HTML that supports client-side image map processing. By default, FrontPage can generate both client-side and server-side HTML by not setting this parameter and by selecting a server-side ImageMapFormat.

ImageMapFormat

This parameter sets the server image-map style. Valid parameters include: FrontPage, NCSA, CERN, Netscape, or <None>. If you select <None>, FrontPage will not generate HTML to support server-side image map processing.

ImageMapURLPrefix

This parameter sets the server-relative URL of the server-side handler for the selected image-map style. If style (ImageMapFormat) is "FrontPage," server-side image maps are handled automatically. For other styles, provide the name and location of a handler.

ScriptLanguage

This parameter sets the scripting language for the scripts that are automatically generated to enforce any data validation settings you apply to form fields. Valid parameters include VBScript, JavaScript, or None.


Files and Permissions for UNIX Web Servers

This appendix lists the file permission settings for both the directories and files that contain the main core of the FrontPage Server Extensions and the directories and files that are installed into the content area of the web server.

Core Server Extensions File/Directory Permissions

The initial installation of the FrontPage Server Extensions will install the following directories and files with the permissions listed below. When virtual servers are added, the appropriate files will be copied from these directories.

This list assumes that the fp_install.sh script was used to install the FrontPage Server Extensions. If the Server Extensions distribution files are manually unpacked then permissions will not be automatically set according to this list.

/usr/local/frontpage/version3.0/
-r--r--r-- | bin | bin | LICENSE.TXT | Software license agreement
dr-xr-xr-x | bin | bin | _vti_bin | Server Extensions CGI stubs directory
dr-xr-xr-x | bin | bin | admin | HTML Administration forms directory
drwx--x--x | root | bin | apache-fp | Apache patch directory
dr-xr-xr-x | bin | bin | bin | Administration tools directory
-r-xr-xr-x | bin | bin | change_server.sh | Apache patch server install script
dr-xr-xr-x | bin | bin | exes | Server Extensions CGI implementation directory
-r-xr-xr-x | bin | bin | fp_install.sh | Server Extensions install script
-rw-rw-r-- | bin | bin | frontpage.cnf | FrontPage Server Extensions configuration file
dr-xr-xr-x | bin | bin | nls | National Language Support files directory
-r--r--r-- | bin | bin | readme.htm | Server Extensions readme file
dr-xr-xr-x | bin | bin | serk | Server Extensions Resource Kit document directory
-r-xr-xr-x | bin | bin | set_default_perms.sh | Resets permissions on server extensions files
/usr/local/frontpage/version3.0/_vti_bin:
dr-xr-xr-x | bin | bin | _vti_adm | Administrative stub directory
dr-xr-xr-x | bin | bin | _vti_aut | Authoring stub directory
-r-xr-xr-x | bin | bin | fpcount.exe | Hit counter component stub
-r-xr-xr-x | bin | bin | shtml.exe | Server Extensions browse-time stub program
/usr/local/frontpage/version3.0/_vti_bin/_vti_adm
-r-xr-xr-x | bin | bin | admin.exe | Server Extensions administration stub program
/usr/local/frontpage/version3.0/_vti_bin/_vti_aut
-r-xr-xr-x | bin | bin | author.exe | Server Extensions authoring stub program
/usr/local/frontpage/version3.0/admin
-r--r--r-- | bin | bin | *.htm | HTML Administration Forms
-r--r--r-- | bin | bin | *.gif | HTML Administration Forms images
dr-xr-xr-x | bin | bin | scripts | HTML Administration server-side executable directory
/usr/local/frontpage/version3.0/admin/scripts
-r-xr-xr-x | bin | bin | fpadmcgi.exe | HTML Administration server-side executable program
/usr/local/frontpage/version3.0/apache-fp
dr-xr-xr-x | bin | bin | _vti_bin | Apache patch stub program directory
-r--r--r-- | bin | bin | fp-patch-apache_1.2.4 | FrontPage Apache patch source code
-r--r--r-- | root | bin | fpexe.c | fpexe program source code
-r-xr-xr-x | root | bin | httpd | Pre-built patched Apache daemon
-rw------- | root | bin | suidkey | Custom key file
-rw------- | root | bin | suidkey.<number> * | Dynamic key files, one per web process
/usr/local/frontpage/version3.0/apache-fp/_vti_bin
-rwsr-xr-x | root | bin | fpexe | Apache patch stub program
/usr/local/frontpage/version3.0/bin
-rw-r--r-- | bin | bin | _vti_inf.html | FrontPage information file
-r-xr-xr-x | bin | bin | fpsrvadm.exe | FrontPage Server Administrator utility
-rw-r--r-- | bin | bin | postinfo.html | WebPost information file
/usr/local/frontpage/version3.0/exes
dr-xr-xr-x | bin | bin | _vti_bin |
/usr/local/frontpage/version3.0/exes/_vti_bin
dr-xr-xr-x | bin | bin | _vti_adm | Administration program directory
dr-xr-xr-x | bin | bin | _vti_aut | Authoring program directory
-r-xr-xr-x | bin | bin | fpcount.exe | Hit counter component runtime
-r-xr-xr-x | bin | bin | shtml.exe | Server Extensions browse-time program
/usr/local/frontpage/version3.0/exes/_vti_bin/_vti_adm
-r-xr-xr-x | bin | bin | admin.exe | Server Extensions administration program
/usr/local/frontpage/version3.0/exes/_vti_bin/_vti_aut
-r-xr-xr-x | bin | bin | author.exe | Server Extensions authoring program
/usr/local/frontpage/version3.0/nls
-r--r--r-- | bin | bin | *.nls | Code page description files
/usr/local/frontpage/version3.0/serk
-r--r--r-- | bin | bin | *.htm | Server Extensions Resource Kit HTML documents
dr-xr-xr-x | bin | bin | images | Server Extensions Resource Kit images directory
/usr/local/frontpage/version3.0/serk/images
-r--r--r-- | bin | bin | *.gif | Server Extensions Resource Kit images

* Created on installation and execution of the FrontPage 98 patch for the Apache Web Server.

Content Area File/Directory Permissions

There are two main methods of running the FrontPage Server Extensions on a UNIX server. The two methods are:

  • Single UNIX account per customer
  • Multiple UNIX accounts per customer

For additional information regarding the FrontPage Server Extensions on a UNIX server, please see the Security document in the Server Extension Resource Kit.

Single UNIX account per customer - Permissions Settings

The file listing below shows the location and permission settings for the FrontPage Server Extensions on a UNIX server when only a single UNIX account requires access to the FrontPage Web. The permissions do not allow for group Write access. Specifically, the file permissions are set accordingly:

644 (rw-r--r--) for files
755 (rwxr-xr-x) for directories
022 for the umask

Additional FrontPage Administrators and Authors may be added by using the Tools Permissions menu option in the FrontPage Explorer. Using this tool will not affect any UNIX file permissions.

Content directory structure (example)

drwxr-xr-x | kelly | volcano | _vti_bin
drwxr-xr-x | kelly | volcano | _vti_cnf
-rw-r--r-- | kelly | volcano | _vti_inf.html
drwxr-xr-x | kelly | volcano | _vti_log
drwxr-xr-x | kelly | volcano | _vti_pvt
drwxr-xr-x | kelly | volcano | _vti_txt
-rw-r--r-- | kelly | volcano | index.html
-rw-r--r-- | kelly | volcano | postinfo.html
_vti_bin:
drwxr-xr-x | kelly | volcano | _vti_adm
drwxr-xr-x | kelly | volcano | _vti_aut
-r-sr-sr-x | kelly | volcano | fpcount.exe
-r-sr-sr-x | kelly | volcano | shtml.exe
_vti_bin/_vti_adm:
-r-sr-sr-x | kelly | volcano | admin.exe
_vti_bin/_vti_aut:
-r-sr-sr-x | kelly | volcano | author.exe

Multiple UNIX accounts per customer - Permissions Settings

The following file listing shows the location and permission settings for the FrontPage Server Extensions on a UNIX server when multiple UNIX accounts require access to the same FrontPage Web. The permissions do allow for group Write access and assume that each individual UNIX account that requires access is a member of that group. Specifically, the file permissions are set accordingly:

664 (rw-rw-r--) for files
775 (rwxrwxr-x) for directories
002 for the umask

Additional FrontPage Administrators and Authors may be added by using the Tools Permissions command in the FrontPage Explorer. Using this tool will not affect any UNIX file permissions.

drwxrwxr-x | george | www | _vti_bin
drwxrwxr-x | george | www | _vti_cnf
-rw-rw-r-- | george | www | _vti_inf.html
drwxrwxr-x | george | www | _vti_log
drwxrwxr-x | george | www | _vti_pvt
drwxrwxr-x | george | www | _vti_txt
-rw-rw-r-- | george | www | index.html
-rw-rw-r-- | george | www | postinfo.html
_vti_bin
drwxrwxr-x | george | www | _vti_adm
drwxrwxr-x | george | www | _vti_aut
-r-sr-sr-x | george | www | fpcount.exe
-r-sr-sr-x | george | www | shtml.exe
_vti_bin/_vti_adm
-r-sr-sr-x | george | www | admin.exe
_vti_bin/_vti_aut
-r-sr-sr-x | george | www | author.exe


FrontPage 98 Server Extensions Resource Kit Contents

Home
Introduction
Security
Installation
Administration
Troubleshooting
Appendices

Created & Managed with
 Created & Managed With FrontPage 98

SERK Version 1.1